//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armdataboxedge

// AlertsClientGetResponse contains the response from method AlertsClient.Get.
type AlertsClientGetResponse struct {
	Alert
}

// AlertsClientListByDataBoxEdgeDeviceResponse contains the response from method AlertsClient.NewListByDataBoxEdgeDevicePager.
type AlertsClientListByDataBoxEdgeDeviceResponse struct {
	AlertList
}

// BandwidthSchedulesClientCreateOrUpdateResponse contains the response from method BandwidthSchedulesClient.BeginCreateOrUpdate.
type BandwidthSchedulesClientCreateOrUpdateResponse struct {
	BandwidthSchedule
}

// BandwidthSchedulesClientDeleteResponse contains the response from method BandwidthSchedulesClient.BeginDelete.
type BandwidthSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// BandwidthSchedulesClientGetResponse contains the response from method BandwidthSchedulesClient.Get.
type BandwidthSchedulesClientGetResponse struct {
	BandwidthSchedule
}

// BandwidthSchedulesClientListByDataBoxEdgeDeviceResponse contains the response from method BandwidthSchedulesClient.NewListByDataBoxEdgeDevicePager.
type BandwidthSchedulesClientListByDataBoxEdgeDeviceResponse struct {
	BandwidthSchedulesList
}

// ContainersClientCreateOrUpdateResponse contains the response from method ContainersClient.BeginCreateOrUpdate.
type ContainersClientCreateOrUpdateResponse struct {
	Container
}

// ContainersClientDeleteResponse contains the response from method ContainersClient.BeginDelete.
type ContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// ContainersClientGetResponse contains the response from method ContainersClient.Get.
type ContainersClientGetResponse struct {
	Container
}

// ContainersClientListByStorageAccountResponse contains the response from method ContainersClient.NewListByStorageAccountPager.
type ContainersClientListByStorageAccountResponse struct {
	ContainerList
}

// ContainersClientRefreshResponse contains the response from method ContainersClient.BeginRefresh.
type ContainersClientRefreshResponse struct {
	// placeholder for future response values
}

// DevicesClientCreateOrUpdateResponse contains the response from method DevicesClient.BeginCreateOrUpdate.
type DevicesClientCreateOrUpdateResponse struct {
	Device
}

// DevicesClientCreateOrUpdateSecuritySettingsResponse contains the response from method DevicesClient.BeginCreateOrUpdateSecuritySettings.
type DevicesClientCreateOrUpdateSecuritySettingsResponse struct {
	// placeholder for future response values
}

// DevicesClientDeleteResponse contains the response from method DevicesClient.BeginDelete.
type DevicesClientDeleteResponse struct {
	// placeholder for future response values
}

// DevicesClientDownloadUpdatesResponse contains the response from method DevicesClient.BeginDownloadUpdates.
type DevicesClientDownloadUpdatesResponse struct {
	// placeholder for future response values
}

// DevicesClientGetExtendedInformationResponse contains the response from method DevicesClient.GetExtendedInformation.
type DevicesClientGetExtendedInformationResponse struct {
	DeviceExtendedInfo
}

// DevicesClientGetNetworkSettingsResponse contains the response from method DevicesClient.GetNetworkSettings.
type DevicesClientGetNetworkSettingsResponse struct {
	NetworkSettings
}

// DevicesClientGetResponse contains the response from method DevicesClient.Get.
type DevicesClientGetResponse struct {
	Device
}

// DevicesClientGetUpdateSummaryResponse contains the response from method DevicesClient.GetUpdateSummary.
type DevicesClientGetUpdateSummaryResponse struct {
	UpdateSummary
}

// DevicesClientInstallUpdatesResponse contains the response from method DevicesClient.BeginInstallUpdates.
type DevicesClientInstallUpdatesResponse struct {
	// placeholder for future response values
}

// DevicesClientListByResourceGroupResponse contains the response from method DevicesClient.NewListByResourceGroupPager.
type DevicesClientListByResourceGroupResponse struct {
	DeviceList
}

// DevicesClientListBySubscriptionResponse contains the response from method DevicesClient.NewListBySubscriptionPager.
type DevicesClientListBySubscriptionResponse struct {
	DeviceList
}

// DevicesClientScanForUpdatesResponse contains the response from method DevicesClient.BeginScanForUpdates.
type DevicesClientScanForUpdatesResponse struct {
	// placeholder for future response values
}

// DevicesClientUpdateResponse contains the response from method DevicesClient.Update.
type DevicesClientUpdateResponse struct {
	Device
}

// DevicesClientUploadCertificateResponse contains the response from method DevicesClient.UploadCertificate.
type DevicesClientUploadCertificateResponse struct {
	UploadCertificateResponse
}

// JobsClientGetResponse contains the response from method JobsClient.Get.
type JobsClientGetResponse struct {
	Job
}

// NodesClientListByDataBoxEdgeDeviceResponse contains the response from method NodesClient.NewListByDataBoxEdgeDevicePager.
type NodesClientListByDataBoxEdgeDeviceResponse struct {
	NodeList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	OperationsList
}

// OperationsStatusClientGetResponse contains the response from method OperationsStatusClient.Get.
type OperationsStatusClientGetResponse struct {
	Job
}

// OrdersClientCreateOrUpdateResponse contains the response from method OrdersClient.BeginCreateOrUpdate.
type OrdersClientCreateOrUpdateResponse struct {
	Order
}

// OrdersClientDeleteResponse contains the response from method OrdersClient.BeginDelete.
type OrdersClientDeleteResponse struct {
	// placeholder for future response values
}

// OrdersClientGetResponse contains the response from method OrdersClient.Get.
type OrdersClientGetResponse struct {
	Order
}

// OrdersClientListByDataBoxEdgeDeviceResponse contains the response from method OrdersClient.NewListByDataBoxEdgeDevicePager.
type OrdersClientListByDataBoxEdgeDeviceResponse struct {
	OrderList
}

// RolesClientCreateOrUpdateResponse contains the response from method RolesClient.BeginCreateOrUpdate.
type RolesClientCreateOrUpdateResponse struct {
	RoleClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type RolesClientCreateOrUpdateResponse.
func (r *RolesClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalRoleClassification(data)
	if err != nil {
		return err
	}
	r.RoleClassification = res
	return nil
}

// RolesClientDeleteResponse contains the response from method RolesClient.BeginDelete.
type RolesClientDeleteResponse struct {
	// placeholder for future response values
}

// RolesClientGetResponse contains the response from method RolesClient.Get.
type RolesClientGetResponse struct {
	RoleClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type RolesClientGetResponse.
func (r *RolesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalRoleClassification(data)
	if err != nil {
		return err
	}
	r.RoleClassification = res
	return nil
}

// RolesClientListByDataBoxEdgeDeviceResponse contains the response from method RolesClient.NewListByDataBoxEdgeDevicePager.
type RolesClientListByDataBoxEdgeDeviceResponse struct {
	RoleList
}

// SKUsClientListResponse contains the response from method SKUsClient.NewListPager.
type SKUsClientListResponse struct {
	SKUInformationList
}

// SharesClientCreateOrUpdateResponse contains the response from method SharesClient.BeginCreateOrUpdate.
type SharesClientCreateOrUpdateResponse struct {
	Share
}

// SharesClientDeleteResponse contains the response from method SharesClient.BeginDelete.
type SharesClientDeleteResponse struct {
	// placeholder for future response values
}

// SharesClientGetResponse contains the response from method SharesClient.Get.
type SharesClientGetResponse struct {
	Share
}

// SharesClientListByDataBoxEdgeDeviceResponse contains the response from method SharesClient.NewListByDataBoxEdgeDevicePager.
type SharesClientListByDataBoxEdgeDeviceResponse struct {
	ShareList
}

// SharesClientRefreshResponse contains the response from method SharesClient.BeginRefresh.
type SharesClientRefreshResponse struct {
	// placeholder for future response values
}

// StorageAccountCredentialsClientCreateOrUpdateResponse contains the response from method StorageAccountCredentialsClient.BeginCreateOrUpdate.
type StorageAccountCredentialsClientCreateOrUpdateResponse struct {
	StorageAccountCredential
}

// StorageAccountCredentialsClientDeleteResponse contains the response from method StorageAccountCredentialsClient.BeginDelete.
type StorageAccountCredentialsClientDeleteResponse struct {
	// placeholder for future response values
}

// StorageAccountCredentialsClientGetResponse contains the response from method StorageAccountCredentialsClient.Get.
type StorageAccountCredentialsClientGetResponse struct {
	StorageAccountCredential
}

// StorageAccountCredentialsClientListByDataBoxEdgeDeviceResponse contains the response from method StorageAccountCredentialsClient.NewListByDataBoxEdgeDevicePager.
type StorageAccountCredentialsClientListByDataBoxEdgeDeviceResponse struct {
	StorageAccountCredentialList
}

// StorageAccountsClientCreateOrUpdateResponse contains the response from method StorageAccountsClient.BeginCreateOrUpdate.
type StorageAccountsClientCreateOrUpdateResponse struct {
	StorageAccount
}

// StorageAccountsClientDeleteResponse contains the response from method StorageAccountsClient.BeginDelete.
type StorageAccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// StorageAccountsClientGetResponse contains the response from method StorageAccountsClient.Get.
type StorageAccountsClientGetResponse struct {
	StorageAccount
}

// StorageAccountsClientListByDataBoxEdgeDeviceResponse contains the response from method StorageAccountsClient.NewListByDataBoxEdgeDevicePager.
type StorageAccountsClientListByDataBoxEdgeDeviceResponse struct {
	StorageAccountList
}

// TriggersClientCreateOrUpdateResponse contains the response from method TriggersClient.BeginCreateOrUpdate.
type TriggersClientCreateOrUpdateResponse struct {
	TriggerClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type TriggersClientCreateOrUpdateResponse.
func (t *TriggersClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalTriggerClassification(data)
	if err != nil {
		return err
	}
	t.TriggerClassification = res
	return nil
}

// TriggersClientDeleteResponse contains the response from method TriggersClient.BeginDelete.
type TriggersClientDeleteResponse struct {
	// placeholder for future response values
}

// TriggersClientGetResponse contains the response from method TriggersClient.Get.
type TriggersClientGetResponse struct {
	TriggerClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type TriggersClientGetResponse.
func (t *TriggersClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalTriggerClassification(data)
	if err != nil {
		return err
	}
	t.TriggerClassification = res
	return nil
}

// TriggersClientListByDataBoxEdgeDeviceResponse contains the response from method TriggersClient.NewListByDataBoxEdgeDevicePager.
type TriggersClientListByDataBoxEdgeDeviceResponse struct {
	TriggerList
}

// UsersClientCreateOrUpdateResponse contains the response from method UsersClient.BeginCreateOrUpdate.
type UsersClientCreateOrUpdateResponse struct {
	User
}

// UsersClientDeleteResponse contains the response from method UsersClient.BeginDelete.
type UsersClientDeleteResponse struct {
	// placeholder for future response values
}

// UsersClientGetResponse contains the response from method UsersClient.Get.
type UsersClientGetResponse struct {
	User
}

// UsersClientListByDataBoxEdgeDeviceResponse contains the response from method UsersClient.NewListByDataBoxEdgeDevicePager.
type UsersClientListByDataBoxEdgeDeviceResponse struct {
	UserList
}
