//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package generated

// AzureAppConfigurationClientBeginCreateSnapshotOptions contains the optional parameters for the AzureAppConfigurationClient.BeginCreateSnapshot
// method.
type AzureAppConfigurationClientBeginCreateSnapshotOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AzureAppConfigurationClientCheckKeyValueOptions contains the optional parameters for the AzureAppConfigurationClient.CheckKeyValue
// method.
type AzureAppConfigurationClientCheckKeyValueOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// The label of the key-value to retrieve.
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields
}

// AzureAppConfigurationClientCheckKeyValuesOptions contains the optional parameters for the AzureAppConfigurationClient.CheckKeyValues
// method.
type AzureAppConfigurationClientCheckKeyValuesOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// A filter used to match keys.
	Key *string

	// A filter used to match labels
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields

	// A filter used get key-values for a snapshot. Not valid when used with 'key' and 'label' filters.
	Snapshot *string
}

// AzureAppConfigurationClientCheckKeysOptions contains the optional parameters for the AzureAppConfigurationClient.CheckKeys
// method.
type AzureAppConfigurationClientCheckKeysOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter for the name of the returned keys.
	Name *string
}

// AzureAppConfigurationClientCheckLabelsOptions contains the optional parameters for the AzureAppConfigurationClient.CheckLabels
// method.
type AzureAppConfigurationClientCheckLabelsOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter for the name of the returned labels.
	Name *string

	// Used to select what fields are present in the returned resource(s).
	Select []LabelFields
}

// AzureAppConfigurationClientCheckRevisionsOptions contains the optional parameters for the AzureAppConfigurationClient.CheckRevisions
// method.
type AzureAppConfigurationClientCheckRevisionsOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter used to match keys.
	Key *string

	// A filter used to match labels
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields
}

// AzureAppConfigurationClientCheckSnapshotOptions contains the optional parameters for the AzureAppConfigurationClient.CheckSnapshot
// method.
type AzureAppConfigurationClientCheckSnapshotOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string
}

// AzureAppConfigurationClientCheckSnapshotsOptions contains the optional parameters for the AzureAppConfigurationClient.CheckSnapshots
// method.
type AzureAppConfigurationClientCheckSnapshotsOptions struct {
	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string
}

// AzureAppConfigurationClientDeleteKeyValueOptions contains the optional parameters for the AzureAppConfigurationClient.DeleteKeyValue
// method.
type AzureAppConfigurationClientDeleteKeyValueOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// The label of the key-value to delete.
	Label *string
}

// AzureAppConfigurationClientDeleteLockOptions contains the optional parameters for the AzureAppConfigurationClient.DeleteLock
// method.
type AzureAppConfigurationClientDeleteLockOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// The label, if any, of the key-value to unlock.
	Label *string
}

// AzureAppConfigurationClientGetKeyValueOptions contains the optional parameters for the AzureAppConfigurationClient.GetKeyValue
// method.
type AzureAppConfigurationClientGetKeyValueOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// The label of the key-value to retrieve.
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields
}

// AzureAppConfigurationClientGetKeyValuesOptions contains the optional parameters for the AzureAppConfigurationClient.NewGetKeyValuesPager
// method.
type AzureAppConfigurationClientGetKeyValuesOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// A filter used to match keys.
	Key *string

	// A filter used to match labels
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields

	// A filter used get key-values for a snapshot. The value should be the name of the snapshot. Not valid when used with 'key'
	// and 'label' filters.
	Snapshot *string
}

// AzureAppConfigurationClientGetKeysOptions contains the optional parameters for the AzureAppConfigurationClient.NewGetKeysPager
// method.
type AzureAppConfigurationClientGetKeysOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter for the name of the returned keys.
	Name *string
}

// AzureAppConfigurationClientGetLabelsOptions contains the optional parameters for the AzureAppConfigurationClient.NewGetLabelsPager
// method.
type AzureAppConfigurationClientGetLabelsOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter for the name of the returned labels.
	Name *string

	// Used to select what fields are present in the returned resource(s).
	Select []LabelFields
}

// AzureAppConfigurationClientGetOperationDetailsOptions contains the optional parameters for the AzureAppConfigurationClient.GetOperationDetails
// method.
type AzureAppConfigurationClientGetOperationDetailsOptions struct {
	// placeholder for future optional parameters
}

// AzureAppConfigurationClientGetRevisionsOptions contains the optional parameters for the AzureAppConfigurationClient.NewGetRevisionsPager
// method.
type AzureAppConfigurationClientGetRevisionsOptions struct {
	// Requests the server to respond with the state of the resource at the specified time.
	AcceptDatetime *string

	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter used to match keys.
	Key *string

	// A filter used to match labels
	Label *string

	// Used to select what fields are present in the returned resource(s).
	Select []SettingFields
}

// AzureAppConfigurationClientGetSnapshotOptions contains the optional parameters for the AzureAppConfigurationClient.GetSnapshot
// method.
type AzureAppConfigurationClientGetSnapshotOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// Used to select what fields are present in the returned resource(s).
	Select []SnapshotFields
}

// AzureAppConfigurationClientGetSnapshotsOptions contains the optional parameters for the AzureAppConfigurationClient.NewGetSnapshotsPager
// method.
type AzureAppConfigurationClientGetSnapshotsOptions struct {
	// Instructs the server to return elements that appear after the element referred to by the specified token.
	After *string

	// A filter for the name of the returned snapshots.
	Name *string

	// Used to select what fields are present in the returned resource(s).
	Select []SnapshotFields

	// Used to filter returned snapshots by their status property.
	Status []SnapshotStatus
}

// AzureAppConfigurationClientPutKeyValueOptions contains the optional parameters for the AzureAppConfigurationClient.PutKeyValue
// method.
type AzureAppConfigurationClientPutKeyValueOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// The label of the key-value to create.
	Label *string
}

// AzureAppConfigurationClientPutLockOptions contains the optional parameters for the AzureAppConfigurationClient.PutLock
// method.
type AzureAppConfigurationClientPutLockOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string

	// The label, if any, of the key-value to lock.
	Label *string
}

// AzureAppConfigurationClientUpdateSnapshotOptions contains the optional parameters for the AzureAppConfigurationClient.UpdateSnapshot
// method.
type AzureAppConfigurationClientUpdateSnapshotOptions struct {
	// Used to perform an operation only if the targeted resource's etag matches the value provided.
	IfMatch *string

	// Used to perform an operation only if the targeted resource's etag does not match the value provided.
	IfNoneMatch *string
}
