//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armagrifood

// ExtensionsClientCreateResponse contains the response from method ExtensionsClient.Create.
type ExtensionsClientCreateResponse struct {
	// Extension resource.
	Extension
}

// ExtensionsClientDeleteResponse contains the response from method ExtensionsClient.Delete.
type ExtensionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ExtensionsClientGetResponse contains the response from method ExtensionsClient.Get.
type ExtensionsClientGetResponse struct {
	// Extension resource.
	Extension
}

// ExtensionsClientListByFarmBeatsResponse contains the response from method ExtensionsClient.NewListByFarmBeatsPager.
type ExtensionsClientListByFarmBeatsResponse struct {
	// Paged response contains list of requested objects and a URL link to get the next set of results.
	ExtensionListResponse
}

// ExtensionsClientUpdateResponse contains the response from method ExtensionsClient.Update.
type ExtensionsClientUpdateResponse struct {
	// Extension resource.
	Extension
}

// FarmBeatsExtensionsClientGetResponse contains the response from method FarmBeatsExtensionsClient.Get.
type FarmBeatsExtensionsClientGetResponse struct {
	// FarmBeats extension resource.
	FarmBeatsExtension
}

// FarmBeatsExtensionsClientListResponse contains the response from method FarmBeatsExtensionsClient.NewListPager.
type FarmBeatsExtensionsClientListResponse struct {
	// Paged response contains list of requested objects and a URL link to get the next set of results.
	FarmBeatsExtensionListResponse
}

// FarmBeatsModelsClientCreateOrUpdateResponse contains the response from method FarmBeatsModelsClient.CreateOrUpdate.
type FarmBeatsModelsClientCreateOrUpdateResponse struct {
	// FarmBeats ARM Resource.
	FarmBeats
}

// FarmBeatsModelsClientDeleteResponse contains the response from method FarmBeatsModelsClient.Delete.
type FarmBeatsModelsClientDeleteResponse struct {
	// placeholder for future response values
}

// FarmBeatsModelsClientGetOperationResultResponse contains the response from method FarmBeatsModelsClient.GetOperationResult.
type FarmBeatsModelsClientGetOperationResultResponse struct {
	// Arm async operation class.
	// Ref: https://docs.microsoft.com/en-us/azure/azure-resource-manager/management/async-operations.
	ArmAsyncOperation
}

// FarmBeatsModelsClientGetResponse contains the response from method FarmBeatsModelsClient.Get.
type FarmBeatsModelsClientGetResponse struct {
	// FarmBeats ARM Resource.
	FarmBeats
}

// FarmBeatsModelsClientListByResourceGroupResponse contains the response from method FarmBeatsModelsClient.NewListByResourceGroupPager.
type FarmBeatsModelsClientListByResourceGroupResponse struct {
	// Paged response contains list of requested objects and a URL link to get the next set of results.
	FarmBeatsListResponse
}

// FarmBeatsModelsClientListBySubscriptionResponse contains the response from method FarmBeatsModelsClient.NewListBySubscriptionPager.
type FarmBeatsModelsClientListBySubscriptionResponse struct {
	// Paged response contains list of requested objects and a URL link to get the next set of results.
	FarmBeatsListResponse
}

// FarmBeatsModelsClientUpdateResponse contains the response from method FarmBeatsModelsClient.BeginUpdate.
type FarmBeatsModelsClientUpdateResponse struct {
	// FarmBeats ARM Resource.
	FarmBeats
}

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	// The check availability result.
	CheckNameAvailabilityResponse
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByResourceResponse contains the response from method PrivateEndpointConnectionsClient.NewListByResourcePager.
type PrivateEndpointConnectionsClientListByResourceResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A private link resource
	PrivateLinkResource
}

// PrivateLinkResourcesClientListByResourceResponse contains the response from method PrivateLinkResourcesClient.NewListByResourcePager.
type PrivateLinkResourcesClientListByResourceResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}
