//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armalertsmanagement

// AlertProcessingRulesClientCreateOrUpdateResponse contains the response from method AlertProcessingRulesClient.CreateOrUpdate.
type AlertProcessingRulesClientCreateOrUpdateResponse struct {
	// Alert processing rule object containing target scopes, conditions and scheduling logic.
	AlertProcessingRule

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertProcessingRulesClientDeleteResponse contains the response from method AlertProcessingRulesClient.Delete.
type AlertProcessingRulesClientDeleteResponse struct {
	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertProcessingRulesClientGetByNameResponse contains the response from method AlertProcessingRulesClient.GetByName.
type AlertProcessingRulesClientGetByNameResponse struct {
	// Alert processing rule object containing target scopes, conditions and scheduling logic.
	AlertProcessingRule

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertProcessingRulesClientListByResourceGroupResponse contains the response from method AlertProcessingRulesClient.NewListByResourceGroupPager.
type AlertProcessingRulesClientListByResourceGroupResponse struct {
	// List of alert processing rules.
	AlertProcessingRulesList

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertProcessingRulesClientListBySubscriptionResponse contains the response from method AlertProcessingRulesClient.NewListBySubscriptionPager.
type AlertProcessingRulesClientListBySubscriptionResponse struct {
	// List of alert processing rules.
	AlertProcessingRulesList

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertProcessingRulesClientUpdateResponse contains the response from method AlertProcessingRulesClient.Update.
type AlertProcessingRulesClientUpdateResponse struct {
	// Alert processing rule object containing target scopes, conditions and scheduling logic.
	AlertProcessingRule

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// AlertRuleRecommendationsClientListByResourceResponse contains the response from method AlertRuleRecommendationsClient.NewListByResourcePager.
type AlertRuleRecommendationsClientListByResourceResponse struct {
	// List of alert rule recommendations.
	AlertRuleRecommendationsListResponse
}

// AlertRuleRecommendationsClientListByTargetTypeResponse contains the response from method AlertRuleRecommendationsClient.NewListByTargetTypePager.
type AlertRuleRecommendationsClientListByTargetTypeResponse struct {
	// List of alert rule recommendations.
	AlertRuleRecommendationsListResponse
}

// AlertsClientChangeStateResponse contains the response from method AlertsClient.ChangeState.
type AlertsClientChangeStateResponse struct {
	// An alert created in alert management service.
	Alert
}

// AlertsClientGetAllResponse contains the response from method AlertsClient.NewGetAllPager.
type AlertsClientGetAllResponse struct {
	// List the alerts.
	AlertsList
}

// AlertsClientGetByIDResponse contains the response from method AlertsClient.GetByID.
type AlertsClientGetByIDResponse struct {
	// An alert created in alert management service.
	Alert
}

// AlertsClientGetHistoryResponse contains the response from method AlertsClient.GetHistory.
type AlertsClientGetHistoryResponse struct {
	// Alert Modification details
	AlertModification
}

// AlertsClientGetSummaryResponse contains the response from method AlertsClient.GetSummary.
type AlertsClientGetSummaryResponse struct {
	// Summary of alerts based on the input filters and 'groupby' parameters.
	AlertsSummary
}

// AlertsClientMetaDataResponse contains the response from method AlertsClient.MetaData.
type AlertsClientMetaDataResponse struct {
	// alert meta data information.
	AlertsMetaData
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Lists the operations available in the AlertsManagement RP.
	OperationsList
}

// PrometheusRuleGroupsClientCreateOrUpdateResponse contains the response from method PrometheusRuleGroupsClient.CreateOrUpdate.
type PrometheusRuleGroupsClientCreateOrUpdateResponse struct {
	// The Prometheus rule group resource.
	PrometheusRuleGroupResource
}

// PrometheusRuleGroupsClientDeleteResponse contains the response from method PrometheusRuleGroupsClient.Delete.
type PrometheusRuleGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrometheusRuleGroupsClientGetResponse contains the response from method PrometheusRuleGroupsClient.Get.
type PrometheusRuleGroupsClientGetResponse struct {
	// The Prometheus rule group resource.
	PrometheusRuleGroupResource
}

// PrometheusRuleGroupsClientListByResourceGroupResponse contains the response from method PrometheusRuleGroupsClient.NewListByResourceGroupPager.
type PrometheusRuleGroupsClientListByResourceGroupResponse struct {
	// Represents a collection of alert rule resources.
	PrometheusRuleGroupResourceCollection
}

// PrometheusRuleGroupsClientListBySubscriptionResponse contains the response from method PrometheusRuleGroupsClient.NewListBySubscriptionPager.
type PrometheusRuleGroupsClientListBySubscriptionResponse struct {
	// Represents a collection of alert rule resources.
	PrometheusRuleGroupResourceCollection
}

// PrometheusRuleGroupsClientUpdateResponse contains the response from method PrometheusRuleGroupsClient.Update.
type PrometheusRuleGroupsClientUpdateResponse struct {
	// The Prometheus rule group resource.
	PrometheusRuleGroupResource
}

// SmartGroupsClientChangeStateResponse contains the response from method SmartGroupsClient.ChangeState.
type SmartGroupsClientChangeStateResponse struct {
	// Set of related alerts grouped together smartly by AMS.
	SmartGroup

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// SmartGroupsClientGetAllResponse contains the response from method SmartGroupsClient.NewGetAllPager.
type SmartGroupsClientGetAllResponse struct {
	// List the alerts.
	SmartGroupsList
}

// SmartGroupsClientGetByIDResponse contains the response from method SmartGroupsClient.GetByID.
type SmartGroupsClientGetByIDResponse struct {
	// Set of related alerts grouped together smartly by AMS.
	SmartGroup

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// SmartGroupsClientGetHistoryResponse contains the response from method SmartGroupsClient.GetHistory.
type SmartGroupsClientGetHistoryResponse struct {
	// Alert Modification details
	SmartGroupModification
}

// TenantActivityLogAlertsClientCreateOrUpdateResponse contains the response from method TenantActivityLogAlertsClient.CreateOrUpdate.
type TenantActivityLogAlertsClientCreateOrUpdateResponse struct {
	// A Tenant Activity Log Alert rule resource.
	TenantActivityLogAlertResource
}

// TenantActivityLogAlertsClientDeleteResponse contains the response from method TenantActivityLogAlertsClient.Delete.
type TenantActivityLogAlertsClientDeleteResponse struct {
	// placeholder for future response values
}

// TenantActivityLogAlertsClientGetResponse contains the response from method TenantActivityLogAlertsClient.Get.
type TenantActivityLogAlertsClientGetResponse struct {
	// A Tenant Activity Log Alert rule resource.
	TenantActivityLogAlertResource
}

// TenantActivityLogAlertsClientListByManagementGroupResponse contains the response from method TenantActivityLogAlertsClient.NewListByManagementGroupPager.
type TenantActivityLogAlertsClientListByManagementGroupResponse struct {
	// A list of Tenant Activity Log Alert rules.
	TenantAlertRuleList
}

// TenantActivityLogAlertsClientListByTenantResponse contains the response from method TenantActivityLogAlertsClient.NewListByTenantPager.
type TenantActivityLogAlertsClientListByTenantResponse struct {
	// A list of Tenant Activity Log Alert rules.
	TenantAlertRuleList
}

// TenantActivityLogAlertsClientUpdateResponse contains the response from method TenantActivityLogAlertsClient.Update.
type TenantActivityLogAlertsClientUpdateResponse struct {
	// A Tenant Activity Log Alert rule resource.
	TenantActivityLogAlertResource
}
