//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armappcontainers_test

import (
	"context"
	"log"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/appcontainers/armappcontainers/v3"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_ListBySubscription.json
func ExampleContainerAppsSessionPoolsClient_NewListBySubscriptionPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewContainerAppsSessionPoolsClient().NewListBySubscriptionPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.SessionPoolCollection = armappcontainers.SessionPoolCollection{
		// 	Value: []*armappcontainers.SessionPool{
		// 		{
		// 			Name: to.Ptr("testsessionpool"),
		// 			Type: to.Ptr("Microsoft.App/sessionPools"),
		// 			ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/sessionPools/testsessionpool"),
		// 			Location: to.Ptr("East US"),
		// 			Properties: &armappcontainers.SessionPoolProperties{
		// 				ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
		// 				CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
		// 					Containers: []*armappcontainers.SessionContainer{
		// 						{
		// 							Name: to.Ptr("testinitcontainer"),
		// 							Args: []*string{
		// 								to.Ptr("-c"),
		// 								to.Ptr("while true; do echo hello; sleep 10;done")},
		// 								Command: []*string{
		// 									to.Ptr("/bin/sh")},
		// 									Image: to.Ptr("repo/testcontainer:v4"),
		// 									Resources: &armappcontainers.SessionContainerResources{
		// 										CPU: to.Ptr[float64](0.25),
		// 										Memory: to.Ptr("0.5Gi"),
		// 									},
		// 							}},
		// 							Ingress: &armappcontainers.SessionIngress{
		// 								TargetPort: to.Ptr[int32](80),
		// 							},
		// 						},
		// 						DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
		// 							CooldownPeriodInSeconds: to.Ptr[int32](600),
		// 							ExecutionType: to.Ptr(armappcontainers.ExecutionTypeTimed),
		// 						},
		// 						EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
		// 						NodeCount: to.Ptr[int32](1),
		// 						PoolManagementEndpoint: to.Ptr("https://testsessionpool.agreeableriver-3d30edf1.eastus.azurecontainerapps.io"),
		// 						PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
		// 						ProvisioningState: to.Ptr(armappcontainers.SessionPoolProvisioningStateSucceeded),
		// 						ScaleConfiguration: &armappcontainers.ScaleConfiguration{
		// 							MaxConcurrentSessions: to.Ptr[int32](500),
		// 							ReadySessionInstances: to.Ptr[int32](100),
		// 						},
		// 						SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
		// 							Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
		// 						},
		// 					},
		// 			}},
		// 		}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_ListByResourceGroup.json
func ExampleContainerAppsSessionPoolsClient_NewListByResourceGroupPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewContainerAppsSessionPoolsClient().NewListByResourceGroupPager("rg", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.SessionPoolCollection = armappcontainers.SessionPoolCollection{
		// 	Value: []*armappcontainers.SessionPool{
		// 		{
		// 			Name: to.Ptr("testsessionpool"),
		// 			Type: to.Ptr("Microsoft.App/sessionPools"),
		// 			ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/sessionPools/testsessionpool"),
		// 			Location: to.Ptr("East US"),
		// 			Properties: &armappcontainers.SessionPoolProperties{
		// 				ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
		// 				CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
		// 					Containers: []*armappcontainers.SessionContainer{
		// 						{
		// 							Name: to.Ptr("testinitcontainer"),
		// 							Args: []*string{
		// 								to.Ptr("-c"),
		// 								to.Ptr("while true; do echo hello; sleep 10;done")},
		// 								Command: []*string{
		// 									to.Ptr("/bin/sh")},
		// 									Image: to.Ptr("repo/testcontainer:v4"),
		// 									Resources: &armappcontainers.SessionContainerResources{
		// 										CPU: to.Ptr[float64](0.25),
		// 										Memory: to.Ptr("0.5Gi"),
		// 									},
		// 							}},
		// 							Ingress: &armappcontainers.SessionIngress{
		// 								TargetPort: to.Ptr[int32](80),
		// 							},
		// 						},
		// 						DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
		// 							CooldownPeriodInSeconds: to.Ptr[int32](600),
		// 							ExecutionType: to.Ptr(armappcontainers.ExecutionTypeTimed),
		// 						},
		// 						EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
		// 						NodeCount: to.Ptr[int32](1),
		// 						PoolManagementEndpoint: to.Ptr("https://testsessionpool.agreeableriver-3d30edf1.eastus.azurecontainerapps.io"),
		// 						PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
		// 						ProvisioningState: to.Ptr(armappcontainers.SessionPoolProvisioningStateSucceeded),
		// 						ScaleConfiguration: &armappcontainers.ScaleConfiguration{
		// 							MaxConcurrentSessions: to.Ptr[int32](500),
		// 							ReadySessionInstances: to.Ptr[int32](100),
		// 						},
		// 						SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
		// 							Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
		// 						},
		// 					},
		// 			}},
		// 		}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_Get.json
func ExampleContainerAppsSessionPoolsClient_Get() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewContainerAppsSessionPoolsClient().Get(ctx, "rg", "testsessionpool", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.SessionPool = armappcontainers.SessionPool{
	// 	Name: to.Ptr("testsessionpool"),
	// 	Type: to.Ptr("Microsoft.App/sessionPools"),
	// 	ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/sessionPools/testsessionpool"),
	// 	Location: to.Ptr("East US"),
	// 	Properties: &armappcontainers.SessionPoolProperties{
	// 		ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
	// 		CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
	// 			Containers: []*armappcontainers.SessionContainer{
	// 				{
	// 					Name: to.Ptr("testinitcontainer"),
	// 					Args: []*string{
	// 						to.Ptr("-c"),
	// 						to.Ptr("while true; do echo hello; sleep 10;done")},
	// 						Command: []*string{
	// 							to.Ptr("/bin/sh")},
	// 							Image: to.Ptr("repo/testcontainer:v4"),
	// 							Resources: &armappcontainers.SessionContainerResources{
	// 								CPU: to.Ptr[float64](0.25),
	// 								Memory: to.Ptr("0.5Gi"),
	// 							},
	// 					}},
	// 					Ingress: &armappcontainers.SessionIngress{
	// 						TargetPort: to.Ptr[int32](80),
	// 					},
	// 					RegistryCredentials: &armappcontainers.SessionRegistryCredentials{
	// 						Identity: to.Ptr("/subscriptions/7a497526-bb8d-4816-9795-db1418a1f977/resourcegroups/test/providers/Microsoft.ManagedIdentity/userAssignedIdentities/testSP"),
	// 						Server: to.Ptr("test.azurecr.io"),
	// 					},
	// 				},
	// 				DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
	// 					CooldownPeriodInSeconds: to.Ptr[int32](600),
	// 					ExecutionType: to.Ptr(armappcontainers.ExecutionTypeTimed),
	// 				},
	// 				EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
	// 				NodeCount: to.Ptr[int32](1),
	// 				PoolManagementEndpoint: to.Ptr("https://testsessionpool.agreeableriver-3d30edf1.eastus.azurecontainerapps.io"),
	// 				PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
	// 				ProvisioningState: to.Ptr(armappcontainers.SessionPoolProvisioningStateSucceeded),
	// 				ScaleConfiguration: &armappcontainers.ScaleConfiguration{
	// 					MaxConcurrentSessions: to.Ptr[int32](500),
	// 					ReadySessionInstances: to.Ptr[int32](100),
	// 				},
	// 				SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
	// 					Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_CreateOrUpdate.json
func ExampleContainerAppsSessionPoolsClient_BeginCreateOrUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewContainerAppsSessionPoolsClient().BeginCreateOrUpdate(ctx, "rg", "testsessionpool", armappcontainers.SessionPool{
		Location: to.Ptr("East US"),
		Properties: &armappcontainers.SessionPoolProperties{
			ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
			CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
				Containers: []*armappcontainers.SessionContainer{
					{
						Name: to.Ptr("testinitcontainer"),
						Args: []*string{
							to.Ptr("-c"),
							to.Ptr("while true; do echo hello; sleep 10;done")},
						Command: []*string{
							to.Ptr("/bin/sh")},
						Image: to.Ptr("repo/testcontainer:v4"),
						Resources: &armappcontainers.SessionContainerResources{
							CPU:    to.Ptr[float64](0.25),
							Memory: to.Ptr("0.5Gi"),
						},
					}},
				Ingress: &armappcontainers.SessionIngress{
					TargetPort: to.Ptr[int32](80),
				},
			},
			DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
				CooldownPeriodInSeconds: to.Ptr[int32](600),
				ExecutionType:           to.Ptr(armappcontainers.ExecutionTypeTimed),
			},
			EnvironmentID:      to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
			PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
			ScaleConfiguration: &armappcontainers.ScaleConfiguration{
				MaxConcurrentSessions: to.Ptr[int32](500),
				ReadySessionInstances: to.Ptr[int32](100),
			},
			SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
				Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
			},
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.SessionPool = armappcontainers.SessionPool{
	// 	Name: to.Ptr("testsessionpool"),
	// 	Type: to.Ptr("Microsoft.App/sessionPools"),
	// 	ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/sessionPools/testsessionpool"),
	// 	Location: to.Ptr("East US"),
	// 	Properties: &armappcontainers.SessionPoolProperties{
	// 		ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
	// 		CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
	// 			Containers: []*armappcontainers.SessionContainer{
	// 				{
	// 					Name: to.Ptr("testinitcontainer"),
	// 					Args: []*string{
	// 						to.Ptr("-c"),
	// 						to.Ptr("while true; do echo hello; sleep 10;done")},
	// 						Command: []*string{
	// 							to.Ptr("/bin/sh")},
	// 							Image: to.Ptr("repo/testcontainer:v4"),
	// 							Resources: &armappcontainers.SessionContainerResources{
	// 								CPU: to.Ptr[float64](0.25),
	// 								Memory: to.Ptr("0.5Gi"),
	// 							},
	// 					}},
	// 					Ingress: &armappcontainers.SessionIngress{
	// 						TargetPort: to.Ptr[int32](80),
	// 					},
	// 					RegistryCredentials: &armappcontainers.SessionRegistryCredentials{
	// 						Identity: to.Ptr("/subscriptions/7a497526-bb8d-4816-9795-db1418a1f977/resourcegroups/test/providers/Microsoft.ManagedIdentity/userAssignedIdentities/testSP"),
	// 						Server: to.Ptr("test.azurecr.io"),
	// 					},
	// 				},
	// 				DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
	// 					CooldownPeriodInSeconds: to.Ptr[int32](600),
	// 					ExecutionType: to.Ptr(armappcontainers.ExecutionTypeTimed),
	// 				},
	// 				EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
	// 				NodeCount: to.Ptr[int32](1),
	// 				PoolManagementEndpoint: to.Ptr("https://testsessionpool.agreeableriver-3d30edf1.eastus.azurecontainerapps.io"),
	// 				PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
	// 				ProvisioningState: to.Ptr(armappcontainers.SessionPoolProvisioningStateSucceeded),
	// 				ScaleConfiguration: &armappcontainers.ScaleConfiguration{
	// 					MaxConcurrentSessions: to.Ptr[int32](500),
	// 					ReadySessionInstances: to.Ptr[int32](100),
	// 				},
	// 				SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
	// 					Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_Patch.json
func ExampleContainerAppsSessionPoolsClient_BeginUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewContainerAppsSessionPoolsClient().BeginUpdate(ctx, "rg", "testsessionpool", armappcontainers.SessionPoolUpdatableProperties{
		Properties: &armappcontainers.SessionPoolUpdatablePropertiesProperties{
			CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
				Containers: []*armappcontainers.SessionContainer{
					{
						Name: to.Ptr("testinitcontainer"),
						Args: []*string{
							to.Ptr("-c"),
							to.Ptr("while true; do echo hello; sleep 10;done")},
						Command: []*string{
							to.Ptr("/bin/sh")},
						Image: to.Ptr("repo/testcontainer:v4"),
						Resources: &armappcontainers.SessionContainerResources{
							CPU:    to.Ptr[float64](0.25),
							Memory: to.Ptr("0.5Gi"),
						},
					}},
				Ingress: &armappcontainers.SessionIngress{
					TargetPort: to.Ptr[int32](80),
				},
			},
			DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
				CooldownPeriodInSeconds: to.Ptr[int32](600),
				ExecutionType:           to.Ptr(armappcontainers.ExecutionTypeTimed),
			},
			ScaleConfiguration: &armappcontainers.ScaleConfiguration{
				MaxConcurrentSessions: to.Ptr[int32](500),
				ReadySessionInstances: to.Ptr[int32](100),
			},
			SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
				Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
			},
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.SessionPool = armappcontainers.SessionPool{
	// 	Name: to.Ptr("testsessionpool"),
	// 	Type: to.Ptr("Microsoft.App/sessionPools"),
	// 	ID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/sessionPools/testsessionpool"),
	// 	Location: to.Ptr("East US"),
	// 	Properties: &armappcontainers.SessionPoolProperties{
	// 		ContainerType: to.Ptr(armappcontainers.ContainerTypeCustomContainer),
	// 		CustomContainerTemplate: &armappcontainers.CustomContainerTemplate{
	// 			Containers: []*armappcontainers.SessionContainer{
	// 				{
	// 					Name: to.Ptr("testinitcontainer"),
	// 					Args: []*string{
	// 						to.Ptr("-c"),
	// 						to.Ptr("while true; do echo hello; sleep 10;done")},
	// 						Command: []*string{
	// 							to.Ptr("/bin/sh")},
	// 							Image: to.Ptr("repo/testcontainer:v4"),
	// 							Resources: &armappcontainers.SessionContainerResources{
	// 								CPU: to.Ptr[float64](0.25),
	// 								Memory: to.Ptr("0.5Gi"),
	// 							},
	// 					}},
	// 					Ingress: &armappcontainers.SessionIngress{
	// 						TargetPort: to.Ptr[int32](80),
	// 					},
	// 				},
	// 				DynamicPoolConfiguration: &armappcontainers.DynamicPoolConfiguration{
	// 					CooldownPeriodInSeconds: to.Ptr[int32](600),
	// 					ExecutionType: to.Ptr(armappcontainers.ExecutionTypeTimed),
	// 				},
	// 				EnvironmentID: to.Ptr("/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/rg/providers/Microsoft.App/managedEnvironments/demokube"),
	// 				NodeCount: to.Ptr[int32](1),
	// 				PoolManagementEndpoint: to.Ptr("https://testsessionpool.agreeableriver-3d30edf1.eastus.azurecontainerapps.io"),
	// 				PoolManagementType: to.Ptr(armappcontainers.PoolManagementTypeDynamic),
	// 				ProvisioningState: to.Ptr(armappcontainers.SessionPoolProvisioningStateSucceeded),
	// 				ScaleConfiguration: &armappcontainers.ScaleConfiguration{
	// 					MaxConcurrentSessions: to.Ptr[int32](500),
	// 					ReadySessionInstances: to.Ptr[int32](100),
	// 				},
	// 				SessionNetworkConfiguration: &armappcontainers.SessionNetworkConfiguration{
	// 					Status: to.Ptr(armappcontainers.SessionNetworkStatusEgressEnabled),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/366aaa13cdd218b9adac716680e49473673410c8/specification/app/resource-manager/Microsoft.App/preview/2024-08-02-preview/examples/SessionPools_Delete.json
func ExampleContainerAppsSessionPoolsClient_BeginDelete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armappcontainers.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewContainerAppsSessionPoolsClient().BeginDelete(ctx, "rg", "testsessionpool", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}
