//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armappcontainers

import "encoding/json"

func unmarshalJavaComponentPropertiesClassification(rawMsg json.RawMessage) (JavaComponentPropertiesClassification, error) {
	if rawMsg == nil || string(rawMsg) == "null" {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b JavaComponentPropertiesClassification
	switch m["componentType"] {
	case string(JavaComponentTypeNacos):
		b = &NacosComponent{}
	case string(JavaComponentTypeSpringBootAdmin):
		b = &SpringBootAdminComponent{}
	case string(JavaComponentTypeSpringCloudConfig):
		b = &SpringCloudConfigComponent{}
	case string(JavaComponentTypeSpringCloudEureka):
		b = &SpringCloudEurekaComponent{}
	case string(JavaComponentTypeSpringCloudGateway):
		b = &SpringCloudGatewayComponent{}
	default:
		b = &JavaComponentProperties{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}
