//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armapplicationinsights

// APIKeysClientCreateResponse contains the response from method APIKeysClient.Create.
type APIKeysClientCreateResponse struct {
	// Properties that define an API key of an Application Insights Component.
	ComponentAPIKey
}

// APIKeysClientDeleteResponse contains the response from method APIKeysClient.Delete.
type APIKeysClientDeleteResponse struct {
	// Properties that define an API key of an Application Insights Component.
	ComponentAPIKey
}

// APIKeysClientGetResponse contains the response from method APIKeysClient.Get.
type APIKeysClientGetResponse struct {
	// Properties that define an API key of an Application Insights Component.
	ComponentAPIKey
}

// APIKeysClientListResponse contains the response from method APIKeysClient.NewListPager.
type APIKeysClientListResponse struct {
	// Describes the list of API Keys of an Application Insights Component.
	ComponentAPIKeyListResult
}

// AnalyticsItemsClientDeleteResponse contains the response from method AnalyticsItemsClient.Delete.
type AnalyticsItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// AnalyticsItemsClientGetResponse contains the response from method AnalyticsItemsClient.Get.
type AnalyticsItemsClientGetResponse struct {
	// Properties that define an Analytics item that is associated to an Application Insights component.
	ComponentAnalyticsItem
}

// AnalyticsItemsClientListResponse contains the response from method AnalyticsItemsClient.List.
type AnalyticsItemsClientListResponse struct {
	// Array of ApplicationInsightsComponentAnalyticsItem
	ComponentAnalyticsItemArray []*ComponentAnalyticsItem
}

// AnalyticsItemsClientPutResponse contains the response from method AnalyticsItemsClient.Put.
type AnalyticsItemsClientPutResponse struct {
	// Properties that define an Analytics item that is associated to an Application Insights component.
	ComponentAnalyticsItem
}

// AnnotationsClientCreateResponse contains the response from method AnnotationsClient.Create.
type AnnotationsClientCreateResponse struct {
	// Array of Annotation
	AnnotationArray []*Annotation
}

// AnnotationsClientDeleteResponse contains the response from method AnnotationsClient.Delete.
type AnnotationsClientDeleteResponse struct {
	// placeholder for future response values
}

// AnnotationsClientGetResponse contains the response from method AnnotationsClient.Get.
type AnnotationsClientGetResponse struct {
	// Array of Annotation
	AnnotationArray []*Annotation
}

// AnnotationsClientListResponse contains the response from method AnnotationsClient.NewListPager.
type AnnotationsClientListResponse struct {
	// Annotations list result.
	AnnotationsListResult
}

// ComponentAvailableFeaturesClientGetResponse contains the response from method ComponentAvailableFeaturesClient.Get.
type ComponentAvailableFeaturesClientGetResponse struct {
	// An Application Insights component available features.
	ComponentAvailableFeatures
}

// ComponentCurrentBillingFeaturesClientGetResponse contains the response from method ComponentCurrentBillingFeaturesClient.Get.
type ComponentCurrentBillingFeaturesClientGetResponse struct {
	// An Application Insights component billing features
	ComponentBillingFeatures
}

// ComponentCurrentBillingFeaturesClientUpdateResponse contains the response from method ComponentCurrentBillingFeaturesClient.Update.
type ComponentCurrentBillingFeaturesClientUpdateResponse struct {
	// An Application Insights component billing features
	ComponentBillingFeatures
}

// ComponentFeatureCapabilitiesClientGetResponse contains the response from method ComponentFeatureCapabilitiesClient.Get.
type ComponentFeatureCapabilitiesClientGetResponse struct {
	// An Application Insights component feature capabilities
	ComponentFeatureCapabilities
}

// ComponentQuotaStatusClientGetResponse contains the response from method ComponentQuotaStatusClient.Get.
type ComponentQuotaStatusClientGetResponse struct {
	// An Application Insights component daily data volume cap status
	ComponentQuotaStatus
}

// ComponentsClientCreateOrUpdateResponse contains the response from method ComponentsClient.CreateOrUpdate.
type ComponentsClientCreateOrUpdateResponse struct {
	// An Application Insights component definition.
	Component
}

// ComponentsClientDeleteResponse contains the response from method ComponentsClient.Delete.
type ComponentsClientDeleteResponse struct {
	// placeholder for future response values
}

// ComponentsClientGetPurgeStatusResponse contains the response from method ComponentsClient.GetPurgeStatus.
type ComponentsClientGetPurgeStatusResponse struct {
	// Response containing status for a specific purge operation.
	ComponentPurgeStatusResponse
}

// ComponentsClientGetResponse contains the response from method ComponentsClient.Get.
type ComponentsClientGetResponse struct {
	// An Application Insights component definition.
	Component
}

// ComponentsClientListByResourceGroupResponse contains the response from method ComponentsClient.NewListByResourceGroupPager.
type ComponentsClientListByResourceGroupResponse struct {
	// Describes the list of Application Insights Resources.
	ComponentListResult
}

// ComponentsClientListResponse contains the response from method ComponentsClient.NewListPager.
type ComponentsClientListResponse struct {
	// Describes the list of Application Insights Resources.
	ComponentListResult
}

// ComponentsClientPurgeResponse contains the response from method ComponentsClient.Purge.
type ComponentsClientPurgeResponse struct {
	// Response containing operationId for a specific purge action.
	ComponentPurgeResponse
}

// ComponentsClientUpdateTagsResponse contains the response from method ComponentsClient.UpdateTags.
type ComponentsClientUpdateTagsResponse struct {
	// An Application Insights component definition.
	Component
}

// ExportConfigurationsClientCreateResponse contains the response from method ExportConfigurationsClient.Create.
type ExportConfigurationsClientCreateResponse struct {
	// A list of Continuous Export configurations.
	ComponentExportConfigurationArray []*ComponentExportConfiguration
}

// ExportConfigurationsClientDeleteResponse contains the response from method ExportConfigurationsClient.Delete.
type ExportConfigurationsClientDeleteResponse struct {
	// Properties that define a Continuous Export configuration.
	ComponentExportConfiguration
}

// ExportConfigurationsClientGetResponse contains the response from method ExportConfigurationsClient.Get.
type ExportConfigurationsClientGetResponse struct {
	// Properties that define a Continuous Export configuration.
	ComponentExportConfiguration
}

// ExportConfigurationsClientListResponse contains the response from method ExportConfigurationsClient.List.
type ExportConfigurationsClientListResponse struct {
	// A list of Continuous Export configurations.
	ComponentExportConfigurationArray []*ComponentExportConfiguration
}

// ExportConfigurationsClientUpdateResponse contains the response from method ExportConfigurationsClient.Update.
type ExportConfigurationsClientUpdateResponse struct {
	// Properties that define a Continuous Export configuration.
	ComponentExportConfiguration
}

// FavoritesClientAddResponse contains the response from method FavoritesClient.Add.
type FavoritesClientAddResponse struct {
	// Properties that define a favorite that is associated to an Application Insights component.
	ComponentFavorite
}

// FavoritesClientDeleteResponse contains the response from method FavoritesClient.Delete.
type FavoritesClientDeleteResponse struct {
	// placeholder for future response values
}

// FavoritesClientGetResponse contains the response from method FavoritesClient.Get.
type FavoritesClientGetResponse struct {
	// Properties that define a favorite that is associated to an Application Insights component.
	ComponentFavorite
}

// FavoritesClientListResponse contains the response from method FavoritesClient.List.
type FavoritesClientListResponse struct {
	// Array of ApplicationInsightsComponentFavorite
	ComponentFavoriteArray []*ComponentFavorite
}

// FavoritesClientUpdateResponse contains the response from method FavoritesClient.Update.
type FavoritesClientUpdateResponse struct {
	// Properties that define a favorite that is associated to an Application Insights component.
	ComponentFavorite
}

// MyWorkbooksClientCreateOrUpdateResponse contains the response from method MyWorkbooksClient.CreateOrUpdate.
type MyWorkbooksClientCreateOrUpdateResponse struct {
	// An Application Insights private workbook definition.
	MyWorkbook
}

// MyWorkbooksClientDeleteResponse contains the response from method MyWorkbooksClient.Delete.
type MyWorkbooksClientDeleteResponse struct {
	// placeholder for future response values
}

// MyWorkbooksClientGetResponse contains the response from method MyWorkbooksClient.Get.
type MyWorkbooksClientGetResponse struct {
	// An Application Insights private workbook definition.
	MyWorkbook
}

// MyWorkbooksClientListByResourceGroupResponse contains the response from method MyWorkbooksClient.NewListByResourceGroupPager.
type MyWorkbooksClientListByResourceGroupResponse struct {
	// Workbook list result.
	MyWorkbooksListResult
}

// MyWorkbooksClientListBySubscriptionResponse contains the response from method MyWorkbooksClient.NewListBySubscriptionPager.
type MyWorkbooksClientListBySubscriptionResponse struct {
	// Workbook list result.
	MyWorkbooksListResult
}

// MyWorkbooksClientUpdateResponse contains the response from method MyWorkbooksClient.Update.
type MyWorkbooksClientUpdateResponse struct {
	// An Application Insights private workbook definition.
	MyWorkbook
}

// ProactiveDetectionConfigurationsClientGetResponse contains the response from method ProactiveDetectionConfigurationsClient.Get.
type ProactiveDetectionConfigurationsClientGetResponse struct {
	// Properties that define a ProactiveDetection configuration.
	ComponentProactiveDetectionConfiguration
}

// ProactiveDetectionConfigurationsClientListResponse contains the response from method ProactiveDetectionConfigurationsClient.List.
type ProactiveDetectionConfigurationsClientListResponse struct {
	// A list of ProactiveDetection configurations.
	ComponentProactiveDetectionConfigurationArray []*ComponentProactiveDetectionConfiguration
}

// ProactiveDetectionConfigurationsClientUpdateResponse contains the response from method ProactiveDetectionConfigurationsClient.Update.
type ProactiveDetectionConfigurationsClientUpdateResponse struct {
	// Properties that define a ProactiveDetection configuration.
	ComponentProactiveDetectionConfiguration
}

// WebTestLocationsClientListResponse contains the response from method WebTestLocationsClient.NewListPager.
type WebTestLocationsClientListResponse struct {
	// Describes the list of web test locations available to an Application Insights Component.
	WebTestLocationsListResult
}

// WebTestsClientCreateOrUpdateResponse contains the response from method WebTestsClient.CreateOrUpdate.
type WebTestsClientCreateOrUpdateResponse struct {
	// An Application Insights web test definition.
	WebTest
}

// WebTestsClientDeleteResponse contains the response from method WebTestsClient.Delete.
type WebTestsClientDeleteResponse struct {
	// placeholder for future response values
}

// WebTestsClientGetResponse contains the response from method WebTestsClient.Get.
type WebTestsClientGetResponse struct {
	// An Application Insights web test definition.
	WebTest
}

// WebTestsClientListByComponentResponse contains the response from method WebTestsClient.NewListByComponentPager.
type WebTestsClientListByComponentResponse struct {
	// A list of 0 or more Application Insights web test definitions.
	WebTestListResult
}

// WebTestsClientListByResourceGroupResponse contains the response from method WebTestsClient.NewListByResourceGroupPager.
type WebTestsClientListByResourceGroupResponse struct {
	// A list of 0 or more Application Insights web test definitions.
	WebTestListResult
}

// WebTestsClientListResponse contains the response from method WebTestsClient.NewListPager.
type WebTestsClientListResponse struct {
	// A list of 0 or more Application Insights web test definitions.
	WebTestListResult
}

// WebTestsClientUpdateTagsResponse contains the response from method WebTestsClient.UpdateTags.
type WebTestsClientUpdateTagsResponse struct {
	// An Application Insights web test definition.
	WebTest
}

// WorkItemConfigurationsClientCreateResponse contains the response from method WorkItemConfigurationsClient.Create.
type WorkItemConfigurationsClientCreateResponse struct {
	// Work item configuration associated with an application insights resource.
	WorkItemConfiguration
}

// WorkItemConfigurationsClientDeleteResponse contains the response from method WorkItemConfigurationsClient.Delete.
type WorkItemConfigurationsClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkItemConfigurationsClientGetDefaultResponse contains the response from method WorkItemConfigurationsClient.GetDefault.
type WorkItemConfigurationsClientGetDefaultResponse struct {
	// Work item configuration associated with an application insights resource.
	WorkItemConfiguration
}

// WorkItemConfigurationsClientGetItemResponse contains the response from method WorkItemConfigurationsClient.GetItem.
type WorkItemConfigurationsClientGetItemResponse struct {
	// Work item configuration associated with an application insights resource.
	WorkItemConfiguration
}

// WorkItemConfigurationsClientListResponse contains the response from method WorkItemConfigurationsClient.NewListPager.
type WorkItemConfigurationsClientListResponse struct {
	// Work item configuration list result.
	WorkItemConfigurationsListResult
}

// WorkItemConfigurationsClientUpdateItemResponse contains the response from method WorkItemConfigurationsClient.UpdateItem.
type WorkItemConfigurationsClientUpdateItemResponse struct {
	// Work item configuration associated with an application insights resource.
	WorkItemConfiguration
}

// WorkbooksClientCreateOrUpdateResponse contains the response from method WorkbooksClient.CreateOrUpdate.
type WorkbooksClientCreateOrUpdateResponse struct {
	// An Application Insights workbook definition.
	Workbook
}

// WorkbooksClientDeleteResponse contains the response from method WorkbooksClient.Delete.
type WorkbooksClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkbooksClientGetResponse contains the response from method WorkbooksClient.Get.
type WorkbooksClientGetResponse struct {
	// An Application Insights workbook definition.
	Workbook
}

// WorkbooksClientListByResourceGroupResponse contains the response from method WorkbooksClient.NewListByResourceGroupPager.
type WorkbooksClientListByResourceGroupResponse struct {
	// Workbook list result.
	WorkbooksListResult
}

// WorkbooksClientUpdateResponse contains the response from method WorkbooksClient.Update.
type WorkbooksClientUpdateResponse struct {
	// An Application Insights workbook definition.
	Workbook
}
