//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armavs

// AddonsClientCreateOrUpdateResponse contains the response from method AddonsClient.BeginCreateOrUpdate.
type AddonsClientCreateOrUpdateResponse struct {
	// An addon resource
	Addon
}

// AddonsClientDeleteResponse contains the response from method AddonsClient.BeginDelete.
type AddonsClientDeleteResponse struct {
	// placeholder for future response values
}

// AddonsClientGetResponse contains the response from method AddonsClient.Get.
type AddonsClientGetResponse struct {
	// An addon resource
	Addon
}

// AddonsClientListResponse contains the response from method AddonsClient.NewListPager.
type AddonsClientListResponse struct {
	// The response of a Addon list operation.
	AddonList
}

// AuthorizationsClientCreateOrUpdateResponse contains the response from method AuthorizationsClient.BeginCreateOrUpdate.
type AuthorizationsClientCreateOrUpdateResponse struct {
	// ExpressRoute Circuit Authorization
	ExpressRouteAuthorization
}

// AuthorizationsClientDeleteResponse contains the response from method AuthorizationsClient.BeginDelete.
type AuthorizationsClientDeleteResponse struct {
	// placeholder for future response values
}

// AuthorizationsClientGetResponse contains the response from method AuthorizationsClient.Get.
type AuthorizationsClientGetResponse struct {
	// ExpressRoute Circuit Authorization
	ExpressRouteAuthorization
}

// AuthorizationsClientListResponse contains the response from method AuthorizationsClient.NewListPager.
type AuthorizationsClientListResponse struct {
	// The response of a ExpressRouteAuthorization list operation.
	ExpressRouteAuthorizationList
}

// CloudLinksClientCreateOrUpdateResponse contains the response from method CloudLinksClient.BeginCreateOrUpdate.
type CloudLinksClientCreateOrUpdateResponse struct {
	// A cloud link resource
	CloudLink
}

// CloudLinksClientDeleteResponse contains the response from method CloudLinksClient.BeginDelete.
type CloudLinksClientDeleteResponse struct {
	// placeholder for future response values
}

// CloudLinksClientGetResponse contains the response from method CloudLinksClient.Get.
type CloudLinksClientGetResponse struct {
	// A cloud link resource
	CloudLink
}

// CloudLinksClientListResponse contains the response from method CloudLinksClient.NewListPager.
type CloudLinksClientListResponse struct {
	// The response of a CloudLink list operation.
	CloudLinkList
}

// ClustersClientCreateOrUpdateResponse contains the response from method ClustersClient.BeginCreateOrUpdate.
type ClustersClientCreateOrUpdateResponse struct {
	// A cluster resource
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// A cluster resource
	Cluster
}

// ClustersClientListResponse contains the response from method ClustersClient.NewListPager.
type ClustersClientListResponse struct {
	// The response of a Cluster list operation.
	ClusterList
}

// ClustersClientListZonesResponse contains the response from method ClustersClient.ListZones.
type ClustersClientListZonesResponse struct {
	// List of all zones and associated hosts for a cluster
	ClusterZoneList
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.BeginUpdate.
type ClustersClientUpdateResponse struct {
	// A cluster resource
	Cluster
}

// DatastoresClientCreateOrUpdateResponse contains the response from method DatastoresClient.BeginCreateOrUpdate.
type DatastoresClientCreateOrUpdateResponse struct {
	// A datastore resource
	Datastore
}

// DatastoresClientDeleteResponse contains the response from method DatastoresClient.BeginDelete.
type DatastoresClientDeleteResponse struct {
	// placeholder for future response values
}

// DatastoresClientGetResponse contains the response from method DatastoresClient.Get.
type DatastoresClientGetResponse struct {
	// A datastore resource
	Datastore
}

// DatastoresClientListResponse contains the response from method DatastoresClient.NewListPager.
type DatastoresClientListResponse struct {
	// The response of a Datastore list operation.
	DatastoreList
}

// GlobalReachConnectionsClientCreateOrUpdateResponse contains the response from method GlobalReachConnectionsClient.BeginCreateOrUpdate.
type GlobalReachConnectionsClientCreateOrUpdateResponse struct {
	// A global reach connection resource
	GlobalReachConnection
}

// GlobalReachConnectionsClientDeleteResponse contains the response from method GlobalReachConnectionsClient.BeginDelete.
type GlobalReachConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// GlobalReachConnectionsClientGetResponse contains the response from method GlobalReachConnectionsClient.Get.
type GlobalReachConnectionsClientGetResponse struct {
	// A global reach connection resource
	GlobalReachConnection
}

// GlobalReachConnectionsClientListResponse contains the response from method GlobalReachConnectionsClient.NewListPager.
type GlobalReachConnectionsClientListResponse struct {
	// The response of a GlobalReachConnection list operation.
	GlobalReachConnectionList
}

// HcxEnterpriseSitesClientCreateOrUpdateResponse contains the response from method HcxEnterpriseSitesClient.CreateOrUpdate.
type HcxEnterpriseSitesClientCreateOrUpdateResponse struct {
	// An HCX Enterprise Site resource
	HcxEnterpriseSite
}

// HcxEnterpriseSitesClientDeleteResponse contains the response from method HcxEnterpriseSitesClient.Delete.
type HcxEnterpriseSitesClientDeleteResponse struct {
	// placeholder for future response values
}

// HcxEnterpriseSitesClientGetResponse contains the response from method HcxEnterpriseSitesClient.Get.
type HcxEnterpriseSitesClientGetResponse struct {
	// An HCX Enterprise Site resource
	HcxEnterpriseSite
}

// HcxEnterpriseSitesClientListResponse contains the response from method HcxEnterpriseSitesClient.NewListPager.
type HcxEnterpriseSitesClientListResponse struct {
	// The response of a HcxEnterpriseSite list operation.
	HcxEnterpriseSiteList
}

// IscsiPathsClientCreateOrUpdateResponse contains the response from method IscsiPathsClient.BeginCreateOrUpdate.
type IscsiPathsClientCreateOrUpdateResponse struct {
	// An iSCSI path resource
	IscsiPath
}

// IscsiPathsClientDeleteResponse contains the response from method IscsiPathsClient.BeginDelete.
type IscsiPathsClientDeleteResponse struct {
	// placeholder for future response values
}

// IscsiPathsClientGetResponse contains the response from method IscsiPathsClient.Get.
type IscsiPathsClientGetResponse struct {
	// An iSCSI path resource
	IscsiPath
}

// IscsiPathsClientListByPrivateCloudResponse contains the response from method IscsiPathsClient.NewListByPrivateCloudPager.
type IscsiPathsClientListByPrivateCloudResponse struct {
	// The response of a IscsiPath list operation.
	IscsiPathListResult
}

// LocationsClientCheckQuotaAvailabilityResponse contains the response from method LocationsClient.CheckQuotaAvailability.
type LocationsClientCheckQuotaAvailabilityResponse struct {
	// Subscription quotas
	Quota
}

// LocationsClientCheckTrialAvailabilityResponse contains the response from method LocationsClient.CheckTrialAvailability.
type LocationsClientCheckTrialAvailabilityResponse struct {
	// Subscription trial availability
	Trial
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PlacementPoliciesClientCreateOrUpdateResponse contains the response from method PlacementPoliciesClient.BeginCreateOrUpdate.
type PlacementPoliciesClientCreateOrUpdateResponse struct {
	// A vSphere Distributed Resource Scheduler (DRS) placement policy
	PlacementPolicy
}

// PlacementPoliciesClientDeleteResponse contains the response from method PlacementPoliciesClient.BeginDelete.
type PlacementPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// PlacementPoliciesClientGetResponse contains the response from method PlacementPoliciesClient.Get.
type PlacementPoliciesClientGetResponse struct {
	// A vSphere Distributed Resource Scheduler (DRS) placement policy
	PlacementPolicy
}

// PlacementPoliciesClientListResponse contains the response from method PlacementPoliciesClient.NewListPager.
type PlacementPoliciesClientListResponse struct {
	// The response of a PlacementPolicy list operation.
	PlacementPoliciesList
}

// PlacementPoliciesClientUpdateResponse contains the response from method PlacementPoliciesClient.BeginUpdate.
type PlacementPoliciesClientUpdateResponse struct {
	// A vSphere Distributed Resource Scheduler (DRS) placement policy
	PlacementPolicy
}

// PrivateCloudsClientCreateOrUpdateResponse contains the response from method PrivateCloudsClient.BeginCreateOrUpdate.
type PrivateCloudsClientCreateOrUpdateResponse struct {
	// A private cloud resource
	PrivateCloud
}

// PrivateCloudsClientDeleteResponse contains the response from method PrivateCloudsClient.BeginDelete.
type PrivateCloudsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateCloudsClientGetResponse contains the response from method PrivateCloudsClient.Get.
type PrivateCloudsClientGetResponse struct {
	// A private cloud resource
	PrivateCloud
}

// PrivateCloudsClientListAdminCredentialsResponse contains the response from method PrivateCloudsClient.ListAdminCredentials.
type PrivateCloudsClientListAdminCredentialsResponse struct {
	// Administrative credentials for accessing vCenter and NSX-T
	AdminCredentials
}

// PrivateCloudsClientListInSubscriptionResponse contains the response from method PrivateCloudsClient.NewListInSubscriptionPager.
type PrivateCloudsClientListInSubscriptionResponse struct {
	// The response of a PrivateCloud list operation.
	PrivateCloudList
}

// PrivateCloudsClientListResponse contains the response from method PrivateCloudsClient.NewListPager.
type PrivateCloudsClientListResponse struct {
	// The response of a PrivateCloud list operation.
	PrivateCloudList
}

// PrivateCloudsClientRotateNsxtPasswordResponse contains the response from method PrivateCloudsClient.BeginRotateNsxtPassword.
type PrivateCloudsClientRotateNsxtPasswordResponse struct {
	// placeholder for future response values
}

// PrivateCloudsClientRotateVcenterPasswordResponse contains the response from method PrivateCloudsClient.BeginRotateVcenterPassword.
type PrivateCloudsClientRotateVcenterPasswordResponse struct {
	// placeholder for future response values
}

// PrivateCloudsClientUpdateResponse contains the response from method PrivateCloudsClient.BeginUpdate.
type PrivateCloudsClientUpdateResponse struct {
	// A private cloud resource
	PrivateCloud
}

// ScriptCmdletsClientGetResponse contains the response from method ScriptCmdletsClient.Get.
type ScriptCmdletsClientGetResponse struct {
	// A cmdlet available for script execution
	ScriptCmdlet
}

// ScriptCmdletsClientListResponse contains the response from method ScriptCmdletsClient.NewListPager.
type ScriptCmdletsClientListResponse struct {
	// The response of a ScriptCmdlet list operation.
	ScriptCmdletsList
}

// ScriptExecutionsClientCreateOrUpdateResponse contains the response from method ScriptExecutionsClient.BeginCreateOrUpdate.
type ScriptExecutionsClientCreateOrUpdateResponse struct {
	// An instance of a script executed by a user - custom or AVS
	ScriptExecution
}

// ScriptExecutionsClientDeleteResponse contains the response from method ScriptExecutionsClient.BeginDelete.
type ScriptExecutionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ScriptExecutionsClientGetExecutionLogsResponse contains the response from method ScriptExecutionsClient.GetExecutionLogs.
type ScriptExecutionsClientGetExecutionLogsResponse struct {
	// An instance of a script executed by a user - custom or AVS
	ScriptExecution
}

// ScriptExecutionsClientGetResponse contains the response from method ScriptExecutionsClient.Get.
type ScriptExecutionsClientGetResponse struct {
	// An instance of a script executed by a user - custom or AVS
	ScriptExecution
}

// ScriptExecutionsClientListResponse contains the response from method ScriptExecutionsClient.NewListPager.
type ScriptExecutionsClientListResponse struct {
	// The response of a ScriptExecution list operation.
	ScriptExecutionsList
}

// ScriptPackagesClientGetResponse contains the response from method ScriptPackagesClient.Get.
type ScriptPackagesClientGetResponse struct {
	// Script Package resources available for execution
	ScriptPackage
}

// ScriptPackagesClientListResponse contains the response from method ScriptPackagesClient.NewListPager.
type ScriptPackagesClientListResponse struct {
	// The response of a ScriptPackage list operation.
	ScriptPackagesList
}

// VirtualMachinesClientGetResponse contains the response from method VirtualMachinesClient.Get.
type VirtualMachinesClientGetResponse struct {
	// Virtual Machine
	VirtualMachine
}

// VirtualMachinesClientListResponse contains the response from method VirtualMachinesClient.NewListPager.
type VirtualMachinesClientListResponse struct {
	// The response of a VirtualMachine list operation.
	VirtualMachinesList
}

// VirtualMachinesClientRestrictMovementResponse contains the response from method VirtualMachinesClient.BeginRestrictMovement.
type VirtualMachinesClientRestrictMovementResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientCreateDNSServiceResponse contains the response from method WorkloadNetworksClient.BeginCreateDNSService.
type WorkloadNetworksClientCreateDNSServiceResponse struct {
	// NSX DNS Service
	WorkloadNetworkDNSService
}

// WorkloadNetworksClientCreateDNSZoneResponse contains the response from method WorkloadNetworksClient.BeginCreateDNSZone.
type WorkloadNetworksClientCreateDNSZoneResponse struct {
	// NSX DNS Zone
	WorkloadNetworkDNSZone
}

// WorkloadNetworksClientCreateDhcpResponse contains the response from method WorkloadNetworksClient.BeginCreateDhcp.
type WorkloadNetworksClientCreateDhcpResponse struct {
	// NSX DHCP
	WorkloadNetworkDhcp
}

// WorkloadNetworksClientCreatePortMirroringResponse contains the response from method WorkloadNetworksClient.BeginCreatePortMirroring.
type WorkloadNetworksClientCreatePortMirroringResponse struct {
	// NSX Port Mirroring
	WorkloadNetworkPortMirroring
}

// WorkloadNetworksClientCreatePublicIPResponse contains the response from method WorkloadNetworksClient.BeginCreatePublicIP.
type WorkloadNetworksClientCreatePublicIPResponse struct {
	// NSX Public IP Block
	WorkloadNetworkPublicIP
}

// WorkloadNetworksClientCreateSegmentsResponse contains the response from method WorkloadNetworksClient.BeginCreateSegments.
type WorkloadNetworksClientCreateSegmentsResponse struct {
	// NSX Segment
	WorkloadNetworkSegment
}

// WorkloadNetworksClientCreateVMGroupResponse contains the response from method WorkloadNetworksClient.BeginCreateVMGroup.
type WorkloadNetworksClientCreateVMGroupResponse struct {
	// NSX VM Group
	WorkloadNetworkVMGroup
}

// WorkloadNetworksClientDeleteDNSServiceResponse contains the response from method WorkloadNetworksClient.BeginDeleteDNSService.
type WorkloadNetworksClientDeleteDNSServiceResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeleteDNSZoneResponse contains the response from method WorkloadNetworksClient.BeginDeleteDNSZone.
type WorkloadNetworksClientDeleteDNSZoneResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeleteDhcpResponse contains the response from method WorkloadNetworksClient.BeginDeleteDhcp.
type WorkloadNetworksClientDeleteDhcpResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeletePortMirroringResponse contains the response from method WorkloadNetworksClient.BeginDeletePortMirroring.
type WorkloadNetworksClientDeletePortMirroringResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeletePublicIPResponse contains the response from method WorkloadNetworksClient.BeginDeletePublicIP.
type WorkloadNetworksClientDeletePublicIPResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeleteSegmentResponse contains the response from method WorkloadNetworksClient.BeginDeleteSegment.
type WorkloadNetworksClientDeleteSegmentResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientDeleteVMGroupResponse contains the response from method WorkloadNetworksClient.BeginDeleteVMGroup.
type WorkloadNetworksClientDeleteVMGroupResponse struct {
	// placeholder for future response values
}

// WorkloadNetworksClientGetDNSServiceResponse contains the response from method WorkloadNetworksClient.GetDNSService.
type WorkloadNetworksClientGetDNSServiceResponse struct {
	// NSX DNS Service
	WorkloadNetworkDNSService
}

// WorkloadNetworksClientGetDNSZoneResponse contains the response from method WorkloadNetworksClient.GetDNSZone.
type WorkloadNetworksClientGetDNSZoneResponse struct {
	// NSX DNS Zone
	WorkloadNetworkDNSZone
}

// WorkloadNetworksClientGetDhcpResponse contains the response from method WorkloadNetworksClient.GetDhcp.
type WorkloadNetworksClientGetDhcpResponse struct {
	// NSX DHCP
	WorkloadNetworkDhcp
}

// WorkloadNetworksClientGetGatewayResponse contains the response from method WorkloadNetworksClient.GetGateway.
type WorkloadNetworksClientGetGatewayResponse struct {
	// NSX Gateway.
	WorkloadNetworkGateway
}

// WorkloadNetworksClientGetPortMirroringResponse contains the response from method WorkloadNetworksClient.GetPortMirroring.
type WorkloadNetworksClientGetPortMirroringResponse struct {
	// NSX Port Mirroring
	WorkloadNetworkPortMirroring
}

// WorkloadNetworksClientGetPublicIPResponse contains the response from method WorkloadNetworksClient.GetPublicIP.
type WorkloadNetworksClientGetPublicIPResponse struct {
	// NSX Public IP Block
	WorkloadNetworkPublicIP
}

// WorkloadNetworksClientGetResponse contains the response from method WorkloadNetworksClient.Get.
type WorkloadNetworksClientGetResponse struct {
	// Workload Network
	WorkloadNetwork
}

// WorkloadNetworksClientGetSegmentResponse contains the response from method WorkloadNetworksClient.GetSegment.
type WorkloadNetworksClientGetSegmentResponse struct {
	// NSX Segment
	WorkloadNetworkSegment
}

// WorkloadNetworksClientGetVMGroupResponse contains the response from method WorkloadNetworksClient.GetVMGroup.
type WorkloadNetworksClientGetVMGroupResponse struct {
	// NSX VM Group
	WorkloadNetworkVMGroup
}

// WorkloadNetworksClientGetVirtualMachineResponse contains the response from method WorkloadNetworksClient.GetVirtualMachine.
type WorkloadNetworksClientGetVirtualMachineResponse struct {
	// NSX Virtual Machine
	WorkloadNetworkVirtualMachine
}

// WorkloadNetworksClientListDNSServicesResponse contains the response from method WorkloadNetworksClient.NewListDNSServicesPager.
type WorkloadNetworksClientListDNSServicesResponse struct {
	// The response of a WorkloadNetworkDnsService list operation.
	WorkloadNetworkDNSServicesList
}

// WorkloadNetworksClientListDNSZonesResponse contains the response from method WorkloadNetworksClient.NewListDNSZonesPager.
type WorkloadNetworksClientListDNSZonesResponse struct {
	// The response of a WorkloadNetworkDnsZone list operation.
	WorkloadNetworkDNSZonesList
}

// WorkloadNetworksClientListDhcpResponse contains the response from method WorkloadNetworksClient.NewListDhcpPager.
type WorkloadNetworksClientListDhcpResponse struct {
	// The response of a WorkloadNetworkDhcp list operation.
	WorkloadNetworkDhcpList
}

// WorkloadNetworksClientListGatewaysResponse contains the response from method WorkloadNetworksClient.NewListGatewaysPager.
type WorkloadNetworksClientListGatewaysResponse struct {
	// The response of a WorkloadNetworkGateway list operation.
	WorkloadNetworkGatewayList
}

// WorkloadNetworksClientListPortMirroringResponse contains the response from method WorkloadNetworksClient.NewListPortMirroringPager.
type WorkloadNetworksClientListPortMirroringResponse struct {
	// The response of a WorkloadNetworkPortMirroring list operation.
	WorkloadNetworkPortMirroringList
}

// WorkloadNetworksClientListPublicIPsResponse contains the response from method WorkloadNetworksClient.NewListPublicIPsPager.
type WorkloadNetworksClientListPublicIPsResponse struct {
	// The response of a WorkloadNetworkPublicIP list operation.
	WorkloadNetworkPublicIPsList
}

// WorkloadNetworksClientListResponse contains the response from method WorkloadNetworksClient.NewListPager.
type WorkloadNetworksClientListResponse struct {
	// The response of a WorkloadNetwork list operation.
	WorkloadNetworkList
}

// WorkloadNetworksClientListSegmentsResponse contains the response from method WorkloadNetworksClient.NewListSegmentsPager.
type WorkloadNetworksClientListSegmentsResponse struct {
	// The response of a WorkloadNetworkSegment list operation.
	WorkloadNetworkSegmentsList
}

// WorkloadNetworksClientListVMGroupsResponse contains the response from method WorkloadNetworksClient.NewListVMGroupsPager.
type WorkloadNetworksClientListVMGroupsResponse struct {
	// The response of a WorkloadNetworkVMGroup list operation.
	WorkloadNetworkVMGroupsList
}

// WorkloadNetworksClientListVirtualMachinesResponse contains the response from method WorkloadNetworksClient.NewListVirtualMachinesPager.
type WorkloadNetworksClientListVirtualMachinesResponse struct {
	// The response of a WorkloadNetworkVirtualMachine list operation.
	WorkloadNetworkVirtualMachinesList
}

// WorkloadNetworksClientUpdateDNSServiceResponse contains the response from method WorkloadNetworksClient.BeginUpdateDNSService.
type WorkloadNetworksClientUpdateDNSServiceResponse struct {
	// NSX DNS Service
	WorkloadNetworkDNSService
}

// WorkloadNetworksClientUpdateDNSZoneResponse contains the response from method WorkloadNetworksClient.BeginUpdateDNSZone.
type WorkloadNetworksClientUpdateDNSZoneResponse struct {
	// NSX DNS Zone
	WorkloadNetworkDNSZone
}

// WorkloadNetworksClientUpdateDhcpResponse contains the response from method WorkloadNetworksClient.BeginUpdateDhcp.
type WorkloadNetworksClientUpdateDhcpResponse struct {
	// NSX DHCP
	WorkloadNetworkDhcp
}

// WorkloadNetworksClientUpdatePortMirroringResponse contains the response from method WorkloadNetworksClient.BeginUpdatePortMirroring.
type WorkloadNetworksClientUpdatePortMirroringResponse struct {
	// NSX Port Mirroring
	WorkloadNetworkPortMirroring
}

// WorkloadNetworksClientUpdateSegmentsResponse contains the response from method WorkloadNetworksClient.BeginUpdateSegments.
type WorkloadNetworksClientUpdateSegmentsResponse struct {
	// NSX Segment
	WorkloadNetworkSegment
}

// WorkloadNetworksClientUpdateVMGroupResponse contains the response from method WorkloadNetworksClient.BeginUpdateVMGroup.
type WorkloadNetworksClientUpdateVMGroupResponse struct {
	// NSX VM Group
	WorkloadNetworkVMGroup
}
