//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/azurestackhci/armazurestackhci/v2"
	"net/http"
	"net/url"
	"regexp"
)

// DeploymentSettingsServer is a fake server for instances of the armazurestackhci.DeploymentSettingsClient type.
type DeploymentSettingsServer struct {
	// BeginCreateOrUpdate is the fake for method DeploymentSettingsClient.BeginCreateOrUpdate
	// HTTP status codes to indicate success: http.StatusOK, http.StatusCreated
	BeginCreateOrUpdate func(ctx context.Context, resourceGroupName string, clusterName string, deploymentSettingsName string, resource armazurestackhci.DeploymentSetting, options *armazurestackhci.DeploymentSettingsClientBeginCreateOrUpdateOptions) (resp azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientCreateOrUpdateResponse], errResp azfake.ErrorResponder)

	// BeginDelete is the fake for method DeploymentSettingsClient.BeginDelete
	// HTTP status codes to indicate success: http.StatusAccepted, http.StatusNoContent
	BeginDelete func(ctx context.Context, resourceGroupName string, clusterName string, deploymentSettingsName string, options *armazurestackhci.DeploymentSettingsClientBeginDeleteOptions) (resp azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientDeleteResponse], errResp azfake.ErrorResponder)

	// Get is the fake for method DeploymentSettingsClient.Get
	// HTTP status codes to indicate success: http.StatusOK
	Get func(ctx context.Context, resourceGroupName string, clusterName string, deploymentSettingsName string, options *armazurestackhci.DeploymentSettingsClientGetOptions) (resp azfake.Responder[armazurestackhci.DeploymentSettingsClientGetResponse], errResp azfake.ErrorResponder)

	// NewListByClustersPager is the fake for method DeploymentSettingsClient.NewListByClustersPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListByClustersPager func(resourceGroupName string, clusterName string, options *armazurestackhci.DeploymentSettingsClientListByClustersOptions) (resp azfake.PagerResponder[armazurestackhci.DeploymentSettingsClientListByClustersResponse])
}

// NewDeploymentSettingsServerTransport creates a new instance of DeploymentSettingsServerTransport with the provided implementation.
// The returned DeploymentSettingsServerTransport instance is connected to an instance of armazurestackhci.DeploymentSettingsClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewDeploymentSettingsServerTransport(srv *DeploymentSettingsServer) *DeploymentSettingsServerTransport {
	return &DeploymentSettingsServerTransport{
		srv:                    srv,
		beginCreateOrUpdate:    newTracker[azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientCreateOrUpdateResponse]](),
		beginDelete:            newTracker[azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientDeleteResponse]](),
		newListByClustersPager: newTracker[azfake.PagerResponder[armazurestackhci.DeploymentSettingsClientListByClustersResponse]](),
	}
}

// DeploymentSettingsServerTransport connects instances of armazurestackhci.DeploymentSettingsClient to instances of DeploymentSettingsServer.
// Don't use this type directly, use NewDeploymentSettingsServerTransport instead.
type DeploymentSettingsServerTransport struct {
	srv                    *DeploymentSettingsServer
	beginCreateOrUpdate    *tracker[azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientCreateOrUpdateResponse]]
	beginDelete            *tracker[azfake.PollerResponder[armazurestackhci.DeploymentSettingsClientDeleteResponse]]
	newListByClustersPager *tracker[azfake.PagerResponder[armazurestackhci.DeploymentSettingsClientListByClustersResponse]]
}

// Do implements the policy.Transporter interface for DeploymentSettingsServerTransport.
func (d *DeploymentSettingsServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "DeploymentSettingsClient.BeginCreateOrUpdate":
		resp, err = d.dispatchBeginCreateOrUpdate(req)
	case "DeploymentSettingsClient.BeginDelete":
		resp, err = d.dispatchBeginDelete(req)
	case "DeploymentSettingsClient.Get":
		resp, err = d.dispatchGet(req)
	case "DeploymentSettingsClient.NewListByClustersPager":
		resp, err = d.dispatchNewListByClustersPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (d *DeploymentSettingsServerTransport) dispatchBeginCreateOrUpdate(req *http.Request) (*http.Response, error) {
	if d.srv.BeginCreateOrUpdate == nil {
		return nil, &nonRetriableError{errors.New("fake for method BeginCreateOrUpdate not implemented")}
	}
	beginCreateOrUpdate := d.beginCreateOrUpdate.get(req)
	if beginCreateOrUpdate == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.AzureStackHCI/clusters/(?P<clusterName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/deploymentSettings/(?P<deploymentSettingsName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 4 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		body, err := server.UnmarshalRequestAsJSON[armazurestackhci.DeploymentSetting](req)
		if err != nil {
			return nil, err
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		clusterNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterName")])
		if err != nil {
			return nil, err
		}
		deploymentSettingsNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("deploymentSettingsName")])
		if err != nil {
			return nil, err
		}
		respr, errRespr := d.srv.BeginCreateOrUpdate(req.Context(), resourceGroupNameParam, clusterNameParam, deploymentSettingsNameParam, body, nil)
		if respErr := server.GetError(errRespr, req); respErr != nil {
			return nil, respErr
		}
		beginCreateOrUpdate = &respr
		d.beginCreateOrUpdate.add(req, beginCreateOrUpdate)
	}

	resp, err := server.PollerResponderNext(beginCreateOrUpdate, req)
	if err != nil {
		return nil, err
	}

	if !contains([]int{http.StatusOK, http.StatusCreated}, resp.StatusCode) {
		d.beginCreateOrUpdate.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK, http.StatusCreated", resp.StatusCode)}
	}
	if !server.PollerResponderMore(beginCreateOrUpdate) {
		d.beginCreateOrUpdate.remove(req)
	}

	return resp, nil
}

func (d *DeploymentSettingsServerTransport) dispatchBeginDelete(req *http.Request) (*http.Response, error) {
	if d.srv.BeginDelete == nil {
		return nil, &nonRetriableError{errors.New("fake for method BeginDelete not implemented")}
	}
	beginDelete := d.beginDelete.get(req)
	if beginDelete == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.AzureStackHCI/clusters/(?P<clusterName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/deploymentSettings/(?P<deploymentSettingsName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 4 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		clusterNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterName")])
		if err != nil {
			return nil, err
		}
		deploymentSettingsNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("deploymentSettingsName")])
		if err != nil {
			return nil, err
		}
		respr, errRespr := d.srv.BeginDelete(req.Context(), resourceGroupNameParam, clusterNameParam, deploymentSettingsNameParam, nil)
		if respErr := server.GetError(errRespr, req); respErr != nil {
			return nil, respErr
		}
		beginDelete = &respr
		d.beginDelete.add(req, beginDelete)
	}

	resp, err := server.PollerResponderNext(beginDelete, req)
	if err != nil {
		return nil, err
	}

	if !contains([]int{http.StatusAccepted, http.StatusNoContent}, resp.StatusCode) {
		d.beginDelete.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusAccepted, http.StatusNoContent", resp.StatusCode)}
	}
	if !server.PollerResponderMore(beginDelete) {
		d.beginDelete.remove(req)
	}

	return resp, nil
}

func (d *DeploymentSettingsServerTransport) dispatchGet(req *http.Request) (*http.Response, error) {
	if d.srv.Get == nil {
		return nil, &nonRetriableError{errors.New("fake for method Get not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.AzureStackHCI/clusters/(?P<clusterName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/deploymentSettings/(?P<deploymentSettingsName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 4 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	clusterNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterName")])
	if err != nil {
		return nil, err
	}
	deploymentSettingsNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("deploymentSettingsName")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := d.srv.Get(req.Context(), resourceGroupNameParam, clusterNameParam, deploymentSettingsNameParam, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).DeploymentSetting, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

func (d *DeploymentSettingsServerTransport) dispatchNewListByClustersPager(req *http.Request) (*http.Response, error) {
	if d.srv.NewListByClustersPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListByClustersPager not implemented")}
	}
	newListByClustersPager := d.newListByClustersPager.get(req)
	if newListByClustersPager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.AzureStackHCI/clusters/(?P<clusterName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/deploymentSettings`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 3 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		clusterNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterName")])
		if err != nil {
			return nil, err
		}
		resp := d.srv.NewListByClustersPager(resourceGroupNameParam, clusterNameParam, nil)
		newListByClustersPager = &resp
		d.newListByClustersPager.add(req, newListByClustersPager)
		server.PagerResponderInjectNextLinks(newListByClustersPager, req, func(page *armazurestackhci.DeploymentSettingsClientListByClustersResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListByClustersPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		d.newListByClustersPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListByClustersPager) {
		d.newListByClustersPager.remove(req)
	}
	return resp, nil
}
