//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armbilling

// AccountsClientAddPaymentTermsResponse contains the response from method AccountsClient.BeginAddPaymentTerms.
type AccountsClientAddPaymentTermsResponse struct {
	// A billing account.
	Account
}

// AccountsClientCancelPaymentTermsResponse contains the response from method AccountsClient.BeginCancelPaymentTerms.
type AccountsClientCancelPaymentTermsResponse struct {
	// A billing account.
	Account
}

// AccountsClientConfirmTransitionResponse contains the response from method AccountsClient.ConfirmTransition.
type AccountsClientConfirmTransitionResponse struct {
	// The details for a billing account transitioned from agreement type Microsoft Online Services Program to agreement type
	// Microsoft Customer Agreement.
	TransitionDetails
}

// AccountsClientGetResponse contains the response from method AccountsClient.Get.
type AccountsClientGetResponse struct {
	// A billing account.
	Account
}

// AccountsClientListInvoiceSectionsByCreateSubscriptionPermissionResponse contains the response from method AccountsClient.NewListInvoiceSectionsByCreateSubscriptionPermissionPager.
type AccountsClientListInvoiceSectionsByCreateSubscriptionPermissionResponse struct {
	// A container for a list of resources
	InvoiceSectionWithCreateSubPermissionListResult
}

// AccountsClientListResponse contains the response from method AccountsClient.NewListPager.
type AccountsClientListResponse struct {
	// A container for a list of resources
	AccountListResult
}

// AccountsClientUpdateResponse contains the response from method AccountsClient.BeginUpdate.
type AccountsClientUpdateResponse struct {
	// A billing account.
	Account
}

// AccountsClientValidatePaymentTermsResponse contains the response from method AccountsClient.ValidatePaymentTerms.
type AccountsClientValidatePaymentTermsResponse struct {
	// Result of the payment terms eligibility.
	PaymentTermsEligibilityResult
}

// AddressClientValidateResponse contains the response from method AddressClient.Validate.
type AddressClientValidateResponse struct {
	// Result of the address validation.
	AddressValidationResponse
}

// AgreementsClientGetResponse contains the response from method AgreementsClient.Get.
type AgreementsClientGetResponse struct {
	// An agreement.
	Agreement
}

// AgreementsClientListByBillingAccountResponse contains the response from method AgreementsClient.NewListByBillingAccountPager.
type AgreementsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	AgreementListResult
}

// AssociatedTenantsClientCreateOrUpdateResponse contains the response from method AssociatedTenantsClient.BeginCreateOrUpdate.
type AssociatedTenantsClientCreateOrUpdateResponse struct {
	// An associated tenant.
	AssociatedTenant
}

// AssociatedTenantsClientDeleteResponse contains the response from method AssociatedTenantsClient.BeginDelete.
type AssociatedTenantsClientDeleteResponse struct {
	// placeholder for future response values
}

// AssociatedTenantsClientGetResponse contains the response from method AssociatedTenantsClient.Get.
type AssociatedTenantsClientGetResponse struct {
	// An associated tenant.
	AssociatedTenant
}

// AssociatedTenantsClientListByBillingAccountResponse contains the response from method AssociatedTenantsClient.NewListByBillingAccountPager.
type AssociatedTenantsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	AssociatedTenantListResult
}

// AvailableBalancesClientGetByBillingAccountResponse contains the response from method AvailableBalancesClient.GetByBillingAccount.
type AvailableBalancesClientGetByBillingAccountResponse struct {
	// The Available Credit or Payment on Account Balance. The credit balance can be used to settle due or past due invoices.
	AvailableBalance
}

// AvailableBalancesClientGetByBillingProfileResponse contains the response from method AvailableBalancesClient.GetByBillingProfile.
type AvailableBalancesClientGetByBillingProfileResponse struct {
	// The Available Credit or Payment on Account Balance. The credit balance can be used to settle due or past due invoices.
	AvailableBalance
}

// CustomersClientGetByBillingAccountResponse contains the response from method CustomersClient.GetByBillingAccount.
type CustomersClientGetByBillingAccountResponse struct {
	// A partner's customer.
	Customer
}

// CustomersClientGetResponse contains the response from method CustomersClient.Get.
type CustomersClientGetResponse struct {
	// A partner's customer.
	Customer
}

// CustomersClientListByBillingAccountResponse contains the response from method CustomersClient.NewListByBillingAccountPager.
type CustomersClientListByBillingAccountResponse struct {
	// A container for a list of resources
	CustomerListResult
}

// CustomersClientListByBillingProfileResponse contains the response from method CustomersClient.NewListByBillingProfilePager.
type CustomersClientListByBillingProfileResponse struct {
	// A container for a list of resources
	CustomerListResult
}

// DepartmentsClientGetResponse contains the response from method DepartmentsClient.Get.
type DepartmentsClientGetResponse struct {
	// Optional grouping of enrollment accounts to segment costs into logical groupings and set budgets.
	Department
}

// DepartmentsClientListByBillingAccountResponse contains the response from method DepartmentsClient.NewListByBillingAccountPager.
type DepartmentsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	DepartmentListResult
}

// EnrollmentAccountsClientGetByDepartmentResponse contains the response from method EnrollmentAccountsClient.GetByDepartment.
type EnrollmentAccountsClientGetByDepartmentResponse struct {
	// It is an organizational hierarchy within a billing account to administer and manage azure costs.
	EnrollmentAccount
}

// EnrollmentAccountsClientGetResponse contains the response from method EnrollmentAccountsClient.Get.
type EnrollmentAccountsClientGetResponse struct {
	// It is an organizational hierarchy within a billing account to administer and manage azure costs.
	EnrollmentAccount
}

// EnrollmentAccountsClientListByBillingAccountResponse contains the response from method EnrollmentAccountsClient.NewListByBillingAccountPager.
type EnrollmentAccountsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	EnrollmentAccountListResult
}

// EnrollmentAccountsClientListByDepartmentResponse contains the response from method EnrollmentAccountsClient.NewListByDepartmentPager.
type EnrollmentAccountsClientListByDepartmentResponse struct {
	// A container for a list of resources
	EnrollmentAccountListResult
}

// InvoiceSectionsClientCreateOrUpdateResponse contains the response from method InvoiceSectionsClient.BeginCreateOrUpdate.
type InvoiceSectionsClientCreateOrUpdateResponse struct {
	// An invoice section.
	InvoiceSection
}

// InvoiceSectionsClientDeleteResponse contains the response from method InvoiceSectionsClient.BeginDelete.
type InvoiceSectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// InvoiceSectionsClientGetResponse contains the response from method InvoiceSectionsClient.Get.
type InvoiceSectionsClientGetResponse struct {
	// An invoice section.
	InvoiceSection
}

// InvoiceSectionsClientListByBillingProfileResponse contains the response from method InvoiceSectionsClient.NewListByBillingProfilePager.
type InvoiceSectionsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	InvoiceSectionListResult
}

// InvoiceSectionsClientValidateDeleteEligibilityResponse contains the response from method InvoiceSectionsClient.ValidateDeleteEligibility.
type InvoiceSectionsClientValidateDeleteEligibilityResponse struct {
	// Eligibility to delete an invoice section result.
	DeleteInvoiceSectionEligibilityResult
}

// InvoicesClientAmendResponse contains the response from method InvoicesClient.BeginAmend.
type InvoicesClientAmendResponse struct {
	// placeholder for future response values
}

// InvoicesClientDownloadByBillingAccountResponse contains the response from method InvoicesClient.BeginDownloadByBillingAccount.
type InvoicesClientDownloadByBillingAccountResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// InvoicesClientDownloadByBillingSubscriptionResponse contains the response from method InvoicesClient.BeginDownloadByBillingSubscription.
type InvoicesClientDownloadByBillingSubscriptionResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// InvoicesClientDownloadDocumentsByBillingAccountResponse contains the response from method InvoicesClient.BeginDownloadDocumentsByBillingAccount.
type InvoicesClientDownloadDocumentsByBillingAccountResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// InvoicesClientDownloadDocumentsByBillingSubscriptionResponse contains the response from method InvoicesClient.BeginDownloadDocumentsByBillingSubscription.
type InvoicesClientDownloadDocumentsByBillingSubscriptionResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// InvoicesClientDownloadSummaryByBillingAccountResponse contains the response from method InvoicesClient.BeginDownloadSummaryByBillingAccount.
type InvoicesClientDownloadSummaryByBillingAccountResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// InvoicesClientGetByBillingAccountResponse contains the response from method InvoicesClient.GetByBillingAccount.
type InvoicesClientGetByBillingAccountResponse struct {
	// An invoice.
	Invoice
}

// InvoicesClientGetByBillingSubscriptionResponse contains the response from method InvoicesClient.GetByBillingSubscription.
type InvoicesClientGetByBillingSubscriptionResponse struct {
	// An invoice.
	Invoice
}

// InvoicesClientGetResponse contains the response from method InvoicesClient.Get.
type InvoicesClientGetResponse struct {
	// An invoice.
	Invoice
}

// InvoicesClientListByBillingAccountResponse contains the response from method InvoicesClient.NewListByBillingAccountPager.
type InvoicesClientListByBillingAccountResponse struct {
	// A container for a list of resources
	InvoiceListResult
}

// InvoicesClientListByBillingProfileResponse contains the response from method InvoicesClient.NewListByBillingProfilePager.
type InvoicesClientListByBillingProfileResponse struct {
	// A container for a list of resources
	InvoiceListResult
}

// InvoicesClientListByBillingSubscriptionResponse contains the response from method InvoicesClient.NewListByBillingSubscriptionPager.
type InvoicesClientListByBillingSubscriptionResponse struct {
	// A container for a list of resources
	InvoiceListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A container for a list of resources
	OperationListResult
}

// PartnerTransfersClientCancelResponse contains the response from method PartnerTransfersClient.Cancel.
type PartnerTransfersClientCancelResponse struct {
	// Details of the transfer.
	PartnerTransferDetails
}

// PartnerTransfersClientGetResponse contains the response from method PartnerTransfersClient.Get.
type PartnerTransfersClientGetResponse struct {
	// Details of the transfer.
	PartnerTransferDetails
}

// PartnerTransfersClientInitiateResponse contains the response from method PartnerTransfersClient.Initiate.
type PartnerTransfersClientInitiateResponse struct {
	// Details of the transfer.
	PartnerTransferDetails
}

// PartnerTransfersClientListResponse contains the response from method PartnerTransfersClient.NewListPager.
type PartnerTransfersClientListResponse struct {
	// The list of transfers initiated by partner.
	PartnerTransferDetailsListResult
}

// PaymentMethodsClientDeleteByUserResponse contains the response from method PaymentMethodsClient.DeleteByUser.
type PaymentMethodsClientDeleteByUserResponse struct {
	// placeholder for future response values
}

// PaymentMethodsClientGetByBillingAccountResponse contains the response from method PaymentMethodsClient.GetByBillingAccount.
type PaymentMethodsClientGetByBillingAccountResponse struct {
	// A payment method.
	PaymentMethod
}

// PaymentMethodsClientGetByBillingProfileResponse contains the response from method PaymentMethodsClient.GetByBillingProfile.
type PaymentMethodsClientGetByBillingProfileResponse struct {
	// A payment method link.
	PaymentMethodLink
}

// PaymentMethodsClientGetByUserResponse contains the response from method PaymentMethodsClient.GetByUser.
type PaymentMethodsClientGetByUserResponse struct {
	// A payment method.
	PaymentMethod
}

// PaymentMethodsClientListByBillingAccountResponse contains the response from method PaymentMethodsClient.NewListByBillingAccountPager.
type PaymentMethodsClientListByBillingAccountResponse struct {
	// The list of payment methods.
	PaymentMethodsListResult
}

// PaymentMethodsClientListByBillingProfileResponse contains the response from method PaymentMethodsClient.NewListByBillingProfilePager.
type PaymentMethodsClientListByBillingProfileResponse struct {
	// The list of payment method links.
	PaymentMethodLinksListResult
}

// PaymentMethodsClientListByUserResponse contains the response from method PaymentMethodsClient.NewListByUserPager.
type PaymentMethodsClientListByUserResponse struct {
	// The list of payment methods.
	PaymentMethodsListResult
}

// PermissionsClientCheckAccessByBillingAccountResponse contains the response from method PermissionsClient.CheckAccessByBillingAccount.
type PermissionsClientCheckAccessByBillingAccountResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientCheckAccessByBillingProfileResponse contains the response from method PermissionsClient.CheckAccessByBillingProfile.
type PermissionsClientCheckAccessByBillingProfileResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientCheckAccessByCustomerResponse contains the response from method PermissionsClient.CheckAccessByCustomer.
type PermissionsClientCheckAccessByCustomerResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientCheckAccessByDepartmentResponse contains the response from method PermissionsClient.CheckAccessByDepartment.
type PermissionsClientCheckAccessByDepartmentResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientCheckAccessByEnrollmentAccountResponse contains the response from method PermissionsClient.CheckAccessByEnrollmentAccount.
type PermissionsClientCheckAccessByEnrollmentAccountResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientCheckAccessByInvoiceSectionResponse contains the response from method PermissionsClient.CheckAccessByInvoiceSection.
type PermissionsClientCheckAccessByInvoiceSectionResponse struct {
	// Array of CheckAccessResponse
	CheckAccessResponseArray []*CheckAccessResponse
}

// PermissionsClientListByBillingAccountResponse contains the response from method PermissionsClient.NewListByBillingAccountPager.
type PermissionsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByBillingProfileResponse contains the response from method PermissionsClient.NewListByBillingProfilePager.
type PermissionsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByCustomerAtBillingAccountResponse contains the response from method PermissionsClient.NewListByCustomerAtBillingAccountPager.
type PermissionsClientListByCustomerAtBillingAccountResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByCustomerResponse contains the response from method PermissionsClient.NewListByCustomerPager.
type PermissionsClientListByCustomerResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByDepartmentResponse contains the response from method PermissionsClient.NewListByDepartmentPager.
type PermissionsClientListByDepartmentResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByEnrollmentAccountResponse contains the response from method PermissionsClient.NewListByEnrollmentAccountPager.
type PermissionsClientListByEnrollmentAccountResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PermissionsClientListByInvoiceSectionResponse contains the response from method PermissionsClient.NewListByInvoiceSectionPager.
type PermissionsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	PermissionListResult
}

// PoliciesClientCreateOrUpdateByBillingAccountResponse contains the response from method PoliciesClient.BeginCreateOrUpdateByBillingAccount.
type PoliciesClientCreateOrUpdateByBillingAccountResponse struct {
	// A policy at billing account scope.
	AccountPolicy
}

// PoliciesClientCreateOrUpdateByBillingProfileResponse contains the response from method PoliciesClient.BeginCreateOrUpdateByBillingProfile.
type PoliciesClientCreateOrUpdateByBillingProfileResponse struct {
	// A policy at billing profile scope.
	ProfilePolicy
}

// PoliciesClientCreateOrUpdateByCustomerAtBillingAccountResponse contains the response from method PoliciesClient.BeginCreateOrUpdateByCustomerAtBillingAccount.
type PoliciesClientCreateOrUpdateByCustomerAtBillingAccountResponse struct {
	// A policy at customer scope.
	CustomerPolicy
}

// PoliciesClientCreateOrUpdateByCustomerResponse contains the response from method PoliciesClient.BeginCreateOrUpdateByCustomer.
type PoliciesClientCreateOrUpdateByCustomerResponse struct {
	// A policy at customer scope.
	CustomerPolicy
}

// PoliciesClientGetByBillingAccountResponse contains the response from method PoliciesClient.GetByBillingAccount.
type PoliciesClientGetByBillingAccountResponse struct {
	// A policy at billing account scope.
	AccountPolicy
}

// PoliciesClientGetByBillingProfileResponse contains the response from method PoliciesClient.GetByBillingProfile.
type PoliciesClientGetByBillingProfileResponse struct {
	// A policy at billing profile scope.
	ProfilePolicy
}

// PoliciesClientGetByCustomerAtBillingAccountResponse contains the response from method PoliciesClient.GetByCustomerAtBillingAccount.
type PoliciesClientGetByCustomerAtBillingAccountResponse struct {
	// A policy at customer scope.
	CustomerPolicy
}

// PoliciesClientGetByCustomerResponse contains the response from method PoliciesClient.GetByCustomer.
type PoliciesClientGetByCustomerResponse struct {
	// A policy at customer scope.
	CustomerPolicy
}

// PoliciesClientGetBySubscriptionResponse contains the response from method PoliciesClient.GetBySubscription.
type PoliciesClientGetBySubscriptionResponse struct {
	// A policy at subscription scope.
	SubscriptionPolicy
}

// ProductsClientGetResponse contains the response from method ProductsClient.Get.
type ProductsClientGetResponse struct {
	// A product.
	Product
}

// ProductsClientListByBillingAccountResponse contains the response from method ProductsClient.NewListByBillingAccountPager.
type ProductsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	ProductListResult
}

// ProductsClientListByBillingProfileResponse contains the response from method ProductsClient.NewListByBillingProfilePager.
type ProductsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	ProductListResult
}

// ProductsClientListByCustomerResponse contains the response from method ProductsClient.NewListByCustomerPager.
type ProductsClientListByCustomerResponse struct {
	// A container for a list of resources
	ProductListResult
}

// ProductsClientListByInvoiceSectionResponse contains the response from method ProductsClient.NewListByInvoiceSectionPager.
type ProductsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	ProductListResult
}

// ProductsClientMoveResponse contains the response from method ProductsClient.BeginMove.
type ProductsClientMoveResponse struct {
	// A product.
	Product
}

// ProductsClientUpdateResponse contains the response from method ProductsClient.Update.
type ProductsClientUpdateResponse struct {
	// A product.
	Product
}

// ProductsClientValidateMoveEligibilityResponse contains the response from method ProductsClient.ValidateMoveEligibility.
type ProductsClientValidateMoveEligibilityResponse struct {
	// Result of the transfer eligibility validation.
	MoveProductEligibilityResult
}

// ProfilesClientCreateOrUpdateResponse contains the response from method ProfilesClient.BeginCreateOrUpdate.
type ProfilesClientCreateOrUpdateResponse struct {
	// A billing profile.
	Profile
}

// ProfilesClientDeleteResponse contains the response from method ProfilesClient.BeginDelete.
type ProfilesClientDeleteResponse struct {
	// placeholder for future response values
}

// ProfilesClientGetResponse contains the response from method ProfilesClient.Get.
type ProfilesClientGetResponse struct {
	// A billing profile.
	Profile
}

// ProfilesClientListByBillingAccountResponse contains the response from method ProfilesClient.NewListByBillingAccountPager.
type ProfilesClientListByBillingAccountResponse struct {
	// A container for a list of resources
	ProfileListResult
}

// ProfilesClientValidateDeleteEligibilityResponse contains the response from method ProfilesClient.ValidateDeleteEligibility.
type ProfilesClientValidateDeleteEligibilityResponse struct {
	// Eligibility to delete a billing profile result.
	DeleteBillingProfileEligibilityResult
}

// PropertyClientGetResponse contains the response from method PropertyClient.Get.
type PropertyClientGetResponse struct {
	// A billing property.
	Property
}

// PropertyClientUpdateResponse contains the response from method PropertyClient.Update.
type PropertyClientUpdateResponse struct {
	// A billing property.
	Property
}

// RecipientTransfersClientAcceptResponse contains the response from method RecipientTransfersClient.Accept.
type RecipientTransfersClientAcceptResponse struct {
	// Details of the transfer.
	RecipientTransferDetails
}

// RecipientTransfersClientDeclineResponse contains the response from method RecipientTransfersClient.Decline.
type RecipientTransfersClientDeclineResponse struct {
	// Details of the transfer.
	RecipientTransferDetails
}

// RecipientTransfersClientGetResponse contains the response from method RecipientTransfersClient.Get.
type RecipientTransfersClientGetResponse struct {
	// Details of the transfer.
	RecipientTransferDetails
}

// RecipientTransfersClientListResponse contains the response from method RecipientTransfersClient.NewListPager.
type RecipientTransfersClientListResponse struct {
	// The list of transfers received by caller.
	RecipientTransferDetailsListResult
}

// RecipientTransfersClientValidateResponse contains the response from method RecipientTransfersClient.Validate.
type RecipientTransfersClientValidateResponse struct {
	// Result of transfer validation.
	ValidateTransferListResponse
}

// RequestsClientCreateOrUpdateResponse contains the response from method RequestsClient.BeginCreateOrUpdate.
type RequestsClientCreateOrUpdateResponse struct {
	// A request submitted by a user to manage billing. Users with an owner role on the scope can approve or decline these requests.
	Request
}

// RequestsClientGetResponse contains the response from method RequestsClient.Get.
type RequestsClientGetResponse struct {
	// A request submitted by a user to manage billing. Users with an owner role on the scope can approve or decline these requests.
	Request
}

// RequestsClientListByBillingAccountResponse contains the response from method RequestsClient.NewListByBillingAccountPager.
type RequestsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	RequestListResult
}

// RequestsClientListByBillingProfileResponse contains the response from method RequestsClient.NewListByBillingProfilePager.
type RequestsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	RequestListResult
}

// RequestsClientListByCustomerResponse contains the response from method RequestsClient.NewListByCustomerPager.
type RequestsClientListByCustomerResponse struct {
	// A container for a list of resources
	RequestListResult
}

// RequestsClientListByInvoiceSectionResponse contains the response from method RequestsClient.NewListByInvoiceSectionPager.
type RequestsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	RequestListResult
}

// RequestsClientListByUserResponse contains the response from method RequestsClient.NewListByUserPager.
type RequestsClientListByUserResponse struct {
	// A container for a list of resources
	RequestListResult
}

// ReservationOrdersClientGetByBillingAccountResponse contains the response from method ReservationOrdersClient.GetByBillingAccount.
type ReservationOrdersClientGetByBillingAccountResponse struct {
	// Details of a reservation order being returned.
	ReservationOrder
}

// ReservationOrdersClientListByBillingAccountResponse contains the response from method ReservationOrdersClient.NewListByBillingAccountPager.
type ReservationOrdersClientListByBillingAccountResponse struct {
	// List of ReservationOrders
	ReservationOrderList
}

// ReservationsClientGetByReservationOrderResponse contains the response from method ReservationsClient.GetByReservationOrder.
type ReservationsClientGetByReservationOrderResponse struct {
	// The definition of the reservation.
	Reservation
}

// ReservationsClientListByBillingAccountResponse contains the response from method ReservationsClient.NewListByBillingAccountPager.
type ReservationsClientListByBillingAccountResponse struct {
	// The list of reservations and summary of roll out count of reservations in each state.
	ReservationsListResult
}

// ReservationsClientListByBillingProfileResponse contains the response from method ReservationsClient.NewListByBillingProfilePager.
type ReservationsClientListByBillingProfileResponse struct {
	// The list of reservations and summary of roll out count of reservations in each state.
	ReservationsListResult
}

// ReservationsClientListByReservationOrderResponse contains the response from method ReservationsClient.NewListByReservationOrderPager.
type ReservationsClientListByReservationOrderResponse struct {
	// List of `Reservations
	ReservationList
}

// ReservationsClientUpdateByBillingAccountResponse contains the response from method ReservationsClient.BeginUpdateByBillingAccount.
type ReservationsClientUpdateByBillingAccountResponse struct {
	// The definition of the reservation.
	Reservation
}

// RoleAssignmentsClientCreateByBillingAccountResponse contains the response from method RoleAssignmentsClient.BeginCreateByBillingAccount.
type RoleAssignmentsClientCreateByBillingAccountResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateByBillingProfileResponse contains the response from method RoleAssignmentsClient.BeginCreateByBillingProfile.
type RoleAssignmentsClientCreateByBillingProfileResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateByCustomerResponse contains the response from method RoleAssignmentsClient.BeginCreateByCustomer.
type RoleAssignmentsClientCreateByCustomerResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateByInvoiceSectionResponse contains the response from method RoleAssignmentsClient.BeginCreateByInvoiceSection.
type RoleAssignmentsClientCreateByInvoiceSectionResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateOrUpdateByBillingAccountResponse contains the response from method RoleAssignmentsClient.BeginCreateOrUpdateByBillingAccount.
type RoleAssignmentsClientCreateOrUpdateByBillingAccountResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateOrUpdateByDepartmentResponse contains the response from method RoleAssignmentsClient.BeginCreateOrUpdateByDepartment.
type RoleAssignmentsClientCreateOrUpdateByDepartmentResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientCreateOrUpdateByEnrollmentAccountResponse contains the response from method RoleAssignmentsClient.BeginCreateOrUpdateByEnrollmentAccount.
type RoleAssignmentsClientCreateOrUpdateByEnrollmentAccountResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientDeleteByBillingAccountResponse contains the response from method RoleAssignmentsClient.DeleteByBillingAccount.
type RoleAssignmentsClientDeleteByBillingAccountResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientDeleteByBillingProfileResponse contains the response from method RoleAssignmentsClient.DeleteByBillingProfile.
type RoleAssignmentsClientDeleteByBillingProfileResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientDeleteByCustomerResponse contains the response from method RoleAssignmentsClient.DeleteByCustomer.
type RoleAssignmentsClientDeleteByCustomerResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientDeleteByDepartmentResponse contains the response from method RoleAssignmentsClient.DeleteByDepartment.
type RoleAssignmentsClientDeleteByDepartmentResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientDeleteByEnrollmentAccountResponse contains the response from method RoleAssignmentsClient.DeleteByEnrollmentAccount.
type RoleAssignmentsClientDeleteByEnrollmentAccountResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientDeleteByInvoiceSectionResponse contains the response from method RoleAssignmentsClient.DeleteByInvoiceSection.
type RoleAssignmentsClientDeleteByInvoiceSectionResponse struct {
	// placeholder for future response values
}

// RoleAssignmentsClientGetByBillingAccountResponse contains the response from method RoleAssignmentsClient.GetByBillingAccount.
type RoleAssignmentsClientGetByBillingAccountResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientGetByBillingProfileResponse contains the response from method RoleAssignmentsClient.GetByBillingProfile.
type RoleAssignmentsClientGetByBillingProfileResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientGetByCustomerResponse contains the response from method RoleAssignmentsClient.GetByCustomer.
type RoleAssignmentsClientGetByCustomerResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientGetByDepartmentResponse contains the response from method RoleAssignmentsClient.GetByDepartment.
type RoleAssignmentsClientGetByDepartmentResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientGetByEnrollmentAccountResponse contains the response from method RoleAssignmentsClient.GetByEnrollmentAccount.
type RoleAssignmentsClientGetByEnrollmentAccountResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientGetByInvoiceSectionResponse contains the response from method RoleAssignmentsClient.GetByInvoiceSection.
type RoleAssignmentsClientGetByInvoiceSectionResponse struct {
	// The properties of the billing role assignment.
	RoleAssignment
}

// RoleAssignmentsClientListByBillingAccountResponse contains the response from method RoleAssignmentsClient.NewListByBillingAccountPager.
type RoleAssignmentsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientListByBillingProfileResponse contains the response from method RoleAssignmentsClient.NewListByBillingProfilePager.
type RoleAssignmentsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientListByCustomerResponse contains the response from method RoleAssignmentsClient.NewListByCustomerPager.
type RoleAssignmentsClientListByCustomerResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientListByDepartmentResponse contains the response from method RoleAssignmentsClient.NewListByDepartmentPager.
type RoleAssignmentsClientListByDepartmentResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientListByEnrollmentAccountResponse contains the response from method RoleAssignmentsClient.NewListByEnrollmentAccountPager.
type RoleAssignmentsClientListByEnrollmentAccountResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientListByInvoiceSectionResponse contains the response from method RoleAssignmentsClient.NewListByInvoiceSectionPager.
type RoleAssignmentsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientResolveByBillingAccountResponse contains the response from method RoleAssignmentsClient.BeginResolveByBillingAccount.
type RoleAssignmentsClientResolveByBillingAccountResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientResolveByBillingProfileResponse contains the response from method RoleAssignmentsClient.BeginResolveByBillingProfile.
type RoleAssignmentsClientResolveByBillingProfileResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientResolveByCustomerResponse contains the response from method RoleAssignmentsClient.BeginResolveByCustomer.
type RoleAssignmentsClientResolveByCustomerResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleAssignmentsClientResolveByInvoiceSectionResponse contains the response from method RoleAssignmentsClient.BeginResolveByInvoiceSection.
type RoleAssignmentsClientResolveByInvoiceSectionResponse struct {
	// A container for a list of resources
	RoleAssignmentListResult
}

// RoleDefinitionClientGetByBillingAccountResponse contains the response from method RoleDefinitionClient.GetByBillingAccount.
type RoleDefinitionClientGetByBillingAccountResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientGetByBillingProfileResponse contains the response from method RoleDefinitionClient.GetByBillingProfile.
type RoleDefinitionClientGetByBillingProfileResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientGetByCustomerResponse contains the response from method RoleDefinitionClient.GetByCustomer.
type RoleDefinitionClientGetByCustomerResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientGetByDepartmentResponse contains the response from method RoleDefinitionClient.GetByDepartment.
type RoleDefinitionClientGetByDepartmentResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientGetByEnrollmentAccountResponse contains the response from method RoleDefinitionClient.GetByEnrollmentAccount.
type RoleDefinitionClientGetByEnrollmentAccountResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientGetByInvoiceSectionResponse contains the response from method RoleDefinitionClient.GetByInvoiceSection.
type RoleDefinitionClientGetByInvoiceSectionResponse struct {
	// The properties of a role definition.
	RoleDefinition
}

// RoleDefinitionClientListByBillingAccountResponse contains the response from method RoleDefinitionClient.NewListByBillingAccountPager.
type RoleDefinitionClientListByBillingAccountResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// RoleDefinitionClientListByBillingProfileResponse contains the response from method RoleDefinitionClient.NewListByBillingProfilePager.
type RoleDefinitionClientListByBillingProfileResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// RoleDefinitionClientListByCustomerResponse contains the response from method RoleDefinitionClient.NewListByCustomerPager.
type RoleDefinitionClientListByCustomerResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// RoleDefinitionClientListByDepartmentResponse contains the response from method RoleDefinitionClient.NewListByDepartmentPager.
type RoleDefinitionClientListByDepartmentResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// RoleDefinitionClientListByEnrollmentAccountResponse contains the response from method RoleDefinitionClient.NewListByEnrollmentAccountPager.
type RoleDefinitionClientListByEnrollmentAccountResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// RoleDefinitionClientListByInvoiceSectionResponse contains the response from method RoleDefinitionClient.NewListByInvoiceSectionPager.
type RoleDefinitionClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	RoleDefinitionListResult
}

// SavingsPlanOrdersClientGetByBillingAccountResponse contains the response from method SavingsPlanOrdersClient.GetByBillingAccount.
type SavingsPlanOrdersClientGetByBillingAccountResponse struct {
	// Savings plan order
	SavingsPlanOrderModel
}

// SavingsPlanOrdersClientListByBillingAccountResponse contains the response from method SavingsPlanOrdersClient.NewListByBillingAccountPager.
type SavingsPlanOrdersClientListByBillingAccountResponse struct {
	// List of savings plan orders
	SavingsPlanOrderModelList
}

// SavingsPlansClientGetByBillingAccountResponse contains the response from method SavingsPlansClient.GetByBillingAccount.
type SavingsPlansClientGetByBillingAccountResponse struct {
	// Savings plan
	SavingsPlanModel
}

// SavingsPlansClientListByBillingAccountResponse contains the response from method SavingsPlansClient.NewListByBillingAccountPager.
type SavingsPlansClientListByBillingAccountResponse struct {
	// List of savings plans
	SavingsPlanModelListResult
}

// SavingsPlansClientListBySavingsPlanOrderResponse contains the response from method SavingsPlansClient.NewListBySavingsPlanOrderPager.
type SavingsPlansClientListBySavingsPlanOrderResponse struct {
	// List of savings plans
	SavingsPlanModelList
}

// SavingsPlansClientUpdateByBillingAccountResponse contains the response from method SavingsPlansClient.BeginUpdateByBillingAccount.
type SavingsPlansClientUpdateByBillingAccountResponse struct {
	// Savings plan
	SavingsPlanModel
}

// SavingsPlansClientValidateUpdateByBillingAccountResponse contains the response from method SavingsPlansClient.ValidateUpdateByBillingAccount.
type SavingsPlansClientValidateUpdateByBillingAccountResponse struct {
	// Savings plan update validate response.
	SavingsPlanValidateResponse
}

// SubscriptionsAliasesClientCreateOrUpdateResponse contains the response from method SubscriptionsAliasesClient.BeginCreateOrUpdate.
type SubscriptionsAliasesClientCreateOrUpdateResponse struct {
	// A billing subscription alias.
	SubscriptionAlias
}

// SubscriptionsAliasesClientGetResponse contains the response from method SubscriptionsAliasesClient.Get.
type SubscriptionsAliasesClientGetResponse struct {
	// A billing subscription alias.
	SubscriptionAlias
}

// SubscriptionsAliasesClientListByBillingAccountResponse contains the response from method SubscriptionsAliasesClient.NewListByBillingAccountPager.
type SubscriptionsAliasesClientListByBillingAccountResponse struct {
	// A container for a list of resources
	SubscriptionAliasListResult
}

// SubscriptionsClientCancelResponse contains the response from method SubscriptionsClient.BeginCancel.
type SubscriptionsClientCancelResponse struct {
	// placeholder for future response values
}

// SubscriptionsClientDeleteResponse contains the response from method SubscriptionsClient.BeginDelete.
type SubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// SubscriptionsClientGetByBillingProfileResponse contains the response from method SubscriptionsClient.GetByBillingProfile.
type SubscriptionsClientGetByBillingProfileResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientGetResponse contains the response from method SubscriptionsClient.Get.
type SubscriptionsClientGetResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientListByBillingAccountResponse contains the response from method SubscriptionsClient.NewListByBillingAccountPager.
type SubscriptionsClientListByBillingAccountResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientListByBillingProfileResponse contains the response from method SubscriptionsClient.NewListByBillingProfilePager.
type SubscriptionsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientListByCustomerAtBillingAccountResponse contains the response from method SubscriptionsClient.NewListByCustomerAtBillingAccountPager.
type SubscriptionsClientListByCustomerAtBillingAccountResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientListByCustomerResponse contains the response from method SubscriptionsClient.NewListByCustomerPager.
type SubscriptionsClientListByCustomerResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientListByEnrollmentAccountResponse contains the response from method SubscriptionsClient.NewListByEnrollmentAccountPager.
type SubscriptionsClientListByEnrollmentAccountResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientListByInvoiceSectionResponse contains the response from method SubscriptionsClient.NewListByInvoiceSectionPager.
type SubscriptionsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	SubscriptionListResult
}

// SubscriptionsClientMergeResponse contains the response from method SubscriptionsClient.BeginMerge.
type SubscriptionsClientMergeResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientMoveResponse contains the response from method SubscriptionsClient.BeginMove.
type SubscriptionsClientMoveResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientSplitResponse contains the response from method SubscriptionsClient.BeginSplit.
type SubscriptionsClientSplitResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientUpdateResponse contains the response from method SubscriptionsClient.BeginUpdate.
type SubscriptionsClientUpdateResponse struct {
	// The billing properties of a subscription.
	Subscription
}

// SubscriptionsClientValidateMoveEligibilityResponse contains the response from method SubscriptionsClient.ValidateMoveEligibility.
type SubscriptionsClientValidateMoveEligibilityResponse struct {
	// Result of the transfer eligibility validation.
	MoveBillingSubscriptionEligibilityResult
}

// TransactionsClientGetTransactionSummaryByInvoiceResponse contains the response from method TransactionsClient.GetTransactionSummaryByInvoice.
type TransactionsClientGetTransactionSummaryByInvoiceResponse struct {
	// A transaction summary.
	TransactionSummary
}

// TransactionsClientListByBillingProfileResponse contains the response from method TransactionsClient.NewListByBillingProfilePager.
type TransactionsClientListByBillingProfileResponse struct {
	// A container for a list of resources
	TransactionListResult
}

// TransactionsClientListByCustomerResponse contains the response from method TransactionsClient.NewListByCustomerPager.
type TransactionsClientListByCustomerResponse struct {
	// A container for a list of resources
	TransactionListResult
}

// TransactionsClientListByInvoiceResponse contains the response from method TransactionsClient.NewListByInvoicePager.
type TransactionsClientListByInvoiceResponse struct {
	// A container for a list of resources
	TransactionListResult
}

// TransactionsClientListByInvoiceSectionResponse contains the response from method TransactionsClient.NewListByInvoiceSectionPager.
type TransactionsClientListByInvoiceSectionResponse struct {
	// A container for a list of resources
	TransactionListResult
}

// TransactionsClientTransactionsDownloadByInvoiceResponse contains the response from method TransactionsClient.BeginTransactionsDownloadByInvoice.
type TransactionsClientTransactionsDownloadByInvoiceResponse struct {
	// A secure URL that can be used to download a an entity until the URL expires.
	DocumentDownloadResult
}

// TransfersClientCancelResponse contains the response from method TransfersClient.Cancel.
type TransfersClientCancelResponse struct {
	// Details of the transfer.
	TransferDetails
}

// TransfersClientGetResponse contains the response from method TransfersClient.Get.
type TransfersClientGetResponse struct {
	// Details of the transfer.
	TransferDetails
}

// TransfersClientInitiateResponse contains the response from method TransfersClient.Initiate.
type TransfersClientInitiateResponse struct {
	// Details of the transfer.
	TransferDetails
}

// TransfersClientListResponse contains the response from method TransfersClient.NewListPager.
type TransfersClientListResponse struct {
	// The list of transfers initiated by caller.
	TransferDetailsListResult
}
