//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armbillingbenefits

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// RPClientValidatePurchaseOptions contains the optional parameters for the RPClient.ValidatePurchase method.
type RPClientValidatePurchaseOptions struct {
	// placeholder for future optional parameters
}

// ReservationOrderAliasClientBeginCreateOptions contains the optional parameters for the ReservationOrderAliasClient.BeginCreate
// method.
type ReservationOrderAliasClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ReservationOrderAliasClientGetOptions contains the optional parameters for the ReservationOrderAliasClient.Get method.
type ReservationOrderAliasClientGetOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanClientGetOptions contains the optional parameters for the SavingsPlanClient.Get method.
type SavingsPlanClientGetOptions struct {
	// May be used to expand the detail information of some properties.
	Expand *string
}

// SavingsPlanClientListAllOptions contains the optional parameters for the SavingsPlanClient.NewListAllPager method.
type SavingsPlanClientListAllOptions struct {
	// May be used to filter by reservation properties. The filter supports 'eq', 'or', and 'and'. It does not currently support
	// 'ne', 'gt', 'le', 'ge', or 'not'. Reservation properties include sku/name,
	// properties/{appliedScopeType, archived, displayName, displayProvisioningState, effectiveDateTime, expiryDate, provisioningState,
	// quantity, renew, reservedResourceType, term,
	// userFriendlyAppliedScopeType, userFriendlyRenewState}
	Filter *string

	// May be used to sort order by reservation properties.
	Orderby *string

	// To indicate whether to refresh the roll up counts of the savings plans group by provisioning states
	RefreshSummary *string

	// The selected provisioning state
	SelectedState *string

	// The number of savings plans to skip from the list before returning results
	Skiptoken *float32

	// To number of savings plans to return
	Take *float32
}

// SavingsPlanClientListOptions contains the optional parameters for the SavingsPlanClient.NewListPager method.
type SavingsPlanClientListOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanClientUpdateOptions contains the optional parameters for the SavingsPlanClient.Update method.
type SavingsPlanClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanClientValidateUpdateOptions contains the optional parameters for the SavingsPlanClient.ValidateUpdate method.
type SavingsPlanClientValidateUpdateOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanOrderAliasClientBeginCreateOptions contains the optional parameters for the SavingsPlanOrderAliasClient.BeginCreate
// method.
type SavingsPlanOrderAliasClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SavingsPlanOrderAliasClientGetOptions contains the optional parameters for the SavingsPlanOrderAliasClient.Get method.
type SavingsPlanOrderAliasClientGetOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanOrderClientElevateOptions contains the optional parameters for the SavingsPlanOrderClient.Elevate method.
type SavingsPlanOrderClientElevateOptions struct {
	// placeholder for future optional parameters
}

// SavingsPlanOrderClientGetOptions contains the optional parameters for the SavingsPlanOrderClient.Get method.
type SavingsPlanOrderClientGetOptions struct {
	// May be used to expand the detail information of some properties.
	Expand *string
}

// SavingsPlanOrderClientListOptions contains the optional parameters for the SavingsPlanOrderClient.NewListPager method.
type SavingsPlanOrderClientListOptions struct {
	// placeholder for future optional parameters
}
