//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"encoding/json"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/blueprint/armblueprint"
)

func unmarshalArtifactClassification(rawMsg json.RawMessage) (armblueprint.ArtifactClassification, error) {
	if rawMsg == nil {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b armblueprint.ArtifactClassification
	switch m["kind"] {
	case string(armblueprint.ArtifactKindPolicyAssignment):
		b = &armblueprint.PolicyAssignmentArtifact{}
	case string(armblueprint.ArtifactKindRoleAssignment):
		b = &armblueprint.RoleAssignmentArtifact{}
	case string(armblueprint.ArtifactKindTemplate):
		b = &armblueprint.TemplateArtifact{}
	default:
		b = &armblueprint.Artifact{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}
