//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armbotservice

// BotConnectionClientCreateResponse contains the response from method BotConnectionClient.Create.
type BotConnectionClientCreateResponse struct {
	// Bot channel resource definition
	ConnectionSetting
}

// BotConnectionClientDeleteResponse contains the response from method BotConnectionClient.Delete.
type BotConnectionClientDeleteResponse struct {
	// placeholder for future response values
}

// BotConnectionClientGetResponse contains the response from method BotConnectionClient.Get.
type BotConnectionClientGetResponse struct {
	// Bot channel resource definition
	ConnectionSetting
}

// BotConnectionClientListByBotServiceResponse contains the response from method BotConnectionClient.NewListByBotServicePager.
type BotConnectionClientListByBotServiceResponse struct {
	// The list of bot service connection settings response.
	ConnectionSettingResponseList
}

// BotConnectionClientListServiceProvidersResponse contains the response from method BotConnectionClient.ListServiceProviders.
type BotConnectionClientListServiceProvidersResponse struct {
	// The list of bot service providers response.
	ServiceProviderResponseList
}

// BotConnectionClientListWithSecretsResponse contains the response from method BotConnectionClient.ListWithSecrets.
type BotConnectionClientListWithSecretsResponse struct {
	// Bot channel resource definition
	ConnectionSetting
}

// BotConnectionClientUpdateResponse contains the response from method BotConnectionClient.Update.
type BotConnectionClientUpdateResponse struct {
	// Bot channel resource definition
	ConnectionSetting
}

// BotsClientCreateResponse contains the response from method BotsClient.Create.
type BotsClientCreateResponse struct {
	// Bot resource definition
	Bot
}

// BotsClientDeleteResponse contains the response from method BotsClient.Delete.
type BotsClientDeleteResponse struct {
	// placeholder for future response values
}

// BotsClientGetCheckNameAvailabilityResponse contains the response from method BotsClient.GetCheckNameAvailability.
type BotsClientGetCheckNameAvailabilityResponse struct {
	// The response body returned for a request to Bot Service Management to check availability of a bot name.
	CheckNameAvailabilityResponseBody
}

// BotsClientGetResponse contains the response from method BotsClient.Get.
type BotsClientGetResponse struct {
	// Bot resource definition
	Bot
}

// BotsClientListByResourceGroupResponse contains the response from method BotsClient.NewListByResourceGroupPager.
type BotsClientListByResourceGroupResponse struct {
	// The list of bot service operation response.
	BotResponseList
}

// BotsClientListResponse contains the response from method BotsClient.NewListPager.
type BotsClientListResponse struct {
	// The list of bot service operation response.
	BotResponseList
}

// BotsClientUpdateResponse contains the response from method BotsClient.Update.
type BotsClientUpdateResponse struct {
	// Bot resource definition
	Bot
}

// ChannelsClientCreateResponse contains the response from method ChannelsClient.Create.
type ChannelsClientCreateResponse struct {
	// Bot channel resource definition
	BotChannel
}

// ChannelsClientDeleteResponse contains the response from method ChannelsClient.Delete.
type ChannelsClientDeleteResponse struct {
	// placeholder for future response values
}

// ChannelsClientGetResponse contains the response from method ChannelsClient.Get.
type ChannelsClientGetResponse struct {
	// Bot channel resource definition
	BotChannel
}

// ChannelsClientListByResourceGroupResponse contains the response from method ChannelsClient.NewListByResourceGroupPager.
type ChannelsClientListByResourceGroupResponse struct {
	// The list of bot service channel operation response.
	ChannelResponseList
}

// ChannelsClientListWithKeysResponse contains the response from method ChannelsClient.ListWithKeys.
type ChannelsClientListWithKeysResponse struct {
	// The ARM channel of list channel with keys operation response.
	ListChannelWithKeysResponse
}

// ChannelsClientUpdateResponse contains the response from method ChannelsClient.Update.
type ChannelsClientUpdateResponse struct {
	// Bot channel resource definition
	BotChannel
}

// DirectLineClientRegenerateKeysResponse contains the response from method DirectLineClient.RegenerateKeys.
type DirectLineClientRegenerateKeysResponse struct {
	// Bot channel resource definition
	BotChannel
}

// EmailClientCreateSignInURLResponse contains the response from method EmailClient.CreateSignInURL.
type EmailClientCreateSignInURLResponse struct {
	// The ARM create email sign in url operation response.
	CreateEmailSignInURLResponse
}

// HostSettingsClientGetResponse contains the response from method HostSettingsClient.Get.
type HostSettingsClientGetResponse struct {
	// The response body returned for a request to Bot Service Management to check per subscription hostSettings
	HostSettingsResponse
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.BeginGet.
type OperationResultsClientGetResponse struct {
	// The properties indicating the operation result of an operation on a service.
	OperationResultsDescription
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// The list of bot service operation response.
	OperationEntityListResult
}

// PrivateEndpointConnectionsClientCreateResponse contains the response from method PrivateEndpointConnectionsClient.Create.
type PrivateEndpointConnectionsClientCreateResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientListByBotResourceResponse contains the response from method PrivateLinkResourcesClient.ListByBotResource.
type PrivateLinkResourcesClientListByBotResourceResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// QnAMakerEndpointKeysClientGetResponse contains the response from method QnAMakerEndpointKeysClient.Get.
type QnAMakerEndpointKeysClientGetResponse struct {
	// Schema for EndpointKeys generate/refresh operations.
	QnAMakerEndpointKeysResponse
}
