//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Code generated by Microsoft (R) AutoRest Code Generator.Changes may cause incorrect behavior and will be lost if the code
// is regenerated.
// Code generated by @autorest/go. DO NOT EDIT.

package armconnectedvmware

// ClustersClientBeginCreateOptions contains the optional parameters for the ClustersClient.BeginCreate method.
type ClustersClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClustersClientBeginDeleteOptions contains the optional parameters for the ClustersClient.BeginDelete method.
type ClustersClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClustersClientGetOptions contains the optional parameters for the ClustersClient.Get method.
type ClustersClientGetOptions struct {
	// placeholder for future optional parameters
}

// ClustersClientListByResourceGroupOptions contains the optional parameters for the ClustersClient.NewListByResourceGroupPager
// method.
type ClustersClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ClustersClientListOptions contains the optional parameters for the ClustersClient.NewListPager method.
type ClustersClientListOptions struct {
	// placeholder for future optional parameters
}

// ClustersClientUpdateOptions contains the optional parameters for the ClustersClient.Update method.
type ClustersClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// DatastoresClientBeginCreateOptions contains the optional parameters for the DatastoresClient.BeginCreate method.
type DatastoresClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DatastoresClientBeginDeleteOptions contains the optional parameters for the DatastoresClient.BeginDelete method.
type DatastoresClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DatastoresClientGetOptions contains the optional parameters for the DatastoresClient.Get method.
type DatastoresClientGetOptions struct {
	// placeholder for future optional parameters
}

// DatastoresClientListByResourceGroupOptions contains the optional parameters for the DatastoresClient.NewListByResourceGroupPager
// method.
type DatastoresClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// DatastoresClientListOptions contains the optional parameters for the DatastoresClient.NewListPager method.
type DatastoresClientListOptions struct {
	// placeholder for future optional parameters
}

// DatastoresClientUpdateOptions contains the optional parameters for the DatastoresClient.Update method.
type DatastoresClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// HostsClientBeginCreateOptions contains the optional parameters for the HostsClient.BeginCreate method.
type HostsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// HostsClientBeginDeleteOptions contains the optional parameters for the HostsClient.BeginDelete method.
type HostsClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// HostsClientGetOptions contains the optional parameters for the HostsClient.Get method.
type HostsClientGetOptions struct {
	// placeholder for future optional parameters
}

// HostsClientListByResourceGroupOptions contains the optional parameters for the HostsClient.NewListByResourceGroupPager
// method.
type HostsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// HostsClientListOptions contains the optional parameters for the HostsClient.NewListPager method.
type HostsClientListOptions struct {
	// placeholder for future optional parameters
}

// HostsClientUpdateOptions contains the optional parameters for the HostsClient.Update method.
type HostsClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientCreateOptions contains the optional parameters for the InventoryItemsClient.Create method.
type InventoryItemsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientDeleteOptions contains the optional parameters for the InventoryItemsClient.Delete method.
type InventoryItemsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientGetOptions contains the optional parameters for the InventoryItemsClient.Get method.
type InventoryItemsClientGetOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientListByVCenterOptions contains the optional parameters for the InventoryItemsClient.NewListByVCenterPager
// method.
type InventoryItemsClientListByVCenterOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// ResourcePoolsClientBeginCreateOptions contains the optional parameters for the ResourcePoolsClient.BeginCreate method.
type ResourcePoolsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ResourcePoolsClientBeginDeleteOptions contains the optional parameters for the ResourcePoolsClient.BeginDelete method.
type ResourcePoolsClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ResourcePoolsClientGetOptions contains the optional parameters for the ResourcePoolsClient.Get method.
type ResourcePoolsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ResourcePoolsClientListByResourceGroupOptions contains the optional parameters for the ResourcePoolsClient.NewListByResourceGroupPager
// method.
type ResourcePoolsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourcePoolsClientListOptions contains the optional parameters for the ResourcePoolsClient.NewListPager method.
type ResourcePoolsClientListOptions struct {
	// placeholder for future optional parameters
}

// ResourcePoolsClientUpdateOptions contains the optional parameters for the ResourcePoolsClient.Update method.
type ResourcePoolsClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// VCentersClientBeginCreateOptions contains the optional parameters for the VCentersClient.BeginCreate method.
type VCentersClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VCentersClientBeginDeleteOptions contains the optional parameters for the VCentersClient.BeginDelete method.
type VCentersClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VCentersClientGetOptions contains the optional parameters for the VCentersClient.Get method.
type VCentersClientGetOptions struct {
	// placeholder for future optional parameters
}

// VCentersClientListByResourceGroupOptions contains the optional parameters for the VCentersClient.NewListByResourceGroupPager
// method.
type VCentersClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VCentersClientListOptions contains the optional parameters for the VCentersClient.NewListPager method.
type VCentersClientListOptions struct {
	// placeholder for future optional parameters
}

// VCentersClientUpdateOptions contains the optional parameters for the VCentersClient.Update method.
type VCentersClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceGuestAgentsClientBeginCreateOptions contains the optional parameters for the VMInstanceGuestAgentsClient.BeginCreate
// method.
type VMInstanceGuestAgentsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VMInstanceGuestAgentsClientBeginDeleteOptions contains the optional parameters for the VMInstanceGuestAgentsClient.BeginDelete
// method.
type VMInstanceGuestAgentsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VMInstanceGuestAgentsClientGetOptions contains the optional parameters for the VMInstanceGuestAgentsClient.Get method.
type VMInstanceGuestAgentsClientGetOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceGuestAgentsClientListOptions contains the optional parameters for the VMInstanceGuestAgentsClient.NewListPager
// method.
type VMInstanceGuestAgentsClientListOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceHybridIdentityMetadataClientGetOptions contains the optional parameters for the VMInstanceHybridIdentityMetadataClient.Get
// method.
type VMInstanceHybridIdentityMetadataClientGetOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceHybridIdentityMetadataClientListOptions contains the optional parameters for the VMInstanceHybridIdentityMetadataClient.NewListPager
// method.
type VMInstanceHybridIdentityMetadataClientListOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineInstancesClientBeginCreateOrUpdateOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginCreateOrUpdate
// method.
type VirtualMachineInstancesClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginDeleteOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginDelete
// method.
type VirtualMachineInstancesClientBeginDeleteOptions struct {
	// Whether to delete the VM from the vCenter.
	DeleteFromHost *bool

	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginRestartOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginRestart
// method.
type VirtualMachineInstancesClientBeginRestartOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginStartOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginStart
// method.
type VirtualMachineInstancesClientBeginStartOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginStopOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginStop
// method.
type VirtualMachineInstancesClientBeginStopOptions struct {
	// Virtualmachine stop action payload.
	Body *StopVirtualMachineOptions

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginUpdateOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginUpdate
// method.
type VirtualMachineInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientGetOptions contains the optional parameters for the VirtualMachineInstancesClient.Get method.
type VirtualMachineInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineInstancesClientListOptions contains the optional parameters for the VirtualMachineInstancesClient.NewListPager
// method.
type VirtualMachineInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientBeginCreateOptions contains the optional parameters for the VirtualMachineTemplatesClient.BeginCreate
// method.
type VirtualMachineTemplatesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineTemplatesClientBeginDeleteOptions contains the optional parameters for the VirtualMachineTemplatesClient.BeginDelete
// method.
type VirtualMachineTemplatesClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineTemplatesClientGetOptions contains the optional parameters for the VirtualMachineTemplatesClient.Get method.
type VirtualMachineTemplatesClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientListByResourceGroupOptions contains the optional parameters for the VirtualMachineTemplatesClient.NewListByResourceGroupPager
// method.
type VirtualMachineTemplatesClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientListOptions contains the optional parameters for the VirtualMachineTemplatesClient.NewListPager
// method.
type VirtualMachineTemplatesClientListOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientUpdateOptions contains the optional parameters for the VirtualMachineTemplatesClient.Update
// method.
type VirtualMachineTemplatesClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientBeginCreateOptions contains the optional parameters for the VirtualNetworksClient.BeginCreate method.
type VirtualNetworksClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualNetworksClientBeginDeleteOptions contains the optional parameters for the VirtualNetworksClient.BeginDelete method.
type VirtualNetworksClientBeginDeleteOptions struct {
	// Whether force delete was specified.
	Force *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualNetworksClientGetOptions contains the optional parameters for the VirtualNetworksClient.Get method.
type VirtualNetworksClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientListByResourceGroupOptions contains the optional parameters for the VirtualNetworksClient.NewListByResourceGroupPager
// method.
type VirtualNetworksClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientListOptions contains the optional parameters for the VirtualNetworksClient.NewListPager method.
type VirtualNetworksClientListOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientUpdateOptions contains the optional parameters for the VirtualNetworksClient.Update method.
type VirtualNetworksClientUpdateOptions struct {
	// placeholder for future optional parameters
}
