//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"net/http"
	"strings"
	"sync"
)

// ServerFactory is a fake server for instances of the armcontainerservicefleet.ClientFactory type.
type ServerFactory struct {
	AutoUpgradeProfilesServer   AutoUpgradeProfilesServer
	FleetMembersServer          FleetMembersServer
	FleetUpdateStrategiesServer FleetUpdateStrategiesServer
	FleetsServer                FleetsServer
	OperationsServer            OperationsServer
	UpdateRunsServer            UpdateRunsServer
}

// NewServerFactoryTransport creates a new instance of ServerFactoryTransport with the provided implementation.
// The returned ServerFactoryTransport instance is connected to an instance of armcontainerservicefleet.ClientFactory via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewServerFactoryTransport(srv *ServerFactory) *ServerFactoryTransport {
	return &ServerFactoryTransport{
		srv: srv,
	}
}

// ServerFactoryTransport connects instances of armcontainerservicefleet.ClientFactory to instances of ServerFactory.
// Don't use this type directly, use NewServerFactoryTransport instead.
type ServerFactoryTransport struct {
	srv                           *ServerFactory
	trMu                          sync.Mutex
	trAutoUpgradeProfilesServer   *AutoUpgradeProfilesServerTransport
	trFleetMembersServer          *FleetMembersServerTransport
	trFleetUpdateStrategiesServer *FleetUpdateStrategiesServerTransport
	trFleetsServer                *FleetsServerTransport
	trOperationsServer            *OperationsServerTransport
	trUpdateRunsServer            *UpdateRunsServerTransport
}

// Do implements the policy.Transporter interface for ServerFactoryTransport.
func (s *ServerFactoryTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	client := method[:strings.Index(method, ".")]
	var resp *http.Response
	var err error

	switch client {
	case "AutoUpgradeProfilesClient":
		initServer(s, &s.trAutoUpgradeProfilesServer, func() *AutoUpgradeProfilesServerTransport {
			return NewAutoUpgradeProfilesServerTransport(&s.srv.AutoUpgradeProfilesServer)
		})
		resp, err = s.trAutoUpgradeProfilesServer.Do(req)
	case "FleetMembersClient":
		initServer(s, &s.trFleetMembersServer, func() *FleetMembersServerTransport { return NewFleetMembersServerTransport(&s.srv.FleetMembersServer) })
		resp, err = s.trFleetMembersServer.Do(req)
	case "FleetUpdateStrategiesClient":
		initServer(s, &s.trFleetUpdateStrategiesServer, func() *FleetUpdateStrategiesServerTransport {
			return NewFleetUpdateStrategiesServerTransport(&s.srv.FleetUpdateStrategiesServer)
		})
		resp, err = s.trFleetUpdateStrategiesServer.Do(req)
	case "FleetsClient":
		initServer(s, &s.trFleetsServer, func() *FleetsServerTransport { return NewFleetsServerTransport(&s.srv.FleetsServer) })
		resp, err = s.trFleetsServer.Do(req)
	case "OperationsClient":
		initServer(s, &s.trOperationsServer, func() *OperationsServerTransport { return NewOperationsServerTransport(&s.srv.OperationsServer) })
		resp, err = s.trOperationsServer.Do(req)
	case "UpdateRunsClient":
		initServer(s, &s.trUpdateRunsServer, func() *UpdateRunsServerTransport { return NewUpdateRunsServerTransport(&s.srv.UpdateRunsServer) })
		resp, err = s.trUpdateRunsServer.Do(req)
	default:
		err = fmt.Errorf("unhandled client %s", client)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func initServer[T any](s *ServerFactoryTransport, dst **T, src func() *T) {
	s.trMu.Lock()
	if *dst == nil {
		*dst = src()
	}
	s.trMu.Unlock()
}
