//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armcosmosforpostgresql

// ClustersClientCheckNameAvailabilityResponse contains the response from method ClustersClient.CheckNameAvailability.
type ClustersClientCheckNameAvailabilityResponse struct {
	// Represents cluster name availability.
	NameAvailability
}

// ClustersClientCreateResponse contains the response from method ClustersClient.BeginCreate.
type ClustersClientCreateResponse struct {
	// Represents a cluster.
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// Represents a cluster.
	Cluster
}

// ClustersClientListByResourceGroupResponse contains the response from method ClustersClient.NewListByResourceGroupPager.
type ClustersClientListByResourceGroupResponse struct {
	// A list of clusters.
	ClusterListResult
}

// ClustersClientListResponse contains the response from method ClustersClient.NewListPager.
type ClustersClientListResponse struct {
	// A list of clusters.
	ClusterListResult
}

// ClustersClientPromoteReadReplicaResponse contains the response from method ClustersClient.BeginPromoteReadReplica.
type ClustersClientPromoteReadReplicaResponse struct {
	// placeholder for future response values
}

// ClustersClientRestartResponse contains the response from method ClustersClient.BeginRestart.
type ClustersClientRestartResponse struct {
	// placeholder for future response values
}

// ClustersClientStartResponse contains the response from method ClustersClient.BeginStart.
type ClustersClientStartResponse struct {
	// placeholder for future response values
}

// ClustersClientStopResponse contains the response from method ClustersClient.BeginStop.
type ClustersClientStopResponse struct {
	// placeholder for future response values
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.BeginUpdate.
type ClustersClientUpdateResponse struct {
	// Represents a cluster.
	Cluster
}

// ConfigurationsClientGetCoordinatorResponse contains the response from method ConfigurationsClient.GetCoordinator.
type ConfigurationsClientGetCoordinatorResponse struct {
	// Represents a configuration.
	ServerConfiguration
}

// ConfigurationsClientGetNodeResponse contains the response from method ConfigurationsClient.GetNode.
type ConfigurationsClientGetNodeResponse struct {
	// Represents a configuration.
	ServerConfiguration
}

// ConfigurationsClientGetResponse contains the response from method ConfigurationsClient.Get.
type ConfigurationsClientGetResponse struct {
	// Represents configuration details for coordinator and node.
	Configuration
}

// ConfigurationsClientListByClusterResponse contains the response from method ConfigurationsClient.NewListByClusterPager.
type ConfigurationsClientListByClusterResponse struct {
	// A list of cluster configurations.
	ClusterConfigurationListResult
}

// ConfigurationsClientListByServerResponse contains the response from method ConfigurationsClient.NewListByServerPager.
type ConfigurationsClientListByServerResponse struct {
	// A list of server configurations.
	ServerConfigurationListResult
}

// ConfigurationsClientUpdateOnCoordinatorResponse contains the response from method ConfigurationsClient.BeginUpdateOnCoordinator.
type ConfigurationsClientUpdateOnCoordinatorResponse struct {
	// Represents a configuration.
	ServerConfiguration
}

// ConfigurationsClientUpdateOnNodeResponse contains the response from method ConfigurationsClient.BeginUpdateOnNode.
type ConfigurationsClientUpdateOnNodeResponse struct {
	// Represents a configuration.
	ServerConfiguration
}

// FirewallRulesClientCreateOrUpdateResponse contains the response from method FirewallRulesClient.BeginCreateOrUpdate.
type FirewallRulesClientCreateOrUpdateResponse struct {
	// Represents a cluster firewall rule.
	FirewallRule
}

// FirewallRulesClientDeleteResponse contains the response from method FirewallRulesClient.BeginDelete.
type FirewallRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// FirewallRulesClientGetResponse contains the response from method FirewallRulesClient.Get.
type FirewallRulesClientGetResponse struct {
	// Represents a cluster firewall rule.
	FirewallRule
}

// FirewallRulesClientListByClusterResponse contains the response from method FirewallRulesClient.NewListByClusterPager.
type FirewallRulesClientListByClusterResponse struct {
	// A list of firewall rules.
	FirewallRuleListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of resource provider operations.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The private endpoint connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The private endpoint connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByClusterResponse contains the response from method PrivateEndpointConnectionsClient.NewListByClusterPager.
type PrivateEndpointConnectionsClientListByClusterResponse struct {
	// List of private endpoint connections associated with the specified resource.
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A private link resource.
	PrivateLinkResource
}

// PrivateLinkResourcesClientListByClusterResponse contains the response from method PrivateLinkResourcesClient.NewListByClusterPager.
type PrivateLinkResourcesClientListByClusterResponse struct {
	// A list of private link resources.
	PrivateLinkResourceListResult
}

// RolesClientCreateResponse contains the response from method RolesClient.BeginCreate.
type RolesClientCreateResponse struct {
	// Represents a cluster role.
	Role
}

// RolesClientDeleteResponse contains the response from method RolesClient.BeginDelete.
type RolesClientDeleteResponse struct {
	// placeholder for future response values
}

// RolesClientGetResponse contains the response from method RolesClient.Get.
type RolesClientGetResponse struct {
	// Represents a cluster role.
	Role
}

// RolesClientListByClusterResponse contains the response from method RolesClient.NewListByClusterPager.
type RolesClientListByClusterResponse struct {
	// A list of roles.
	RoleListResult
}

// ServersClientGetResponse contains the response from method ServersClient.Get.
type ServersClientGetResponse struct {
	// Represents a server in a cluster.
	ClusterServer
}

// ServersClientListByClusterResponse contains the response from method ServersClient.NewListByClusterPager.
type ServersClientListByClusterResponse struct {
	// A list of servers in a cluster.
	ClusterServerListResult
}
