//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armcostmanagement

// AlertsClientDismissResponse contains the response from method AlertsClient.Dismiss.
type AlertsClientDismissResponse struct {
	// An individual alert.
	Alert
}

// AlertsClientGetResponse contains the response from method AlertsClient.Get.
type AlertsClientGetResponse struct {
	// An individual alert.
	Alert
}

// AlertsClientListExternalResponse contains the response from method AlertsClient.ListExternal.
type AlertsClientListExternalResponse struct {
	// Result of alerts.
	AlertsResult
}

// AlertsClientListResponse contains the response from method AlertsClient.List.
type AlertsClientListResponse struct {
	// Result of alerts.
	AlertsResult
}

// BenefitRecommendationsClientListResponse contains the response from method BenefitRecommendationsClient.NewListPager.
type BenefitRecommendationsClientListResponse struct {
	// Result of listing benefit recommendations.
	BenefitRecommendationsListResult
}

// BenefitUtilizationSummariesClientListByBillingAccountIDResponse contains the response from method BenefitUtilizationSummariesClient.NewListByBillingAccountIDPager.
type BenefitUtilizationSummariesClientListByBillingAccountIDResponse struct {
	// List of benefit utilization summaries.
	BenefitUtilizationSummariesListResult
}

// BenefitUtilizationSummariesClientListByBillingProfileIDResponse contains the response from method BenefitUtilizationSummariesClient.NewListByBillingProfileIDPager.
type BenefitUtilizationSummariesClientListByBillingProfileIDResponse struct {
	// List of benefit utilization summaries.
	BenefitUtilizationSummariesListResult
}

// BenefitUtilizationSummariesClientListBySavingsPlanIDResponse contains the response from method BenefitUtilizationSummariesClient.NewListBySavingsPlanIDPager.
type BenefitUtilizationSummariesClientListBySavingsPlanIDResponse struct {
	// List of benefit utilization summaries.
	BenefitUtilizationSummariesListResult
}

// BenefitUtilizationSummariesClientListBySavingsPlanOrderResponse contains the response from method BenefitUtilizationSummariesClient.NewListBySavingsPlanOrderPager.
type BenefitUtilizationSummariesClientListBySavingsPlanOrderResponse struct {
	// List of benefit utilization summaries.
	BenefitUtilizationSummariesListResult
}

// DimensionsClientByExternalCloudProviderTypeResponse contains the response from method DimensionsClient.NewByExternalCloudProviderTypePager.
type DimensionsClientByExternalCloudProviderTypeResponse struct {
	// Result of listing dimensions. It contains a list of available dimensions.
	DimensionsListResult
}

// DimensionsClientListResponse contains the response from method DimensionsClient.NewListPager.
type DimensionsClientListResponse struct {
	// Result of listing dimensions. It contains a list of available dimensions.
	DimensionsListResult
}

// ExportsClientCreateOrUpdateResponse contains the response from method ExportsClient.CreateOrUpdate.
type ExportsClientCreateOrUpdateResponse struct {
	// An export resource.
	Export
}

// ExportsClientDeleteResponse contains the response from method ExportsClient.Delete.
type ExportsClientDeleteResponse struct {
	// placeholder for future response values
}

// ExportsClientExecuteResponse contains the response from method ExportsClient.Execute.
type ExportsClientExecuteResponse struct {
	// placeholder for future response values
}

// ExportsClientGetExecutionHistoryResponse contains the response from method ExportsClient.GetExecutionHistory.
type ExportsClientGetExecutionHistoryResponse struct {
	// Result of listing the run history of an export.
	ExportExecutionListResult
}

// ExportsClientGetResponse contains the response from method ExportsClient.Get.
type ExportsClientGetResponse struct {
	// An export resource.
	Export
}

// ExportsClientListResponse contains the response from method ExportsClient.List.
type ExportsClientListResponse struct {
	// Result of listing exports. It contains a list of available exports in the scope provided.
	ExportListResult
}

// ForecastClientExternalCloudProviderUsageResponse contains the response from method ForecastClient.ExternalCloudProviderUsage.
type ForecastClientExternalCloudProviderUsageResponse struct {
	// Result of forecast. It contains all columns listed under groupings and aggregation.
	ForecastResult
}

// ForecastClientUsageResponse contains the response from method ForecastClient.Usage.
type ForecastClientUsageResponse struct {
	// Result of forecast. It contains all columns listed under groupings and aggregation.
	ForecastResult
}

// GenerateCostDetailsReportClientCreateOperationResponse contains the response from method GenerateCostDetailsReportClient.BeginCreateOperation.
type GenerateCostDetailsReportClientCreateOperationResponse struct {
	// The result of the long running operation for cost details Api.
	CostDetailsOperationResults
}

// GenerateCostDetailsReportClientGetOperationResultsResponse contains the response from method GenerateCostDetailsReportClient.BeginGetOperationResults.
type GenerateCostDetailsReportClientGetOperationResultsResponse struct {
	// The result of the long running operation for cost details Api.
	CostDetailsOperationResults
}

// GenerateDetailedCostReportClientCreateOperationResponse contains the response from method GenerateDetailedCostReportClient.BeginCreateOperation.
type GenerateDetailedCostReportClientCreateOperationResponse struct {
	// The result of the long running operation for cost detailed report.
	GenerateDetailedCostReportOperationResult
}

// GenerateDetailedCostReportOperationResultsClientGetResponse contains the response from method GenerateDetailedCostReportOperationResultsClient.BeginGet.
type GenerateDetailedCostReportOperationResultsClientGetResponse struct {
	// The result of the long running operation for cost detailed report.
	GenerateDetailedCostReportOperationResult
}

// GenerateDetailedCostReportOperationStatusClientGetResponse contains the response from method GenerateDetailedCostReportOperationStatusClient.Get.
type GenerateDetailedCostReportOperationStatusClientGetResponse struct {
	// The status of the long running operation for cost detailed report.
	GenerateDetailedCostReportOperationStatuses
}

// GenerateReservationDetailsReportClientByBillingAccountIDResponse contains the response from method GenerateReservationDetailsReportClient.BeginByBillingAccountID.
type GenerateReservationDetailsReportClientByBillingAccountIDResponse struct {
	// The status of the long running operation.
	OperationStatus
}

// GenerateReservationDetailsReportClientByBillingProfileIDResponse contains the response from method GenerateReservationDetailsReportClient.BeginByBillingProfileID.
type GenerateReservationDetailsReportClientByBillingProfileIDResponse struct {
	// The status of the long running operation.
	OperationStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of listing cost management operations. It contains a list of operations and a URL link to get the next set of results.
	OperationListResult
}

// PriceSheetClientDownloadByBillingProfileResponse contains the response from method PriceSheetClient.BeginDownloadByBillingProfile.
type PriceSheetClientDownloadByBillingProfileResponse struct {
	// The URL to download the generated report.
	DownloadURL
}

// PriceSheetClientDownloadResponse contains the response from method PriceSheetClient.BeginDownload.
type PriceSheetClientDownloadResponse struct {
	// The URL to download the generated report.
	DownloadURL
}

// QueryClientUsageByExternalCloudProviderTypeResponse contains the response from method QueryClient.UsageByExternalCloudProviderType.
type QueryClientUsageByExternalCloudProviderTypeResponse struct {
	// Result of query. It contains all columns listed under groupings and aggregation.
	QueryResult
}

// QueryClientUsageResponse contains the response from method QueryClient.Usage.
type QueryClientUsageResponse struct {
	// Result of query. It contains all columns listed under groupings and aggregation.
	QueryResult
}

// ScheduledActionsClientCheckNameAvailabilityByScopeResponse contains the response from method ScheduledActionsClient.CheckNameAvailabilityByScope.
type ScheduledActionsClientCheckNameAvailabilityByScopeResponse struct {
	// The check availability result.
	CheckNameAvailabilityResponse
}

// ScheduledActionsClientCheckNameAvailabilityResponse contains the response from method ScheduledActionsClient.CheckNameAvailability.
type ScheduledActionsClientCheckNameAvailabilityResponse struct {
	// The check availability result.
	CheckNameAvailabilityResponse
}

// ScheduledActionsClientCreateOrUpdateByScopeResponse contains the response from method ScheduledActionsClient.CreateOrUpdateByScope.
type ScheduledActionsClientCreateOrUpdateByScopeResponse struct {
	// Scheduled action definition.
	ScheduledAction
}

// ScheduledActionsClientCreateOrUpdateResponse contains the response from method ScheduledActionsClient.CreateOrUpdate.
type ScheduledActionsClientCreateOrUpdateResponse struct {
	// Scheduled action definition.
	ScheduledAction
}

// ScheduledActionsClientDeleteByScopeResponse contains the response from method ScheduledActionsClient.DeleteByScope.
type ScheduledActionsClientDeleteByScopeResponse struct {
	// placeholder for future response values
}

// ScheduledActionsClientDeleteResponse contains the response from method ScheduledActionsClient.Delete.
type ScheduledActionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ScheduledActionsClientGetByScopeResponse contains the response from method ScheduledActionsClient.GetByScope.
type ScheduledActionsClientGetByScopeResponse struct {
	// Scheduled action definition.
	ScheduledAction
}

// ScheduledActionsClientGetResponse contains the response from method ScheduledActionsClient.Get.
type ScheduledActionsClientGetResponse struct {
	// Scheduled action definition.
	ScheduledAction
}

// ScheduledActionsClientListByScopeResponse contains the response from method ScheduledActionsClient.NewListByScopePager.
type ScheduledActionsClientListByScopeResponse struct {
	// Scheduled actions list result. It contains a list of scheduled actions.
	ScheduledActionListResult
}

// ScheduledActionsClientListResponse contains the response from method ScheduledActionsClient.NewListPager.
type ScheduledActionsClientListResponse struct {
	// Scheduled actions list result. It contains a list of scheduled actions.
	ScheduledActionListResult
}

// ScheduledActionsClientRunByScopeResponse contains the response from method ScheduledActionsClient.RunByScope.
type ScheduledActionsClientRunByScopeResponse struct {
	// placeholder for future response values
}

// ScheduledActionsClientRunResponse contains the response from method ScheduledActionsClient.Run.
type ScheduledActionsClientRunResponse struct {
	// placeholder for future response values
}

// ViewsClientCreateOrUpdateByScopeResponse contains the response from method ViewsClient.CreateOrUpdateByScope.
type ViewsClientCreateOrUpdateByScopeResponse struct {
	// States and configurations of Cost Analysis.
	View
}

// ViewsClientCreateOrUpdateResponse contains the response from method ViewsClient.CreateOrUpdate.
type ViewsClientCreateOrUpdateResponse struct {
	// States and configurations of Cost Analysis.
	View
}

// ViewsClientDeleteByScopeResponse contains the response from method ViewsClient.DeleteByScope.
type ViewsClientDeleteByScopeResponse struct {
	// placeholder for future response values
}

// ViewsClientDeleteResponse contains the response from method ViewsClient.Delete.
type ViewsClientDeleteResponse struct {
	// placeholder for future response values
}

// ViewsClientGetByScopeResponse contains the response from method ViewsClient.GetByScope.
type ViewsClientGetByScopeResponse struct {
	// States and configurations of Cost Analysis.
	View
}

// ViewsClientGetResponse contains the response from method ViewsClient.Get.
type ViewsClientGetResponse struct {
	// States and configurations of Cost Analysis.
	View
}

// ViewsClientListByScopeResponse contains the response from method ViewsClient.NewListByScopePager.
type ViewsClientListByScopeResponse struct {
	// Result of listing views. It contains a list of available views.
	ViewListResult
}

// ViewsClientListResponse contains the response from method ViewsClient.NewListPager.
type ViewsClientListResponse struct {
	// Result of listing views. It contains a list of available views.
	ViewListResult
}
