//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v3"
	"net/http"
	"net/url"
	"regexp"
)

// BackupInstancesExtensionRoutingServer is a fake server for instances of the armdataprotection.BackupInstancesExtensionRoutingClient type.
type BackupInstancesExtensionRoutingServer struct {
	// NewListPager is the fake for method BackupInstancesExtensionRoutingClient.NewListPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListPager func(resourceID string, options *armdataprotection.BackupInstancesExtensionRoutingClientListOptions) (resp azfake.PagerResponder[armdataprotection.BackupInstancesExtensionRoutingClientListResponse])
}

// NewBackupInstancesExtensionRoutingServerTransport creates a new instance of BackupInstancesExtensionRoutingServerTransport with the provided implementation.
// The returned BackupInstancesExtensionRoutingServerTransport instance is connected to an instance of armdataprotection.BackupInstancesExtensionRoutingClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewBackupInstancesExtensionRoutingServerTransport(srv *BackupInstancesExtensionRoutingServer) *BackupInstancesExtensionRoutingServerTransport {
	return &BackupInstancesExtensionRoutingServerTransport{
		srv:          srv,
		newListPager: newTracker[azfake.PagerResponder[armdataprotection.BackupInstancesExtensionRoutingClientListResponse]](),
	}
}

// BackupInstancesExtensionRoutingServerTransport connects instances of armdataprotection.BackupInstancesExtensionRoutingClient to instances of BackupInstancesExtensionRoutingServer.
// Don't use this type directly, use NewBackupInstancesExtensionRoutingServerTransport instead.
type BackupInstancesExtensionRoutingServerTransport struct {
	srv          *BackupInstancesExtensionRoutingServer
	newListPager *tracker[azfake.PagerResponder[armdataprotection.BackupInstancesExtensionRoutingClientListResponse]]
}

// Do implements the policy.Transporter interface for BackupInstancesExtensionRoutingServerTransport.
func (b *BackupInstancesExtensionRoutingServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "BackupInstancesExtensionRoutingClient.NewListPager":
		resp, err = b.dispatchNewListPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (b *BackupInstancesExtensionRoutingServerTransport) dispatchNewListPager(req *http.Request) (*http.Response, error) {
	if b.srv.NewListPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListPager not implemented")}
	}
	newListPager := b.newListPager.get(req)
	if newListPager == nil {
		const regexStr = `/(?P<resourceId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.DataProtection/backupInstances`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 1 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceIDParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceId")])
		if err != nil {
			return nil, err
		}
		resp := b.srv.NewListPager(resourceIDParam, nil)
		newListPager = &resp
		b.newListPager.add(req, newListPager)
		server.PagerResponderInjectNextLinks(newListPager, req, func(page *armdataprotection.BackupInstancesExtensionRoutingClientListResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		b.newListPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListPager) {
		b.newListPager.remove(req)
	}
	return resp, nil
}
