//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdatashare

// AccountsClientBeginCreateOptions contains the optional parameters for the AccountsClient.BeginCreate method.
type AccountsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AccountsClientBeginDeleteOptions contains the optional parameters for the AccountsClient.BeginDelete method.
type AccountsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AccountsClientGetOptions contains the optional parameters for the AccountsClient.Get method.
type AccountsClientGetOptions struct {
	// placeholder for future optional parameters
}

// AccountsClientListByResourceGroupOptions contains the optional parameters for the AccountsClient.NewListByResourceGroupPager
// method.
type AccountsClientListByResourceGroupOptions struct {
	// Continuation token
	SkipToken *string
}

// AccountsClientListBySubscriptionOptions contains the optional parameters for the AccountsClient.NewListBySubscriptionPager
// method.
type AccountsClientListBySubscriptionOptions struct {
	// Continuation token
	SkipToken *string
}

// AccountsClientUpdateOptions contains the optional parameters for the AccountsClient.Update method.
type AccountsClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// ConsumerInvitationsClientGetOptions contains the optional parameters for the ConsumerInvitationsClient.Get method.
type ConsumerInvitationsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ConsumerInvitationsClientListInvitationsOptions contains the optional parameters for the ConsumerInvitationsClient.NewListInvitationsPager
// method.
type ConsumerInvitationsClientListInvitationsOptions struct {
	// The continuation token
	SkipToken *string
}

// ConsumerInvitationsClientRejectInvitationOptions contains the optional parameters for the ConsumerInvitationsClient.RejectInvitation
// method.
type ConsumerInvitationsClientRejectInvitationOptions struct {
	// placeholder for future optional parameters
}

// ConsumerSourceDataSetsClientListByShareSubscriptionOptions contains the optional parameters for the ConsumerSourceDataSetsClient.NewListByShareSubscriptionPager
// method.
type ConsumerSourceDataSetsClientListByShareSubscriptionOptions struct {
	// Continuation token
	SkipToken *string
}

// DataSetMappingsClientCreateOptions contains the optional parameters for the DataSetMappingsClient.Create method.
type DataSetMappingsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// DataSetMappingsClientDeleteOptions contains the optional parameters for the DataSetMappingsClient.Delete method.
type DataSetMappingsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// DataSetMappingsClientGetOptions contains the optional parameters for the DataSetMappingsClient.Get method.
type DataSetMappingsClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataSetMappingsClientListByShareSubscriptionOptions contains the optional parameters for the DataSetMappingsClient.NewListByShareSubscriptionPager
// method.
type DataSetMappingsClientListByShareSubscriptionOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation token
	SkipToken *string
}

// DataSetsClientBeginDeleteOptions contains the optional parameters for the DataSetsClient.BeginDelete method.
type DataSetsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataSetsClientCreateOptions contains the optional parameters for the DataSetsClient.Create method.
type DataSetsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// DataSetsClientGetOptions contains the optional parameters for the DataSetsClient.Get method.
type DataSetsClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataSetsClientListByShareOptions contains the optional parameters for the DataSetsClient.NewListBySharePager method.
type DataSetsClientListByShareOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// continuation token
	SkipToken *string
}

// EmailRegistrationsClientActivateEmailOptions contains the optional parameters for the EmailRegistrationsClient.ActivateEmail
// method.
type EmailRegistrationsClientActivateEmailOptions struct {
	// placeholder for future optional parameters
}

// EmailRegistrationsClientRegisterEmailOptions contains the optional parameters for the EmailRegistrationsClient.RegisterEmail
// method.
type EmailRegistrationsClientRegisterEmailOptions struct {
	// placeholder for future optional parameters
}

// InvitationsClientCreateOptions contains the optional parameters for the InvitationsClient.Create method.
type InvitationsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// InvitationsClientDeleteOptions contains the optional parameters for the InvitationsClient.Delete method.
type InvitationsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// InvitationsClientGetOptions contains the optional parameters for the InvitationsClient.Get method.
type InvitationsClientGetOptions struct {
	// placeholder for future optional parameters
}

// InvitationsClientListByShareOptions contains the optional parameters for the InvitationsClient.NewListBySharePager method.
type InvitationsClientListByShareOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// The continuation token
	SkipToken *string
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// ProviderShareSubscriptionsClientAdjustOptions contains the optional parameters for the ProviderShareSubscriptionsClient.Adjust
// method.
type ProviderShareSubscriptionsClientAdjustOptions struct {
	// placeholder for future optional parameters
}

// ProviderShareSubscriptionsClientBeginRevokeOptions contains the optional parameters for the ProviderShareSubscriptionsClient.BeginRevoke
// method.
type ProviderShareSubscriptionsClientBeginRevokeOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProviderShareSubscriptionsClientGetByShareOptions contains the optional parameters for the ProviderShareSubscriptionsClient.GetByShare
// method.
type ProviderShareSubscriptionsClientGetByShareOptions struct {
	// placeholder for future optional parameters
}

// ProviderShareSubscriptionsClientListByShareOptions contains the optional parameters for the ProviderShareSubscriptionsClient.NewListBySharePager
// method.
type ProviderShareSubscriptionsClientListByShareOptions struct {
	// Continuation Token
	SkipToken *string
}

// ProviderShareSubscriptionsClientReinstateOptions contains the optional parameters for the ProviderShareSubscriptionsClient.Reinstate
// method.
type ProviderShareSubscriptionsClientReinstateOptions struct {
	// placeholder for future optional parameters
}

// ShareSubscriptionsClientBeginCancelSynchronizationOptions contains the optional parameters for the ShareSubscriptionsClient.BeginCancelSynchronization
// method.
type ShareSubscriptionsClientBeginCancelSynchronizationOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ShareSubscriptionsClientBeginDeleteOptions contains the optional parameters for the ShareSubscriptionsClient.BeginDelete
// method.
type ShareSubscriptionsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ShareSubscriptionsClientBeginSynchronizeOptions contains the optional parameters for the ShareSubscriptionsClient.BeginSynchronize
// method.
type ShareSubscriptionsClientBeginSynchronizeOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ShareSubscriptionsClientCreateOptions contains the optional parameters for the ShareSubscriptionsClient.Create method.
type ShareSubscriptionsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// ShareSubscriptionsClientGetOptions contains the optional parameters for the ShareSubscriptionsClient.Get method.
type ShareSubscriptionsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ShareSubscriptionsClientListByAccountOptions contains the optional parameters for the ShareSubscriptionsClient.NewListByAccountPager
// method.
type ShareSubscriptionsClientListByAccountOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation Token
	SkipToken *string
}

// ShareSubscriptionsClientListSourceShareSynchronizationSettingsOptions contains the optional parameters for the ShareSubscriptionsClient.NewListSourceShareSynchronizationSettingsPager
// method.
type ShareSubscriptionsClientListSourceShareSynchronizationSettingsOptions struct {
	// Continuation token
	SkipToken *string
}

// ShareSubscriptionsClientListSynchronizationDetailsOptions contains the optional parameters for the ShareSubscriptionsClient.NewListSynchronizationDetailsPager
// method.
type ShareSubscriptionsClientListSynchronizationDetailsOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation token
	SkipToken *string
}

// ShareSubscriptionsClientListSynchronizationsOptions contains the optional parameters for the ShareSubscriptionsClient.NewListSynchronizationsPager
// method.
type ShareSubscriptionsClientListSynchronizationsOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation token
	SkipToken *string
}

// SharesClientBeginDeleteOptions contains the optional parameters for the SharesClient.BeginDelete method.
type SharesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SharesClientCreateOptions contains the optional parameters for the SharesClient.Create method.
type SharesClientCreateOptions struct {
	// placeholder for future optional parameters
}

// SharesClientGetOptions contains the optional parameters for the SharesClient.Get method.
type SharesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SharesClientListByAccountOptions contains the optional parameters for the SharesClient.NewListByAccountPager method.
type SharesClientListByAccountOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation Token
	SkipToken *string
}

// SharesClientListSynchronizationDetailsOptions contains the optional parameters for the SharesClient.NewListSynchronizationDetailsPager
// method.
type SharesClientListSynchronizationDetailsOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation token
	SkipToken *string
}

// SharesClientListSynchronizationsOptions contains the optional parameters for the SharesClient.NewListSynchronizationsPager
// method.
type SharesClientListSynchronizationsOptions struct {
	// Filters the results using OData syntax.
	Filter *string

	// Sorts the results using OData syntax.
	Orderby *string

	// Continuation token
	SkipToken *string
}

// SynchronizationSettingsClientBeginDeleteOptions contains the optional parameters for the SynchronizationSettingsClient.BeginDelete
// method.
type SynchronizationSettingsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SynchronizationSettingsClientCreateOptions contains the optional parameters for the SynchronizationSettingsClient.Create
// method.
type SynchronizationSettingsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// SynchronizationSettingsClientGetOptions contains the optional parameters for the SynchronizationSettingsClient.Get method.
type SynchronizationSettingsClientGetOptions struct {
	// placeholder for future optional parameters
}

// SynchronizationSettingsClientListByShareOptions contains the optional parameters for the SynchronizationSettingsClient.NewListBySharePager
// method.
type SynchronizationSettingsClientListByShareOptions struct {
	// continuation token
	SkipToken *string
}

// TriggersClientBeginCreateOptions contains the optional parameters for the TriggersClient.BeginCreate method.
type TriggersClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// TriggersClientBeginDeleteOptions contains the optional parameters for the TriggersClient.BeginDelete method.
type TriggersClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// TriggersClientGetOptions contains the optional parameters for the TriggersClient.Get method.
type TriggersClientGetOptions struct {
	// placeholder for future optional parameters
}

// TriggersClientListByShareSubscriptionOptions contains the optional parameters for the TriggersClient.NewListByShareSubscriptionPager
// method.
type TriggersClientListByShareSubscriptionOptions struct {
	// Continuation token
	SkipToken *string
}
