//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdeploymentmanager

// ArtifactSourcesClientCreateOrUpdateOptions contains the optional parameters for the ArtifactSourcesClient.CreateOrUpdate
// method.
type ArtifactSourcesClientCreateOrUpdateOptions struct {
	// Source object that defines the resource.
	ArtifactSourceInfo *ArtifactSource
}

// ArtifactSourcesClientDeleteOptions contains the optional parameters for the ArtifactSourcesClient.Delete method.
type ArtifactSourcesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// ArtifactSourcesClientGetOptions contains the optional parameters for the ArtifactSourcesClient.Get method.
type ArtifactSourcesClientGetOptions struct {
	// placeholder for future optional parameters
}

// ArtifactSourcesClientListOptions contains the optional parameters for the ArtifactSourcesClient.List method.
type ArtifactSourcesClientListOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.List method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// RolloutsClientBeginCreateOrUpdateOptions contains the optional parameters for the RolloutsClient.BeginCreateOrUpdate method.
type RolloutsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string

	// Source rollout request object that defines the rollout.
	RolloutRequest *RolloutRequest
}

// RolloutsClientCancelOptions contains the optional parameters for the RolloutsClient.Cancel method.
type RolloutsClientCancelOptions struct {
	// placeholder for future optional parameters
}

// RolloutsClientDeleteOptions contains the optional parameters for the RolloutsClient.Delete method.
type RolloutsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// RolloutsClientGetOptions contains the optional parameters for the RolloutsClient.Get method.
type RolloutsClientGetOptions struct {
	// Rollout retry attempt ordinal to get the result of. If not specified, result of the latest attempt will be returned.
	RetryAttempt *int32
}

// RolloutsClientListOptions contains the optional parameters for the RolloutsClient.List method.
type RolloutsClientListOptions struct {
	// placeholder for future optional parameters
}

// RolloutsClientRestartOptions contains the optional parameters for the RolloutsClient.Restart method.
type RolloutsClientRestartOptions struct {
	// If true, will skip all succeeded steps so far in the rollout. If false, will execute the entire rollout again regardless
	// of the current state of individual resources. Defaults to false if not
	// specified.
	SkipSucceeded *bool
}

// ServiceTopologiesClientCreateOrUpdateOptions contains the optional parameters for the ServiceTopologiesClient.CreateOrUpdate
// method.
type ServiceTopologiesClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// ServiceTopologiesClientDeleteOptions contains the optional parameters for the ServiceTopologiesClient.Delete method.
type ServiceTopologiesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// ServiceTopologiesClientGetOptions contains the optional parameters for the ServiceTopologiesClient.Get method.
type ServiceTopologiesClientGetOptions struct {
	// placeholder for future optional parameters
}

// ServiceTopologiesClientListOptions contains the optional parameters for the ServiceTopologiesClient.List method.
type ServiceTopologiesClientListOptions struct {
	// placeholder for future optional parameters
}

// ServiceUnitsClientBeginCreateOrUpdateOptions contains the optional parameters for the ServiceUnitsClient.BeginCreateOrUpdate
// method.
type ServiceUnitsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServiceUnitsClientDeleteOptions contains the optional parameters for the ServiceUnitsClient.Delete method.
type ServiceUnitsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// ServiceUnitsClientGetOptions contains the optional parameters for the ServiceUnitsClient.Get method.
type ServiceUnitsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ServiceUnitsClientListOptions contains the optional parameters for the ServiceUnitsClient.List method.
type ServiceUnitsClientListOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientCreateOrUpdateOptions contains the optional parameters for the ServicesClient.CreateOrUpdate method.
type ServicesClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientDeleteOptions contains the optional parameters for the ServicesClient.Delete method.
type ServicesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientGetOptions contains the optional parameters for the ServicesClient.Get method.
type ServicesClientGetOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientListOptions contains the optional parameters for the ServicesClient.List method.
type ServicesClientListOptions struct {
	// placeholder for future optional parameters
}

// StepsClientCreateOrUpdateOptions contains the optional parameters for the StepsClient.CreateOrUpdate method.
type StepsClientCreateOrUpdateOptions struct {
	// The step object.
	StepInfo *StepResource
}

// StepsClientDeleteOptions contains the optional parameters for the StepsClient.Delete method.
type StepsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// StepsClientGetOptions contains the optional parameters for the StepsClient.Get method.
type StepsClientGetOptions struct {
	// placeholder for future optional parameters
}

// StepsClientListOptions contains the optional parameters for the StepsClient.List method.
type StepsClientListOptions struct {
	// placeholder for future optional parameters
}
