//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdesktopvirtualization

// AppAttachPackageClientCreateOrUpdateResponse contains the response from method AppAttachPackageClient.CreateOrUpdate.
type AppAttachPackageClientCreateOrUpdateResponse struct {
	// Schema for App Attach Package properties.
	AppAttachPackage
}

// AppAttachPackageClientDeleteResponse contains the response from method AppAttachPackageClient.Delete.
type AppAttachPackageClientDeleteResponse struct {
	// placeholder for future response values
}

// AppAttachPackageClientGetResponse contains the response from method AppAttachPackageClient.Get.
type AppAttachPackageClientGetResponse struct {
	// Schema for App Attach Package properties.
	AppAttachPackage
}

// AppAttachPackageClientListByResourceGroupResponse contains the response from method AppAttachPackageClient.NewListByResourceGroupPager.
type AppAttachPackageClientListByResourceGroupResponse struct {
	// List of App Attach Package definitions.
	AppAttachPackageList
}

// AppAttachPackageClientListBySubscriptionResponse contains the response from method AppAttachPackageClient.NewListBySubscriptionPager.
type AppAttachPackageClientListBySubscriptionResponse struct {
	// List of App Attach Package definitions.
	AppAttachPackageList
}

// AppAttachPackageClientUpdateResponse contains the response from method AppAttachPackageClient.Update.
type AppAttachPackageClientUpdateResponse struct {
	// Schema for App Attach Package properties.
	AppAttachPackage
}

// AppAttachPackageInfoClientImportResponse contains the response from method AppAttachPackageInfoClient.NewImportPager.
type AppAttachPackageInfoClientImportResponse struct {
	// List of App Attach Package definitions.
	AppAttachPackageList
}

// ApplicationGroupsClientCreateOrUpdateResponse contains the response from method ApplicationGroupsClient.CreateOrUpdate.
type ApplicationGroupsClientCreateOrUpdateResponse struct {
	// Represents a ApplicationGroup definition.
	ApplicationGroup
}

// ApplicationGroupsClientDeleteResponse contains the response from method ApplicationGroupsClient.Delete.
type ApplicationGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationGroupsClientGetResponse contains the response from method ApplicationGroupsClient.Get.
type ApplicationGroupsClientGetResponse struct {
	// Represents a ApplicationGroup definition.
	ApplicationGroup
}

// ApplicationGroupsClientListByResourceGroupResponse contains the response from method ApplicationGroupsClient.NewListByResourceGroupPager.
type ApplicationGroupsClientListByResourceGroupResponse struct {
	// List of ApplicationGroup definitions.
	ApplicationGroupList
}

// ApplicationGroupsClientListBySubscriptionResponse contains the response from method ApplicationGroupsClient.NewListBySubscriptionPager.
type ApplicationGroupsClientListBySubscriptionResponse struct {
	// List of ApplicationGroup definitions.
	ApplicationGroupList
}

// ApplicationGroupsClientUpdateResponse contains the response from method ApplicationGroupsClient.Update.
type ApplicationGroupsClientUpdateResponse struct {
	// Represents a ApplicationGroup definition.
	ApplicationGroup
}

// ApplicationsClientCreateOrUpdateResponse contains the response from method ApplicationsClient.CreateOrUpdate.
type ApplicationsClientCreateOrUpdateResponse struct {
	// Schema for Application properties.
	Application
}

// ApplicationsClientDeleteResponse contains the response from method ApplicationsClient.Delete.
type ApplicationsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationsClientGetResponse contains the response from method ApplicationsClient.Get.
type ApplicationsClientGetResponse struct {
	// Schema for Application properties.
	Application
}

// ApplicationsClientListResponse contains the response from method ApplicationsClient.NewListPager.
type ApplicationsClientListResponse struct {
	// List of Application definitions.
	ApplicationList
}

// ApplicationsClientUpdateResponse contains the response from method ApplicationsClient.Update.
type ApplicationsClientUpdateResponse struct {
	// Schema for Application properties.
	Application
}

// DesktopsClientGetResponse contains the response from method DesktopsClient.Get.
type DesktopsClientGetResponse struct {
	// Schema for Desktop properties.
	Desktop
}

// DesktopsClientListResponse contains the response from method DesktopsClient.NewListPager.
type DesktopsClientListResponse struct {
	// List of Desktop definitions.
	DesktopList
}

// DesktopsClientUpdateResponse contains the response from method DesktopsClient.Update.
type DesktopsClientUpdateResponse struct {
	// Schema for Desktop properties.
	Desktop
}

// HostPoolsClientCreateOrUpdateResponse contains the response from method HostPoolsClient.CreateOrUpdate.
type HostPoolsClientCreateOrUpdateResponse struct {
	// Represents a HostPool definition.
	HostPool
}

// HostPoolsClientDeleteResponse contains the response from method HostPoolsClient.Delete.
type HostPoolsClientDeleteResponse struct {
	// placeholder for future response values
}

// HostPoolsClientGetResponse contains the response from method HostPoolsClient.Get.
type HostPoolsClientGetResponse struct {
	// Represents a HostPool definition.
	HostPool
}

// HostPoolsClientListByResourceGroupResponse contains the response from method HostPoolsClient.NewListByResourceGroupPager.
type HostPoolsClientListByResourceGroupResponse struct {
	// List of HostPool definitions.
	HostPoolList
}

// HostPoolsClientListRegistrationTokensResponse contains the response from method HostPoolsClient.ListRegistrationTokens.
type HostPoolsClientListRegistrationTokensResponse struct {
	// List of RegistrationToken definitions.
	RegistrationTokenList
}

// HostPoolsClientListResponse contains the response from method HostPoolsClient.NewListPager.
type HostPoolsClientListResponse struct {
	// List of HostPool definitions.
	HostPoolList
}

// HostPoolsClientRetrieveRegistrationTokenResponse contains the response from method HostPoolsClient.RetrieveRegistrationToken.
type HostPoolsClientRetrieveRegistrationTokenResponse struct {
	// Represents a RegistrationInfo definition.
	RegistrationInfo
}

// HostPoolsClientUpdateResponse contains the response from method HostPoolsClient.Update.
type HostPoolsClientUpdateResponse struct {
	// Represents a HostPool definition.
	HostPool
}

// MSIXPackagesClientCreateOrUpdateResponse contains the response from method MSIXPackagesClient.CreateOrUpdate.
type MSIXPackagesClientCreateOrUpdateResponse struct {
	// Schema for MSIX Package properties.
	MSIXPackage
}

// MSIXPackagesClientDeleteResponse contains the response from method MSIXPackagesClient.Delete.
type MSIXPackagesClientDeleteResponse struct {
	// placeholder for future response values
}

// MSIXPackagesClientGetResponse contains the response from method MSIXPackagesClient.Get.
type MSIXPackagesClientGetResponse struct {
	// Schema for MSIX Package properties.
	MSIXPackage
}

// MSIXPackagesClientListResponse contains the response from method MSIXPackagesClient.NewListPager.
type MSIXPackagesClientListResponse struct {
	// List of MSIX Package definitions.
	MSIXPackageList
}

// MSIXPackagesClientUpdateResponse contains the response from method MSIXPackagesClient.Update.
type MSIXPackagesClientUpdateResponse struct {
	// Schema for MSIX Package properties.
	MSIXPackage
}

// MsixImagesClientExpandResponse contains the response from method MsixImagesClient.NewExpandPager.
type MsixImagesClientExpandResponse struct {
	// List of MSIX package properties retrieved from MSIX Image expansion.
	ExpandMsixImageList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list operations.
	ResourceProviderOperationList
}

// PrivateEndpointConnectionsClientDeleteByHostPoolResponse contains the response from method PrivateEndpointConnectionsClient.DeleteByHostPool.
type PrivateEndpointConnectionsClientDeleteByHostPoolResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientDeleteByWorkspaceResponse contains the response from method PrivateEndpointConnectionsClient.DeleteByWorkspace.
type PrivateEndpointConnectionsClientDeleteByWorkspaceResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetByHostPoolResponse contains the response from method PrivateEndpointConnectionsClient.GetByHostPool.
type PrivateEndpointConnectionsClientGetByHostPoolResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnectionWithSystemData
}

// PrivateEndpointConnectionsClientGetByWorkspaceResponse contains the response from method PrivateEndpointConnectionsClient.GetByWorkspace.
type PrivateEndpointConnectionsClientGetByWorkspaceResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnectionWithSystemData
}

// PrivateEndpointConnectionsClientListByHostPoolResponse contains the response from method PrivateEndpointConnectionsClient.NewListByHostPoolPager.
type PrivateEndpointConnectionsClientListByHostPoolResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResultWithSystemData
}

// PrivateEndpointConnectionsClientListByWorkspaceResponse contains the response from method PrivateEndpointConnectionsClient.NewListByWorkspacePager.
type PrivateEndpointConnectionsClientListByWorkspaceResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResultWithSystemData
}

// PrivateEndpointConnectionsClientUpdateByHostPoolResponse contains the response from method PrivateEndpointConnectionsClient.UpdateByHostPool.
type PrivateEndpointConnectionsClientUpdateByHostPoolResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnectionWithSystemData
}

// PrivateEndpointConnectionsClientUpdateByWorkspaceResponse contains the response from method PrivateEndpointConnectionsClient.UpdateByWorkspace.
type PrivateEndpointConnectionsClientUpdateByWorkspaceResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnectionWithSystemData
}

// PrivateLinkResourcesClientListByHostPoolResponse contains the response from method PrivateLinkResourcesClient.NewListByHostPoolPager.
type PrivateLinkResourcesClientListByHostPoolResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// PrivateLinkResourcesClientListByWorkspaceResponse contains the response from method PrivateLinkResourcesClient.NewListByWorkspacePager.
type PrivateLinkResourcesClientListByWorkspaceResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// ScalingPlanPersonalSchedulesClientCreateResponse contains the response from method ScalingPlanPersonalSchedulesClient.Create.
type ScalingPlanPersonalSchedulesClientCreateResponse struct {
	// Represents a ScalingPlanPersonalSchedule definition.
	ScalingPlanPersonalSchedule
}

// ScalingPlanPersonalSchedulesClientDeleteResponse contains the response from method ScalingPlanPersonalSchedulesClient.Delete.
type ScalingPlanPersonalSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// ScalingPlanPersonalSchedulesClientGetResponse contains the response from method ScalingPlanPersonalSchedulesClient.Get.
type ScalingPlanPersonalSchedulesClientGetResponse struct {
	// Represents a ScalingPlanPersonalSchedule definition.
	ScalingPlanPersonalSchedule
}

// ScalingPlanPersonalSchedulesClientListResponse contains the response from method ScalingPlanPersonalSchedulesClient.NewListPager.
type ScalingPlanPersonalSchedulesClientListResponse struct {
	// List of ScalingPlanPersonalSchedule definitions.
	ScalingPlanPersonalScheduleList
}

// ScalingPlanPersonalSchedulesClientUpdateResponse contains the response from method ScalingPlanPersonalSchedulesClient.Update.
type ScalingPlanPersonalSchedulesClientUpdateResponse struct {
	// Represents a ScalingPlanPersonalSchedule definition.
	ScalingPlanPersonalSchedule
}

// ScalingPlanPooledSchedulesClientCreateResponse contains the response from method ScalingPlanPooledSchedulesClient.Create.
type ScalingPlanPooledSchedulesClientCreateResponse struct {
	// Represents a ScalingPlanPooledSchedule definition.
	ScalingPlanPooledSchedule
}

// ScalingPlanPooledSchedulesClientDeleteResponse contains the response from method ScalingPlanPooledSchedulesClient.Delete.
type ScalingPlanPooledSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// ScalingPlanPooledSchedulesClientGetResponse contains the response from method ScalingPlanPooledSchedulesClient.Get.
type ScalingPlanPooledSchedulesClientGetResponse struct {
	// Represents a ScalingPlanPooledSchedule definition.
	ScalingPlanPooledSchedule
}

// ScalingPlanPooledSchedulesClientListResponse contains the response from method ScalingPlanPooledSchedulesClient.NewListPager.
type ScalingPlanPooledSchedulesClientListResponse struct {
	// List of ScalingPlanPooledSchedule definitions.
	ScalingPlanPooledScheduleList
}

// ScalingPlanPooledSchedulesClientUpdateResponse contains the response from method ScalingPlanPooledSchedulesClient.Update.
type ScalingPlanPooledSchedulesClientUpdateResponse struct {
	// Represents a ScalingPlanPooledSchedule definition.
	ScalingPlanPooledSchedule
}

// ScalingPlansClientCreateResponse contains the response from method ScalingPlansClient.Create.
type ScalingPlansClientCreateResponse struct {
	// Represents a scaling plan definition.
	ScalingPlan
}

// ScalingPlansClientDeleteResponse contains the response from method ScalingPlansClient.Delete.
type ScalingPlansClientDeleteResponse struct {
	// placeholder for future response values
}

// ScalingPlansClientGetResponse contains the response from method ScalingPlansClient.Get.
type ScalingPlansClientGetResponse struct {
	// Represents a scaling plan definition.
	ScalingPlan
}

// ScalingPlansClientListByHostPoolResponse contains the response from method ScalingPlansClient.NewListByHostPoolPager.
type ScalingPlansClientListByHostPoolResponse struct {
	// List of scaling plan definitions.
	ScalingPlanList
}

// ScalingPlansClientListByResourceGroupResponse contains the response from method ScalingPlansClient.NewListByResourceGroupPager.
type ScalingPlansClientListByResourceGroupResponse struct {
	// List of scaling plan definitions.
	ScalingPlanList
}

// ScalingPlansClientListBySubscriptionResponse contains the response from method ScalingPlansClient.NewListBySubscriptionPager.
type ScalingPlansClientListBySubscriptionResponse struct {
	// List of scaling plan definitions.
	ScalingPlanList
}

// ScalingPlansClientUpdateResponse contains the response from method ScalingPlansClient.Update.
type ScalingPlansClientUpdateResponse struct {
	// Represents a scaling plan definition.
	ScalingPlan
}

// SessionHostsClientDeleteResponse contains the response from method SessionHostsClient.Delete.
type SessionHostsClientDeleteResponse struct {
	// placeholder for future response values
}

// SessionHostsClientGetResponse contains the response from method SessionHostsClient.Get.
type SessionHostsClientGetResponse struct {
	// Represents a SessionHost definition.
	SessionHost
}

// SessionHostsClientListResponse contains the response from method SessionHostsClient.NewListPager.
type SessionHostsClientListResponse struct {
	// List of SessionHost definitions.
	SessionHostList
}

// SessionHostsClientUpdateResponse contains the response from method SessionHostsClient.Update.
type SessionHostsClientUpdateResponse struct {
	// Represents a SessionHost definition.
	SessionHost
}

// StartMenuItemsClientListResponse contains the response from method StartMenuItemsClient.NewListPager.
type StartMenuItemsClientListResponse struct {
	// List of StartMenuItem definitions.
	StartMenuItemList
}

// UserSessionsClientDeleteResponse contains the response from method UserSessionsClient.Delete.
type UserSessionsClientDeleteResponse struct {
	// placeholder for future response values
}

// UserSessionsClientDisconnectResponse contains the response from method UserSessionsClient.Disconnect.
type UserSessionsClientDisconnectResponse struct {
	// placeholder for future response values
}

// UserSessionsClientGetResponse contains the response from method UserSessionsClient.Get.
type UserSessionsClientGetResponse struct {
	// Represents a UserSession definition.
	UserSession
}

// UserSessionsClientListByHostPoolResponse contains the response from method UserSessionsClient.NewListByHostPoolPager.
type UserSessionsClientListByHostPoolResponse struct {
	// List of UserSession definitions.
	UserSessionList
}

// UserSessionsClientListResponse contains the response from method UserSessionsClient.NewListPager.
type UserSessionsClientListResponse struct {
	// List of UserSession definitions.
	UserSessionList
}

// UserSessionsClientSendMessageResponse contains the response from method UserSessionsClient.SendMessage.
type UserSessionsClientSendMessageResponse struct {
	// placeholder for future response values
}

// WorkspacesClientCreateOrUpdateResponse contains the response from method WorkspacesClient.CreateOrUpdate.
type WorkspacesClientCreateOrUpdateResponse struct {
	// Represents a Workspace definition.
	Workspace
}

// WorkspacesClientDeleteResponse contains the response from method WorkspacesClient.Delete.
type WorkspacesClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspacesClientGetResponse contains the response from method WorkspacesClient.Get.
type WorkspacesClientGetResponse struct {
	// Represents a Workspace definition.
	Workspace
}

// WorkspacesClientListByResourceGroupResponse contains the response from method WorkspacesClient.NewListByResourceGroupPager.
type WorkspacesClientListByResourceGroupResponse struct {
	// List of Workspace definitions.
	WorkspaceList
}

// WorkspacesClientListBySubscriptionResponse contains the response from method WorkspacesClient.NewListBySubscriptionPager.
type WorkspacesClientListBySubscriptionResponse struct {
	// List of Workspace definitions.
	WorkspaceList
}

// WorkspacesClientUpdateResponse contains the response from method WorkspacesClient.Update.
type WorkspacesClientUpdateResponse struct {
	// Represents a Workspace definition.
	Workspace
}
