//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdevhub

// DeveloperHubServiceClientGeneratePreviewArtifactsResponse contains the response from method DeveloperHubServiceClient.GeneratePreviewArtifacts.
type DeveloperHubServiceClientGeneratePreviewArtifactsResponse struct {
	// Dockerfile and manifest artifacts generated as a preview are returned as a map<path string,content string>
	Value map[string]*string
}

// DeveloperHubServiceClientGitHubOAuthCallbackResponse contains the response from method DeveloperHubServiceClient.GitHubOAuthCallback.
type DeveloperHubServiceClientGitHubOAuthCallbackResponse struct {
	// Singleton response of GitHubOAuth containing
	GitHubOAuthResponse
}

// DeveloperHubServiceClientGitHubOAuthResponse contains the response from method DeveloperHubServiceClient.GitHubOAuth.
type DeveloperHubServiceClientGitHubOAuthResponse struct {
	// URL used to authorize the Developer Hub GitHub App
	GitHubOAuthInfoResponse
}

// DeveloperHubServiceClientListGitHubOAuthResponse contains the response from method DeveloperHubServiceClient.ListGitHubOAuth.
type DeveloperHubServiceClientListGitHubOAuthResponse struct {
	// The response from List GitHubOAuth operation.
	GitHubOAuthListResponse
}

// IacProfilesClientCreateOrUpdateResponse contains the response from method IacProfilesClient.CreateOrUpdate.
type IacProfilesClientCreateOrUpdateResponse struct {
	// Resource representation of a IacProfile.
	IacProfile
}

// IacProfilesClientDeleteResponse contains the response from method IacProfilesClient.Delete.
type IacProfilesClientDeleteResponse struct {
	// placeholder for future response values
}

// IacProfilesClientExportResponse contains the response from method IacProfilesClient.Export.
type IacProfilesClientExportResponse struct {
	PrLinkResponse
}

// IacProfilesClientGetResponse contains the response from method IacProfilesClient.Get.
type IacProfilesClientGetResponse struct {
	// Resource representation of a IacProfile.
	IacProfile
}

// IacProfilesClientListByResourceGroupResponse contains the response from method IacProfilesClient.NewListByResourceGroupPager.
type IacProfilesClientListByResourceGroupResponse struct {
	IacProfileListResult
}

// IacProfilesClientListResponse contains the response from method IacProfilesClient.NewListPager.
type IacProfilesClientListResponse struct {
	IacProfileListResult
}

// IacProfilesClientScaleResponse contains the response from method IacProfilesClient.Scale.
type IacProfilesClientScaleResponse struct {
	PrLinkResponse
}

// IacProfilesClientSyncResponse contains the response from method IacProfilesClient.Sync.
type IacProfilesClientSyncResponse struct {
	// placeholder for future response values
}

// IacProfilesClientUpdateTagsResponse contains the response from method IacProfilesClient.UpdateTags.
type IacProfilesClientUpdateTagsResponse struct {
	// Resource representation of a IacProfile.
	IacProfile
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// WorkflowClientCreateOrUpdateResponse contains the response from method WorkflowClient.CreateOrUpdate.
type WorkflowClientCreateOrUpdateResponse struct {
	// Resource representation of a workflow
	Workflow
}

// WorkflowClientDeleteResponse contains the response from method WorkflowClient.Delete.
type WorkflowClientDeleteResponse struct {
	// delete response if content must be provided on delete operation
	DeleteWorkflowResponse
}

// WorkflowClientGetResponse contains the response from method WorkflowClient.Get.
type WorkflowClientGetResponse struct {
	// Resource representation of a workflow
	Workflow
}

// WorkflowClientListByResourceGroupResponse contains the response from method WorkflowClient.NewListByResourceGroupPager.
type WorkflowClientListByResourceGroupResponse struct {
	// The response from List Workflows operation.
	WorkflowListResult
}

// WorkflowClientListResponse contains the response from method WorkflowClient.NewListPager.
type WorkflowClientListResponse struct {
	// The response from List Workflows operation.
	WorkflowListResult
}

// WorkflowClientUpdateTagsResponse contains the response from method WorkflowClient.UpdateTags.
type WorkflowClientUpdateTagsResponse struct {
	// Resource representation of a workflow
	Workflow
}
