//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdeviceprovisioningservices

// DpsCertificateClientCreateOrUpdateResponse contains the response from method DpsCertificateClient.CreateOrUpdate.
type DpsCertificateClientCreateOrUpdateResponse struct {
	// The X509 Certificate.
	CertificateResponse
}

// DpsCertificateClientDeleteResponse contains the response from method DpsCertificateClient.Delete.
type DpsCertificateClientDeleteResponse struct {
	// placeholder for future response values
}

// DpsCertificateClientGenerateVerificationCodeResponse contains the response from method DpsCertificateClient.GenerateVerificationCode.
type DpsCertificateClientGenerateVerificationCodeResponse struct {
	// Description of the response of the verification code.
	VerificationCodeResponse
}

// DpsCertificateClientGetResponse contains the response from method DpsCertificateClient.Get.
type DpsCertificateClientGetResponse struct {
	// The X509 Certificate.
	CertificateResponse
}

// DpsCertificateClientListResponse contains the response from method DpsCertificateClient.List.
type DpsCertificateClientListResponse struct {
	// The JSON-serialized array of Certificate objects.
	CertificateListDescription
}

// DpsCertificateClientVerifyCertificateResponse contains the response from method DpsCertificateClient.VerifyCertificate.
type DpsCertificateClientVerifyCertificateResponse struct {
	// The X509 Certificate.
	CertificateResponse
}

// IotDpsResourceClientCheckProvisioningServiceNameAvailabilityResponse contains the response from method IotDpsResourceClient.CheckProvisioningServiceNameAvailability.
type IotDpsResourceClientCheckProvisioningServiceNameAvailabilityResponse struct {
	// Description of name availability.
	NameAvailabilityInfo
}

// IotDpsResourceClientCreateOrUpdatePrivateEndpointConnectionResponse contains the response from method IotDpsResourceClient.BeginCreateOrUpdatePrivateEndpointConnection.
type IotDpsResourceClientCreateOrUpdatePrivateEndpointConnectionResponse struct {
	// The private endpoint connection of a provisioning service
	PrivateEndpointConnection
}

// IotDpsResourceClientCreateOrUpdateResponse contains the response from method IotDpsResourceClient.BeginCreateOrUpdate.
type IotDpsResourceClientCreateOrUpdateResponse struct {
	// The description of the provisioning service.
	ProvisioningServiceDescription
}

// IotDpsResourceClientDeletePrivateEndpointConnectionResponse contains the response from method IotDpsResourceClient.BeginDeletePrivateEndpointConnection.
type IotDpsResourceClientDeletePrivateEndpointConnectionResponse struct {
	// The private endpoint connection of a provisioning service
	PrivateEndpointConnection
}

// IotDpsResourceClientDeleteResponse contains the response from method IotDpsResourceClient.BeginDelete.
type IotDpsResourceClientDeleteResponse struct {
	// placeholder for future response values
}

// IotDpsResourceClientGetOperationResultResponse contains the response from method IotDpsResourceClient.GetOperationResult.
type IotDpsResourceClientGetOperationResultResponse struct {
	// Result of a long running operation.
	AsyncOperationResult
}

// IotDpsResourceClientGetPrivateEndpointConnectionResponse contains the response from method IotDpsResourceClient.GetPrivateEndpointConnection.
type IotDpsResourceClientGetPrivateEndpointConnectionResponse struct {
	// The private endpoint connection of a provisioning service
	PrivateEndpointConnection
}

// IotDpsResourceClientGetPrivateLinkResourcesResponse contains the response from method IotDpsResourceClient.GetPrivateLinkResources.
type IotDpsResourceClientGetPrivateLinkResourcesResponse struct {
	// The group information for creating a private endpoint on a provisioning service
	GroupIDInformation
}

// IotDpsResourceClientGetResponse contains the response from method IotDpsResourceClient.Get.
type IotDpsResourceClientGetResponse struct {
	// The description of the provisioning service.
	ProvisioningServiceDescription
}

// IotDpsResourceClientListByResourceGroupResponse contains the response from method IotDpsResourceClient.NewListByResourceGroupPager.
type IotDpsResourceClientListByResourceGroupResponse struct {
	// List of provisioning service descriptions.
	ProvisioningServiceDescriptionListResult
}

// IotDpsResourceClientListBySubscriptionResponse contains the response from method IotDpsResourceClient.NewListBySubscriptionPager.
type IotDpsResourceClientListBySubscriptionResponse struct {
	// List of provisioning service descriptions.
	ProvisioningServiceDescriptionListResult
}

// IotDpsResourceClientListKeysForKeyNameResponse contains the response from method IotDpsResourceClient.ListKeysForKeyName.
type IotDpsResourceClientListKeysForKeyNameResponse struct {
	// Description of the shared access key.
	SharedAccessSignatureAuthorizationRuleAccessRightsDescription
}

// IotDpsResourceClientListKeysResponse contains the response from method IotDpsResourceClient.NewListKeysPager.
type IotDpsResourceClientListKeysResponse struct {
	// List of shared access keys.
	SharedAccessSignatureAuthorizationRuleListResult
}

// IotDpsResourceClientListPrivateEndpointConnectionsResponse contains the response from method IotDpsResourceClient.ListPrivateEndpointConnections.
type IotDpsResourceClientListPrivateEndpointConnectionsResponse struct {
	// The list of private endpoint connections for a provisioning service
	PrivateEndpointConnectionArray []*PrivateEndpointConnection
}

// IotDpsResourceClientListPrivateLinkResourcesResponse contains the response from method IotDpsResourceClient.ListPrivateLinkResources.
type IotDpsResourceClientListPrivateLinkResourcesResponse struct {
	// The available private link resources for a provisioning service
	PrivateLinkResources
}

// IotDpsResourceClientListValidSKUsResponse contains the response from method IotDpsResourceClient.NewListValidSKUsPager.
type IotDpsResourceClientListValidSKUsResponse struct {
	// List of available SKUs.
	IotDpsSKUDefinitionListResult
}

// IotDpsResourceClientUpdateResponse contains the response from method IotDpsResourceClient.BeginUpdate.
type IotDpsResourceClientUpdateResponse struct {
	// The description of the provisioning service.
	ProvisioningServiceDescription
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list provisioning service operations. It contains a list of operations and a URL link to get the
	// next set of results.
	OperationListResult
}
