//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdevtestlabs

// ArmTemplatesClientGetResponse contains the response from method ArmTemplatesClient.Get.
type ArmTemplatesClientGetResponse struct {
	// An Azure Resource Manager template.
	ArmTemplate
}

// ArmTemplatesClientListResponse contains the response from method ArmTemplatesClient.NewListPager.
type ArmTemplatesClientListResponse struct {
	// The response of a list operation.
	ArmTemplateList
}

// ArtifactSourcesClientCreateOrUpdateResponse contains the response from method ArtifactSourcesClient.CreateOrUpdate.
type ArtifactSourcesClientCreateOrUpdateResponse struct {
	// Properties of an artifact source.
	ArtifactSource
}

// ArtifactSourcesClientDeleteResponse contains the response from method ArtifactSourcesClient.Delete.
type ArtifactSourcesClientDeleteResponse struct {
	// placeholder for future response values
}

// ArtifactSourcesClientGetResponse contains the response from method ArtifactSourcesClient.Get.
type ArtifactSourcesClientGetResponse struct {
	// Properties of an artifact source.
	ArtifactSource
}

// ArtifactSourcesClientListResponse contains the response from method ArtifactSourcesClient.NewListPager.
type ArtifactSourcesClientListResponse struct {
	// The response of a list operation.
	ArtifactSourceList
}

// ArtifactSourcesClientUpdateResponse contains the response from method ArtifactSourcesClient.Update.
type ArtifactSourcesClientUpdateResponse struct {
	// Properties of an artifact source.
	ArtifactSource
}

// ArtifactsClientGenerateArmTemplateResponse contains the response from method ArtifactsClient.GenerateArmTemplate.
type ArtifactsClientGenerateArmTemplateResponse struct {
	// Information about a generated ARM template.
	ArmTemplateInfo
}

// ArtifactsClientGetResponse contains the response from method ArtifactsClient.Get.
type ArtifactsClientGetResponse struct {
	// An artifact.
	Artifact
}

// ArtifactsClientListResponse contains the response from method ArtifactsClient.NewListPager.
type ArtifactsClientListResponse struct {
	// The response of a list operation.
	ArtifactList
}

// CostsClientCreateOrUpdateResponse contains the response from method CostsClient.CreateOrUpdate.
type CostsClientCreateOrUpdateResponse struct {
	// A cost item.
	LabCost
}

// CostsClientGetResponse contains the response from method CostsClient.Get.
type CostsClientGetResponse struct {
	// A cost item.
	LabCost
}

// CustomImagesClientCreateOrUpdateResponse contains the response from method CustomImagesClient.BeginCreateOrUpdate.
type CustomImagesClientCreateOrUpdateResponse struct {
	// A custom image.
	CustomImage
}

// CustomImagesClientDeleteResponse contains the response from method CustomImagesClient.BeginDelete.
type CustomImagesClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomImagesClientGetResponse contains the response from method CustomImagesClient.Get.
type CustomImagesClientGetResponse struct {
	// A custom image.
	CustomImage
}

// CustomImagesClientListResponse contains the response from method CustomImagesClient.NewListPager.
type CustomImagesClientListResponse struct {
	// The response of a list operation.
	CustomImageList
}

// CustomImagesClientUpdateResponse contains the response from method CustomImagesClient.Update.
type CustomImagesClientUpdateResponse struct {
	// A custom image.
	CustomImage
}

// DisksClientAttachResponse contains the response from method DisksClient.BeginAttach.
type DisksClientAttachResponse struct {
	// placeholder for future response values
}

// DisksClientCreateOrUpdateResponse contains the response from method DisksClient.BeginCreateOrUpdate.
type DisksClientCreateOrUpdateResponse struct {
	// A Disk.
	Disk
}

// DisksClientDeleteResponse contains the response from method DisksClient.BeginDelete.
type DisksClientDeleteResponse struct {
	// placeholder for future response values
}

// DisksClientDetachResponse contains the response from method DisksClient.BeginDetach.
type DisksClientDetachResponse struct {
	// placeholder for future response values
}

// DisksClientGetResponse contains the response from method DisksClient.Get.
type DisksClientGetResponse struct {
	// A Disk.
	Disk
}

// DisksClientListResponse contains the response from method DisksClient.NewListPager.
type DisksClientListResponse struct {
	// The response of a list operation.
	DiskList
}

// DisksClientUpdateResponse contains the response from method DisksClient.Update.
type DisksClientUpdateResponse struct {
	// A Disk.
	Disk
}

// EnvironmentsClientCreateOrUpdateResponse contains the response from method EnvironmentsClient.BeginCreateOrUpdate.
type EnvironmentsClientCreateOrUpdateResponse struct {
	// An environment, which is essentially an ARM template deployment.
	DtlEnvironment
}

// EnvironmentsClientDeleteResponse contains the response from method EnvironmentsClient.BeginDelete.
type EnvironmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// EnvironmentsClientGetResponse contains the response from method EnvironmentsClient.Get.
type EnvironmentsClientGetResponse struct {
	// An environment, which is essentially an ARM template deployment.
	DtlEnvironment
}

// EnvironmentsClientListResponse contains the response from method EnvironmentsClient.NewListPager.
type EnvironmentsClientListResponse struct {
	// The response of a list operation.
	DtlEnvironmentList
}

// EnvironmentsClientUpdateResponse contains the response from method EnvironmentsClient.Update.
type EnvironmentsClientUpdateResponse struct {
	// An environment, which is essentially an ARM template deployment.
	DtlEnvironment
}

// FormulasClientCreateOrUpdateResponse contains the response from method FormulasClient.BeginCreateOrUpdate.
type FormulasClientCreateOrUpdateResponse struct {
	// A formula for creating a VM, specifying an image base and other parameters
	Formula
}

// FormulasClientDeleteResponse contains the response from method FormulasClient.Delete.
type FormulasClientDeleteResponse struct {
	// placeholder for future response values
}

// FormulasClientGetResponse contains the response from method FormulasClient.Get.
type FormulasClientGetResponse struct {
	// A formula for creating a VM, specifying an image base and other parameters
	Formula
}

// FormulasClientListResponse contains the response from method FormulasClient.NewListPager.
type FormulasClientListResponse struct {
	// The response of a list operation.
	FormulaList
}

// FormulasClientUpdateResponse contains the response from method FormulasClient.Update.
type FormulasClientUpdateResponse struct {
	// A formula for creating a VM, specifying an image base and other parameters
	Formula
}

// GalleryImagesClientListResponse contains the response from method GalleryImagesClient.NewListPager.
type GalleryImagesClientListResponse struct {
	// The response of a list operation.
	GalleryImageList
}

// GlobalSchedulesClientCreateOrUpdateResponse contains the response from method GlobalSchedulesClient.CreateOrUpdate.
type GlobalSchedulesClientCreateOrUpdateResponse struct {
	// A schedule.
	Schedule
}

// GlobalSchedulesClientDeleteResponse contains the response from method GlobalSchedulesClient.Delete.
type GlobalSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// GlobalSchedulesClientExecuteResponse contains the response from method GlobalSchedulesClient.BeginExecute.
type GlobalSchedulesClientExecuteResponse struct {
	// placeholder for future response values
}

// GlobalSchedulesClientGetResponse contains the response from method GlobalSchedulesClient.Get.
type GlobalSchedulesClientGetResponse struct {
	// A schedule.
	Schedule
}

// GlobalSchedulesClientListByResourceGroupResponse contains the response from method GlobalSchedulesClient.NewListByResourceGroupPager.
type GlobalSchedulesClientListByResourceGroupResponse struct {
	// The response of a list operation.
	ScheduleList
}

// GlobalSchedulesClientListBySubscriptionResponse contains the response from method GlobalSchedulesClient.NewListBySubscriptionPager.
type GlobalSchedulesClientListBySubscriptionResponse struct {
	// The response of a list operation.
	ScheduleList
}

// GlobalSchedulesClientRetargetResponse contains the response from method GlobalSchedulesClient.BeginRetarget.
type GlobalSchedulesClientRetargetResponse struct {
	// placeholder for future response values
}

// GlobalSchedulesClientUpdateResponse contains the response from method GlobalSchedulesClient.Update.
type GlobalSchedulesClientUpdateResponse struct {
	// A schedule.
	Schedule
}

// LabsClientClaimAnyVMResponse contains the response from method LabsClient.BeginClaimAnyVM.
type LabsClientClaimAnyVMResponse struct {
	// placeholder for future response values
}

// LabsClientCreateEnvironmentResponse contains the response from method LabsClient.BeginCreateEnvironment.
type LabsClientCreateEnvironmentResponse struct {
	// placeholder for future response values
}

// LabsClientCreateOrUpdateResponse contains the response from method LabsClient.BeginCreateOrUpdate.
type LabsClientCreateOrUpdateResponse struct {
	// A lab.
	Lab
}

// LabsClientDeleteResponse contains the response from method LabsClient.BeginDelete.
type LabsClientDeleteResponse struct {
	// placeholder for future response values
}

// LabsClientExportResourceUsageResponse contains the response from method LabsClient.BeginExportResourceUsage.
type LabsClientExportResourceUsageResponse struct {
	// placeholder for future response values
}

// LabsClientGenerateUploadURIResponse contains the response from method LabsClient.GenerateUploadURI.
type LabsClientGenerateUploadURIResponse struct {
	// Response body for generating an upload URI.
	GenerateUploadURIResponse
}

// LabsClientGetResponse contains the response from method LabsClient.Get.
type LabsClientGetResponse struct {
	// A lab.
	Lab
}

// LabsClientImportVirtualMachineResponse contains the response from method LabsClient.BeginImportVirtualMachine.
type LabsClientImportVirtualMachineResponse struct {
	// placeholder for future response values
}

// LabsClientListByResourceGroupResponse contains the response from method LabsClient.NewListByResourceGroupPager.
type LabsClientListByResourceGroupResponse struct {
	// The response of a list operation.
	LabList
}

// LabsClientListBySubscriptionResponse contains the response from method LabsClient.NewListBySubscriptionPager.
type LabsClientListBySubscriptionResponse struct {
	// The response of a list operation.
	LabList
}

// LabsClientListVhdsResponse contains the response from method LabsClient.NewListVhdsPager.
type LabsClientListVhdsResponse struct {
	// The response of a list operation.
	LabVhdList
}

// LabsClientUpdateResponse contains the response from method LabsClient.Update.
type LabsClientUpdateResponse struct {
	// A lab.
	Lab
}

// NotificationChannelsClientCreateOrUpdateResponse contains the response from method NotificationChannelsClient.CreateOrUpdate.
type NotificationChannelsClientCreateOrUpdateResponse struct {
	// A notification.
	NotificationChannel
}

// NotificationChannelsClientDeleteResponse contains the response from method NotificationChannelsClient.Delete.
type NotificationChannelsClientDeleteResponse struct {
	// placeholder for future response values
}

// NotificationChannelsClientGetResponse contains the response from method NotificationChannelsClient.Get.
type NotificationChannelsClientGetResponse struct {
	// A notification.
	NotificationChannel
}

// NotificationChannelsClientListResponse contains the response from method NotificationChannelsClient.NewListPager.
type NotificationChannelsClientListResponse struct {
	// The response of a list operation.
	NotificationChannelList
}

// NotificationChannelsClientNotifyResponse contains the response from method NotificationChannelsClient.Notify.
type NotificationChannelsClientNotifyResponse struct {
	// placeholder for future response values
}

// NotificationChannelsClientUpdateResponse contains the response from method NotificationChannelsClient.Update.
type NotificationChannelsClientUpdateResponse struct {
	// A notification.
	NotificationChannel
}

// OperationsClientGetResponse contains the response from method OperationsClient.Get.
type OperationsClientGetResponse struct {
	// An Operation Result
	OperationResult
}

// PoliciesClientCreateOrUpdateResponse contains the response from method PoliciesClient.CreateOrUpdate.
type PoliciesClientCreateOrUpdateResponse struct {
	// A Policy.
	Policy
}

// PoliciesClientDeleteResponse contains the response from method PoliciesClient.Delete.
type PoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// PoliciesClientGetResponse contains the response from method PoliciesClient.Get.
type PoliciesClientGetResponse struct {
	// A Policy.
	Policy
}

// PoliciesClientListResponse contains the response from method PoliciesClient.NewListPager.
type PoliciesClientListResponse struct {
	// The response of a list operation.
	PolicyList
}

// PoliciesClientUpdateResponse contains the response from method PoliciesClient.Update.
type PoliciesClientUpdateResponse struct {
	// A Policy.
	Policy
}

// PolicySetsClientEvaluatePoliciesResponse contains the response from method PolicySetsClient.EvaluatePolicies.
type PolicySetsClientEvaluatePoliciesResponse struct {
	// Response body for evaluating a policy set.
	EvaluatePoliciesResponse
}

// ProviderOperationsClientListResponse contains the response from method ProviderOperationsClient.NewListPager.
type ProviderOperationsClientListResponse struct {
	// Result of the request to list REST API operations
	ProviderOperationResult
}

// SchedulesClientCreateOrUpdateResponse contains the response from method SchedulesClient.CreateOrUpdate.
type SchedulesClientCreateOrUpdateResponse struct {
	// A schedule.
	Schedule
}

// SchedulesClientDeleteResponse contains the response from method SchedulesClient.Delete.
type SchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// SchedulesClientExecuteResponse contains the response from method SchedulesClient.BeginExecute.
type SchedulesClientExecuteResponse struct {
	// placeholder for future response values
}

// SchedulesClientGetResponse contains the response from method SchedulesClient.Get.
type SchedulesClientGetResponse struct {
	// A schedule.
	Schedule
}

// SchedulesClientListApplicableResponse contains the response from method SchedulesClient.NewListApplicablePager.
type SchedulesClientListApplicableResponse struct {
	// The response of a list operation.
	ScheduleList
}

// SchedulesClientListResponse contains the response from method SchedulesClient.NewListPager.
type SchedulesClientListResponse struct {
	// The response of a list operation.
	ScheduleList
}

// SchedulesClientUpdateResponse contains the response from method SchedulesClient.Update.
type SchedulesClientUpdateResponse struct {
	// A schedule.
	Schedule
}

// SecretsClientCreateOrUpdateResponse contains the response from method SecretsClient.BeginCreateOrUpdate.
type SecretsClientCreateOrUpdateResponse struct {
	// A secret.
	Secret
}

// SecretsClientDeleteResponse contains the response from method SecretsClient.Delete.
type SecretsClientDeleteResponse struct {
	// placeholder for future response values
}

// SecretsClientGetResponse contains the response from method SecretsClient.Get.
type SecretsClientGetResponse struct {
	// A secret.
	Secret
}

// SecretsClientListResponse contains the response from method SecretsClient.NewListPager.
type SecretsClientListResponse struct {
	// The response of a list operation.
	SecretList
}

// SecretsClientUpdateResponse contains the response from method SecretsClient.Update.
type SecretsClientUpdateResponse struct {
	// A secret.
	Secret
}

// ServiceFabricSchedulesClientCreateOrUpdateResponse contains the response from method ServiceFabricSchedulesClient.CreateOrUpdate.
type ServiceFabricSchedulesClientCreateOrUpdateResponse struct {
	// A schedule.
	Schedule
}

// ServiceFabricSchedulesClientDeleteResponse contains the response from method ServiceFabricSchedulesClient.Delete.
type ServiceFabricSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// ServiceFabricSchedulesClientExecuteResponse contains the response from method ServiceFabricSchedulesClient.BeginExecute.
type ServiceFabricSchedulesClientExecuteResponse struct {
	// placeholder for future response values
}

// ServiceFabricSchedulesClientGetResponse contains the response from method ServiceFabricSchedulesClient.Get.
type ServiceFabricSchedulesClientGetResponse struct {
	// A schedule.
	Schedule
}

// ServiceFabricSchedulesClientListResponse contains the response from method ServiceFabricSchedulesClient.NewListPager.
type ServiceFabricSchedulesClientListResponse struct {
	// The response of a list operation.
	ScheduleList
}

// ServiceFabricSchedulesClientUpdateResponse contains the response from method ServiceFabricSchedulesClient.Update.
type ServiceFabricSchedulesClientUpdateResponse struct {
	// A schedule.
	Schedule
}

// ServiceFabricsClientCreateOrUpdateResponse contains the response from method ServiceFabricsClient.BeginCreateOrUpdate.
type ServiceFabricsClientCreateOrUpdateResponse struct {
	// A Service Fabric.
	ServiceFabric
}

// ServiceFabricsClientDeleteResponse contains the response from method ServiceFabricsClient.BeginDelete.
type ServiceFabricsClientDeleteResponse struct {
	// placeholder for future response values
}

// ServiceFabricsClientGetResponse contains the response from method ServiceFabricsClient.Get.
type ServiceFabricsClientGetResponse struct {
	// A Service Fabric.
	ServiceFabric
}

// ServiceFabricsClientListApplicableSchedulesResponse contains the response from method ServiceFabricsClient.ListApplicableSchedules.
type ServiceFabricsClientListApplicableSchedulesResponse struct {
	// Schedules applicable to a virtual machine. The schedules may have been defined on a VM or on lab level.
	ApplicableSchedule
}

// ServiceFabricsClientListResponse contains the response from method ServiceFabricsClient.NewListPager.
type ServiceFabricsClientListResponse struct {
	// The response of a list operation.
	ServiceFabricList
}

// ServiceFabricsClientStartResponse contains the response from method ServiceFabricsClient.BeginStart.
type ServiceFabricsClientStartResponse struct {
	// placeholder for future response values
}

// ServiceFabricsClientStopResponse contains the response from method ServiceFabricsClient.BeginStop.
type ServiceFabricsClientStopResponse struct {
	// placeholder for future response values
}

// ServiceFabricsClientUpdateResponse contains the response from method ServiceFabricsClient.Update.
type ServiceFabricsClientUpdateResponse struct {
	// A Service Fabric.
	ServiceFabric
}

// ServiceRunnersClientCreateOrUpdateResponse contains the response from method ServiceRunnersClient.CreateOrUpdate.
type ServiceRunnersClientCreateOrUpdateResponse struct {
	// A container for a managed identity to execute DevTest lab services.
	ServiceRunner
}

// ServiceRunnersClientDeleteResponse contains the response from method ServiceRunnersClient.Delete.
type ServiceRunnersClientDeleteResponse struct {
	// placeholder for future response values
}

// ServiceRunnersClientGetResponse contains the response from method ServiceRunnersClient.Get.
type ServiceRunnersClientGetResponse struct {
	// A container for a managed identity to execute DevTest lab services.
	ServiceRunner
}

// UsersClientCreateOrUpdateResponse contains the response from method UsersClient.BeginCreateOrUpdate.
type UsersClientCreateOrUpdateResponse struct {
	// Profile of a lab user.
	User
}

// UsersClientDeleteResponse contains the response from method UsersClient.BeginDelete.
type UsersClientDeleteResponse struct {
	// placeholder for future response values
}

// UsersClientGetResponse contains the response from method UsersClient.Get.
type UsersClientGetResponse struct {
	// Profile of a lab user.
	User
}

// UsersClientListResponse contains the response from method UsersClient.NewListPager.
type UsersClientListResponse struct {
	// The response of a list operation.
	UserList
}

// UsersClientUpdateResponse contains the response from method UsersClient.Update.
type UsersClientUpdateResponse struct {
	// Profile of a lab user.
	User
}

// VirtualMachineSchedulesClientCreateOrUpdateResponse contains the response from method VirtualMachineSchedulesClient.CreateOrUpdate.
type VirtualMachineSchedulesClientCreateOrUpdateResponse struct {
	// A schedule.
	Schedule
}

// VirtualMachineSchedulesClientDeleteResponse contains the response from method VirtualMachineSchedulesClient.Delete.
type VirtualMachineSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachineSchedulesClientExecuteResponse contains the response from method VirtualMachineSchedulesClient.BeginExecute.
type VirtualMachineSchedulesClientExecuteResponse struct {
	// placeholder for future response values
}

// VirtualMachineSchedulesClientGetResponse contains the response from method VirtualMachineSchedulesClient.Get.
type VirtualMachineSchedulesClientGetResponse struct {
	// A schedule.
	Schedule
}

// VirtualMachineSchedulesClientListResponse contains the response from method VirtualMachineSchedulesClient.NewListPager.
type VirtualMachineSchedulesClientListResponse struct {
	// The response of a list operation.
	ScheduleList
}

// VirtualMachineSchedulesClientUpdateResponse contains the response from method VirtualMachineSchedulesClient.Update.
type VirtualMachineSchedulesClientUpdateResponse struct {
	// A schedule.
	Schedule
}

// VirtualMachinesClientAddDataDiskResponse contains the response from method VirtualMachinesClient.BeginAddDataDisk.
type VirtualMachinesClientAddDataDiskResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientApplyArtifactsResponse contains the response from method VirtualMachinesClient.BeginApplyArtifacts.
type VirtualMachinesClientApplyArtifactsResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientClaimResponse contains the response from method VirtualMachinesClient.BeginClaim.
type VirtualMachinesClientClaimResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientCreateOrUpdateResponse contains the response from method VirtualMachinesClient.BeginCreateOrUpdate.
type VirtualMachinesClientCreateOrUpdateResponse struct {
	// A virtual machine.
	LabVirtualMachine
}

// VirtualMachinesClientDeleteResponse contains the response from method VirtualMachinesClient.BeginDelete.
type VirtualMachinesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientDetachDataDiskResponse contains the response from method VirtualMachinesClient.BeginDetachDataDisk.
type VirtualMachinesClientDetachDataDiskResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientGetRdpFileContentsResponse contains the response from method VirtualMachinesClient.GetRdpFileContents.
type VirtualMachinesClientGetRdpFileContentsResponse struct {
	// Represents a .rdp file
	RdpConnection
}

// VirtualMachinesClientGetResponse contains the response from method VirtualMachinesClient.Get.
type VirtualMachinesClientGetResponse struct {
	// A virtual machine.
	LabVirtualMachine
}

// VirtualMachinesClientListApplicableSchedulesResponse contains the response from method VirtualMachinesClient.ListApplicableSchedules.
type VirtualMachinesClientListApplicableSchedulesResponse struct {
	// Schedules applicable to a virtual machine. The schedules may have been defined on a VM or on lab level.
	ApplicableSchedule
}

// VirtualMachinesClientListResponse contains the response from method VirtualMachinesClient.NewListPager.
type VirtualMachinesClientListResponse struct {
	// The response of a list operation.
	LabVirtualMachineList
}

// VirtualMachinesClientRedeployResponse contains the response from method VirtualMachinesClient.BeginRedeploy.
type VirtualMachinesClientRedeployResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientResizeResponse contains the response from method VirtualMachinesClient.BeginResize.
type VirtualMachinesClientResizeResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientRestartResponse contains the response from method VirtualMachinesClient.BeginRestart.
type VirtualMachinesClientRestartResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientStartResponse contains the response from method VirtualMachinesClient.BeginStart.
type VirtualMachinesClientStartResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientStopResponse contains the response from method VirtualMachinesClient.BeginStop.
type VirtualMachinesClientStopResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientTransferDisksResponse contains the response from method VirtualMachinesClient.BeginTransferDisks.
type VirtualMachinesClientTransferDisksResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientUnClaimResponse contains the response from method VirtualMachinesClient.BeginUnClaim.
type VirtualMachinesClientUnClaimResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientUpdateResponse contains the response from method VirtualMachinesClient.Update.
type VirtualMachinesClientUpdateResponse struct {
	// A virtual machine.
	LabVirtualMachine
}

// VirtualNetworksClientCreateOrUpdateResponse contains the response from method VirtualNetworksClient.BeginCreateOrUpdate.
type VirtualNetworksClientCreateOrUpdateResponse struct {
	// A virtual network.
	VirtualNetwork
}

// VirtualNetworksClientDeleteResponse contains the response from method VirtualNetworksClient.BeginDelete.
type VirtualNetworksClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualNetworksClientGetResponse contains the response from method VirtualNetworksClient.Get.
type VirtualNetworksClientGetResponse struct {
	// A virtual network.
	VirtualNetwork
}

// VirtualNetworksClientListResponse contains the response from method VirtualNetworksClient.NewListPager.
type VirtualNetworksClientListResponse struct {
	// The response of a list operation.
	VirtualNetworkList
}

// VirtualNetworksClientUpdateResponse contains the response from method VirtualNetworksClient.Update.
type VirtualNetworksClientUpdateResponse struct {
	// A virtual network.
	VirtualNetwork
}
