//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armeducation

// GrantsClientGetOptions contains the optional parameters for the GrantsClient.Get method.
type GrantsClientGetOptions struct {
	// May be used to include information about budget that has been allocated.
	IncludeAllocatedBudget *bool
}

// GrantsClientListAllOptions contains the optional parameters for the GrantsClient.NewListAllPager method.
type GrantsClientListAllOptions struct {
	// May be used to include information about budget that has been allocated.
	IncludeAllocatedBudget *bool
}

// GrantsClientListOptions contains the optional parameters for the GrantsClient.NewListPager method.
type GrantsClientListOptions struct {
	// May be used to include information about budget that has been allocated.
	IncludeAllocatedBudget *bool
}

// JoinRequestsClientApproveOptions contains the optional parameters for the JoinRequestsClient.Approve method.
type JoinRequestsClientApproveOptions struct {
	// placeholder for future optional parameters
}

// JoinRequestsClientDenyOptions contains the optional parameters for the JoinRequestsClient.Deny method.
type JoinRequestsClientDenyOptions struct {
	// placeholder for future optional parameters
}

// JoinRequestsClientGetOptions contains the optional parameters for the JoinRequestsClient.Get method.
type JoinRequestsClientGetOptions struct {
	// placeholder for future optional parameters
}

// JoinRequestsClientListOptions contains the optional parameters for the JoinRequestsClient.NewListPager method.
type JoinRequestsClientListOptions struct {
	// Include denied
	IncludeDenied *bool
}

// LabsClientCreateOrUpdateOptions contains the optional parameters for the LabsClient.CreateOrUpdate method.
type LabsClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// LabsClientDeleteOptions contains the optional parameters for the LabsClient.Delete method.
type LabsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// LabsClientGenerateInviteCodeOptions contains the optional parameters for the LabsClient.GenerateInviteCode method.
type LabsClientGenerateInviteCodeOptions struct {
	// set this flag to true if you want to update student count without generating a new invite code
	OnlyUpdateStudentCountParameter *bool
}

// LabsClientGetOptions contains the optional parameters for the LabsClient.Get method.
type LabsClientGetOptions struct {
	// May be used to include budget information.
	IncludeBudget *bool
}

// LabsClientListAllOptions contains the optional parameters for the LabsClient.NewListAllPager method.
type LabsClientListAllOptions struct {
	// May be used to include budget information.
	IncludeBudget *bool

	// May be used to show deleted items.
	IncludeDeleted *bool
}

// LabsClientListOptions contains the optional parameters for the LabsClient.NewListPager method.
type LabsClientListOptions struct {
	// May be used to include budget information.
	IncludeBudget *bool
}

// ManagementClientRedeemInvitationCodeOptions contains the optional parameters for the ManagementClient.RedeemInvitationCode
// method.
type ManagementClientRedeemInvitationCodeOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.List method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// StudentLabsClientGetOptions contains the optional parameters for the StudentLabsClient.Get method.
type StudentLabsClientGetOptions struct {
	// placeholder for future optional parameters
}

// StudentLabsClientListAllOptions contains the optional parameters for the StudentLabsClient.NewListAllPager method.
type StudentLabsClientListAllOptions struct {
	// placeholder for future optional parameters
}

// StudentsClientCreateOrUpdateOptions contains the optional parameters for the StudentsClient.CreateOrUpdate method.
type StudentsClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// StudentsClientDeleteOptions contains the optional parameters for the StudentsClient.Delete method.
type StudentsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// StudentsClientGetOptions contains the optional parameters for the StudentsClient.Get method.
type StudentsClientGetOptions struct {
	// placeholder for future optional parameters
}

// StudentsClientListOptions contains the optional parameters for the StudentsClient.NewListPager method.
type StudentsClientListOptions struct {
	// May be used to show deleted items.
	IncludeDeleted *bool
}
