//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armeventgrid

// CaCertificatesClientCreateOrUpdateResponse contains the response from method CaCertificatesClient.BeginCreateOrUpdate.
type CaCertificatesClientCreateOrUpdateResponse struct {
	// The CA Certificate resource.
	CaCertificate
}

// CaCertificatesClientDeleteResponse contains the response from method CaCertificatesClient.BeginDelete.
type CaCertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CaCertificatesClientGetResponse contains the response from method CaCertificatesClient.Get.
type CaCertificatesClientGetResponse struct {
	// The CA Certificate resource.
	CaCertificate
}

// CaCertificatesClientListByNamespaceResponse contains the response from method CaCertificatesClient.NewListByNamespacePager.
type CaCertificatesClientListByNamespaceResponse struct {
	// Result of the List CA Certificate operation.
	CaCertificatesListResult
}

// ChannelsClientCreateOrUpdateResponse contains the response from method ChannelsClient.CreateOrUpdate.
type ChannelsClientCreateOrUpdateResponse struct {
	// Channel info.
	Channel
}

// ChannelsClientDeleteResponse contains the response from method ChannelsClient.BeginDelete.
type ChannelsClientDeleteResponse struct {
	// placeholder for future response values
}

// ChannelsClientGetFullURLResponse contains the response from method ChannelsClient.GetFullURL.
type ChannelsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// ChannelsClientGetResponse contains the response from method ChannelsClient.Get.
type ChannelsClientGetResponse struct {
	// Channel info.
	Channel
}

// ChannelsClientListByPartnerNamespaceResponse contains the response from method ChannelsClient.NewListByPartnerNamespacePager.
type ChannelsClientListByPartnerNamespaceResponse struct {
	// Result of the List Channels operation
	ChannelsListResult
}

// ChannelsClientUpdateResponse contains the response from method ChannelsClient.Update.
type ChannelsClientUpdateResponse struct {
	// placeholder for future response values
}

// ClientGroupsClientCreateOrUpdateResponse contains the response from method ClientGroupsClient.BeginCreateOrUpdate.
type ClientGroupsClientCreateOrUpdateResponse struct {
	// The Client group resource.
	ClientGroup
}

// ClientGroupsClientDeleteResponse contains the response from method ClientGroupsClient.BeginDelete.
type ClientGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientGroupsClientGetResponse contains the response from method ClientGroupsClient.Get.
type ClientGroupsClientGetResponse struct {
	// The Client group resource.
	ClientGroup
}

// ClientGroupsClientListByNamespaceResponse contains the response from method ClientGroupsClient.NewListByNamespacePager.
type ClientGroupsClientListByNamespaceResponse struct {
	// Result of the List Client Group operation.
	ClientGroupsListResult
}

// ClientsClientCreateOrUpdateResponse contains the response from method ClientsClient.BeginCreateOrUpdate.
type ClientsClientCreateOrUpdateResponse struct {
	// The Client resource.
	Client
}

// ClientsClientDeleteResponse contains the response from method ClientsClient.BeginDelete.
type ClientsClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientsClientGetResponse contains the response from method ClientsClient.Get.
type ClientsClientGetResponse struct {
	// The Client resource.
	Client
}

// ClientsClientListByNamespaceResponse contains the response from method ClientsClient.NewListByNamespacePager.
type ClientsClientListByNamespaceResponse struct {
	// Result of the List Client operation.
	ClientsListResult
}

// DomainEventSubscriptionsClientCreateOrUpdateResponse contains the response from method DomainEventSubscriptionsClient.BeginCreateOrUpdate.
type DomainEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainEventSubscriptionsClientDeleteResponse contains the response from method DomainEventSubscriptionsClient.BeginDelete.
type DomainEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// DomainEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method DomainEventSubscriptionsClient.GetDeliveryAttributes.
type DomainEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// DomainEventSubscriptionsClientGetFullURLResponse contains the response from method DomainEventSubscriptionsClient.GetFullURL.
type DomainEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// DomainEventSubscriptionsClientGetResponse contains the response from method DomainEventSubscriptionsClient.Get.
type DomainEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainEventSubscriptionsClientListResponse contains the response from method DomainEventSubscriptionsClient.NewListPager.
type DomainEventSubscriptionsClientListResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// DomainEventSubscriptionsClientUpdateResponse contains the response from method DomainEventSubscriptionsClient.BeginUpdate.
type DomainEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainTopicEventSubscriptionsClientCreateOrUpdateResponse contains the response from method DomainTopicEventSubscriptionsClient.BeginCreateOrUpdate.
type DomainTopicEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainTopicEventSubscriptionsClientDeleteResponse contains the response from method DomainTopicEventSubscriptionsClient.BeginDelete.
type DomainTopicEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// DomainTopicEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method DomainTopicEventSubscriptionsClient.GetDeliveryAttributes.
type DomainTopicEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// DomainTopicEventSubscriptionsClientGetFullURLResponse contains the response from method DomainTopicEventSubscriptionsClient.GetFullURL.
type DomainTopicEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// DomainTopicEventSubscriptionsClientGetResponse contains the response from method DomainTopicEventSubscriptionsClient.Get.
type DomainTopicEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainTopicEventSubscriptionsClientListResponse contains the response from method DomainTopicEventSubscriptionsClient.NewListPager.
type DomainTopicEventSubscriptionsClientListResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// DomainTopicEventSubscriptionsClientUpdateResponse contains the response from method DomainTopicEventSubscriptionsClient.BeginUpdate.
type DomainTopicEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// DomainTopicsClientCreateOrUpdateResponse contains the response from method DomainTopicsClient.BeginCreateOrUpdate.
type DomainTopicsClientCreateOrUpdateResponse struct {
	// Domain Topic.
	DomainTopic
}

// DomainTopicsClientDeleteResponse contains the response from method DomainTopicsClient.BeginDelete.
type DomainTopicsClientDeleteResponse struct {
	// placeholder for future response values
}

// DomainTopicsClientGetResponse contains the response from method DomainTopicsClient.Get.
type DomainTopicsClientGetResponse struct {
	// Domain Topic.
	DomainTopic
}

// DomainTopicsClientListByDomainResponse contains the response from method DomainTopicsClient.NewListByDomainPager.
type DomainTopicsClientListByDomainResponse struct {
	// Result of the List Domain Topics operation.
	DomainTopicsListResult
}

// DomainsClientCreateOrUpdateResponse contains the response from method DomainsClient.BeginCreateOrUpdate.
type DomainsClientCreateOrUpdateResponse struct {
	// EventGrid Domain.
	Domain
}

// DomainsClientDeleteResponse contains the response from method DomainsClient.BeginDelete.
type DomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// DomainsClientGetResponse contains the response from method DomainsClient.Get.
type DomainsClientGetResponse struct {
	// EventGrid Domain.
	Domain
}

// DomainsClientListByResourceGroupResponse contains the response from method DomainsClient.NewListByResourceGroupPager.
type DomainsClientListByResourceGroupResponse struct {
	// Result of the List Domains operation.
	DomainsListResult
}

// DomainsClientListBySubscriptionResponse contains the response from method DomainsClient.NewListBySubscriptionPager.
type DomainsClientListBySubscriptionResponse struct {
	// Result of the List Domains operation.
	DomainsListResult
}

// DomainsClientListSharedAccessKeysResponse contains the response from method DomainsClient.ListSharedAccessKeys.
type DomainsClientListSharedAccessKeysResponse struct {
	// Shared access keys of the Domain.
	DomainSharedAccessKeys
}

// DomainsClientRegenerateKeyResponse contains the response from method DomainsClient.RegenerateKey.
type DomainsClientRegenerateKeyResponse struct {
	// Shared access keys of the Domain.
	DomainSharedAccessKeys
}

// DomainsClientUpdateResponse contains the response from method DomainsClient.BeginUpdate.
type DomainsClientUpdateResponse struct {
	// EventGrid Domain.
	Domain
}

// EventSubscriptionsClientCreateOrUpdateResponse contains the response from method EventSubscriptionsClient.BeginCreateOrUpdate.
type EventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// EventSubscriptionsClientDeleteResponse contains the response from method EventSubscriptionsClient.BeginDelete.
type EventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// EventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method EventSubscriptionsClient.GetDeliveryAttributes.
type EventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// EventSubscriptionsClientGetFullURLResponse contains the response from method EventSubscriptionsClient.GetFullURL.
type EventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// EventSubscriptionsClientGetResponse contains the response from method EventSubscriptionsClient.Get.
type EventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// EventSubscriptionsClientListByDomainTopicResponse contains the response from method EventSubscriptionsClient.NewListByDomainTopicPager.
type EventSubscriptionsClientListByDomainTopicResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListByResourceResponse contains the response from method EventSubscriptionsClient.NewListByResourcePager.
type EventSubscriptionsClientListByResourceResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListGlobalByResourceGroupForTopicTypeResponse contains the response from method EventSubscriptionsClient.NewListGlobalByResourceGroupForTopicTypePager.
type EventSubscriptionsClientListGlobalByResourceGroupForTopicTypeResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListGlobalByResourceGroupResponse contains the response from method EventSubscriptionsClient.NewListGlobalByResourceGroupPager.
type EventSubscriptionsClientListGlobalByResourceGroupResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListGlobalBySubscriptionForTopicTypeResponse contains the response from method EventSubscriptionsClient.NewListGlobalBySubscriptionForTopicTypePager.
type EventSubscriptionsClientListGlobalBySubscriptionForTopicTypeResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListGlobalBySubscriptionResponse contains the response from method EventSubscriptionsClient.NewListGlobalBySubscriptionPager.
type EventSubscriptionsClientListGlobalBySubscriptionResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListRegionalByResourceGroupForTopicTypeResponse contains the response from method EventSubscriptionsClient.NewListRegionalByResourceGroupForTopicTypePager.
type EventSubscriptionsClientListRegionalByResourceGroupForTopicTypeResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListRegionalByResourceGroupResponse contains the response from method EventSubscriptionsClient.NewListRegionalByResourceGroupPager.
type EventSubscriptionsClientListRegionalByResourceGroupResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListRegionalBySubscriptionForTopicTypeResponse contains the response from method EventSubscriptionsClient.NewListRegionalBySubscriptionForTopicTypePager.
type EventSubscriptionsClientListRegionalBySubscriptionForTopicTypeResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientListRegionalBySubscriptionResponse contains the response from method EventSubscriptionsClient.NewListRegionalBySubscriptionPager.
type EventSubscriptionsClientListRegionalBySubscriptionResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// EventSubscriptionsClientUpdateResponse contains the response from method EventSubscriptionsClient.BeginUpdate.
type EventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// ExtensionTopicsClientGetResponse contains the response from method ExtensionTopicsClient.Get.
type ExtensionTopicsClientGetResponse struct {
	// Event grid Extension Topic. This is used for getting Event Grid related metrics for Azure resources.
	ExtensionTopic
}

// NamespaceTopicEventSubscriptionsClientCreateOrUpdateResponse contains the response from method NamespaceTopicEventSubscriptionsClient.BeginCreateOrUpdate.
type NamespaceTopicEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	Subscription
}

// NamespaceTopicEventSubscriptionsClientDeleteResponse contains the response from method NamespaceTopicEventSubscriptionsClient.BeginDelete.
type NamespaceTopicEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// NamespaceTopicEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method NamespaceTopicEventSubscriptionsClient.GetDeliveryAttributes.
type NamespaceTopicEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// NamespaceTopicEventSubscriptionsClientGetFullURLResponse contains the response from method NamespaceTopicEventSubscriptionsClient.GetFullURL.
type NamespaceTopicEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	SubscriptionFullURL
}

// NamespaceTopicEventSubscriptionsClientGetResponse contains the response from method NamespaceTopicEventSubscriptionsClient.Get.
type NamespaceTopicEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	Subscription
}

// NamespaceTopicEventSubscriptionsClientListByNamespaceTopicResponse contains the response from method NamespaceTopicEventSubscriptionsClient.NewListByNamespaceTopicPager.
type NamespaceTopicEventSubscriptionsClientListByNamespaceTopicResponse struct {
	// Result of the List event subscriptions operation.
	SubscriptionsListResult
}

// NamespaceTopicEventSubscriptionsClientUpdateResponse contains the response from method NamespaceTopicEventSubscriptionsClient.BeginUpdate.
type NamespaceTopicEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	Subscription
}

// NamespaceTopicsClientCreateOrUpdateResponse contains the response from method NamespaceTopicsClient.BeginCreateOrUpdate.
type NamespaceTopicsClientCreateOrUpdateResponse struct {
	// Namespace topic details.
	NamespaceTopic
}

// NamespaceTopicsClientDeleteResponse contains the response from method NamespaceTopicsClient.BeginDelete.
type NamespaceTopicsClientDeleteResponse struct {
	// placeholder for future response values
}

// NamespaceTopicsClientGetResponse contains the response from method NamespaceTopicsClient.Get.
type NamespaceTopicsClientGetResponse struct {
	// Namespace topic details.
	NamespaceTopic
}

// NamespaceTopicsClientListByNamespaceResponse contains the response from method NamespaceTopicsClient.NewListByNamespacePager.
type NamespaceTopicsClientListByNamespaceResponse struct {
	// Result of the List namespace topics operation.
	NamespaceTopicsListResult
}

// NamespaceTopicsClientListSharedAccessKeysResponse contains the response from method NamespaceTopicsClient.ListSharedAccessKeys.
type NamespaceTopicsClientListSharedAccessKeysResponse struct {
	// Shared access keys of the Topic
	TopicSharedAccessKeys
}

// NamespaceTopicsClientRegenerateKeyResponse contains the response from method NamespaceTopicsClient.BeginRegenerateKey.
type NamespaceTopicsClientRegenerateKeyResponse struct {
	// Shared access keys of the Topic
	TopicSharedAccessKeys
}

// NamespaceTopicsClientUpdateResponse contains the response from method NamespaceTopicsClient.BeginUpdate.
type NamespaceTopicsClientUpdateResponse struct {
	// Namespace topic details.
	NamespaceTopic
}

// NamespacesClientCreateOrUpdateResponse contains the response from method NamespacesClient.BeginCreateOrUpdate.
type NamespacesClientCreateOrUpdateResponse struct {
	// Namespace resource.
	Namespace
}

// NamespacesClientDeleteResponse contains the response from method NamespacesClient.BeginDelete.
type NamespacesClientDeleteResponse struct {
	// placeholder for future response values
}

// NamespacesClientGetResponse contains the response from method NamespacesClient.Get.
type NamespacesClientGetResponse struct {
	// Namespace resource.
	Namespace
}

// NamespacesClientListByResourceGroupResponse contains the response from method NamespacesClient.NewListByResourceGroupPager.
type NamespacesClientListByResourceGroupResponse struct {
	// Result of the List Namespaces operation.
	NamespacesListResult
}

// NamespacesClientListBySubscriptionResponse contains the response from method NamespacesClient.NewListBySubscriptionPager.
type NamespacesClientListBySubscriptionResponse struct {
	// Result of the List Namespaces operation.
	NamespacesListResult
}

// NamespacesClientListSharedAccessKeysResponse contains the response from method NamespacesClient.ListSharedAccessKeys.
type NamespacesClientListSharedAccessKeysResponse struct {
	// Shared access keys of the Namespace.
	NamespaceSharedAccessKeys
}

// NamespacesClientRegenerateKeyResponse contains the response from method NamespacesClient.BeginRegenerateKey.
type NamespacesClientRegenerateKeyResponse struct {
	// Shared access keys of the Namespace.
	NamespaceSharedAccessKeys
}

// NamespacesClientUpdateResponse contains the response from method NamespacesClient.BeginUpdate.
type NamespacesClientUpdateResponse struct {
	// Namespace resource.
	Namespace
}

// NamespacesClientValidateCustomDomainOwnershipResponse contains the response from method NamespacesClient.BeginValidateCustomDomainOwnership.
type NamespacesClientValidateCustomDomainOwnershipResponse struct {
	// Namespace custom domain ownership validation result.
	CustomDomainOwnershipValidationResult
}

// NetworkSecurityPerimeterConfigurationsClientGetResponse contains the response from method NetworkSecurityPerimeterConfigurationsClient.Get.
type NetworkSecurityPerimeterConfigurationsClientGetResponse struct {
	// Network security perimeter configuration.
	NetworkSecurityPerimeterConfiguration
}

// NetworkSecurityPerimeterConfigurationsClientListResponse contains the response from method NetworkSecurityPerimeterConfigurationsClient.NewListPager.
type NetworkSecurityPerimeterConfigurationsClientListResponse struct {
	// Network security perimeter configuration List.
	NetworkSecurityPerimeterConfigurationList
}

// NetworkSecurityPerimeterConfigurationsClientReconcileResponse contains the response from method NetworkSecurityPerimeterConfigurationsClient.BeginReconcile.
type NetworkSecurityPerimeterConfigurationsClientReconcileResponse struct {
	// Network security perimeter configuration.
	NetworkSecurityPerimeterConfiguration
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the List Operations operation
	OperationsListResult
}

// PartnerConfigurationsClientAuthorizePartnerResponse contains the response from method PartnerConfigurationsClient.AuthorizePartner.
type PartnerConfigurationsClientAuthorizePartnerResponse struct {
	// Partner configuration information
	PartnerConfiguration
}

// PartnerConfigurationsClientCreateOrUpdateResponse contains the response from method PartnerConfigurationsClient.BeginCreateOrUpdate.
type PartnerConfigurationsClientCreateOrUpdateResponse struct {
	// Partner configuration information
	PartnerConfiguration
}

// PartnerConfigurationsClientDeleteResponse contains the response from method PartnerConfigurationsClient.BeginDelete.
type PartnerConfigurationsClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerConfigurationsClientGetResponse contains the response from method PartnerConfigurationsClient.Get.
type PartnerConfigurationsClientGetResponse struct {
	// Partner configuration information
	PartnerConfiguration
}

// PartnerConfigurationsClientListByResourceGroupResponse contains the response from method PartnerConfigurationsClient.NewListByResourceGroupPager.
type PartnerConfigurationsClientListByResourceGroupResponse struct {
	// Result of the List partner configurations operation
	PartnerConfigurationsListResult
}

// PartnerConfigurationsClientListBySubscriptionResponse contains the response from method PartnerConfigurationsClient.NewListBySubscriptionPager.
type PartnerConfigurationsClientListBySubscriptionResponse struct {
	// Result of the List partner configurations operation
	PartnerConfigurationsListResult
}

// PartnerConfigurationsClientUnauthorizePartnerResponse contains the response from method PartnerConfigurationsClient.UnauthorizePartner.
type PartnerConfigurationsClientUnauthorizePartnerResponse struct {
	// Partner configuration information
	PartnerConfiguration
}

// PartnerConfigurationsClientUpdateResponse contains the response from method PartnerConfigurationsClient.BeginUpdate.
type PartnerConfigurationsClientUpdateResponse struct {
	// Partner configuration information
	PartnerConfiguration
}

// PartnerDestinationsClientActivateResponse contains the response from method PartnerDestinationsClient.Activate.
type PartnerDestinationsClientActivateResponse struct {
	// Event Grid Partner Destination.
	PartnerDestination
}

// PartnerDestinationsClientCreateOrUpdateResponse contains the response from method PartnerDestinationsClient.BeginCreateOrUpdate.
type PartnerDestinationsClientCreateOrUpdateResponse struct {
	// Event Grid Partner Destination.
	PartnerDestination
}

// PartnerDestinationsClientDeleteResponse contains the response from method PartnerDestinationsClient.BeginDelete.
type PartnerDestinationsClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerDestinationsClientGetResponse contains the response from method PartnerDestinationsClient.Get.
type PartnerDestinationsClientGetResponse struct {
	// Event Grid Partner Destination.
	PartnerDestination
}

// PartnerDestinationsClientListByResourceGroupResponse contains the response from method PartnerDestinationsClient.NewListByResourceGroupPager.
type PartnerDestinationsClientListByResourceGroupResponse struct {
	// Result of the List Partner Destinations operation.
	PartnerDestinationsListResult
}

// PartnerDestinationsClientListBySubscriptionResponse contains the response from method PartnerDestinationsClient.NewListBySubscriptionPager.
type PartnerDestinationsClientListBySubscriptionResponse struct {
	// Result of the List Partner Destinations operation.
	PartnerDestinationsListResult
}

// PartnerDestinationsClientUpdateResponse contains the response from method PartnerDestinationsClient.BeginUpdate.
type PartnerDestinationsClientUpdateResponse struct {
	// Event Grid Partner Destination.
	PartnerDestination
}

// PartnerNamespacesClientCreateOrUpdateResponse contains the response from method PartnerNamespacesClient.BeginCreateOrUpdate.
type PartnerNamespacesClientCreateOrUpdateResponse struct {
	// EventGrid Partner Namespace.
	PartnerNamespace
}

// PartnerNamespacesClientDeleteResponse contains the response from method PartnerNamespacesClient.BeginDelete.
type PartnerNamespacesClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerNamespacesClientGetResponse contains the response from method PartnerNamespacesClient.Get.
type PartnerNamespacesClientGetResponse struct {
	// EventGrid Partner Namespace.
	PartnerNamespace
}

// PartnerNamespacesClientListByResourceGroupResponse contains the response from method PartnerNamespacesClient.NewListByResourceGroupPager.
type PartnerNamespacesClientListByResourceGroupResponse struct {
	// Result of the List Partner Namespaces operation
	PartnerNamespacesListResult
}

// PartnerNamespacesClientListBySubscriptionResponse contains the response from method PartnerNamespacesClient.NewListBySubscriptionPager.
type PartnerNamespacesClientListBySubscriptionResponse struct {
	// Result of the List Partner Namespaces operation
	PartnerNamespacesListResult
}

// PartnerNamespacesClientListSharedAccessKeysResponse contains the response from method PartnerNamespacesClient.ListSharedAccessKeys.
type PartnerNamespacesClientListSharedAccessKeysResponse struct {
	// Shared access keys of the partner namespace.
	PartnerNamespaceSharedAccessKeys
}

// PartnerNamespacesClientRegenerateKeyResponse contains the response from method PartnerNamespacesClient.RegenerateKey.
type PartnerNamespacesClientRegenerateKeyResponse struct {
	// Shared access keys of the partner namespace.
	PartnerNamespaceSharedAccessKeys
}

// PartnerNamespacesClientUpdateResponse contains the response from method PartnerNamespacesClient.BeginUpdate.
type PartnerNamespacesClientUpdateResponse struct {
	// EventGrid Partner Namespace.
	PartnerNamespace
}

// PartnerRegistrationsClientCreateOrUpdateResponse contains the response from method PartnerRegistrationsClient.BeginCreateOrUpdate.
type PartnerRegistrationsClientCreateOrUpdateResponse struct {
	// Information about a partner registration.
	PartnerRegistration
}

// PartnerRegistrationsClientDeleteResponse contains the response from method PartnerRegistrationsClient.BeginDelete.
type PartnerRegistrationsClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerRegistrationsClientGetResponse contains the response from method PartnerRegistrationsClient.Get.
type PartnerRegistrationsClientGetResponse struct {
	// Information about a partner registration.
	PartnerRegistration
}

// PartnerRegistrationsClientListByResourceGroupResponse contains the response from method PartnerRegistrationsClient.NewListByResourceGroupPager.
type PartnerRegistrationsClientListByResourceGroupResponse struct {
	// Result of the List Partner Registrations operation.
	PartnerRegistrationsListResult
}

// PartnerRegistrationsClientListBySubscriptionResponse contains the response from method PartnerRegistrationsClient.NewListBySubscriptionPager.
type PartnerRegistrationsClientListBySubscriptionResponse struct {
	// Result of the List Partner Registrations operation.
	PartnerRegistrationsListResult
}

// PartnerRegistrationsClientUpdateResponse contains the response from method PartnerRegistrationsClient.BeginUpdate.
type PartnerRegistrationsClientUpdateResponse struct {
	// Information about a partner registration.
	PartnerRegistration
}

// PartnerTopicEventSubscriptionsClientCreateOrUpdateResponse contains the response from method PartnerTopicEventSubscriptionsClient.BeginCreateOrUpdate.
type PartnerTopicEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// PartnerTopicEventSubscriptionsClientDeleteResponse contains the response from method PartnerTopicEventSubscriptionsClient.BeginDelete.
type PartnerTopicEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerTopicEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method PartnerTopicEventSubscriptionsClient.GetDeliveryAttributes.
type PartnerTopicEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// PartnerTopicEventSubscriptionsClientGetFullURLResponse contains the response from method PartnerTopicEventSubscriptionsClient.GetFullURL.
type PartnerTopicEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// PartnerTopicEventSubscriptionsClientGetResponse contains the response from method PartnerTopicEventSubscriptionsClient.Get.
type PartnerTopicEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// PartnerTopicEventSubscriptionsClientListByPartnerTopicResponse contains the response from method PartnerTopicEventSubscriptionsClient.NewListByPartnerTopicPager.
type PartnerTopicEventSubscriptionsClientListByPartnerTopicResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// PartnerTopicEventSubscriptionsClientUpdateResponse contains the response from method PartnerTopicEventSubscriptionsClient.BeginUpdate.
type PartnerTopicEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// PartnerTopicsClientActivateResponse contains the response from method PartnerTopicsClient.Activate.
type PartnerTopicsClientActivateResponse struct {
	// Event Grid Partner Topic.
	PartnerTopic
}

// PartnerTopicsClientCreateOrUpdateResponse contains the response from method PartnerTopicsClient.CreateOrUpdate.
type PartnerTopicsClientCreateOrUpdateResponse struct {
	// Event Grid Partner Topic.
	PartnerTopic
}

// PartnerTopicsClientDeactivateResponse contains the response from method PartnerTopicsClient.Deactivate.
type PartnerTopicsClientDeactivateResponse struct {
	// Event Grid Partner Topic.
	PartnerTopic
}

// PartnerTopicsClientDeleteResponse contains the response from method PartnerTopicsClient.BeginDelete.
type PartnerTopicsClientDeleteResponse struct {
	// placeholder for future response values
}

// PartnerTopicsClientGetResponse contains the response from method PartnerTopicsClient.Get.
type PartnerTopicsClientGetResponse struct {
	// Event Grid Partner Topic.
	PartnerTopic
}

// PartnerTopicsClientListByResourceGroupResponse contains the response from method PartnerTopicsClient.NewListByResourceGroupPager.
type PartnerTopicsClientListByResourceGroupResponse struct {
	// Result of the List Partner Topics operation.
	PartnerTopicsListResult
}

// PartnerTopicsClientListBySubscriptionResponse contains the response from method PartnerTopicsClient.NewListBySubscriptionPager.
type PartnerTopicsClientListBySubscriptionResponse struct {
	// Result of the List Partner Topics operation.
	PartnerTopicsListResult
}

// PartnerTopicsClientUpdateResponse contains the response from method PartnerTopicsClient.Update.
type PartnerTopicsClientUpdateResponse struct {
	// Event Grid Partner Topic.
	PartnerTopic
}

// PermissionBindingsClientCreateOrUpdateResponse contains the response from method PermissionBindingsClient.BeginCreateOrUpdate.
type PermissionBindingsClientCreateOrUpdateResponse struct {
	// The Permission binding resource.
	PermissionBinding
}

// PermissionBindingsClientDeleteResponse contains the response from method PermissionBindingsClient.BeginDelete.
type PermissionBindingsClientDeleteResponse struct {
	// placeholder for future response values
}

// PermissionBindingsClientGetResponse contains the response from method PermissionBindingsClient.Get.
type PermissionBindingsClientGetResponse struct {
	// The Permission binding resource.
	PermissionBinding
}

// PermissionBindingsClientListByNamespaceResponse contains the response from method PermissionBindingsClient.NewListByNamespacePager.
type PermissionBindingsClientListByNamespaceResponse struct {
	// Result of the List Permission Binding operation.
	PermissionBindingsListResult
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByResourceResponse contains the response from method PrivateEndpointConnectionsClient.NewListByResourcePager.
type PrivateEndpointConnectionsClientListByResourceResponse struct {
	// Result of the list of all private endpoint connections operation.
	PrivateEndpointConnectionListResult
}

// PrivateEndpointConnectionsClientUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginUpdate.
type PrivateEndpointConnectionsClientUpdateResponse struct {
	PrivateEndpointConnection
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// Information of the private link resource.
	PrivateLinkResource
}

// PrivateLinkResourcesClientListByResourceResponse contains the response from method PrivateLinkResourcesClient.NewListByResourcePager.
type PrivateLinkResourcesClientListByResourceResponse struct {
	// Result of the List private link resources operation.
	PrivateLinkResourcesListResult
}

// SystemTopicEventSubscriptionsClientCreateOrUpdateResponse contains the response from method SystemTopicEventSubscriptionsClient.BeginCreateOrUpdate.
type SystemTopicEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// SystemTopicEventSubscriptionsClientDeleteResponse contains the response from method SystemTopicEventSubscriptionsClient.BeginDelete.
type SystemTopicEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// SystemTopicEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method SystemTopicEventSubscriptionsClient.GetDeliveryAttributes.
type SystemTopicEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// SystemTopicEventSubscriptionsClientGetFullURLResponse contains the response from method SystemTopicEventSubscriptionsClient.GetFullURL.
type SystemTopicEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// SystemTopicEventSubscriptionsClientGetResponse contains the response from method SystemTopicEventSubscriptionsClient.Get.
type SystemTopicEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// SystemTopicEventSubscriptionsClientListBySystemTopicResponse contains the response from method SystemTopicEventSubscriptionsClient.NewListBySystemTopicPager.
type SystemTopicEventSubscriptionsClientListBySystemTopicResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// SystemTopicEventSubscriptionsClientUpdateResponse contains the response from method SystemTopicEventSubscriptionsClient.BeginUpdate.
type SystemTopicEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// SystemTopicsClientCreateOrUpdateResponse contains the response from method SystemTopicsClient.BeginCreateOrUpdate.
type SystemTopicsClientCreateOrUpdateResponse struct {
	// EventGrid System Topic.
	SystemTopic
}

// SystemTopicsClientDeleteResponse contains the response from method SystemTopicsClient.BeginDelete.
type SystemTopicsClientDeleteResponse struct {
	// placeholder for future response values
}

// SystemTopicsClientGetResponse contains the response from method SystemTopicsClient.Get.
type SystemTopicsClientGetResponse struct {
	// EventGrid System Topic.
	SystemTopic
}

// SystemTopicsClientListByResourceGroupResponse contains the response from method SystemTopicsClient.NewListByResourceGroupPager.
type SystemTopicsClientListByResourceGroupResponse struct {
	// Result of the List System topics operation.
	SystemTopicsListResult
}

// SystemTopicsClientListBySubscriptionResponse contains the response from method SystemTopicsClient.NewListBySubscriptionPager.
type SystemTopicsClientListBySubscriptionResponse struct {
	// Result of the List System topics operation.
	SystemTopicsListResult
}

// SystemTopicsClientUpdateResponse contains the response from method SystemTopicsClient.BeginUpdate.
type SystemTopicsClientUpdateResponse struct {
	// EventGrid System Topic.
	SystemTopic
}

// TopicEventSubscriptionsClientCreateOrUpdateResponse contains the response from method TopicEventSubscriptionsClient.BeginCreateOrUpdate.
type TopicEventSubscriptionsClientCreateOrUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// TopicEventSubscriptionsClientDeleteResponse contains the response from method TopicEventSubscriptionsClient.BeginDelete.
type TopicEventSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// TopicEventSubscriptionsClientGetDeliveryAttributesResponse contains the response from method TopicEventSubscriptionsClient.GetDeliveryAttributes.
type TopicEventSubscriptionsClientGetDeliveryAttributesResponse struct {
	// Result of the Get delivery attributes operation.
	DeliveryAttributeListResult
}

// TopicEventSubscriptionsClientGetFullURLResponse contains the response from method TopicEventSubscriptionsClient.GetFullURL.
type TopicEventSubscriptionsClientGetFullURLResponse struct {
	// Full endpoint URL of an event subscription
	EventSubscriptionFullURL
}

// TopicEventSubscriptionsClientGetResponse contains the response from method TopicEventSubscriptionsClient.Get.
type TopicEventSubscriptionsClientGetResponse struct {
	// Event Subscription.
	EventSubscription
}

// TopicEventSubscriptionsClientListResponse contains the response from method TopicEventSubscriptionsClient.NewListPager.
type TopicEventSubscriptionsClientListResponse struct {
	// Result of the List EventSubscriptions operation
	EventSubscriptionsListResult
}

// TopicEventSubscriptionsClientUpdateResponse contains the response from method TopicEventSubscriptionsClient.BeginUpdate.
type TopicEventSubscriptionsClientUpdateResponse struct {
	// Event Subscription.
	EventSubscription
}

// TopicSpacesClientCreateOrUpdateResponse contains the response from method TopicSpacesClient.BeginCreateOrUpdate.
type TopicSpacesClientCreateOrUpdateResponse struct {
	// The Topic space resource.
	TopicSpace
}

// TopicSpacesClientDeleteResponse contains the response from method TopicSpacesClient.BeginDelete.
type TopicSpacesClientDeleteResponse struct {
	// placeholder for future response values
}

// TopicSpacesClientGetResponse contains the response from method TopicSpacesClient.Get.
type TopicSpacesClientGetResponse struct {
	// The Topic space resource.
	TopicSpace
}

// TopicSpacesClientListByNamespaceResponse contains the response from method TopicSpacesClient.NewListByNamespacePager.
type TopicSpacesClientListByNamespaceResponse struct {
	// Result of the List Topic Space operation.
	TopicSpacesListResult
}

// TopicTypesClientGetResponse contains the response from method TopicTypesClient.Get.
type TopicTypesClientGetResponse struct {
	// Properties of a topic type info.
	TopicTypeInfo
}

// TopicTypesClientListEventTypesResponse contains the response from method TopicTypesClient.NewListEventTypesPager.
type TopicTypesClientListEventTypesResponse struct {
	// Result of the List Event Types operation
	EventTypesListResult
}

// TopicTypesClientListResponse contains the response from method TopicTypesClient.NewListPager.
type TopicTypesClientListResponse struct {
	// Result of the List Topic Types operation
	TopicTypesListResult
}

// TopicsClientCreateOrUpdateResponse contains the response from method TopicsClient.BeginCreateOrUpdate.
type TopicsClientCreateOrUpdateResponse struct {
	// EventGrid Topic
	Topic
}

// TopicsClientDeleteResponse contains the response from method TopicsClient.BeginDelete.
type TopicsClientDeleteResponse struct {
	// placeholder for future response values
}

// TopicsClientGetResponse contains the response from method TopicsClient.Get.
type TopicsClientGetResponse struct {
	// EventGrid Topic
	Topic
}

// TopicsClientListByResourceGroupResponse contains the response from method TopicsClient.NewListByResourceGroupPager.
type TopicsClientListByResourceGroupResponse struct {
	// Result of the List Topics operation
	TopicsListResult
}

// TopicsClientListBySubscriptionResponse contains the response from method TopicsClient.NewListBySubscriptionPager.
type TopicsClientListBySubscriptionResponse struct {
	// Result of the List Topics operation
	TopicsListResult
}

// TopicsClientListEventTypesResponse contains the response from method TopicsClient.NewListEventTypesPager.
type TopicsClientListEventTypesResponse struct {
	// Result of the List Event Types operation
	EventTypesListResult
}

// TopicsClientListSharedAccessKeysResponse contains the response from method TopicsClient.ListSharedAccessKeys.
type TopicsClientListSharedAccessKeysResponse struct {
	// Shared access keys of the Topic
	TopicSharedAccessKeys
}

// TopicsClientRegenerateKeyResponse contains the response from method TopicsClient.BeginRegenerateKey.
type TopicsClientRegenerateKeyResponse struct {
	// Shared access keys of the Topic
	TopicSharedAccessKeys
}

// TopicsClientUpdateResponse contains the response from method TopicsClient.BeginUpdate.
type TopicsClientUpdateResponse struct {
	// EventGrid Topic
	Topic
}

// VerifiedPartnersClientGetResponse contains the response from method VerifiedPartnersClient.Get.
type VerifiedPartnersClientGetResponse struct {
	// Verified partner information
	VerifiedPartner
}

// VerifiedPartnersClientListResponse contains the response from method VerifiedPartnersClient.NewListPager.
type VerifiedPartnersClientListResponse struct {
	// Result of the List verified partners operation
	VerifiedPartnersListResult
}
