//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armhdinsight

// ApplicationsClientCreateResponse contains the response from method ApplicationsClient.BeginCreate.
type ApplicationsClientCreateResponse struct {
	// The HDInsight cluster application
	Application
}

// ApplicationsClientDeleteResponse contains the response from method ApplicationsClient.BeginDelete.
type ApplicationsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationsClientGetAzureAsyncOperationStatusResponse contains the response from method ApplicationsClient.GetAzureAsyncOperationStatus.
type ApplicationsClientGetAzureAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// ApplicationsClientGetResponse contains the response from method ApplicationsClient.Get.
type ApplicationsClientGetResponse struct {
	// The HDInsight cluster application
	Application
}

// ApplicationsClientListByClusterResponse contains the response from method ApplicationsClient.NewListByClusterPager.
type ApplicationsClientListByClusterResponse struct {
	// Result of the request to list cluster Applications. It contains a list of operations and a URL link to get the next set
	// of results.
	ApplicationListResult
}

// ClustersClientCreateResponse contains the response from method ClustersClient.BeginCreate.
type ClustersClientCreateResponse struct {
	// The HDInsight cluster.
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ClustersClientExecuteScriptActionsResponse contains the response from method ClustersClient.BeginExecuteScriptActions.
type ClustersClientExecuteScriptActionsResponse struct {
	// placeholder for future response values
}

// ClustersClientGetAzureAsyncOperationStatusResponse contains the response from method ClustersClient.GetAzureAsyncOperationStatus.
type ClustersClientGetAzureAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// ClustersClientGetGatewaySettingsResponse contains the response from method ClustersClient.GetGatewaySettings.
type ClustersClientGetGatewaySettingsResponse struct {
	// Gateway settings.
	GatewaySettings
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// The HDInsight cluster.
	Cluster
}

// ClustersClientListByResourceGroupResponse contains the response from method ClustersClient.NewListByResourceGroupPager.
type ClustersClientListByResourceGroupResponse struct {
	// The List Cluster operation response.
	ClusterListResult
}

// ClustersClientListResponse contains the response from method ClustersClient.NewListPager.
type ClustersClientListResponse struct {
	// The List Cluster operation response.
	ClusterListResult
}

// ClustersClientResizeResponse contains the response from method ClustersClient.BeginResize.
type ClustersClientResizeResponse struct {
	// placeholder for future response values
}

// ClustersClientRotateDiskEncryptionKeyResponse contains the response from method ClustersClient.BeginRotateDiskEncryptionKey.
type ClustersClientRotateDiskEncryptionKeyResponse struct {
	// placeholder for future response values
}

// ClustersClientUpdateAutoScaleConfigurationResponse contains the response from method ClustersClient.BeginUpdateAutoScaleConfiguration.
type ClustersClientUpdateAutoScaleConfigurationResponse struct {
	// placeholder for future response values
}

// ClustersClientUpdateGatewaySettingsResponse contains the response from method ClustersClient.BeginUpdateGatewaySettings.
type ClustersClientUpdateGatewaySettingsResponse struct {
	// placeholder for future response values
}

// ClustersClientUpdateIdentityCertificateResponse contains the response from method ClustersClient.BeginUpdateIdentityCertificate.
type ClustersClientUpdateIdentityCertificateResponse struct {
	// placeholder for future response values
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.Update.
type ClustersClientUpdateResponse struct {
	// The HDInsight cluster.
	Cluster
}

// ConfigurationsClientGetResponse contains the response from method ConfigurationsClient.Get.
type ConfigurationsClientGetResponse struct {
	// The configuration object for the specified configuration for the specified cluster.
	Value map[string]*string
}

// ConfigurationsClientListResponse contains the response from method ConfigurationsClient.List.
type ConfigurationsClientListResponse struct {
	// The configuration object for the specified cluster.
	ClusterConfigurations
}

// ConfigurationsClientUpdateResponse contains the response from method ConfigurationsClient.BeginUpdate.
type ConfigurationsClientUpdateResponse struct {
	// placeholder for future response values
}

// ExtensionsClientCreateResponse contains the response from method ExtensionsClient.BeginCreate.
type ExtensionsClientCreateResponse struct {
	// placeholder for future response values
}

// ExtensionsClientDeleteResponse contains the response from method ExtensionsClient.BeginDelete.
type ExtensionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ExtensionsClientDisableAzureMonitorAgentResponse contains the response from method ExtensionsClient.BeginDisableAzureMonitorAgent.
type ExtensionsClientDisableAzureMonitorAgentResponse struct {
	// placeholder for future response values
}

// ExtensionsClientDisableAzureMonitorResponse contains the response from method ExtensionsClient.BeginDisableAzureMonitor.
type ExtensionsClientDisableAzureMonitorResponse struct {
	// placeholder for future response values
}

// ExtensionsClientDisableMonitoringResponse contains the response from method ExtensionsClient.BeginDisableMonitoring.
type ExtensionsClientDisableMonitoringResponse struct {
	// placeholder for future response values
}

// ExtensionsClientEnableAzureMonitorAgentResponse contains the response from method ExtensionsClient.BeginEnableAzureMonitorAgent.
type ExtensionsClientEnableAzureMonitorAgentResponse struct {
	// placeholder for future response values
}

// ExtensionsClientEnableAzureMonitorResponse contains the response from method ExtensionsClient.BeginEnableAzureMonitor.
type ExtensionsClientEnableAzureMonitorResponse struct {
	// placeholder for future response values
}

// ExtensionsClientEnableMonitoringResponse contains the response from method ExtensionsClient.BeginEnableMonitoring.
type ExtensionsClientEnableMonitoringResponse struct {
	// placeholder for future response values
}

// ExtensionsClientGetAzureAsyncOperationStatusResponse contains the response from method ExtensionsClient.GetAzureAsyncOperationStatus.
type ExtensionsClientGetAzureAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// ExtensionsClientGetAzureMonitorAgentStatusResponse contains the response from method ExtensionsClient.GetAzureMonitorAgentStatus.
type ExtensionsClientGetAzureMonitorAgentStatusResponse struct {
	// The azure monitor status response.
	AzureMonitorResponse
}

// ExtensionsClientGetAzureMonitorStatusResponse contains the response from method ExtensionsClient.GetAzureMonitorStatus.
type ExtensionsClientGetAzureMonitorStatusResponse struct {
	// The azure monitor status response.
	AzureMonitorResponse
}

// ExtensionsClientGetMonitoringStatusResponse contains the response from method ExtensionsClient.GetMonitoringStatus.
type ExtensionsClientGetMonitoringStatusResponse struct {
	// The cluster monitoring status response.
	ClusterMonitoringResponse
}

// ExtensionsClientGetResponse contains the response from method ExtensionsClient.Get.
type ExtensionsClientGetResponse struct {
	// The cluster monitoring status response.
	ClusterMonitoringResponse
}

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	// The response spec of checking name availability.
	NameAvailabilityCheckResult
}

// LocationsClientGetAzureAsyncOperationStatusResponse contains the response from method LocationsClient.GetAzureAsyncOperationStatus.
type LocationsClientGetAzureAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// LocationsClientGetCapabilitiesResponse contains the response from method LocationsClient.GetCapabilities.
type LocationsClientGetCapabilitiesResponse struct {
	// The Get Capabilities operation response.
	CapabilitiesResult
}

// LocationsClientListBillingSpecsResponse contains the response from method LocationsClient.ListBillingSpecs.
type LocationsClientListBillingSpecsResponse struct {
	// The response for the operation to get regional billingSpecs for a subscription.
	BillingResponseListResult
}

// LocationsClientListUsagesResponse contains the response from method LocationsClient.ListUsages.
type LocationsClientListUsagesResponse struct {
	// The response for the operation to get regional usages for a subscription.
	UsagesListResult
}

// LocationsClientValidateClusterCreateRequestResponse contains the response from method LocationsClient.ValidateClusterCreateRequest.
type LocationsClientValidateClusterCreateRequestResponse struct {
	// The response of cluster create request validation.
	ClusterCreateValidationResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list HDInsight operations. It contains a list of operations and a URL link to get the next set
	// of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The private endpoint connection.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The private endpoint connection.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByClusterResponse contains the response from method PrivateEndpointConnectionsClient.NewListByClusterPager.
type PrivateEndpointConnectionsClientListByClusterResponse struct {
	// The list private endpoint connections response.
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A private link resource
	PrivateLinkResource
}

// PrivateLinkResourcesClientListByClusterResponse contains the response from method PrivateLinkResourcesClient.ListByCluster.
type PrivateLinkResourcesClientListByClusterResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// ScriptActionsClientDeleteResponse contains the response from method ScriptActionsClient.Delete.
type ScriptActionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ScriptActionsClientGetExecutionAsyncOperationStatusResponse contains the response from method ScriptActionsClient.GetExecutionAsyncOperationStatus.
type ScriptActionsClientGetExecutionAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// ScriptActionsClientGetExecutionDetailResponse contains the response from method ScriptActionsClient.GetExecutionDetail.
type ScriptActionsClientGetExecutionDetailResponse struct {
	// The execution details of a script action.
	RuntimeScriptActionDetail
}

// ScriptActionsClientListByClusterResponse contains the response from method ScriptActionsClient.NewListByClusterPager.
type ScriptActionsClientListByClusterResponse struct {
	// The persisted script action for the cluster.
	ScriptActionsList
}

// ScriptExecutionHistoryClientListByClusterResponse contains the response from method ScriptExecutionHistoryClient.NewListByClusterPager.
type ScriptExecutionHistoryClientListByClusterResponse struct {
	// The list script execution history response.
	ScriptActionExecutionHistoryList
}

// ScriptExecutionHistoryClientPromoteResponse contains the response from method ScriptExecutionHistoryClient.Promote.
type ScriptExecutionHistoryClientPromoteResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientGetAsyncOperationStatusResponse contains the response from method VirtualMachinesClient.GetAsyncOperationStatus.
type VirtualMachinesClientGetAsyncOperationStatusResponse struct {
	// The azure async operation response.
	AsyncOperationResult
}

// VirtualMachinesClientListHostsResponse contains the response from method VirtualMachinesClient.ListHosts.
type VirtualMachinesClientListHostsResponse struct {
	// Result of the request to list cluster hosts
	HostInfoArray []*HostInfo
}

// VirtualMachinesClientRestartHostsResponse contains the response from method VirtualMachinesClient.BeginRestartHosts.
type VirtualMachinesClientRestartHostsResponse struct {
	// placeholder for future response values
}
