//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/hdinsightcontainers/armhdinsightcontainers"
	"net/http"
	"net/url"
	"regexp"
)

// ClusterPoolUpgradeHistoriesServer is a fake server for instances of the armhdinsightcontainers.ClusterPoolUpgradeHistoriesClient type.
type ClusterPoolUpgradeHistoriesServer struct {
	// NewListPager is the fake for method ClusterPoolUpgradeHistoriesClient.NewListPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListPager func(resourceGroupName string, clusterPoolName string, options *armhdinsightcontainers.ClusterPoolUpgradeHistoriesClientListOptions) (resp azfake.PagerResponder[armhdinsightcontainers.ClusterPoolUpgradeHistoriesClientListResponse])
}

// NewClusterPoolUpgradeHistoriesServerTransport creates a new instance of ClusterPoolUpgradeHistoriesServerTransport with the provided implementation.
// The returned ClusterPoolUpgradeHistoriesServerTransport instance is connected to an instance of armhdinsightcontainers.ClusterPoolUpgradeHistoriesClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewClusterPoolUpgradeHistoriesServerTransport(srv *ClusterPoolUpgradeHistoriesServer) *ClusterPoolUpgradeHistoriesServerTransport {
	return &ClusterPoolUpgradeHistoriesServerTransport{
		srv:          srv,
		newListPager: newTracker[azfake.PagerResponder[armhdinsightcontainers.ClusterPoolUpgradeHistoriesClientListResponse]](),
	}
}

// ClusterPoolUpgradeHistoriesServerTransport connects instances of armhdinsightcontainers.ClusterPoolUpgradeHistoriesClient to instances of ClusterPoolUpgradeHistoriesServer.
// Don't use this type directly, use NewClusterPoolUpgradeHistoriesServerTransport instead.
type ClusterPoolUpgradeHistoriesServerTransport struct {
	srv          *ClusterPoolUpgradeHistoriesServer
	newListPager *tracker[azfake.PagerResponder[armhdinsightcontainers.ClusterPoolUpgradeHistoriesClientListResponse]]
}

// Do implements the policy.Transporter interface for ClusterPoolUpgradeHistoriesServerTransport.
func (c *ClusterPoolUpgradeHistoriesServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "ClusterPoolUpgradeHistoriesClient.NewListPager":
		resp, err = c.dispatchNewListPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (c *ClusterPoolUpgradeHistoriesServerTransport) dispatchNewListPager(req *http.Request) (*http.Response, error) {
	if c.srv.NewListPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListPager not implemented")}
	}
	newListPager := c.newListPager.get(req)
	if newListPager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.HDInsight/clusterpools/(?P<clusterPoolName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/upgradeHistories`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 3 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		clusterPoolNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterPoolName")])
		if err != nil {
			return nil, err
		}
		resp := c.srv.NewListPager(resourceGroupNameParam, clusterPoolNameParam, nil)
		newListPager = &resp
		c.newListPager.add(req, newListPager)
		server.PagerResponderInjectNextLinks(newListPager, req, func(page *armhdinsightcontainers.ClusterPoolUpgradeHistoriesClientListResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		c.newListPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListPager) {
		c.newListPager.remove(req)
	}
	return resp, nil
}
