//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armhybridnetwork

// ArtifactManifestsClientCreateOrUpdateResponse contains the response from method ArtifactManifestsClient.BeginCreateOrUpdate.
type ArtifactManifestsClientCreateOrUpdateResponse struct {
	// Artifact manifest properties.
	ArtifactManifest
}

// ArtifactManifestsClientDeleteResponse contains the response from method ArtifactManifestsClient.BeginDelete.
type ArtifactManifestsClientDeleteResponse struct {
	// placeholder for future response values
}

// ArtifactManifestsClientGetResponse contains the response from method ArtifactManifestsClient.Get.
type ArtifactManifestsClientGetResponse struct {
	// Artifact manifest properties.
	ArtifactManifest
}

// ArtifactManifestsClientListByArtifactStoreResponse contains the response from method ArtifactManifestsClient.NewListByArtifactStorePager.
type ArtifactManifestsClientListByArtifactStoreResponse struct {
	// A list of artifact manifests.
	ArtifactManifestListResult
}

// ArtifactManifestsClientListCredentialResponse contains the response from method ArtifactManifestsClient.ListCredential.
type ArtifactManifestsClientListCredentialResponse struct {
	// The artifact manifest credential definition.
	ArtifactAccessCredentialClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ArtifactManifestsClientListCredentialResponse.
func (a *ArtifactManifestsClientListCredentialResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalArtifactAccessCredentialClassification(data)
	if err != nil {
		return err
	}
	a.ArtifactAccessCredentialClassification = res
	return nil
}

// ArtifactManifestsClientUpdateResponse contains the response from method ArtifactManifestsClient.Update.
type ArtifactManifestsClientUpdateResponse struct {
	// Artifact manifest properties.
	ArtifactManifest
}

// ArtifactManifestsClientUpdateStateResponse contains the response from method ArtifactManifestsClient.BeginUpdateState.
type ArtifactManifestsClientUpdateStateResponse struct {
	// The artifact manifest updating request payload. Only the 'Uploaded' state is allowed for updates. Other states are used
	// for internal state transitioning.
	ArtifactManifestUpdateState
}

// ArtifactStoresClientCreateOrUpdateResponse contains the response from method ArtifactStoresClient.BeginCreateOrUpdate.
type ArtifactStoresClientCreateOrUpdateResponse struct {
	// Artifact store properties.
	ArtifactStore
}

// ArtifactStoresClientDeleteResponse contains the response from method ArtifactStoresClient.BeginDelete.
type ArtifactStoresClientDeleteResponse struct {
	// placeholder for future response values
}

// ArtifactStoresClientGetResponse contains the response from method ArtifactStoresClient.Get.
type ArtifactStoresClientGetResponse struct {
	// Artifact store properties.
	ArtifactStore
}

// ArtifactStoresClientListByPublisherResponse contains the response from method ArtifactStoresClient.NewListByPublisherPager.
type ArtifactStoresClientListByPublisherResponse struct {
	// A list of artifact stores.
	ArtifactStoreListResult
}

// ArtifactStoresClientUpdateResponse contains the response from method ArtifactStoresClient.Update.
type ArtifactStoresClientUpdateResponse struct {
	// Artifact store properties.
	ArtifactStore
}

// ComponentsClientGetResponse contains the response from method ComponentsClient.Get.
type ComponentsClientGetResponse struct {
	// The component sub resource.
	Component
}

// ComponentsClientListByNetworkFunctionResponse contains the response from method ComponentsClient.NewListByNetworkFunctionPager.
type ComponentsClientListByNetworkFunctionResponse struct {
	// Response for list component API service call.
	ComponentListResult
}

// ConfigurationGroupSchemasClientCreateOrUpdateResponse contains the response from method ConfigurationGroupSchemasClient.BeginCreateOrUpdate.
type ConfigurationGroupSchemasClientCreateOrUpdateResponse struct {
	// Configuration group schema resource.
	ConfigurationGroupSchema
}

// ConfigurationGroupSchemasClientDeleteResponse contains the response from method ConfigurationGroupSchemasClient.BeginDelete.
type ConfigurationGroupSchemasClientDeleteResponse struct {
	// placeholder for future response values
}

// ConfigurationGroupSchemasClientGetResponse contains the response from method ConfigurationGroupSchemasClient.Get.
type ConfigurationGroupSchemasClientGetResponse struct {
	// Configuration group schema resource.
	ConfigurationGroupSchema
}

// ConfigurationGroupSchemasClientListByPublisherResponse contains the response from method ConfigurationGroupSchemasClient.NewListByPublisherPager.
type ConfigurationGroupSchemasClientListByPublisherResponse struct {
	// A list of configuration group schema resources.
	ConfigurationGroupSchemaListResult
}

// ConfigurationGroupSchemasClientUpdateResponse contains the response from method ConfigurationGroupSchemasClient.Update.
type ConfigurationGroupSchemasClientUpdateResponse struct {
	// Configuration group schema resource.
	ConfigurationGroupSchema
}

// ConfigurationGroupSchemasClientUpdateStateResponse contains the response from method ConfigurationGroupSchemasClient.BeginUpdateState.
type ConfigurationGroupSchemasClientUpdateStateResponse struct {
	// Publisher configuration group schema update request definition.
	ConfigurationGroupSchemaVersionUpdateState
}

// ConfigurationGroupValuesClientCreateOrUpdateResponse contains the response from method ConfigurationGroupValuesClient.BeginCreateOrUpdate.
type ConfigurationGroupValuesClientCreateOrUpdateResponse struct {
	// Hybrid configuration group value resource.
	ConfigurationGroupValue
}

// ConfigurationGroupValuesClientDeleteResponse contains the response from method ConfigurationGroupValuesClient.BeginDelete.
type ConfigurationGroupValuesClientDeleteResponse struct {
	// placeholder for future response values
}

// ConfigurationGroupValuesClientGetResponse contains the response from method ConfigurationGroupValuesClient.Get.
type ConfigurationGroupValuesClientGetResponse struct {
	// Hybrid configuration group value resource.
	ConfigurationGroupValue
}

// ConfigurationGroupValuesClientListByResourceGroupResponse contains the response from method ConfigurationGroupValuesClient.NewListByResourceGroupPager.
type ConfigurationGroupValuesClientListByResourceGroupResponse struct {
	// Response for hybrid configurationGroups API service call.
	ConfigurationGroupValueListResult
}

// ConfigurationGroupValuesClientListBySubscriptionResponse contains the response from method ConfigurationGroupValuesClient.NewListBySubscriptionPager.
type ConfigurationGroupValuesClientListBySubscriptionResponse struct {
	// Response for hybrid configurationGroups API service call.
	ConfigurationGroupValueListResult
}

// ConfigurationGroupValuesClientUpdateTagsResponse contains the response from method ConfigurationGroupValuesClient.UpdateTags.
type ConfigurationGroupValuesClientUpdateTagsResponse struct {
	// Hybrid configuration group value resource.
	ConfigurationGroupValue
}

// NetworkFunctionDefinitionGroupsClientCreateOrUpdateResponse contains the response from method NetworkFunctionDefinitionGroupsClient.BeginCreateOrUpdate.
type NetworkFunctionDefinitionGroupsClientCreateOrUpdateResponse struct {
	// Network function definition group resource.
	NetworkFunctionDefinitionGroup
}

// NetworkFunctionDefinitionGroupsClientDeleteResponse contains the response from method NetworkFunctionDefinitionGroupsClient.BeginDelete.
type NetworkFunctionDefinitionGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFunctionDefinitionGroupsClientGetResponse contains the response from method NetworkFunctionDefinitionGroupsClient.Get.
type NetworkFunctionDefinitionGroupsClientGetResponse struct {
	// Network function definition group resource.
	NetworkFunctionDefinitionGroup
}

// NetworkFunctionDefinitionGroupsClientListByPublisherResponse contains the response from method NetworkFunctionDefinitionGroupsClient.NewListByPublisherPager.
type NetworkFunctionDefinitionGroupsClientListByPublisherResponse struct {
	// A list of network function definition group resources.
	NetworkFunctionDefinitionGroupListResult
}

// NetworkFunctionDefinitionGroupsClientUpdateResponse contains the response from method NetworkFunctionDefinitionGroupsClient.Update.
type NetworkFunctionDefinitionGroupsClientUpdateResponse struct {
	// Network function definition group resource.
	NetworkFunctionDefinitionGroup
}

// NetworkFunctionDefinitionVersionsClientCreateOrUpdateResponse contains the response from method NetworkFunctionDefinitionVersionsClient.BeginCreateOrUpdate.
type NetworkFunctionDefinitionVersionsClientCreateOrUpdateResponse struct {
	// Network function definition version.
	NetworkFunctionDefinitionVersion
}

// NetworkFunctionDefinitionVersionsClientDeleteResponse contains the response from method NetworkFunctionDefinitionVersionsClient.BeginDelete.
type NetworkFunctionDefinitionVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFunctionDefinitionVersionsClientGetResponse contains the response from method NetworkFunctionDefinitionVersionsClient.Get.
type NetworkFunctionDefinitionVersionsClientGetResponse struct {
	// Network function definition version.
	NetworkFunctionDefinitionVersion
}

// NetworkFunctionDefinitionVersionsClientListByNetworkFunctionDefinitionGroupResponse contains the response from method NetworkFunctionDefinitionVersionsClient.NewListByNetworkFunctionDefinitionGroupPager.
type NetworkFunctionDefinitionVersionsClientListByNetworkFunctionDefinitionGroupResponse struct {
	// A list of network function definition versions.
	NetworkFunctionDefinitionVersionListResult
}

// NetworkFunctionDefinitionVersionsClientUpdateResponse contains the response from method NetworkFunctionDefinitionVersionsClient.Update.
type NetworkFunctionDefinitionVersionsClientUpdateResponse struct {
	// Network function definition version.
	NetworkFunctionDefinitionVersion
}

// NetworkFunctionDefinitionVersionsClientUpdateStateResponse contains the response from method NetworkFunctionDefinitionVersionsClient.BeginUpdateState.
type NetworkFunctionDefinitionVersionsClientUpdateStateResponse struct {
	// Publisher network function definition version update request definition.
	NetworkFunctionDefinitionVersionUpdateState
}

// NetworkFunctionsClientCreateOrUpdateResponse contains the response from method NetworkFunctionsClient.BeginCreateOrUpdate.
type NetworkFunctionsClientCreateOrUpdateResponse struct {
	// Network function resource response.
	NetworkFunction
}

// NetworkFunctionsClientDeleteResponse contains the response from method NetworkFunctionsClient.BeginDelete.
type NetworkFunctionsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFunctionsClientExecuteRequestResponse contains the response from method NetworkFunctionsClient.BeginExecuteRequest.
type NetworkFunctionsClientExecuteRequestResponse struct {
	// placeholder for future response values
}

// NetworkFunctionsClientGetResponse contains the response from method NetworkFunctionsClient.Get.
type NetworkFunctionsClientGetResponse struct {
	// Network function resource response.
	NetworkFunction
}

// NetworkFunctionsClientListByResourceGroupResponse contains the response from method NetworkFunctionsClient.NewListByResourceGroupPager.
type NetworkFunctionsClientListByResourceGroupResponse struct {
	// Response for network function API service call.
	NetworkFunctionListResult
}

// NetworkFunctionsClientListBySubscriptionResponse contains the response from method NetworkFunctionsClient.NewListBySubscriptionPager.
type NetworkFunctionsClientListBySubscriptionResponse struct {
	// Response for network function API service call.
	NetworkFunctionListResult
}

// NetworkFunctionsClientUpdateTagsResponse contains the response from method NetworkFunctionsClient.UpdateTags.
type NetworkFunctionsClientUpdateTagsResponse struct {
	// Network function resource response.
	NetworkFunction
}

// NetworkServiceDesignGroupsClientCreateOrUpdateResponse contains the response from method NetworkServiceDesignGroupsClient.BeginCreateOrUpdate.
type NetworkServiceDesignGroupsClientCreateOrUpdateResponse struct {
	// network service design group resource.
	NetworkServiceDesignGroup
}

// NetworkServiceDesignGroupsClientDeleteResponse contains the response from method NetworkServiceDesignGroupsClient.BeginDelete.
type NetworkServiceDesignGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkServiceDesignGroupsClientGetResponse contains the response from method NetworkServiceDesignGroupsClient.Get.
type NetworkServiceDesignGroupsClientGetResponse struct {
	// network service design group resource.
	NetworkServiceDesignGroup
}

// NetworkServiceDesignGroupsClientListByPublisherResponse contains the response from method NetworkServiceDesignGroupsClient.NewListByPublisherPager.
type NetworkServiceDesignGroupsClientListByPublisherResponse struct {
	// A list of network service design group resources.
	NetworkServiceDesignGroupListResult
}

// NetworkServiceDesignGroupsClientUpdateResponse contains the response from method NetworkServiceDesignGroupsClient.Update.
type NetworkServiceDesignGroupsClientUpdateResponse struct {
	// network service design group resource.
	NetworkServiceDesignGroup
}

// NetworkServiceDesignVersionsClientCreateOrUpdateResponse contains the response from method NetworkServiceDesignVersionsClient.BeginCreateOrUpdate.
type NetworkServiceDesignVersionsClientCreateOrUpdateResponse struct {
	// network service design version.
	NetworkServiceDesignVersion
}

// NetworkServiceDesignVersionsClientDeleteResponse contains the response from method NetworkServiceDesignVersionsClient.BeginDelete.
type NetworkServiceDesignVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkServiceDesignVersionsClientGetResponse contains the response from method NetworkServiceDesignVersionsClient.Get.
type NetworkServiceDesignVersionsClientGetResponse struct {
	// network service design version.
	NetworkServiceDesignVersion
}

// NetworkServiceDesignVersionsClientListByNetworkServiceDesignGroupResponse contains the response from method NetworkServiceDesignVersionsClient.NewListByNetworkServiceDesignGroupPager.
type NetworkServiceDesignVersionsClientListByNetworkServiceDesignGroupResponse struct {
	// A list of network service design versions.
	NetworkServiceDesignVersionListResult
}

// NetworkServiceDesignVersionsClientUpdateResponse contains the response from method NetworkServiceDesignVersionsClient.Update.
type NetworkServiceDesignVersionsClientUpdateResponse struct {
	// network service design version.
	NetworkServiceDesignVersion
}

// NetworkServiceDesignVersionsClientUpdateStateResponse contains the response from method NetworkServiceDesignVersionsClient.BeginUpdateState.
type NetworkServiceDesignVersionsClientUpdateStateResponse struct {
	// Publisher network service design version update request definition.
	NetworkServiceDesignVersionUpdateState
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// ProxyArtifactClientGetResponse contains the response from method ProxyArtifactClient.NewGetPager.
type ProxyArtifactClientGetResponse struct {
	// The proxy artifact list result.
	ProxyArtifactVersionsOverviewListResult
}

// ProxyArtifactClientListResponse contains the response from method ProxyArtifactClient.NewListPager.
type ProxyArtifactClientListResponse struct {
	// The proxy artifact list result.
	ProxyArtifactOverviewListResult
}

// ProxyArtifactClientUpdateStateResponse contains the response from method ProxyArtifactClient.BeginUpdateState.
type ProxyArtifactClientUpdateStateResponse struct {
	// The proxy artifact overview.
	ProxyArtifactVersionsListOverview
}

// PublishersClientCreateOrUpdateResponse contains the response from method PublishersClient.BeginCreateOrUpdate.
type PublishersClientCreateOrUpdateResponse struct {
	// publisher resource.
	Publisher
}

// PublishersClientDeleteResponse contains the response from method PublishersClient.BeginDelete.
type PublishersClientDeleteResponse struct {
	// placeholder for future response values
}

// PublishersClientGetResponse contains the response from method PublishersClient.Get.
type PublishersClientGetResponse struct {
	// publisher resource.
	Publisher
}

// PublishersClientListByResourceGroupResponse contains the response from method PublishersClient.NewListByResourceGroupPager.
type PublishersClientListByResourceGroupResponse struct {
	// A list of publishers.
	PublisherListResult
}

// PublishersClientListBySubscriptionResponse contains the response from method PublishersClient.NewListBySubscriptionPager.
type PublishersClientListBySubscriptionResponse struct {
	// A list of publishers.
	PublisherListResult
}

// PublishersClientUpdateResponse contains the response from method PublishersClient.Update.
type PublishersClientUpdateResponse struct {
	// publisher resource.
	Publisher
}

// SiteNetworkServicesClientCreateOrUpdateResponse contains the response from method SiteNetworkServicesClient.BeginCreateOrUpdate.
type SiteNetworkServicesClientCreateOrUpdateResponse struct {
	// Site network service resource.
	SiteNetworkService
}

// SiteNetworkServicesClientDeleteResponse contains the response from method SiteNetworkServicesClient.BeginDelete.
type SiteNetworkServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// SiteNetworkServicesClientGetResponse contains the response from method SiteNetworkServicesClient.Get.
type SiteNetworkServicesClientGetResponse struct {
	// Site network service resource.
	SiteNetworkService
}

// SiteNetworkServicesClientListByResourceGroupResponse contains the response from method SiteNetworkServicesClient.NewListByResourceGroupPager.
type SiteNetworkServicesClientListByResourceGroupResponse struct {
	// Response for site network services API service call.
	SiteNetworkServiceListResult
}

// SiteNetworkServicesClientListBySubscriptionResponse contains the response from method SiteNetworkServicesClient.NewListBySubscriptionPager.
type SiteNetworkServicesClientListBySubscriptionResponse struct {
	// Response for site network services API service call.
	SiteNetworkServiceListResult
}

// SiteNetworkServicesClientUpdateTagsResponse contains the response from method SiteNetworkServicesClient.UpdateTags.
type SiteNetworkServicesClientUpdateTagsResponse struct {
	// Site network service resource.
	SiteNetworkService
}

// SitesClientCreateOrUpdateResponse contains the response from method SitesClient.BeginCreateOrUpdate.
type SitesClientCreateOrUpdateResponse struct {
	// Site resource.
	Site
}

// SitesClientDeleteResponse contains the response from method SitesClient.BeginDelete.
type SitesClientDeleteResponse struct {
	// placeholder for future response values
}

// SitesClientGetResponse contains the response from method SitesClient.Get.
type SitesClientGetResponse struct {
	// Site resource.
	Site
}

// SitesClientListByResourceGroupResponse contains the response from method SitesClient.NewListByResourceGroupPager.
type SitesClientListByResourceGroupResponse struct {
	// Response for sites API service call.
	SiteListResult
}

// SitesClientListBySubscriptionResponse contains the response from method SitesClient.NewListBySubscriptionPager.
type SitesClientListBySubscriptionResponse struct {
	// Response for sites API service call.
	SiteListResult
}

// SitesClientUpdateTagsResponse contains the response from method SitesClient.UpdateTags.
type SitesClientUpdateTagsResponse struct {
	// Site resource.
	Site
}
