//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armiothub

// CertificatesClientCreateOrUpdateResponse contains the response from method CertificatesClient.CreateOrUpdate.
type CertificatesClientCreateOrUpdateResponse struct {
	// The X509 Certificate.
	CertificateDescription
}

// CertificatesClientDeleteResponse contains the response from method CertificatesClient.Delete.
type CertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificatesClientGenerateVerificationCodeResponse contains the response from method CertificatesClient.GenerateVerificationCode.
type CertificatesClientGenerateVerificationCodeResponse struct {
	// The X509 Certificate.
	CertificateWithNonceDescription
}

// CertificatesClientGetResponse contains the response from method CertificatesClient.Get.
type CertificatesClientGetResponse struct {
	// The X509 Certificate.
	CertificateDescription
}

// CertificatesClientListByIotHubResponse contains the response from method CertificatesClient.ListByIotHub.
type CertificatesClientListByIotHubResponse struct {
	// The JSON-serialized array of Certificate objects.
	CertificateListDescription
}

// CertificatesClientVerifyResponse contains the response from method CertificatesClient.Verify.
type CertificatesClientVerifyResponse struct {
	// The X509 Certificate.
	CertificateDescription
}

// ClientManualFailoverResponse contains the response from method Client.BeginManualFailover.
type ClientManualFailoverResponse struct {
	// placeholder for future response values
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list IoT Hub operations. It contains a list of operations and a URL link to get the next set of
	// results.
	OperationListResult
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// The private endpoint connection of an IotHub
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The private endpoint connection of an IotHub
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	// The list of private endpoint connections for an IotHub
	PrivateEndpointConnectionArray []*PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginUpdate.
type PrivateEndpointConnectionsClientUpdateResponse struct {
	// The private endpoint connection of an IotHub
	PrivateEndpointConnection
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// The group information for creating a private endpoint on an IotHub
	GroupIDInformation
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	// The available private link resources for an IotHub
	PrivateLinkResources
}

// ResourceClientCheckNameAvailabilityResponse contains the response from method ResourceClient.CheckNameAvailability.
type ResourceClientCheckNameAvailabilityResponse struct {
	// The properties indicating whether a given IoT hub name is available.
	NameAvailabilityInfo
}

// ResourceClientCreateEventHubConsumerGroupResponse contains the response from method ResourceClient.CreateEventHubConsumerGroup.
type ResourceClientCreateEventHubConsumerGroupResponse struct {
	// The properties of the EventHubConsumerGroupInfo object.
	EventHubConsumerGroupInfo
}

// ResourceClientCreateOrUpdateResponse contains the response from method ResourceClient.BeginCreateOrUpdate.
type ResourceClientCreateOrUpdateResponse struct {
	// The description of the IoT hub.
	Description
}

// ResourceClientDeleteEventHubConsumerGroupResponse contains the response from method ResourceClient.DeleteEventHubConsumerGroup.
type ResourceClientDeleteEventHubConsumerGroupResponse struct {
	// placeholder for future response values
}

// ResourceClientDeleteResponse contains the response from method ResourceClient.BeginDelete.
type ResourceClientDeleteResponse struct {
	// The description of the IoT hub.
	Description
}

// ResourceClientExportDevicesResponse contains the response from method ResourceClient.ExportDevices.
type ResourceClientExportDevicesResponse struct {
	// The properties of the Job Response object.
	JobResponse
}

// ResourceClientGetEndpointHealthResponse contains the response from method ResourceClient.NewGetEndpointHealthPager.
type ResourceClientGetEndpointHealthResponse struct {
	// The JSON-serialized array of EndpointHealthData objects with a next link.
	EndpointHealthDataListResult
}

// ResourceClientGetEventHubConsumerGroupResponse contains the response from method ResourceClient.GetEventHubConsumerGroup.
type ResourceClientGetEventHubConsumerGroupResponse struct {
	// The properties of the EventHubConsumerGroupInfo object.
	EventHubConsumerGroupInfo
}

// ResourceClientGetJobResponse contains the response from method ResourceClient.GetJob.
type ResourceClientGetJobResponse struct {
	// The properties of the Job Response object.
	JobResponse
}

// ResourceClientGetKeysForKeyNameResponse contains the response from method ResourceClient.GetKeysForKeyName.
type ResourceClientGetKeysForKeyNameResponse struct {
	// The properties of an IoT hub shared access policy.
	SharedAccessSignatureAuthorizationRule
}

// ResourceClientGetQuotaMetricsResponse contains the response from method ResourceClient.NewGetQuotaMetricsPager.
type ResourceClientGetQuotaMetricsResponse struct {
	// The JSON-serialized array of IotHubQuotaMetricInfo objects with a next link.
	QuotaMetricInfoListResult
}

// ResourceClientGetResponse contains the response from method ResourceClient.Get.
type ResourceClientGetResponse struct {
	// The description of the IoT hub.
	Description
}

// ResourceClientGetStatsResponse contains the response from method ResourceClient.GetStats.
type ResourceClientGetStatsResponse struct {
	// Identity registry statistics.
	RegistryStatistics
}

// ResourceClientGetValidSKUsResponse contains the response from method ResourceClient.NewGetValidSKUsPager.
type ResourceClientGetValidSKUsResponse struct {
	// The JSON-serialized array of IotHubSkuDescription objects with a next link.
	SKUDescriptionListResult
}

// ResourceClientImportDevicesResponse contains the response from method ResourceClient.ImportDevices.
type ResourceClientImportDevicesResponse struct {
	// The properties of the Job Response object.
	JobResponse
}

// ResourceClientListByResourceGroupResponse contains the response from method ResourceClient.NewListByResourceGroupPager.
type ResourceClientListByResourceGroupResponse struct {
	// The JSON-serialized array of IotHubDescription objects with a next link.
	DescriptionListResult
}

// ResourceClientListBySubscriptionResponse contains the response from method ResourceClient.NewListBySubscriptionPager.
type ResourceClientListBySubscriptionResponse struct {
	// The JSON-serialized array of IotHubDescription objects with a next link.
	DescriptionListResult
}

// ResourceClientListEventHubConsumerGroupsResponse contains the response from method ResourceClient.NewListEventHubConsumerGroupsPager.
type ResourceClientListEventHubConsumerGroupsResponse struct {
	// The JSON-serialized array of Event Hub-compatible consumer group names with a next link.
	EventHubConsumerGroupsListResult
}

// ResourceClientListJobsResponse contains the response from method ResourceClient.NewListJobsPager.
type ResourceClientListJobsResponse struct {
	// The JSON-serialized array of JobResponse objects with a next link.
	JobResponseListResult
}

// ResourceClientListKeysResponse contains the response from method ResourceClient.NewListKeysPager.
type ResourceClientListKeysResponse struct {
	// The list of shared access policies with a next link.
	SharedAccessSignatureAuthorizationRuleListResult
}

// ResourceClientTestAllRoutesResponse contains the response from method ResourceClient.TestAllRoutes.
type ResourceClientTestAllRoutesResponse struct {
	// Result of testing all routes
	TestAllRoutesResult
}

// ResourceClientTestRouteResponse contains the response from method ResourceClient.TestRoute.
type ResourceClientTestRouteResponse struct {
	// Result of testing one route
	TestRouteResult
}

// ResourceClientUpdateResponse contains the response from method ResourceClient.BeginUpdate.
type ResourceClientUpdateResponse struct {
	// The description of the IoT hub.
	Description
}

// ResourceProviderCommonClientGetSubscriptionQuotaResponse contains the response from method ResourceProviderCommonClient.GetSubscriptionQuota.
type ResourceProviderCommonClientGetSubscriptionQuotaResponse struct {
	// Json-serialized array of User subscription quota response
	UserSubscriptionQuotaListResult
}
