//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/maintenance/armmaintenance"
	"net/http"
	"regexp"
)

// ConfigurationAssignmentsWithinSubscriptionServer is a fake server for instances of the armmaintenance.ConfigurationAssignmentsWithinSubscriptionClient type.
type ConfigurationAssignmentsWithinSubscriptionServer struct {
	// NewListPager is the fake for method ConfigurationAssignmentsWithinSubscriptionClient.NewListPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListPager func(options *armmaintenance.ConfigurationAssignmentsWithinSubscriptionClientListOptions) (resp azfake.PagerResponder[armmaintenance.ConfigurationAssignmentsWithinSubscriptionClientListResponse])
}

// NewConfigurationAssignmentsWithinSubscriptionServerTransport creates a new instance of ConfigurationAssignmentsWithinSubscriptionServerTransport with the provided implementation.
// The returned ConfigurationAssignmentsWithinSubscriptionServerTransport instance is connected to an instance of armmaintenance.ConfigurationAssignmentsWithinSubscriptionClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewConfigurationAssignmentsWithinSubscriptionServerTransport(srv *ConfigurationAssignmentsWithinSubscriptionServer) *ConfigurationAssignmentsWithinSubscriptionServerTransport {
	return &ConfigurationAssignmentsWithinSubscriptionServerTransport{
		srv:          srv,
		newListPager: newTracker[azfake.PagerResponder[armmaintenance.ConfigurationAssignmentsWithinSubscriptionClientListResponse]](),
	}
}

// ConfigurationAssignmentsWithinSubscriptionServerTransport connects instances of armmaintenance.ConfigurationAssignmentsWithinSubscriptionClient to instances of ConfigurationAssignmentsWithinSubscriptionServer.
// Don't use this type directly, use NewConfigurationAssignmentsWithinSubscriptionServerTransport instead.
type ConfigurationAssignmentsWithinSubscriptionServerTransport struct {
	srv          *ConfigurationAssignmentsWithinSubscriptionServer
	newListPager *tracker[azfake.PagerResponder[armmaintenance.ConfigurationAssignmentsWithinSubscriptionClientListResponse]]
}

// Do implements the policy.Transporter interface for ConfigurationAssignmentsWithinSubscriptionServerTransport.
func (c *ConfigurationAssignmentsWithinSubscriptionServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "ConfigurationAssignmentsWithinSubscriptionClient.NewListPager":
		resp, err = c.dispatchNewListPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (c *ConfigurationAssignmentsWithinSubscriptionServerTransport) dispatchNewListPager(req *http.Request) (*http.Response, error) {
	if c.srv.NewListPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListPager not implemented")}
	}
	newListPager := c.newListPager.get(req)
	if newListPager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Maintenance/configurationAssignments`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 1 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resp := c.srv.NewListPager(nil)
		newListPager = &resp
		c.newListPager.add(req, newListPager)
	}
	resp, err := server.PagerResponderNext(newListPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		c.newListPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListPager) {
		c.newListPager.remove(req)
	}
	return resp, nil
}
