//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armmaps

// AccountsClientCreateOrUpdateResponse contains the response from method AccountsClient.CreateOrUpdate.
type AccountsClientCreateOrUpdateResponse struct {
	// An Azure resource which represents access to a suite of Maps REST APIs.
	Account
}

// AccountsClientDeleteResponse contains the response from method AccountsClient.Delete.
type AccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountsClientGetResponse contains the response from method AccountsClient.Get.
type AccountsClientGetResponse struct {
	// An Azure resource which represents access to a suite of Maps REST APIs.
	Account
}

// AccountsClientListByResourceGroupResponse contains the response from method AccountsClient.NewListByResourceGroupPager.
type AccountsClientListByResourceGroupResponse struct {
	// A list of Maps Accounts.
	Accounts
}

// AccountsClientListBySubscriptionResponse contains the response from method AccountsClient.NewListBySubscriptionPager.
type AccountsClientListBySubscriptionResponse struct {
	// A list of Maps Accounts.
	Accounts
}

// AccountsClientListKeysResponse contains the response from method AccountsClient.ListKeys.
type AccountsClientListKeysResponse struct {
	// The set of keys which can be used to access the Maps REST APIs. Two keys are provided for key rotation without interruption.
	AccountKeys
}

// AccountsClientListSasResponse contains the response from method AccountsClient.ListSas.
type AccountsClientListSasResponse struct {
	// A new Sas token which can be used to access the Maps REST APIs and is controlled by the specified Managed identity permissions
	// on Azure (IAM) Role Based Access Control.
	AccountSasToken
}

// AccountsClientRegenerateKeysResponse contains the response from method AccountsClient.RegenerateKeys.
type AccountsClientRegenerateKeysResponse struct {
	// The set of keys which can be used to access the Maps REST APIs. Two keys are provided for key rotation without interruption.
	AccountKeys
}

// AccountsClientUpdateResponse contains the response from method AccountsClient.Update.
type AccountsClientUpdateResponse struct {
	// An Azure resource which represents access to a suite of Maps REST APIs.
	Account
}

// ClientListOperationsResponse contains the response from method Client.NewListOperationsPager.
type ClientListOperationsResponse struct {
	// The set of operations available for Maps.
	Operations
}

// ClientListSubscriptionOperationsResponse contains the response from method Client.NewListSubscriptionOperationsPager.
type ClientListSubscriptionOperationsResponse struct {
	// The set of operations available for Maps.
	Operations
}

// CreatorsClientCreateOrUpdateResponse contains the response from method CreatorsClient.CreateOrUpdate.
type CreatorsClientCreateOrUpdateResponse struct {
	// An Azure resource which represents Maps Creator product and provides ability to manage private location data.
	Creator
}

// CreatorsClientDeleteResponse contains the response from method CreatorsClient.Delete.
type CreatorsClientDeleteResponse struct {
	// placeholder for future response values
}

// CreatorsClientGetResponse contains the response from method CreatorsClient.Get.
type CreatorsClientGetResponse struct {
	// An Azure resource which represents Maps Creator product and provides ability to manage private location data.
	Creator
}

// CreatorsClientListByAccountResponse contains the response from method CreatorsClient.NewListByAccountPager.
type CreatorsClientListByAccountResponse struct {
	// A list of Creator resources.
	CreatorList
}

// CreatorsClientUpdateResponse contains the response from method CreatorsClient.Update.
type CreatorsClientUpdateResponse struct {
	// An Azure resource which represents Maps Creator product and provides ability to manage private location data.
	Creator
}
