//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armmediaservices

// AccountFiltersClientCreateOrUpdateResponse contains the response from method AccountFiltersClient.CreateOrUpdate.
type AccountFiltersClientCreateOrUpdateResponse struct {
	// An Account Filter.
	AccountFilter
}

// AccountFiltersClientDeleteResponse contains the response from method AccountFiltersClient.Delete.
type AccountFiltersClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountFiltersClientGetResponse contains the response from method AccountFiltersClient.Get.
type AccountFiltersClientGetResponse struct {
	// An Account Filter.
	AccountFilter
}

// AccountFiltersClientListResponse contains the response from method AccountFiltersClient.NewListPager.
type AccountFiltersClientListResponse struct {
	// A collection of AccountFilter items.
	AccountFilterCollection
}

// AccountFiltersClientUpdateResponse contains the response from method AccountFiltersClient.Update.
type AccountFiltersClientUpdateResponse struct {
	// An Account Filter.
	AccountFilter
}

// AssetFiltersClientCreateOrUpdateResponse contains the response from method AssetFiltersClient.CreateOrUpdate.
type AssetFiltersClientCreateOrUpdateResponse struct {
	// An Asset Filter.
	AssetFilter
}

// AssetFiltersClientDeleteResponse contains the response from method AssetFiltersClient.Delete.
type AssetFiltersClientDeleteResponse struct {
	// placeholder for future response values
}

// AssetFiltersClientGetResponse contains the response from method AssetFiltersClient.Get.
type AssetFiltersClientGetResponse struct {
	// An Asset Filter.
	AssetFilter
}

// AssetFiltersClientListResponse contains the response from method AssetFiltersClient.NewListPager.
type AssetFiltersClientListResponse struct {
	// A collection of AssetFilter items.
	AssetFilterCollection
}

// AssetFiltersClientUpdateResponse contains the response from method AssetFiltersClient.Update.
type AssetFiltersClientUpdateResponse struct {
	// An Asset Filter.
	AssetFilter
}

// AssetTrackOperationResultsClientGetResponse contains the response from method AssetTrackOperationResultsClient.Get.
type AssetTrackOperationResultsClientGetResponse struct {
	// An Asset Track resource.
	AssetTrack

	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// AssetTrackOperationStatusesClientGetResponse contains the response from method AssetTrackOperationStatusesClient.Get.
type AssetTrackOperationStatusesClientGetResponse struct {
	// Status of asset track operation.
	AssetTrackOperationStatus
}

// AssetsClientCreateOrUpdateResponse contains the response from method AssetsClient.CreateOrUpdate.
type AssetsClientCreateOrUpdateResponse struct {
	// An Asset.
	Asset
}

// AssetsClientDeleteResponse contains the response from method AssetsClient.Delete.
type AssetsClientDeleteResponse struct {
	// placeholder for future response values
}

// AssetsClientGetEncryptionKeyResponse contains the response from method AssetsClient.GetEncryptionKey.
type AssetsClientGetEncryptionKeyResponse struct {
	// Data needed to decrypt asset files encrypted with legacy storage encryption.
	StorageEncryptedAssetDecryptionData
}

// AssetsClientGetResponse contains the response from method AssetsClient.Get.
type AssetsClientGetResponse struct {
	// An Asset.
	Asset
}

// AssetsClientListContainerSasResponse contains the response from method AssetsClient.ListContainerSas.
type AssetsClientListContainerSasResponse struct {
	// The Asset Storage container SAS URLs.
	AssetContainerSas
}

// AssetsClientListResponse contains the response from method AssetsClient.NewListPager.
type AssetsClientListResponse struct {
	// A collection of Asset items.
	AssetCollection
}

// AssetsClientListStreamingLocatorsResponse contains the response from method AssetsClient.ListStreamingLocators.
type AssetsClientListStreamingLocatorsResponse struct {
	// The Streaming Locators associated with this Asset.
	ListStreamingLocatorsResponse
}

// AssetsClientUpdateResponse contains the response from method AssetsClient.Update.
type AssetsClientUpdateResponse struct {
	// An Asset.
	Asset
}

// ClientCreateOrUpdateResponse contains the response from method Client.BeginCreateOrUpdate.
type ClientCreateOrUpdateResponse struct {
	// A Media Services account.
	MediaService
}

// ClientDeleteResponse contains the response from method Client.Delete.
type ClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	// A Media Services account.
	MediaService
}

// ClientListBySubscriptionResponse contains the response from method Client.NewListBySubscriptionPager.
type ClientListBySubscriptionResponse struct {
	// A collection of MediaService items.
	MediaServiceCollection
}

// ClientListEdgePoliciesResponse contains the response from method Client.ListEdgePolicies.
type ClientListEdgePoliciesResponse struct {
	EdgePolicies
}

// ClientListResponse contains the response from method Client.NewListPager.
type ClientListResponse struct {
	// A collection of MediaService items.
	MediaServiceCollection
}

// ClientSyncStorageKeysResponse contains the response from method Client.SyncStorageKeys.
type ClientSyncStorageKeysResponse struct {
	// placeholder for future response values
}

// ClientUpdateResponse contains the response from method Client.BeginUpdate.
type ClientUpdateResponse struct {
	// A Media Services account.
	MediaService
}

// ContentKeyPoliciesClientCreateOrUpdateResponse contains the response from method ContentKeyPoliciesClient.CreateOrUpdate.
type ContentKeyPoliciesClientCreateOrUpdateResponse struct {
	// A Content Key Policy resource.
	ContentKeyPolicy
}

// ContentKeyPoliciesClientDeleteResponse contains the response from method ContentKeyPoliciesClient.Delete.
type ContentKeyPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// ContentKeyPoliciesClientGetPolicyPropertiesWithSecretsResponse contains the response from method ContentKeyPoliciesClient.GetPolicyPropertiesWithSecrets.
type ContentKeyPoliciesClientGetPolicyPropertiesWithSecretsResponse struct {
	// The properties of the Content Key Policy.
	ContentKeyPolicyProperties
}

// ContentKeyPoliciesClientGetResponse contains the response from method ContentKeyPoliciesClient.Get.
type ContentKeyPoliciesClientGetResponse struct {
	// A Content Key Policy resource.
	ContentKeyPolicy
}

// ContentKeyPoliciesClientListResponse contains the response from method ContentKeyPoliciesClient.NewListPager.
type ContentKeyPoliciesClientListResponse struct {
	// A collection of ContentKeyPolicy items.
	ContentKeyPolicyCollection
}

// ContentKeyPoliciesClientUpdateResponse contains the response from method ContentKeyPoliciesClient.Update.
type ContentKeyPoliciesClientUpdateResponse struct {
	// A Content Key Policy resource.
	ContentKeyPolicy
}

// JobsClientCancelJobResponse contains the response from method JobsClient.CancelJob.
type JobsClientCancelJobResponse struct {
	// placeholder for future response values
}

// JobsClientCreateResponse contains the response from method JobsClient.Create.
type JobsClientCreateResponse struct {
	// A Job resource type. The progress and state can be obtained by polling a Job or subscribing to events using EventGrid.
	Job
}

// JobsClientDeleteResponse contains the response from method JobsClient.Delete.
type JobsClientDeleteResponse struct {
	// placeholder for future response values
}

// JobsClientGetResponse contains the response from method JobsClient.Get.
type JobsClientGetResponse struct {
	// A Job resource type. The progress and state can be obtained by polling a Job or subscribing to events using EventGrid.
	Job
}

// JobsClientListResponse contains the response from method JobsClient.NewListPager.
type JobsClientListResponse struct {
	// A collection of Job items.
	JobCollection
}

// JobsClientUpdateResponse contains the response from method JobsClient.Update.
type JobsClientUpdateResponse struct {
	// A Job resource type. The progress and state can be obtained by polling a Job or subscribing to events using EventGrid.
	Job
}

// LiveEventsClientAllocateResponse contains the response from method LiveEventsClient.BeginAllocate.
type LiveEventsClientAllocateResponse struct {
	// placeholder for future response values
}

// LiveEventsClientAsyncOperationResponse contains the response from method LiveEventsClient.AsyncOperation.
type LiveEventsClientAsyncOperationResponse struct {
	// The status of an async operation.
	AsyncOperationResult
}

// LiveEventsClientCreateResponse contains the response from method LiveEventsClient.BeginCreate.
type LiveEventsClientCreateResponse struct {
	// The live event.
	LiveEvent
}

// LiveEventsClientDeleteResponse contains the response from method LiveEventsClient.BeginDelete.
type LiveEventsClientDeleteResponse struct {
	// placeholder for future response values
}

// LiveEventsClientGetResponse contains the response from method LiveEventsClient.Get.
type LiveEventsClientGetResponse struct {
	// The live event.
	LiveEvent
}

// LiveEventsClientListResponse contains the response from method LiveEventsClient.NewListPager.
type LiveEventsClientListResponse struct {
	// The LiveEvent list result.
	LiveEventListResult
}

// LiveEventsClientOperationLocationResponse contains the response from method LiveEventsClient.OperationLocation.
type LiveEventsClientOperationLocationResponse struct {
	// The live event.
	LiveEvent
}

// LiveEventsClientResetResponse contains the response from method LiveEventsClient.BeginReset.
type LiveEventsClientResetResponse struct {
	// placeholder for future response values
}

// LiveEventsClientStartResponse contains the response from method LiveEventsClient.BeginStart.
type LiveEventsClientStartResponse struct {
	// placeholder for future response values
}

// LiveEventsClientStopResponse contains the response from method LiveEventsClient.BeginStop.
type LiveEventsClientStopResponse struct {
	// placeholder for future response values
}

// LiveEventsClientUpdateResponse contains the response from method LiveEventsClient.BeginUpdate.
type LiveEventsClientUpdateResponse struct {
	// The live event.
	LiveEvent
}

// LiveOutputsClientAsyncOperationResponse contains the response from method LiveOutputsClient.AsyncOperation.
type LiveOutputsClientAsyncOperationResponse struct {
	// The status of an async operation.
	AsyncOperationResult
}

// LiveOutputsClientCreateResponse contains the response from method LiveOutputsClient.BeginCreate.
type LiveOutputsClientCreateResponse struct {
	// The Live Output.
	LiveOutput
}

// LiveOutputsClientDeleteResponse contains the response from method LiveOutputsClient.BeginDelete.
type LiveOutputsClientDeleteResponse struct {
	// placeholder for future response values
}

// LiveOutputsClientGetResponse contains the response from method LiveOutputsClient.Get.
type LiveOutputsClientGetResponse struct {
	// The Live Output.
	LiveOutput
}

// LiveOutputsClientListResponse contains the response from method LiveOutputsClient.NewListPager.
type LiveOutputsClientListResponse struct {
	// The LiveOutput list result.
	LiveOutputListResult
}

// LiveOutputsClientOperationLocationResponse contains the response from method LiveOutputsClient.OperationLocation.
type LiveOutputsClientOperationLocationResponse struct {
	// The Live Output.
	LiveOutput
}

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	// The response from the check name availability request.
	EntityNameAvailabilityCheckOutput
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.Get.
type OperationResultsClientGetResponse struct {
	// A Media Services account.
	MediaService

	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// OperationStatusesClientGetResponse contains the response from method OperationStatusesClient.Get.
type OperationStatusesClientGetResponse struct {
	// Status of media service operation.
	MediaServiceOperationStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	// A collection of Operation items.
	OperationCollection
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A private link resource
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// StreamingEndpointsClientAsyncOperationResponse contains the response from method StreamingEndpointsClient.AsyncOperation.
type StreamingEndpointsClientAsyncOperationResponse struct {
	// The status of an async operation.
	AsyncOperationResult
}

// StreamingEndpointsClientCreateResponse contains the response from method StreamingEndpointsClient.BeginCreate.
type StreamingEndpointsClientCreateResponse struct {
	// The streaming endpoint.
	StreamingEndpoint
}

// StreamingEndpointsClientDeleteResponse contains the response from method StreamingEndpointsClient.BeginDelete.
type StreamingEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientGetResponse contains the response from method StreamingEndpointsClient.Get.
type StreamingEndpointsClientGetResponse struct {
	// The streaming endpoint.
	StreamingEndpoint
}

// StreamingEndpointsClientListResponse contains the response from method StreamingEndpointsClient.NewListPager.
type StreamingEndpointsClientListResponse struct {
	// The streaming endpoint list result.
	StreamingEndpointListResult
}

// StreamingEndpointsClientOperationLocationResponse contains the response from method StreamingEndpointsClient.OperationLocation.
type StreamingEndpointsClientOperationLocationResponse struct {
	// The streaming endpoint.
	StreamingEndpoint
}

// StreamingEndpointsClientSKUsResponse contains the response from method StreamingEndpointsClient.SKUs.
type StreamingEndpointsClientSKUsResponse struct {
	StreamingEndpointSKUInfoListResult
}

// StreamingEndpointsClientScaleResponse contains the response from method StreamingEndpointsClient.BeginScale.
type StreamingEndpointsClientScaleResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientStartResponse contains the response from method StreamingEndpointsClient.BeginStart.
type StreamingEndpointsClientStartResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientStopResponse contains the response from method StreamingEndpointsClient.BeginStop.
type StreamingEndpointsClientStopResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientUpdateResponse contains the response from method StreamingEndpointsClient.BeginUpdate.
type StreamingEndpointsClientUpdateResponse struct {
	// The streaming endpoint.
	StreamingEndpoint
}

// StreamingLocatorsClientCreateResponse contains the response from method StreamingLocatorsClient.Create.
type StreamingLocatorsClientCreateResponse struct {
	// A Streaming Locator resource
	StreamingLocator
}

// StreamingLocatorsClientDeleteResponse contains the response from method StreamingLocatorsClient.Delete.
type StreamingLocatorsClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingLocatorsClientGetResponse contains the response from method StreamingLocatorsClient.Get.
type StreamingLocatorsClientGetResponse struct {
	// A Streaming Locator resource
	StreamingLocator
}

// StreamingLocatorsClientListContentKeysResponse contains the response from method StreamingLocatorsClient.ListContentKeys.
type StreamingLocatorsClientListContentKeysResponse struct {
	// Class of response for listContentKeys action
	ListContentKeysResponse
}

// StreamingLocatorsClientListPathsResponse contains the response from method StreamingLocatorsClient.ListPaths.
type StreamingLocatorsClientListPathsResponse struct {
	// Class of response for listPaths action
	ListPathsResponse
}

// StreamingLocatorsClientListResponse contains the response from method StreamingLocatorsClient.NewListPager.
type StreamingLocatorsClientListResponse struct {
	// A collection of StreamingLocator items.
	StreamingLocatorCollection
}

// StreamingPoliciesClientCreateResponse contains the response from method StreamingPoliciesClient.Create.
type StreamingPoliciesClientCreateResponse struct {
	// A Streaming Policy resource
	StreamingPolicy
}

// StreamingPoliciesClientDeleteResponse contains the response from method StreamingPoliciesClient.Delete.
type StreamingPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingPoliciesClientGetResponse contains the response from method StreamingPoliciesClient.Get.
type StreamingPoliciesClientGetResponse struct {
	// A Streaming Policy resource
	StreamingPolicy
}

// StreamingPoliciesClientListResponse contains the response from method StreamingPoliciesClient.NewListPager.
type StreamingPoliciesClientListResponse struct {
	// A collection of StreamingPolicy items.
	StreamingPolicyCollection
}

// TracksClientCreateOrUpdateResponse contains the response from method TracksClient.BeginCreateOrUpdate.
type TracksClientCreateOrUpdateResponse struct {
	// An Asset Track resource.
	AssetTrack
}

// TracksClientDeleteResponse contains the response from method TracksClient.BeginDelete.
type TracksClientDeleteResponse struct {
	// placeholder for future response values
}

// TracksClientGetResponse contains the response from method TracksClient.Get.
type TracksClientGetResponse struct {
	// An Asset Track resource.
	AssetTrack
}

// TracksClientListResponse contains the response from method TracksClient.NewListPager.
type TracksClientListResponse struct {
	// A collection of AssetTrack items.
	AssetTrackCollection
}

// TracksClientUpdateResponse contains the response from method TracksClient.BeginUpdate.
type TracksClientUpdateResponse struct {
	// An Asset Track resource.
	AssetTrack
}

// TracksClientUpdateTrackDataResponse contains the response from method TracksClient.BeginUpdateTrackData.
type TracksClientUpdateTrackDataResponse struct {
	// placeholder for future response values
}

// TransformsClientCreateOrUpdateResponse contains the response from method TransformsClient.CreateOrUpdate.
type TransformsClientCreateOrUpdateResponse struct {
	// A Transform encapsulates the rules or instructions for generating desired outputs from input media, such as by transcoding
	// or by extracting insights. After the Transform is created, it can be applied to input media by creating Jobs.
	Transform
}

// TransformsClientDeleteResponse contains the response from method TransformsClient.Delete.
type TransformsClientDeleteResponse struct {
	// placeholder for future response values
}

// TransformsClientGetResponse contains the response from method TransformsClient.Get.
type TransformsClientGetResponse struct {
	// A Transform encapsulates the rules or instructions for generating desired outputs from input media, such as by transcoding
	// or by extracting insights. After the Transform is created, it can be applied to input media by creating Jobs.
	Transform
}

// TransformsClientListResponse contains the response from method TransformsClient.NewListPager.
type TransformsClientListResponse struct {
	// A collection of Transform items.
	TransformCollection
}

// TransformsClientUpdateResponse contains the response from method TransformsClient.Update.
type TransformsClientUpdateResponse struct {
	// A Transform encapsulates the rules or instructions for generating desired outputs from input media, such as by transcoding
	// or by extracting insights. After the Transform is created, it can be applied to input media by creating Jobs.
	Transform
}
