//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armnetwork_test

import (
	"context"
	"log"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/network/armnetwork/v6"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/ab04533261eff228f28e08900445d0edef3eb70c/specification/network/resource-manager/Microsoft.Network/stable/2024-05-01/examples/ReachabilityAnalysisRunList.json
func ExampleReachabilityAnalysisRunsClient_NewListPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armnetwork.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewReachabilityAnalysisRunsClient().NewListPager("rg1", "testNetworkManager", "testVerifierWorkspace1", &armnetwork.ReachabilityAnalysisRunsClientListOptions{SkipToken: nil,
		Skip:      nil,
		Top:       nil,
		SortKey:   nil,
		SortValue: nil,
	})
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.ReachabilityAnalysisRunListResult = armnetwork.ReachabilityAnalysisRunListResult{
		// 	Value: []*armnetwork.ReachabilityAnalysisRun{
		// 		{
		// 			Name: to.Ptr("testReachabilityAnalysisRun1"),
		// 			Type: to.Ptr("Microsoft.Network/networkManagers/verifierWorkspaces/reachabilityAnalysisRuns"),
		// 			ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testVerifierWorkspace1/reachabilityAnalysisRuns/testReachabilityAnalysisRun1"),
		// 			SystemData: &armnetwork.SystemData{
		// 				CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
		// 				CreatedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
		// 				CreatedByType: to.Ptr(armnetwork.CreatedByTypeUser),
		// 				LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
		// 				LastModifiedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
		// 				LastModifiedByType: to.Ptr(armnetwork.CreatedByTypeUser),
		// 			},
		// 			Properties: &armnetwork.ReachabilityAnalysisRunProperties{
		// 				Description: to.Ptr("A sample  reachability analysis intent"),
		// 				IntentContent: &armnetwork.IntentContent{
		// 					DestinationResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmDest"),
		// 					IPTraffic: &armnetwork.IPTraffic{
		// 						DestinationIPs: []*string{
		// 							to.Ptr("10.4.0.1")},
		// 							DestinationPorts: []*string{
		// 								to.Ptr("0")},
		// 								Protocols: []*armnetwork.NetworkProtocol{
		// 									to.Ptr(armnetwork.NetworkProtocolAny)},
		// 									SourceIPs: []*string{
		// 										to.Ptr("10.4.0.0")},
		// 										SourcePorts: []*string{
		// 											to.Ptr("0")},
		// 										},
		// 										SourceResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmSrc"),
		// 									},
		// 									IntentID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testVerifierWorkspace1/reachabilityAnalysisIntents/testReachabilityAnalysisIntenant1"),
		// 									ProvisioningState: to.Ptr(armnetwork.ProvisioningStateSucceeded),
		// 								},
		// 						}},
		// 					}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/ab04533261eff228f28e08900445d0edef3eb70c/specification/network/resource-manager/Microsoft.Network/stable/2024-05-01/examples/ReachabilityAnalysisRunGet.json
func ExampleReachabilityAnalysisRunsClient_Get() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armnetwork.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewReachabilityAnalysisRunsClient().Get(ctx, "rg1", "testNetworkManager", "testWorkspace", "testAnalysisRunName", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.ReachabilityAnalysisRun = armnetwork.ReachabilityAnalysisRun{
	// 	Name: to.Ptr("testAnalysisRunName"),
	// 	Type: to.Ptr("Microsoft.Network/networkManagers/verifierWorkspaces/reachabilityAnalysisRuns"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testWorkspace/reachabilityAnalysisRuns/testAnalysisRunName"),
	// 	SystemData: &armnetwork.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
	// 		CreatedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
	// 		CreatedByType: to.Ptr(armnetwork.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
	// 		LastModifiedByType: to.Ptr(armnetwork.CreatedByTypeUser),
	// 	},
	// 	Properties: &armnetwork.ReachabilityAnalysisRunProperties{
	// 		Description: to.Ptr("A sample  reachability analysis intent"),
	// 		AnalysisResult: to.Ptr("{\"resultOutcome\":\"NoPacketsReached\",\"unreachedTrace\":\"[{\\\"name\\\":\\\"testVmSrc\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmSrc\\\",\\\"resourceType\\\":\\\"Microsoft.Compute/virtualMachines\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet has source IP address matching one of the network interface IPs.\\\",\\\"explanationCode\\\":\\\"MATCHED_NETWORK_INTERFACE_IP_SOURCE\\\",\\\"matchedNetworkInterfaceAddress\\\":{\\\"networkInterface\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkInterfaces/testNetworkInterface\\\",\\\"ipAddress\\\":\\\"10.5.0.4\\\"}}},{\\\"name\\\":\\\"testNetworkInterface\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkInterfaces/testNetworkInterface\\\",\\\"resourceType\\\":\\\"Microsoft.Network/networkInterfaces\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet has source IP address matching one of the network interface IPs.\\\",\\\"explanationCode\\\":\\\"MATCHED_NETWORK_INTERFACE_IP_SOURCE\\\",\\\"matchedNetworkInterfaceAddress\\\":{\\\"networkInterface\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkInterfaces/testNetworkInterface\\\",\\\"ipAddress\\\":\\\"10.5.0.4\\\"}}},{\\\"name\\\":\\\"testNetworkManager\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager\\\",\\\"resourceType\\\":\\\"Microsoft.Network/networkManagers\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet matched an admin security rule.\\\",\\\"explanationCode\\\":\\\"MATCHED_ADMIN_SECURITY_RULE\\\",\\\"matchedSecurityRule\\\":{\\\"name\\\":\\\"AllowAllOutbound\\\",\\\"action\\\":\\\"Allow\\\",\\\"destinationAddress\\\":\\\"*\\\",\\\"sourceAddress\\\":\\\"*\\\",\\\"destinationPort\\\":\\\"1-65535\\\",\\\"sourcePort\\\":\\\"1-65535\\\",\\\"protocol\\\":\\\"Any\\\"}}},{\\\"name\\\":\\\"testnsg\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkSecurityGroups/nsg-eus2\\\",\\\"resourceType\\\":\\\"Microsoft.Network/networkSecurityGroups\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet matched a network security rule.\\\",\\\"explanationCode\\\":\\\"MATCHED_NETWORK_SECURITY_RULE\\\",\\\"matchedSecurityRule\\\":{\\\"name\\\":\\\"defaultSecurityRules/AllowVnetOutBound\\\",\\\"action\\\":\\\"allow\\\",\\\"destinationAddress\\\":\\\"VirtualNetwork\\\",\\\"sourceAddress\\\":\\\"VirtualNetwork\\\",\\\"destinationPort\\\":\\\"0-65535\\\",\\\"sourcePort\\\":\\\"0-65535\\\",\\\"protocol\\\":\\\"All\\\"}}},{\\\"name\\\":\\\"default\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/testvnet/subnets/default\\\",\\\"resourceType\\\":\\\"Microsoft.Network/virtualNetworks/subnets\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet matched a system route.\\\",\\\"explanationCode\\\":\\\"MATCHED_SYSTEM_ROUTE\\\",\\\"matchedSubnetRoute\\\":{\\\"source\\\":\\\"Default\\\",\\\"addressPrefix\\\":\\\"10.1.0.0/16\\\",\\\"nextHopIpAddress\\\":[],\\\"nextHopType\\\":\\\"ConnectedGroup\\\"}}},{\\\"name\\\":\\\"testvnet1\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/testvnet1\\\",\\\"resourceType\\\":\\\"Microsoft.Network/virtualNetworks\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"0\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\",\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet destination IP is destined to subnet prefix.\\\",\\\"explanationCode\\\":\\\"MATCHED_SUBNET_PREFIX\\\",\\\"matchedSubnetPrefix\\\":{\\\"subnet\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/testvnet-1/subnets/default\\\",\\\"subnetPrefix\\\":\\\"10.1.0.0/24\\\"}}},{\\\"name\\\":\\\"default\\\",\\\"resourceId\\\":\\\"/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/testvnet1/subnets/default\\\",\\\"resourceType\\\":\\\"Microsoft.Network/virtualNetworks/subnets\\\",\\\"packet\\\":{\\\"destinationAddress\\\":\\\"10.1.0.4\\\",\\\"destinationPort\\\":\\\"443\\\",\\\"sourceAddress\\\":\\\"10.5.0.4\\\",\\\"sourcePort\\\":\\\"0\\\"\\\"protocol\\\":\\\"TCP\\\"},\\\"explanation\\\":{\\\"description\\\":\\\"Packet denied due to VM not currently running.\\\",\\\"explanationCode\\\":\\\"VM_TURNED_OFF\\\"}}]\"}"),
	// 		ErrorMessage: to.Ptr(""),
	// 		IntentContent: &armnetwork.IntentContent{
	// 			DestinationResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmDest"),
	// 			IPTraffic: &armnetwork.IPTraffic{
	// 				DestinationIPs: []*string{
	// 					to.Ptr("10.4.0.1")},
	// 					DestinationPorts: []*string{
	// 						to.Ptr("0")},
	// 						Protocols: []*armnetwork.NetworkProtocol{
	// 							to.Ptr(armnetwork.NetworkProtocolAny)},
	// 							SourceIPs: []*string{
	// 								to.Ptr("10.4.0.0")},
	// 								SourcePorts: []*string{
	// 									to.Ptr("0")},
	// 								},
	// 								SourceResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmSrc"),
	// 							},
	// 							IntentID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testVerifierWorkspace1/reachabilityAnalysisIntents/testReachabilityAnalysisIntenant1"),
	// 							ProvisioningState: to.Ptr(armnetwork.ProvisioningStateSucceeded),
	// 						},
	// 					}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/ab04533261eff228f28e08900445d0edef3eb70c/specification/network/resource-manager/Microsoft.Network/stable/2024-05-01/examples/ReachabilityAnalysisRunPut.json
func ExampleReachabilityAnalysisRunsClient_Create() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armnetwork.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewReachabilityAnalysisRunsClient().Create(ctx, "rg1", "testNetworkManager", "testWorkspace", "testAnalysisRunName", armnetwork.ReachabilityAnalysisRun{
		Properties: &armnetwork.ReachabilityAnalysisRunProperties{
			Description: to.Ptr("A sample reachability analysis run"),
			IntentID:    to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testVerifierWorkspace1/reachabilityAnalysisIntents/testReachabilityAnalysisIntenant1"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.ReachabilityAnalysisRun = armnetwork.ReachabilityAnalysisRun{
	// 	Name: to.Ptr("testAnalysisRunName"),
	// 	Type: to.Ptr("Microsoft.Network/networkManagers/verifierWorkspaces/reachabilityAnalysisRuns"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testWorkspace/reachabilityAnalysisRuns/testAnalysisRunName"),
	// 	SystemData: &armnetwork.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
	// 		CreatedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
	// 		CreatedByType: to.Ptr(armnetwork.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2021-01-11T18:52:27.000Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("b69a9388-9488-4534-b470-7ec6d41beef5"),
	// 		LastModifiedByType: to.Ptr(armnetwork.CreatedByTypeUser),
	// 	},
	// 	Properties: &armnetwork.ReachabilityAnalysisRunProperties{
	// 		Description: to.Ptr("A sample  reachability analysis intent"),
	// 		IntentContent: &armnetwork.IntentContent{
	// 			DestinationResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmDest"),
	// 			IPTraffic: &armnetwork.IPTraffic{
	// 				DestinationIPs: []*string{
	// 					to.Ptr("10.4.0.1")},
	// 					DestinationPorts: []*string{
	// 						to.Ptr("0")},
	// 						Protocols: []*armnetwork.NetworkProtocol{
	// 							to.Ptr(armnetwork.NetworkProtocolAny)},
	// 							SourceIPs: []*string{
	// 								to.Ptr("10.4.0.0")},
	// 								SourcePorts: []*string{
	// 									to.Ptr("0")},
	// 								},
	// 								SourceResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Compute/virtualMachines/testVmSrc"),
	// 							},
	// 							IntentID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/networkManagers/testNetworkManager/verifierWorkspaces/testVerifierWorkspace1/reachabilityAnalysisIntents/testReachabilityAnalysisIntenant1"),
	// 							ProvisioningState: to.Ptr(armnetwork.ProvisioningStateSucceeded),
	// 						},
	// 					}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/ab04533261eff228f28e08900445d0edef3eb70c/specification/network/resource-manager/Microsoft.Network/stable/2024-05-01/examples/ReachabilityAnalysisRunDelete.json
func ExampleReachabilityAnalysisRunsClient_BeginDelete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armnetwork.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewReachabilityAnalysisRunsClient().BeginDelete(ctx, "rg1", "testNetworkManager", "testWorkspace", "testAnalysisRun", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}
