//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armnetworkfunction

const (
	moduleName    = "github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/networkfunction/armnetworkfunction"
	moduleVersion = "v2.2.0"
)

type APIVersionParameter string

const (
	APIVersionParameterTwoThousandTwentyTwo0501 APIVersionParameter = "2022-05-01"
	APIVersionParameterTwoThousandTwentyTwo0801 APIVersionParameter = "2022-08-01"
	APIVersionParameterTwoThousandTwentyTwo1101 APIVersionParameter = "2022-11-01"
)

// PossibleAPIVersionParameterValues returns the possible values for the APIVersionParameter const type.
func PossibleAPIVersionParameterValues() []APIVersionParameter {
	return []APIVersionParameter{
		APIVersionParameterTwoThousandTwentyTwo0501,
		APIVersionParameterTwoThousandTwentyTwo0801,
		APIVersionParameterTwoThousandTwentyTwo1101,
	}
}

// CreatedByType - The type of identity that created the resource.
type CreatedByType string

const (
	CreatedByTypeApplication     CreatedByType = "Application"
	CreatedByTypeKey             CreatedByType = "Key"
	CreatedByTypeManagedIdentity CreatedByType = "ManagedIdentity"
	CreatedByTypeUser            CreatedByType = "User"
)

// PossibleCreatedByTypeValues returns the possible values for the CreatedByType const type.
func PossibleCreatedByTypeValues() []CreatedByType {
	return []CreatedByType{
		CreatedByTypeApplication,
		CreatedByTypeKey,
		CreatedByTypeManagedIdentity,
		CreatedByTypeUser,
	}
}

// DestinationType - Emission destination type.
type DestinationType string

const (
	DestinationTypeAzureMonitor DestinationType = "AzureMonitor"
)

// PossibleDestinationTypeValues returns the possible values for the DestinationType const type.
func PossibleDestinationTypeValues() []DestinationType {
	return []DestinationType{
		DestinationTypeAzureMonitor,
	}
}

// EmissionType - Emission format type.
type EmissionType string

const (
	EmissionTypeIPFIX EmissionType = "IPFIX"
)

// PossibleEmissionTypeValues returns the possible values for the EmissionType const type.
func PossibleEmissionTypeValues() []EmissionType {
	return []EmissionType{
		EmissionTypeIPFIX,
	}
}

// IngestionType - The ingestion type.
type IngestionType string

const (
	IngestionTypeIPFIX IngestionType = "IPFIX"
)

// PossibleIngestionTypeValues returns the possible values for the IngestionType const type.
func PossibleIngestionTypeValues() []IngestionType {
	return []IngestionType{
		IngestionTypeIPFIX,
	}
}

// ProvisioningState - The current provisioning state.
type ProvisioningState string

const (
	ProvisioningStateDeleting  ProvisioningState = "Deleting"
	ProvisioningStateFailed    ProvisioningState = "Failed"
	ProvisioningStateSucceeded ProvisioningState = "Succeeded"
	ProvisioningStateUpdating  ProvisioningState = "Updating"
)

// PossibleProvisioningStateValues returns the possible values for the ProvisioningState const type.
func PossibleProvisioningStateValues() []ProvisioningState {
	return []ProvisioningState{
		ProvisioningStateDeleting,
		ProvisioningStateFailed,
		ProvisioningStateSucceeded,
		ProvisioningStateUpdating,
	}
}

// SourceType - Ingestion source type.
type SourceType string

const (
	SourceTypeResource SourceType = "Resource"
)

// PossibleSourceTypeValues returns the possible values for the SourceType const type.
func PossibleSourceTypeValues() []SourceType {
	return []SourceType{
		SourceTypeResource,
	}
}
