//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/postgresql/armpostgresql"
	"net/http"
	"net/url"
	"regexp"
)

// LocationBasedPerformanceTierServer is a fake server for instances of the armpostgresql.LocationBasedPerformanceTierClient type.
type LocationBasedPerformanceTierServer struct {
	// NewListPager is the fake for method LocationBasedPerformanceTierClient.NewListPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListPager func(locationName string, options *armpostgresql.LocationBasedPerformanceTierClientListOptions) (resp azfake.PagerResponder[armpostgresql.LocationBasedPerformanceTierClientListResponse])
}

// NewLocationBasedPerformanceTierServerTransport creates a new instance of LocationBasedPerformanceTierServerTransport with the provided implementation.
// The returned LocationBasedPerformanceTierServerTransport instance is connected to an instance of armpostgresql.LocationBasedPerformanceTierClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewLocationBasedPerformanceTierServerTransport(srv *LocationBasedPerformanceTierServer) *LocationBasedPerformanceTierServerTransport {
	return &LocationBasedPerformanceTierServerTransport{
		srv:          srv,
		newListPager: newTracker[azfake.PagerResponder[armpostgresql.LocationBasedPerformanceTierClientListResponse]](),
	}
}

// LocationBasedPerformanceTierServerTransport connects instances of armpostgresql.LocationBasedPerformanceTierClient to instances of LocationBasedPerformanceTierServer.
// Don't use this type directly, use NewLocationBasedPerformanceTierServerTransport instead.
type LocationBasedPerformanceTierServerTransport struct {
	srv          *LocationBasedPerformanceTierServer
	newListPager *tracker[azfake.PagerResponder[armpostgresql.LocationBasedPerformanceTierClientListResponse]]
}

// Do implements the policy.Transporter interface for LocationBasedPerformanceTierServerTransport.
func (l *LocationBasedPerformanceTierServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "LocationBasedPerformanceTierClient.NewListPager":
		resp, err = l.dispatchNewListPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (l *LocationBasedPerformanceTierServerTransport) dispatchNewListPager(req *http.Request) (*http.Response, error) {
	if l.srv.NewListPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListPager not implemented")}
	}
	newListPager := l.newListPager.get(req)
	if newListPager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.DBforPostgreSQL/locations/(?P<locationName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/performanceTiers`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 2 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		locationNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("locationName")])
		if err != nil {
			return nil, err
		}
		resp := l.srv.NewListPager(locationNameParam, nil)
		newListPager = &resp
		l.newListPager.add(req, newListPager)
	}
	resp, err := server.PagerResponderNext(newListPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		l.newListPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListPager) {
		l.newListPager.remove(req)
	}
	return resp, nil
}
