//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/postgresql/armpostgresqlflexibleservers/v4"
	"net/http"
	"net/url"
	"regexp"
)

// PostgreSQLServerManagementServer is a fake server for instances of the armpostgresqlflexibleservers.PostgreSQLServerManagementClient type.
type PostgreSQLServerManagementServer struct {
	// CheckMigrationNameAvailability is the fake for method PostgreSQLServerManagementClient.CheckMigrationNameAvailability
	// HTTP status codes to indicate success: http.StatusOK
	CheckMigrationNameAvailability func(ctx context.Context, subscriptionID string, resourceGroupName string, targetDbServerName string, parameters armpostgresqlflexibleservers.MigrationNameAvailabilityResource, options *armpostgresqlflexibleservers.PostgreSQLServerManagementClientCheckMigrationNameAvailabilityOptions) (resp azfake.Responder[armpostgresqlflexibleservers.PostgreSQLServerManagementClientCheckMigrationNameAvailabilityResponse], errResp azfake.ErrorResponder)
}

// NewPostgreSQLServerManagementServerTransport creates a new instance of PostgreSQLServerManagementServerTransport with the provided implementation.
// The returned PostgreSQLServerManagementServerTransport instance is connected to an instance of armpostgresqlflexibleservers.PostgreSQLServerManagementClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewPostgreSQLServerManagementServerTransport(srv *PostgreSQLServerManagementServer) *PostgreSQLServerManagementServerTransport {
	return &PostgreSQLServerManagementServerTransport{srv: srv}
}

// PostgreSQLServerManagementServerTransport connects instances of armpostgresqlflexibleservers.PostgreSQLServerManagementClient to instances of PostgreSQLServerManagementServer.
// Don't use this type directly, use NewPostgreSQLServerManagementServerTransport instead.
type PostgreSQLServerManagementServerTransport struct {
	srv *PostgreSQLServerManagementServer
}

// Do implements the policy.Transporter interface for PostgreSQLServerManagementServerTransport.
func (p *PostgreSQLServerManagementServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "PostgreSQLServerManagementClient.CheckMigrationNameAvailability":
		resp, err = p.dispatchCheckMigrationNameAvailability(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (p *PostgreSQLServerManagementServerTransport) dispatchCheckMigrationNameAvailability(req *http.Request) (*http.Response, error) {
	if p.srv.CheckMigrationNameAvailability == nil {
		return nil, &nonRetriableError{errors.New("fake for method CheckMigrationNameAvailability not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.DBforPostgreSQL/flexibleServers/(?P<targetDbServerName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/checkMigrationNameAvailability`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 3 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	body, err := server.UnmarshalRequestAsJSON[armpostgresqlflexibleservers.MigrationNameAvailabilityResource](req)
	if err != nil {
		return nil, err
	}
	subscriptionIDParam, err := url.PathUnescape(matches[regex.SubexpIndex("subscriptionId")])
	if err != nil {
		return nil, err
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	targetDbServerNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("targetDbServerName")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := p.srv.CheckMigrationNameAvailability(req.Context(), subscriptionIDParam, resourceGroupNameParam, targetDbServerNameParam, body, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).MigrationNameAvailabilityResource, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
