//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armrecoveryservicessiterecovery

// MigrationRecoveryPointsClientGetResponse contains the response from method MigrationRecoveryPointsClient.Get.
type MigrationRecoveryPointsClientGetResponse struct {
	// Recovery point for a migration item.
	MigrationRecoveryPoint
}

// MigrationRecoveryPointsClientListByReplicationMigrationItemsResponse contains the response from method MigrationRecoveryPointsClient.NewListByReplicationMigrationItemsPager.
type MigrationRecoveryPointsClientListByReplicationMigrationItemsResponse struct {
	// Collection of migration recovery points.
	MigrationRecoveryPointCollection
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Collection of ClientDiscovery details.
	OperationsDiscoveryCollection
}

// RecoveryPointsClientGetResponse contains the response from method RecoveryPointsClient.Get.
type RecoveryPointsClientGetResponse struct {
	// Recovery point.
	RecoveryPoint
}

// RecoveryPointsClientListByReplicationProtectedItemsResponse contains the response from method RecoveryPointsClient.NewListByReplicationProtectedItemsPager.
type RecoveryPointsClientListByReplicationProtectedItemsResponse struct {
	// Collection of recovery point details.
	RecoveryPointCollection
}

// ReplicationAlertSettingsClientCreateResponse contains the response from method ReplicationAlertSettingsClient.Create.
type ReplicationAlertSettingsClientCreateResponse struct {
	// Implements the Alert class.
	Alert
}

// ReplicationAlertSettingsClientGetResponse contains the response from method ReplicationAlertSettingsClient.Get.
type ReplicationAlertSettingsClientGetResponse struct {
	// Implements the Alert class.
	Alert
}

// ReplicationAlertSettingsClientListResponse contains the response from method ReplicationAlertSettingsClient.NewListPager.
type ReplicationAlertSettingsClientListResponse struct {
	// Collection of alerts.
	AlertCollection
}

// ReplicationAppliancesClientListResponse contains the response from method ReplicationAppliancesClient.NewListPager.
type ReplicationAppliancesClientListResponse struct {
	// Collection of appliance details.
	ApplianceCollection
}

// ReplicationEligibilityResultsClientGetResponse contains the response from method ReplicationEligibilityResultsClient.Get.
type ReplicationEligibilityResultsClientGetResponse struct {
	// Replication eligibility results response model.
	ReplicationEligibilityResults
}

// ReplicationEligibilityResultsClientListResponse contains the response from method ReplicationEligibilityResultsClient.List.
type ReplicationEligibilityResultsClientListResponse struct {
	// Replication eligibility results collection response model.
	ReplicationEligibilityResultsCollection
}

// ReplicationEventsClientGetResponse contains the response from method ReplicationEventsClient.Get.
type ReplicationEventsClientGetResponse struct {
	// Implements the Event class.
	Event
}

// ReplicationEventsClientListResponse contains the response from method ReplicationEventsClient.NewListPager.
type ReplicationEventsClientListResponse struct {
	// Collection of fabric details.
	EventCollection
}

// ReplicationFabricsClientCheckConsistencyResponse contains the response from method ReplicationFabricsClient.BeginCheckConsistency.
type ReplicationFabricsClientCheckConsistencyResponse struct {
	// Fabric definition.
	Fabric
}

// ReplicationFabricsClientCreateResponse contains the response from method ReplicationFabricsClient.BeginCreate.
type ReplicationFabricsClientCreateResponse struct {
	// Fabric definition.
	Fabric
}

// ReplicationFabricsClientDeleteResponse contains the response from method ReplicationFabricsClient.BeginDelete.
type ReplicationFabricsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationFabricsClientGetResponse contains the response from method ReplicationFabricsClient.Get.
type ReplicationFabricsClientGetResponse struct {
	// Fabric definition.
	Fabric
}

// ReplicationFabricsClientListResponse contains the response from method ReplicationFabricsClient.NewListPager.
type ReplicationFabricsClientListResponse struct {
	// Collection of fabric details.
	FabricCollection
}

// ReplicationFabricsClientMigrateToAADResponse contains the response from method ReplicationFabricsClient.BeginMigrateToAAD.
type ReplicationFabricsClientMigrateToAADResponse struct {
	// placeholder for future response values
}

// ReplicationFabricsClientPurgeResponse contains the response from method ReplicationFabricsClient.BeginPurge.
type ReplicationFabricsClientPurgeResponse struct {
	// placeholder for future response values
}

// ReplicationFabricsClientReassociateGatewayResponse contains the response from method ReplicationFabricsClient.BeginReassociateGateway.
type ReplicationFabricsClientReassociateGatewayResponse struct {
	// Fabric definition.
	Fabric
}

// ReplicationFabricsClientRemoveInfraResponse contains the response from method ReplicationFabricsClient.BeginRemoveInfra.
type ReplicationFabricsClientRemoveInfraResponse struct {
	// placeholder for future response values
}

// ReplicationFabricsClientRenewCertificateResponse contains the response from method ReplicationFabricsClient.BeginRenewCertificate.
type ReplicationFabricsClientRenewCertificateResponse struct {
	// Fabric definition.
	Fabric
}

// ReplicationJobsClientCancelResponse contains the response from method ReplicationJobsClient.BeginCancel.
type ReplicationJobsClientCancelResponse struct {
	// Job details.
	Job
}

// ReplicationJobsClientExportResponse contains the response from method ReplicationJobsClient.BeginExport.
type ReplicationJobsClientExportResponse struct {
	// Job details.
	Job
}

// ReplicationJobsClientGetResponse contains the response from method ReplicationJobsClient.Get.
type ReplicationJobsClientGetResponse struct {
	// Job details.
	Job
}

// ReplicationJobsClientListResponse contains the response from method ReplicationJobsClient.NewListPager.
type ReplicationJobsClientListResponse struct {
	// Collection of jobs.
	JobCollection
}

// ReplicationJobsClientRestartResponse contains the response from method ReplicationJobsClient.BeginRestart.
type ReplicationJobsClientRestartResponse struct {
	// Job details.
	Job
}

// ReplicationJobsClientResumeResponse contains the response from method ReplicationJobsClient.BeginResume.
type ReplicationJobsClientResumeResponse struct {
	// Job details.
	Job
}

// ReplicationLogicalNetworksClientGetResponse contains the response from method ReplicationLogicalNetworksClient.Get.
type ReplicationLogicalNetworksClientGetResponse struct {
	// Logical network data model.
	LogicalNetwork
}

// ReplicationLogicalNetworksClientListByReplicationFabricsResponse contains the response from method ReplicationLogicalNetworksClient.NewListByReplicationFabricsPager.
type ReplicationLogicalNetworksClientListByReplicationFabricsResponse struct {
	// List of logical networks.
	LogicalNetworkCollection
}

// ReplicationMigrationItemsClientCreateResponse contains the response from method ReplicationMigrationItemsClient.BeginCreate.
type ReplicationMigrationItemsClientCreateResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientDeleteResponse contains the response from method ReplicationMigrationItemsClient.BeginDelete.
type ReplicationMigrationItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationMigrationItemsClientGetResponse contains the response from method ReplicationMigrationItemsClient.Get.
type ReplicationMigrationItemsClientGetResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientListByReplicationProtectionContainersResponse contains the response from method ReplicationMigrationItemsClient.NewListByReplicationProtectionContainersPager.
type ReplicationMigrationItemsClientListByReplicationProtectionContainersResponse struct {
	// Migration item collection.
	MigrationItemCollection
}

// ReplicationMigrationItemsClientListResponse contains the response from method ReplicationMigrationItemsClient.NewListPager.
type ReplicationMigrationItemsClientListResponse struct {
	// Migration item collection.
	MigrationItemCollection
}

// ReplicationMigrationItemsClientMigrateResponse contains the response from method ReplicationMigrationItemsClient.BeginMigrate.
type ReplicationMigrationItemsClientMigrateResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientPauseReplicationResponse contains the response from method ReplicationMigrationItemsClient.BeginPauseReplication.
type ReplicationMigrationItemsClientPauseReplicationResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientResumeReplicationResponse contains the response from method ReplicationMigrationItemsClient.BeginResumeReplication.
type ReplicationMigrationItemsClientResumeReplicationResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientResyncResponse contains the response from method ReplicationMigrationItemsClient.BeginResync.
type ReplicationMigrationItemsClientResyncResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientTestMigrateCleanupResponse contains the response from method ReplicationMigrationItemsClient.BeginTestMigrateCleanup.
type ReplicationMigrationItemsClientTestMigrateCleanupResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientTestMigrateResponse contains the response from method ReplicationMigrationItemsClient.BeginTestMigrate.
type ReplicationMigrationItemsClientTestMigrateResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationMigrationItemsClientUpdateResponse contains the response from method ReplicationMigrationItemsClient.BeginUpdate.
type ReplicationMigrationItemsClientUpdateResponse struct {
	// Migration item.
	MigrationItem
}

// ReplicationNetworkMappingsClientCreateResponse contains the response from method ReplicationNetworkMappingsClient.BeginCreate.
type ReplicationNetworkMappingsClientCreateResponse struct {
	// Network Mapping model. Ideally it should have been possible to inherit this class from prev version in InheritedModels
	// as long as there is no difference in structure or method signature. Since there were no base Models for certain fields
	// and methods viz NetworkMappingProperties and Load with required return type, the class has been introduced in its entirety
	// with references to base models to facilitate extensions in subsequent versions.
	NetworkMapping
}

// ReplicationNetworkMappingsClientDeleteResponse contains the response from method ReplicationNetworkMappingsClient.BeginDelete.
type ReplicationNetworkMappingsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationNetworkMappingsClientGetResponse contains the response from method ReplicationNetworkMappingsClient.Get.
type ReplicationNetworkMappingsClientGetResponse struct {
	// Network Mapping model. Ideally it should have been possible to inherit this class from prev version in InheritedModels
	// as long as there is no difference in structure or method signature. Since there were no base Models for certain fields
	// and methods viz NetworkMappingProperties and Load with required return type, the class has been introduced in its entirety
	// with references to base models to facilitate extensions in subsequent versions.
	NetworkMapping
}

// ReplicationNetworkMappingsClientListByReplicationNetworksResponse contains the response from method ReplicationNetworkMappingsClient.NewListByReplicationNetworksPager.
type ReplicationNetworkMappingsClientListByReplicationNetworksResponse struct {
	// List of network mappings. As with NetworkMapping, it should be possible to reuse a prev version of this class. It doesn't
	// seem likely this class could be anything more than a slightly bespoke collection of NetworkMapping. Hence it makes sense
	// to override Load with Base.NetworkMapping instead of existing CurrentVersion.NetworkMapping.
	NetworkMappingCollection
}

// ReplicationNetworkMappingsClientListResponse contains the response from method ReplicationNetworkMappingsClient.NewListPager.
type ReplicationNetworkMappingsClientListResponse struct {
	// List of network mappings. As with NetworkMapping, it should be possible to reuse a prev version of this class. It doesn't
	// seem likely this class could be anything more than a slightly bespoke collection of NetworkMapping. Hence it makes sense
	// to override Load with Base.NetworkMapping instead of existing CurrentVersion.NetworkMapping.
	NetworkMappingCollection
}

// ReplicationNetworkMappingsClientUpdateResponse contains the response from method ReplicationNetworkMappingsClient.BeginUpdate.
type ReplicationNetworkMappingsClientUpdateResponse struct {
	// Network Mapping model. Ideally it should have been possible to inherit this class from prev version in InheritedModels
	// as long as there is no difference in structure or method signature. Since there were no base Models for certain fields
	// and methods viz NetworkMappingProperties and Load with required return type, the class has been introduced in its entirety
	// with references to base models to facilitate extensions in subsequent versions.
	NetworkMapping
}

// ReplicationNetworksClientGetResponse contains the response from method ReplicationNetworksClient.Get.
type ReplicationNetworksClientGetResponse struct {
	// Network model.
	Network
}

// ReplicationNetworksClientListByReplicationFabricsResponse contains the response from method ReplicationNetworksClient.NewListByReplicationFabricsPager.
type ReplicationNetworksClientListByReplicationFabricsResponse struct {
	// List of networks.
	NetworkCollection
}

// ReplicationNetworksClientListResponse contains the response from method ReplicationNetworksClient.NewListPager.
type ReplicationNetworksClientListResponse struct {
	// List of networks.
	NetworkCollection
}

// ReplicationPoliciesClientCreateResponse contains the response from method ReplicationPoliciesClient.BeginCreate.
type ReplicationPoliciesClientCreateResponse struct {
	// Protection profile details.
	Policy
}

// ReplicationPoliciesClientDeleteResponse contains the response from method ReplicationPoliciesClient.BeginDelete.
type ReplicationPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationPoliciesClientGetResponse contains the response from method ReplicationPoliciesClient.Get.
type ReplicationPoliciesClientGetResponse struct {
	// Protection profile details.
	Policy
}

// ReplicationPoliciesClientListResponse contains the response from method ReplicationPoliciesClient.NewListPager.
type ReplicationPoliciesClientListResponse struct {
	// Protection Profile Collection details.
	PolicyCollection
}

// ReplicationPoliciesClientUpdateResponse contains the response from method ReplicationPoliciesClient.BeginUpdate.
type ReplicationPoliciesClientUpdateResponse struct {
	// Protection profile details.
	Policy
}

// ReplicationProtectableItemsClientGetResponse contains the response from method ReplicationProtectableItemsClient.Get.
type ReplicationProtectableItemsClientGetResponse struct {
	// Replication protected item.
	ProtectableItem
}

// ReplicationProtectableItemsClientListByReplicationProtectionContainersResponse contains the response from method ReplicationProtectableItemsClient.NewListByReplicationProtectionContainersPager.
type ReplicationProtectableItemsClientListByReplicationProtectionContainersResponse struct {
	// Protectable item collection.
	ProtectableItemCollection
}

// ReplicationProtectedItemsClientAddDisksResponse contains the response from method ReplicationProtectedItemsClient.BeginAddDisks.
type ReplicationProtectedItemsClientAddDisksResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientApplyRecoveryPointResponse contains the response from method ReplicationProtectedItemsClient.BeginApplyRecoveryPoint.
type ReplicationProtectedItemsClientApplyRecoveryPointResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientCreateResponse contains the response from method ReplicationProtectedItemsClient.BeginCreate.
type ReplicationProtectedItemsClientCreateResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientDeleteResponse contains the response from method ReplicationProtectedItemsClient.BeginDelete.
type ReplicationProtectedItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationProtectedItemsClientFailoverCancelResponse contains the response from method ReplicationProtectedItemsClient.BeginFailoverCancel.
type ReplicationProtectedItemsClientFailoverCancelResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientFailoverCommitResponse contains the response from method ReplicationProtectedItemsClient.BeginFailoverCommit.
type ReplicationProtectedItemsClientFailoverCommitResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientGetResponse contains the response from method ReplicationProtectedItemsClient.Get.
type ReplicationProtectedItemsClientGetResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientListByReplicationProtectionContainersResponse contains the response from method ReplicationProtectedItemsClient.NewListByReplicationProtectionContainersPager.
type ReplicationProtectedItemsClientListByReplicationProtectionContainersResponse struct {
	// Replication protected item collection.
	ReplicationProtectedItemCollection
}

// ReplicationProtectedItemsClientListResponse contains the response from method ReplicationProtectedItemsClient.NewListPager.
type ReplicationProtectedItemsClientListResponse struct {
	// Replication protected item collection.
	ReplicationProtectedItemCollection
}

// ReplicationProtectedItemsClientPlannedFailoverResponse contains the response from method ReplicationProtectedItemsClient.BeginPlannedFailover.
type ReplicationProtectedItemsClientPlannedFailoverResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientPurgeResponse contains the response from method ReplicationProtectedItemsClient.BeginPurge.
type ReplicationProtectedItemsClientPurgeResponse struct {
	// placeholder for future response values
}

// ReplicationProtectedItemsClientRemoveDisksResponse contains the response from method ReplicationProtectedItemsClient.BeginRemoveDisks.
type ReplicationProtectedItemsClientRemoveDisksResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientRepairReplicationResponse contains the response from method ReplicationProtectedItemsClient.BeginRepairReplication.
type ReplicationProtectedItemsClientRepairReplicationResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientReprotectResponse contains the response from method ReplicationProtectedItemsClient.BeginReprotect.
type ReplicationProtectedItemsClientReprotectResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientResolveHealthErrorsResponse contains the response from method ReplicationProtectedItemsClient.BeginResolveHealthErrors.
type ReplicationProtectedItemsClientResolveHealthErrorsResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientSwitchProviderResponse contains the response from method ReplicationProtectedItemsClient.BeginSwitchProvider.
type ReplicationProtectedItemsClientSwitchProviderResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientTestFailoverCleanupResponse contains the response from method ReplicationProtectedItemsClient.BeginTestFailoverCleanup.
type ReplicationProtectedItemsClientTestFailoverCleanupResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientTestFailoverResponse contains the response from method ReplicationProtectedItemsClient.BeginTestFailover.
type ReplicationProtectedItemsClientTestFailoverResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientUnplannedFailoverResponse contains the response from method ReplicationProtectedItemsClient.BeginUnplannedFailover.
type ReplicationProtectedItemsClientUnplannedFailoverResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientUpdateApplianceResponse contains the response from method ReplicationProtectedItemsClient.BeginUpdateAppliance.
type ReplicationProtectedItemsClientUpdateApplianceResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientUpdateMobilityServiceResponse contains the response from method ReplicationProtectedItemsClient.BeginUpdateMobilityService.
type ReplicationProtectedItemsClientUpdateMobilityServiceResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectedItemsClientUpdateResponse contains the response from method ReplicationProtectedItemsClient.BeginUpdate.
type ReplicationProtectedItemsClientUpdateResponse struct {
	// Replication protected item.
	ReplicationProtectedItem
}

// ReplicationProtectionContainerMappingsClientCreateResponse contains the response from method ReplicationProtectionContainerMappingsClient.BeginCreate.
type ReplicationProtectionContainerMappingsClientCreateResponse struct {
	// Protection container mapping object.
	ProtectionContainerMapping
}

// ReplicationProtectionContainerMappingsClientDeleteResponse contains the response from method ReplicationProtectionContainerMappingsClient.BeginDelete.
type ReplicationProtectionContainerMappingsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationProtectionContainerMappingsClientGetResponse contains the response from method ReplicationProtectionContainerMappingsClient.Get.
type ReplicationProtectionContainerMappingsClientGetResponse struct {
	// Protection container mapping object.
	ProtectionContainerMapping
}

// ReplicationProtectionContainerMappingsClientListByReplicationProtectionContainersResponse contains the response from method
// ReplicationProtectionContainerMappingsClient.NewListByReplicationProtectionContainersPager.
type ReplicationProtectionContainerMappingsClientListByReplicationProtectionContainersResponse struct {
	// Protection container mapping collection class.
	ProtectionContainerMappingCollection
}

// ReplicationProtectionContainerMappingsClientListResponse contains the response from method ReplicationProtectionContainerMappingsClient.NewListPager.
type ReplicationProtectionContainerMappingsClientListResponse struct {
	// Protection container mapping collection class.
	ProtectionContainerMappingCollection
}

// ReplicationProtectionContainerMappingsClientPurgeResponse contains the response from method ReplicationProtectionContainerMappingsClient.BeginPurge.
type ReplicationProtectionContainerMappingsClientPurgeResponse struct {
	// placeholder for future response values
}

// ReplicationProtectionContainerMappingsClientUpdateResponse contains the response from method ReplicationProtectionContainerMappingsClient.BeginUpdate.
type ReplicationProtectionContainerMappingsClientUpdateResponse struct {
	// Protection container mapping object.
	ProtectionContainerMapping
}

// ReplicationProtectionContainersClientCreateResponse contains the response from method ReplicationProtectionContainersClient.BeginCreate.
type ReplicationProtectionContainersClientCreateResponse struct {
	// Protection container details.
	ProtectionContainer
}

// ReplicationProtectionContainersClientDeleteResponse contains the response from method ReplicationProtectionContainersClient.BeginDelete.
type ReplicationProtectionContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationProtectionContainersClientDiscoverProtectableItemResponse contains the response from method ReplicationProtectionContainersClient.BeginDiscoverProtectableItem.
type ReplicationProtectionContainersClientDiscoverProtectableItemResponse struct {
	// Protection container details.
	ProtectionContainer
}

// ReplicationProtectionContainersClientGetResponse contains the response from method ReplicationProtectionContainersClient.Get.
type ReplicationProtectionContainersClientGetResponse struct {
	// Protection container details.
	ProtectionContainer
}

// ReplicationProtectionContainersClientListByReplicationFabricsResponse contains the response from method ReplicationProtectionContainersClient.NewListByReplicationFabricsPager.
type ReplicationProtectionContainersClientListByReplicationFabricsResponse struct {
	// Protection Container collection.
	ProtectionContainerCollection
}

// ReplicationProtectionContainersClientListResponse contains the response from method ReplicationProtectionContainersClient.NewListPager.
type ReplicationProtectionContainersClientListResponse struct {
	// Protection Container collection.
	ProtectionContainerCollection
}

// ReplicationProtectionContainersClientSwitchProtectionResponse contains the response from method ReplicationProtectionContainersClient.BeginSwitchProtection.
type ReplicationProtectionContainersClientSwitchProtectionResponse struct {
	// Protection container details.
	ProtectionContainer
}

// ReplicationProtectionIntentsClientCreateResponse contains the response from method ReplicationProtectionIntentsClient.Create.
type ReplicationProtectionIntentsClientCreateResponse struct {
	// Replication protection intent.
	ReplicationProtectionIntent
}

// ReplicationProtectionIntentsClientGetResponse contains the response from method ReplicationProtectionIntentsClient.Get.
type ReplicationProtectionIntentsClientGetResponse struct {
	// Replication protection intent.
	ReplicationProtectionIntent
}

// ReplicationProtectionIntentsClientListResponse contains the response from method ReplicationProtectionIntentsClient.NewListPager.
type ReplicationProtectionIntentsClientListResponse struct {
	// Replication protection intent objects collection.
	ReplicationProtectionIntentCollection
}

// ReplicationRecoveryPlansClientCreateResponse contains the response from method ReplicationRecoveryPlansClient.BeginCreate.
type ReplicationRecoveryPlansClientCreateResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientDeleteResponse contains the response from method ReplicationRecoveryPlansClient.BeginDelete.
type ReplicationRecoveryPlansClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationRecoveryPlansClientFailoverCancelResponse contains the response from method ReplicationRecoveryPlansClient.BeginFailoverCancel.
type ReplicationRecoveryPlansClientFailoverCancelResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientFailoverCommitResponse contains the response from method ReplicationRecoveryPlansClient.BeginFailoverCommit.
type ReplicationRecoveryPlansClientFailoverCommitResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientGetResponse contains the response from method ReplicationRecoveryPlansClient.Get.
type ReplicationRecoveryPlansClientGetResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientListResponse contains the response from method ReplicationRecoveryPlansClient.NewListPager.
type ReplicationRecoveryPlansClientListResponse struct {
	// Recovery plan collection details.
	RecoveryPlanCollection
}

// ReplicationRecoveryPlansClientPlannedFailoverResponse contains the response from method ReplicationRecoveryPlansClient.BeginPlannedFailover.
type ReplicationRecoveryPlansClientPlannedFailoverResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientReprotectResponse contains the response from method ReplicationRecoveryPlansClient.BeginReprotect.
type ReplicationRecoveryPlansClientReprotectResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientTestFailoverCleanupResponse contains the response from method ReplicationRecoveryPlansClient.BeginTestFailoverCleanup.
type ReplicationRecoveryPlansClientTestFailoverCleanupResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientTestFailoverResponse contains the response from method ReplicationRecoveryPlansClient.BeginTestFailover.
type ReplicationRecoveryPlansClientTestFailoverResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientUnplannedFailoverResponse contains the response from method ReplicationRecoveryPlansClient.BeginUnplannedFailover.
type ReplicationRecoveryPlansClientUnplannedFailoverResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryPlansClientUpdateResponse contains the response from method ReplicationRecoveryPlansClient.BeginUpdate.
type ReplicationRecoveryPlansClientUpdateResponse struct {
	// Recovery plan details.
	RecoveryPlan
}

// ReplicationRecoveryServicesProvidersClientCreateResponse contains the response from method ReplicationRecoveryServicesProvidersClient.BeginCreate.
type ReplicationRecoveryServicesProvidersClientCreateResponse struct {
	// Provider details.
	RecoveryServicesProvider
}

// ReplicationRecoveryServicesProvidersClientDeleteResponse contains the response from method ReplicationRecoveryServicesProvidersClient.BeginDelete.
type ReplicationRecoveryServicesProvidersClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationRecoveryServicesProvidersClientGetResponse contains the response from method ReplicationRecoveryServicesProvidersClient.Get.
type ReplicationRecoveryServicesProvidersClientGetResponse struct {
	// Provider details.
	RecoveryServicesProvider
}

// ReplicationRecoveryServicesProvidersClientListByReplicationFabricsResponse contains the response from method ReplicationRecoveryServicesProvidersClient.NewListByReplicationFabricsPager.
type ReplicationRecoveryServicesProvidersClientListByReplicationFabricsResponse struct {
	// Collection of providers.
	RecoveryServicesProviderCollection
}

// ReplicationRecoveryServicesProvidersClientListResponse contains the response from method ReplicationRecoveryServicesProvidersClient.NewListPager.
type ReplicationRecoveryServicesProvidersClientListResponse struct {
	// Collection of providers.
	RecoveryServicesProviderCollection
}

// ReplicationRecoveryServicesProvidersClientPurgeResponse contains the response from method ReplicationRecoveryServicesProvidersClient.BeginPurge.
type ReplicationRecoveryServicesProvidersClientPurgeResponse struct {
	// placeholder for future response values
}

// ReplicationRecoveryServicesProvidersClientRefreshProviderResponse contains the response from method ReplicationRecoveryServicesProvidersClient.BeginRefreshProvider.
type ReplicationRecoveryServicesProvidersClientRefreshProviderResponse struct {
	// Provider details.
	RecoveryServicesProvider
}

// ReplicationStorageClassificationMappingsClientCreateResponse contains the response from method ReplicationStorageClassificationMappingsClient.BeginCreate.
type ReplicationStorageClassificationMappingsClientCreateResponse struct {
	// Storage mapping object.
	StorageClassificationMapping
}

// ReplicationStorageClassificationMappingsClientDeleteResponse contains the response from method ReplicationStorageClassificationMappingsClient.BeginDelete.
type ReplicationStorageClassificationMappingsClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationStorageClassificationMappingsClientGetResponse contains the response from method ReplicationStorageClassificationMappingsClient.Get.
type ReplicationStorageClassificationMappingsClientGetResponse struct {
	// Storage mapping object.
	StorageClassificationMapping
}

// ReplicationStorageClassificationMappingsClientListByReplicationStorageClassificationsResponse contains the response from
// method ReplicationStorageClassificationMappingsClient.NewListByReplicationStorageClassificationsPager.
type ReplicationStorageClassificationMappingsClientListByReplicationStorageClassificationsResponse struct {
	// Collection of storage mapping details.
	StorageClassificationMappingCollection
}

// ReplicationStorageClassificationMappingsClientListResponse contains the response from method ReplicationStorageClassificationMappingsClient.NewListPager.
type ReplicationStorageClassificationMappingsClientListResponse struct {
	// Collection of storage mapping details.
	StorageClassificationMappingCollection
}

// ReplicationStorageClassificationsClientGetResponse contains the response from method ReplicationStorageClassificationsClient.Get.
type ReplicationStorageClassificationsClientGetResponse struct {
	// Storage object definition.
	StorageClassification
}

// ReplicationStorageClassificationsClientListByReplicationFabricsResponse contains the response from method ReplicationStorageClassificationsClient.NewListByReplicationFabricsPager.
type ReplicationStorageClassificationsClientListByReplicationFabricsResponse struct {
	// Collection of storage details.
	StorageClassificationCollection
}

// ReplicationStorageClassificationsClientListResponse contains the response from method ReplicationStorageClassificationsClient.NewListPager.
type ReplicationStorageClassificationsClientListResponse struct {
	// Collection of storage details.
	StorageClassificationCollection
}

// ReplicationVaultHealthClientGetResponse contains the response from method ReplicationVaultHealthClient.Get.
type ReplicationVaultHealthClientGetResponse struct {
	// Vault health details definition.
	VaultHealthDetails
}

// ReplicationVaultHealthClientRefreshResponse contains the response from method ReplicationVaultHealthClient.BeginRefresh.
type ReplicationVaultHealthClientRefreshResponse struct {
	// Vault health details definition.
	VaultHealthDetails
}

// ReplicationVaultSettingClientCreateResponse contains the response from method ReplicationVaultSettingClient.BeginCreate.
type ReplicationVaultSettingClientCreateResponse struct {
	// Vault setting.
	VaultSetting
}

// ReplicationVaultSettingClientGetResponse contains the response from method ReplicationVaultSettingClient.Get.
type ReplicationVaultSettingClientGetResponse struct {
	// Vault setting.
	VaultSetting
}

// ReplicationVaultSettingClientListResponse contains the response from method ReplicationVaultSettingClient.NewListPager.
type ReplicationVaultSettingClientListResponse struct {
	// Vault setting collection.
	VaultSettingCollection
}

// ReplicationvCentersClientCreateResponse contains the response from method ReplicationvCentersClient.BeginCreate.
type ReplicationvCentersClientCreateResponse struct {
	// vCenter definition.
	VCenter
}

// ReplicationvCentersClientDeleteResponse contains the response from method ReplicationvCentersClient.BeginDelete.
type ReplicationvCentersClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicationvCentersClientGetResponse contains the response from method ReplicationvCentersClient.Get.
type ReplicationvCentersClientGetResponse struct {
	// vCenter definition.
	VCenter
}

// ReplicationvCentersClientListByReplicationFabricsResponse contains the response from method ReplicationvCentersClient.NewListByReplicationFabricsPager.
type ReplicationvCentersClientListByReplicationFabricsResponse struct {
	// Collection of vCenter details.
	VCenterCollection
}

// ReplicationvCentersClientListResponse contains the response from method ReplicationvCentersClient.NewListPager.
type ReplicationvCentersClientListResponse struct {
	// Collection of vCenter details.
	VCenterCollection
}

// ReplicationvCentersClientUpdateResponse contains the response from method ReplicationvCentersClient.BeginUpdate.
type ReplicationvCentersClientUpdateResponse struct {
	// vCenter definition.
	VCenter
}

// SupportedOperatingSystemsClientGetResponse contains the response from method SupportedOperatingSystemsClient.Get.
type SupportedOperatingSystemsClientGetResponse struct {
	// Supported operating systems.
	SupportedOperatingSystems
}

// TargetComputeSizesClientListByReplicationProtectedItemsResponse contains the response from method TargetComputeSizesClient.NewListByReplicationProtectedItemsPager.
type TargetComputeSizesClientListByReplicationProtectedItemsResponse struct {
	// Target compute size collection.
	TargetComputeSizeCollection
}
