//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armredis

// AccessPolicyAssignmentClientCreateUpdateResponse contains the response from method AccessPolicyAssignmentClient.BeginCreateUpdate.
type AccessPolicyAssignmentClientCreateUpdateResponse struct {
	// Response to an operation on access policy assignment
	CacheAccessPolicyAssignment
}

// AccessPolicyAssignmentClientDeleteResponse contains the response from method AccessPolicyAssignmentClient.BeginDelete.
type AccessPolicyAssignmentClientDeleteResponse struct {
	// placeholder for future response values
}

// AccessPolicyAssignmentClientGetResponse contains the response from method AccessPolicyAssignmentClient.Get.
type AccessPolicyAssignmentClientGetResponse struct {
	// Response to an operation on access policy assignment
	CacheAccessPolicyAssignment
}

// AccessPolicyAssignmentClientListResponse contains the response from method AccessPolicyAssignmentClient.NewListPager.
type AccessPolicyAssignmentClientListResponse struct {
	// List of access policies assignments (with properties) of a Redis cache.
	CacheAccessPolicyAssignmentList
}

// AccessPolicyClientCreateUpdateResponse contains the response from method AccessPolicyClient.BeginCreateUpdate.
type AccessPolicyClientCreateUpdateResponse struct {
	// Response to get/put access policy.
	CacheAccessPolicy
}

// AccessPolicyClientDeleteResponse contains the response from method AccessPolicyClient.BeginDelete.
type AccessPolicyClientDeleteResponse struct {
	// placeholder for future response values
}

// AccessPolicyClientGetResponse contains the response from method AccessPolicyClient.Get.
type AccessPolicyClientGetResponse struct {
	// Response to get/put access policy.
	CacheAccessPolicy
}

// AccessPolicyClientListResponse contains the response from method AccessPolicyClient.NewListPager.
type AccessPolicyClientListResponse struct {
	// List of access policies (with properties) of a Redis cache.
	CacheAccessPolicyList
}

// AsyncOperationStatusClientGetResponse contains the response from method AsyncOperationStatusClient.Get.
type AsyncOperationStatusClientGetResponse struct {
	// Asynchronous operation status
	OperationStatus
}

// ClientCheckNameAvailabilityResponse contains the response from method Client.CheckNameAvailability.
type ClientCheckNameAvailabilityResponse struct {
	// placeholder for future response values
}

// ClientCreateResponse contains the response from method Client.BeginCreate.
type ClientCreateResponse struct {
	// A single Redis item in List or Get Operation.
	ResourceInfo
}

// ClientDeleteResponse contains the response from method Client.BeginDelete.
type ClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientExportDataResponse contains the response from method Client.BeginExportData.
type ClientExportDataResponse struct {
	// placeholder for future response values
}

// ClientFlushCacheResponse contains the response from method Client.BeginFlushCache.
type ClientFlushCacheResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClientForceRebootResponse contains the response from method Client.ForceReboot.
type ClientForceRebootResponse struct {
	// Response to force reboot for Redis cache.
	ForceRebootResponse
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	// A single Redis item in List or Get Operation.
	ResourceInfo
}

// ClientImportDataResponse contains the response from method Client.BeginImportData.
type ClientImportDataResponse struct {
	// placeholder for future response values
}

// ClientListByResourceGroupResponse contains the response from method Client.NewListByResourceGroupPager.
type ClientListByResourceGroupResponse struct {
	// The response of list Redis operation.
	ListResult
}

// ClientListBySubscriptionResponse contains the response from method Client.NewListBySubscriptionPager.
type ClientListBySubscriptionResponse struct {
	// The response of list Redis operation.
	ListResult
}

// ClientListKeysResponse contains the response from method Client.ListKeys.
type ClientListKeysResponse struct {
	// Redis cache access keys.
	AccessKeys
}

// ClientListUpgradeNotificationsResponse contains the response from method Client.NewListUpgradeNotificationsPager.
type ClientListUpgradeNotificationsResponse struct {
	// The response of listUpgradeNotifications.
	NotificationListResponse
}

// ClientRegenerateKeyResponse contains the response from method Client.RegenerateKey.
type ClientRegenerateKeyResponse struct {
	// Redis cache access keys.
	AccessKeys
}

// ClientUpdateResponse contains the response from method Client.BeginUpdate.
type ClientUpdateResponse struct {
	// A single Redis item in List or Get Operation.
	ResourceInfo
}

// FirewallRulesClientCreateOrUpdateResponse contains the response from method FirewallRulesClient.CreateOrUpdate.
type FirewallRulesClientCreateOrUpdateResponse struct {
	// A firewall rule on a redis cache has a name, and describes a contiguous range of IP addresses permitted to connect
	FirewallRule
}

// FirewallRulesClientDeleteResponse contains the response from method FirewallRulesClient.Delete.
type FirewallRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// FirewallRulesClientGetResponse contains the response from method FirewallRulesClient.Get.
type FirewallRulesClientGetResponse struct {
	// A firewall rule on a redis cache has a name, and describes a contiguous range of IP addresses permitted to connect
	FirewallRule
}

// FirewallRulesClientListResponse contains the response from method FirewallRulesClient.NewListPager.
type FirewallRulesClientListResponse struct {
	// The response of list firewall rules Redis operation.
	FirewallRuleListResult
}

// LinkedServerClientCreateResponse contains the response from method LinkedServerClient.BeginCreate.
type LinkedServerClientCreateResponse struct {
	// Response to put/get linked server (with properties) for Redis cache.
	LinkedServerWithProperties
}

// LinkedServerClientDeleteResponse contains the response from method LinkedServerClient.BeginDelete.
type LinkedServerClientDeleteResponse struct {
	// placeholder for future response values
}

// LinkedServerClientGetResponse contains the response from method LinkedServerClient.Get.
type LinkedServerClientGetResponse struct {
	// Response to put/get linked server (with properties) for Redis cache.
	LinkedServerWithProperties
}

// LinkedServerClientListResponse contains the response from method LinkedServerClient.NewListPager.
type LinkedServerClientListResponse struct {
	// List of linked servers (with properties) of a Redis cache.
	LinkedServerWithPropertiesList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list REST API operations. It contains a list of operations and a URL nextLink to get the next
	// set of results.
	OperationListResult
}

// PatchSchedulesClientCreateOrUpdateResponse contains the response from method PatchSchedulesClient.CreateOrUpdate.
type PatchSchedulesClientCreateOrUpdateResponse struct {
	// Response to put/get patch schedules for Redis cache.
	PatchSchedule
}

// PatchSchedulesClientDeleteResponse contains the response from method PatchSchedulesClient.Delete.
type PatchSchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// PatchSchedulesClientGetResponse contains the response from method PatchSchedulesClient.Get.
type PatchSchedulesClientGetResponse struct {
	// Response to put/get patch schedules for Redis cache.
	PatchSchedule
}

// PatchSchedulesClientListByRedisResourceResponse contains the response from method PatchSchedulesClient.NewListByRedisResourcePager.
type PatchSchedulesClientListByRedisResourceResponse struct {
	// The response of list patch schedules Redis operation.
	PatchScheduleListResult
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateEndpointConnectionsClientPutResponse contains the response from method PrivateEndpointConnectionsClient.BeginPut.
type PrivateEndpointConnectionsClientPutResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateLinkResourcesClientListByRedisCacheResponse contains the response from method PrivateLinkResourcesClient.NewListByRedisCachePager.
type PrivateLinkResourcesClientListByRedisCacheResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}
