//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armrelay

// HybridConnectionsClientCreateOrUpdateAuthorizationRuleResponse contains the response from method HybridConnectionsClient.CreateOrUpdateAuthorizationRule.
type HybridConnectionsClientCreateOrUpdateAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// HybridConnectionsClientCreateOrUpdateResponse contains the response from method HybridConnectionsClient.CreateOrUpdate.
type HybridConnectionsClientCreateOrUpdateResponse struct {
	// Description of hybrid connection resource.
	HybridConnection
}

// HybridConnectionsClientDeleteAuthorizationRuleResponse contains the response from method HybridConnectionsClient.DeleteAuthorizationRule.
type HybridConnectionsClientDeleteAuthorizationRuleResponse struct {
	// placeholder for future response values
}

// HybridConnectionsClientDeleteResponse contains the response from method HybridConnectionsClient.Delete.
type HybridConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// HybridConnectionsClientGetAuthorizationRuleResponse contains the response from method HybridConnectionsClient.GetAuthorizationRule.
type HybridConnectionsClientGetAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// HybridConnectionsClientGetResponse contains the response from method HybridConnectionsClient.Get.
type HybridConnectionsClientGetResponse struct {
	// Description of hybrid connection resource.
	HybridConnection
}

// HybridConnectionsClientListAuthorizationRulesResponse contains the response from method HybridConnectionsClient.NewListAuthorizationRulesPager.
type HybridConnectionsClientListAuthorizationRulesResponse struct {
	// The response from the list namespace operation.
	AuthorizationRuleListResult
}

// HybridConnectionsClientListByNamespaceResponse contains the response from method HybridConnectionsClient.NewListByNamespacePager.
type HybridConnectionsClientListByNamespaceResponse struct {
	// The response of the list hybrid connection operation.
	HybridConnectionListResult
}

// HybridConnectionsClientListKeysResponse contains the response from method HybridConnectionsClient.ListKeys.
type HybridConnectionsClientListKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}

// HybridConnectionsClientRegenerateKeysResponse contains the response from method HybridConnectionsClient.RegenerateKeys.
type HybridConnectionsClientRegenerateKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}

// NamespacesClientCheckNameAvailabilityResponse contains the response from method NamespacesClient.CheckNameAvailability.
type NamespacesClientCheckNameAvailabilityResponse struct {
	// Description of the check name availability request properties.
	CheckNameAvailabilityResult
}

// NamespacesClientCreateOrUpdateAuthorizationRuleResponse contains the response from method NamespacesClient.CreateOrUpdateAuthorizationRule.
type NamespacesClientCreateOrUpdateAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// NamespacesClientCreateOrUpdateNetworkRuleSetResponse contains the response from method NamespacesClient.CreateOrUpdateNetworkRuleSet.
type NamespacesClientCreateOrUpdateNetworkRuleSetResponse struct {
	// Description of topic resource.
	NetworkRuleSet
}

// NamespacesClientCreateOrUpdateResponse contains the response from method NamespacesClient.BeginCreateOrUpdate.
type NamespacesClientCreateOrUpdateResponse struct {
	// Description of a namespace resource.
	Namespace
}

// NamespacesClientDeleteAuthorizationRuleResponse contains the response from method NamespacesClient.DeleteAuthorizationRule.
type NamespacesClientDeleteAuthorizationRuleResponse struct {
	// placeholder for future response values
}

// NamespacesClientDeleteResponse contains the response from method NamespacesClient.BeginDelete.
type NamespacesClientDeleteResponse struct {
	// placeholder for future response values
}

// NamespacesClientGetAuthorizationRuleResponse contains the response from method NamespacesClient.GetAuthorizationRule.
type NamespacesClientGetAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// NamespacesClientGetNetworkRuleSetResponse contains the response from method NamespacesClient.GetNetworkRuleSet.
type NamespacesClientGetNetworkRuleSetResponse struct {
	// Description of topic resource.
	NetworkRuleSet
}

// NamespacesClientGetResponse contains the response from method NamespacesClient.Get.
type NamespacesClientGetResponse struct {
	// Description of a namespace resource.
	Namespace
}

// NamespacesClientListAuthorizationRulesResponse contains the response from method NamespacesClient.NewListAuthorizationRulesPager.
type NamespacesClientListAuthorizationRulesResponse struct {
	// The response from the list namespace operation.
	AuthorizationRuleListResult
}

// NamespacesClientListByResourceGroupResponse contains the response from method NamespacesClient.NewListByResourceGroupPager.
type NamespacesClientListByResourceGroupResponse struct {
	// The response from the list namespace operation.
	NamespaceListResult
}

// NamespacesClientListKeysResponse contains the response from method NamespacesClient.ListKeys.
type NamespacesClientListKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}

// NamespacesClientListResponse contains the response from method NamespacesClient.NewListPager.
type NamespacesClientListResponse struct {
	// The response from the list namespace operation.
	NamespaceListResult
}

// NamespacesClientRegenerateKeysResponse contains the response from method NamespacesClient.RegenerateKeys.
type NamespacesClientRegenerateKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}

// NamespacesClientUpdateResponse contains the response from method NamespacesClient.Update.
type NamespacesClientUpdateResponse struct {
	// Description of a namespace resource.
	Namespace
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list Relay operations. It contains a list of operations and a URL link to get the next set of
	// results.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// Properties of the PrivateEndpointConnection.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// Properties of the PrivateEndpointConnection.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// Result of the list of all private endpoint connections operation.
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// Information of the private link resource.
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	// Result of the List private link resources operation.
	PrivateLinkResourcesListResult
}

// WCFRelaysClientCreateOrUpdateAuthorizationRuleResponse contains the response from method WCFRelaysClient.CreateOrUpdateAuthorizationRule.
type WCFRelaysClientCreateOrUpdateAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// WCFRelaysClientCreateOrUpdateResponse contains the response from method WCFRelaysClient.CreateOrUpdate.
type WCFRelaysClientCreateOrUpdateResponse struct {
	// Description of the WCF relay resource.
	WcfRelay
}

// WCFRelaysClientDeleteAuthorizationRuleResponse contains the response from method WCFRelaysClient.DeleteAuthorizationRule.
type WCFRelaysClientDeleteAuthorizationRuleResponse struct {
	// placeholder for future response values
}

// WCFRelaysClientDeleteResponse contains the response from method WCFRelaysClient.Delete.
type WCFRelaysClientDeleteResponse struct {
	// placeholder for future response values
}

// WCFRelaysClientGetAuthorizationRuleResponse contains the response from method WCFRelaysClient.GetAuthorizationRule.
type WCFRelaysClientGetAuthorizationRuleResponse struct {
	// Single item in a List or Get AuthorizationRule operation
	AuthorizationRule
}

// WCFRelaysClientGetResponse contains the response from method WCFRelaysClient.Get.
type WCFRelaysClientGetResponse struct {
	// Description of the WCF relay resource.
	WcfRelay
}

// WCFRelaysClientListAuthorizationRulesResponse contains the response from method WCFRelaysClient.NewListAuthorizationRulesPager.
type WCFRelaysClientListAuthorizationRulesResponse struct {
	// The response from the list namespace operation.
	AuthorizationRuleListResult
}

// WCFRelaysClientListByNamespaceResponse contains the response from method WCFRelaysClient.NewListByNamespacePager.
type WCFRelaysClientListByNamespaceResponse struct {
	// The response of the list WCF relay operation.
	WcfRelaysListResult
}

// WCFRelaysClientListKeysResponse contains the response from method WCFRelaysClient.ListKeys.
type WCFRelaysClientListKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}

// WCFRelaysClientRegenerateKeysResponse contains the response from method WCFRelaysClient.RegenerateKeys.
type WCFRelaysClientRegenerateKeysResponse struct {
	// Namespace/Relay Connection String
	AccessKeys
}
