//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armresourcemover

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	credential     azcore.TokenCredential
	options        *arm.ClientOptions
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The Subscription ID.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	_, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID, credential: credential,
		options: options.Clone(),
	}, nil
}

// NewMoveCollectionsClient creates a new instance of MoveCollectionsClient.
func (c *ClientFactory) NewMoveCollectionsClient() *MoveCollectionsClient {
	subClient, _ := NewMoveCollectionsClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

// NewMoveResourcesClient creates a new instance of MoveResourcesClient.
func (c *ClientFactory) NewMoveResourcesClient() *MoveResourcesClient {
	subClient, _ := NewMoveResourcesClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

// NewOperationsDiscoveryClient creates a new instance of OperationsDiscoveryClient.
func (c *ClientFactory) NewOperationsDiscoveryClient() *OperationsDiscoveryClient {
	subClient, _ := NewOperationsDiscoveryClient(c.credential, c.options)
	return subClient
}

// NewUnresolvedDependenciesClient creates a new instance of UnresolvedDependenciesClient.
func (c *ClientFactory) NewUnresolvedDependenciesClient() *UnresolvedDependenciesClient {
	subClient, _ := NewUnresolvedDependenciesClient(c.subscriptionID, c.credential, c.options)
	return subClient
}
