//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdeploymentstacks

// ClientBeginCreateOrUpdateAtManagementGroupOptions contains the optional parameters for the Client.BeginCreateOrUpdateAtManagementGroup
// method.
type ClientBeginCreateOrUpdateAtManagementGroupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientBeginCreateOrUpdateAtResourceGroupOptions contains the optional parameters for the Client.BeginCreateOrUpdateAtResourceGroup
// method.
type ClientBeginCreateOrUpdateAtResourceGroupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientBeginCreateOrUpdateAtSubscriptionOptions contains the optional parameters for the Client.BeginCreateOrUpdateAtSubscription
// method.
type ClientBeginCreateOrUpdateAtSubscriptionOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientBeginDeleteAtManagementGroupOptions contains the optional parameters for the Client.BeginDeleteAtManagementGroup
// method.
type ClientBeginDeleteAtManagementGroupOptions struct {
	// Flag to bypass service errors that indicate the stack resource list is not correctly synchronized.
	BypassStackOutOfSyncError *bool

	// Resumes the LRO from the provided token.
	ResumeToken string

	// Flag to indicate delete rather than detach for unmanaged management groups.
	UnmanageActionManagementGroups *UnmanageActionManagementGroupMode

	// Flag to indicate delete rather than detach for unmanaged resource groups.
	UnmanageActionResourceGroups *UnmanageActionResourceGroupMode

	// Flag to indicate delete rather than detach for unmanaged resources.
	UnmanageActionResources *UnmanageActionResourceMode
}

// ClientBeginDeleteAtResourceGroupOptions contains the optional parameters for the Client.BeginDeleteAtResourceGroup method.
type ClientBeginDeleteAtResourceGroupOptions struct {
	// Flag to bypass service errors that indicate the stack resource list is not correctly synchronized.
	BypassStackOutOfSyncError *bool

	// Resumes the LRO from the provided token.
	ResumeToken string

	// Flag to indicate delete rather than detach for unmanaged management groups.
	UnmanageActionManagementGroups *UnmanageActionManagementGroupMode

	// Flag to indicate delete rather than detach for unmanaged resource groups.
	UnmanageActionResourceGroups *UnmanageActionResourceGroupMode

	// Flag to indicate delete rather than detach for unmanaged resources.
	UnmanageActionResources *UnmanageActionResourceMode
}

// ClientBeginDeleteAtSubscriptionOptions contains the optional parameters for the Client.BeginDeleteAtSubscription method.
type ClientBeginDeleteAtSubscriptionOptions struct {
	// Flag to bypass service errors that indicate the stack resource list is not correctly synchronized.
	BypassStackOutOfSyncError *bool

	// Resumes the LRO from the provided token.
	ResumeToken string

	// Flag to indicate delete rather than detach for unmanaged management groups.
	UnmanageActionManagementGroups *UnmanageActionManagementGroupMode

	// Flag to indicate delete rather than detach for unmanaged resource groups.
	UnmanageActionResourceGroups *UnmanageActionResourceGroupMode

	// Flag to indicate delete rather than detach for unmanaged resources.
	UnmanageActionResources *UnmanageActionResourceMode
}

// ClientBeginValidateStackAtManagementGroupOptions contains the optional parameters for the Client.BeginValidateStackAtManagementGroup
// method.
type ClientBeginValidateStackAtManagementGroupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientBeginValidateStackAtResourceGroupOptions contains the optional parameters for the Client.BeginValidateStackAtResourceGroup
// method.
type ClientBeginValidateStackAtResourceGroupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientBeginValidateStackAtSubscriptionOptions contains the optional parameters for the Client.BeginValidateStackAtSubscription
// method.
type ClientBeginValidateStackAtSubscriptionOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ClientExportTemplateAtManagementGroupOptions contains the optional parameters for the Client.ExportTemplateAtManagementGroup
// method.
type ClientExportTemplateAtManagementGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientExportTemplateAtResourceGroupOptions contains the optional parameters for the Client.ExportTemplateAtResourceGroup
// method.
type ClientExportTemplateAtResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientExportTemplateAtSubscriptionOptions contains the optional parameters for the Client.ExportTemplateAtSubscription
// method.
type ClientExportTemplateAtSubscriptionOptions struct {
	// placeholder for future optional parameters
}

// ClientGetAtManagementGroupOptions contains the optional parameters for the Client.GetAtManagementGroup method.
type ClientGetAtManagementGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientGetAtResourceGroupOptions contains the optional parameters for the Client.GetAtResourceGroup method.
type ClientGetAtResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientGetAtSubscriptionOptions contains the optional parameters for the Client.GetAtSubscription method.
type ClientGetAtSubscriptionOptions struct {
	// placeholder for future optional parameters
}

// ClientListAtManagementGroupOptions contains the optional parameters for the Client.NewListAtManagementGroupPager method.
type ClientListAtManagementGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientListAtResourceGroupOptions contains the optional parameters for the Client.NewListAtResourceGroupPager method.
type ClientListAtResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ClientListAtSubscriptionOptions contains the optional parameters for the Client.NewListAtSubscriptionPager method.
type ClientListAtSubscriptionOptions struct {
	// placeholder for future optional parameters
}
