//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armscvmm

// AvailabilitySetsClientBeginCreateOrUpdateOptions contains the optional parameters for the AvailabilitySetsClient.BeginCreateOrUpdate
// method.
type AvailabilitySetsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AvailabilitySetsClientBeginDeleteOptions contains the optional parameters for the AvailabilitySetsClient.BeginDelete method.
type AvailabilitySetsClientBeginDeleteOptions struct {
	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AvailabilitySetsClientBeginUpdateOptions contains the optional parameters for the AvailabilitySetsClient.BeginUpdate method.
type AvailabilitySetsClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// AvailabilitySetsClientGetOptions contains the optional parameters for the AvailabilitySetsClient.Get method.
type AvailabilitySetsClientGetOptions struct {
	// placeholder for future optional parameters
}

// AvailabilitySetsClientListByResourceGroupOptions contains the optional parameters for the AvailabilitySetsClient.NewListByResourceGroupPager
// method.
type AvailabilitySetsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// AvailabilitySetsClientListBySubscriptionOptions contains the optional parameters for the AvailabilitySetsClient.NewListBySubscriptionPager
// method.
type AvailabilitySetsClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// CloudsClientBeginCreateOrUpdateOptions contains the optional parameters for the CloudsClient.BeginCreateOrUpdate method.
type CloudsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudsClientBeginDeleteOptions contains the optional parameters for the CloudsClient.BeginDelete method.
type CloudsClientBeginDeleteOptions struct {
	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudsClientBeginUpdateOptions contains the optional parameters for the CloudsClient.BeginUpdate method.
type CloudsClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudsClientGetOptions contains the optional parameters for the CloudsClient.Get method.
type CloudsClientGetOptions struct {
	// placeholder for future optional parameters
}

// CloudsClientListByResourceGroupOptions contains the optional parameters for the CloudsClient.NewListByResourceGroupPager
// method.
type CloudsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// CloudsClientListBySubscriptionOptions contains the optional parameters for the CloudsClient.NewListBySubscriptionPager
// method.
type CloudsClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// GuestAgentsClientBeginCreateOptions contains the optional parameters for the GuestAgentsClient.BeginCreate method.
type GuestAgentsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// GuestAgentsClientDeleteOptions contains the optional parameters for the GuestAgentsClient.Delete method.
type GuestAgentsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// GuestAgentsClientGetOptions contains the optional parameters for the GuestAgentsClient.Get method.
type GuestAgentsClientGetOptions struct {
	// placeholder for future optional parameters
}

// GuestAgentsClientListByVirtualMachineInstanceOptions contains the optional parameters for the GuestAgentsClient.NewListByVirtualMachineInstancePager
// method.
type GuestAgentsClientListByVirtualMachineInstanceOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientCreateOptions contains the optional parameters for the InventoryItemsClient.Create method.
type InventoryItemsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientDeleteOptions contains the optional parameters for the InventoryItemsClient.Delete method.
type InventoryItemsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientGetOptions contains the optional parameters for the InventoryItemsClient.Get method.
type InventoryItemsClientGetOptions struct {
	// placeholder for future optional parameters
}

// InventoryItemsClientListByVmmServerOptions contains the optional parameters for the InventoryItemsClient.NewListByVmmServerPager
// method.
type InventoryItemsClientListByVmmServerOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceHybridIdentityMetadatasClientGetOptions contains the optional parameters for the VMInstanceHybridIdentityMetadatasClient.Get
// method.
type VMInstanceHybridIdentityMetadatasClientGetOptions struct {
	// placeholder for future optional parameters
}

// VMInstanceHybridIdentityMetadatasClientListByVirtualMachineInstanceOptions contains the optional parameters for the VMInstanceHybridIdentityMetadatasClient.NewListByVirtualMachineInstancePager
// method.
type VMInstanceHybridIdentityMetadatasClientListByVirtualMachineInstanceOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineInstancesClientBeginCreateCheckpointOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginCreateCheckpoint
// method.
type VirtualMachineInstancesClientBeginCreateCheckpointOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginCreateOrUpdateOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginCreateOrUpdate
// method.
type VirtualMachineInstancesClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginDeleteCheckpointOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginDeleteCheckpoint
// method.
type VirtualMachineInstancesClientBeginDeleteCheckpointOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginDeleteOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginDelete
// method.
type VirtualMachineInstancesClientBeginDeleteOptions struct {
	// Whether to disable the VM from azure and also delete it from Vmm.
	DeleteFromHost *DeleteFromHost

	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginRestartOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginRestart
// method.
type VirtualMachineInstancesClientBeginRestartOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginRestoreCheckpointOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginRestoreCheckpoint
// method.
type VirtualMachineInstancesClientBeginRestoreCheckpointOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginStartOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginStart
// method.
type VirtualMachineInstancesClientBeginStartOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginStopOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginStop
// method.
type VirtualMachineInstancesClientBeginStopOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientBeginUpdateOptions contains the optional parameters for the VirtualMachineInstancesClient.BeginUpdate
// method.
type VirtualMachineInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineInstancesClientGetOptions contains the optional parameters for the VirtualMachineInstancesClient.Get method.
type VirtualMachineInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineInstancesClientListOptions contains the optional parameters for the VirtualMachineInstancesClient.NewListPager
// method.
type VirtualMachineInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientBeginCreateOrUpdateOptions contains the optional parameters for the VirtualMachineTemplatesClient.BeginCreateOrUpdate
// method.
type VirtualMachineTemplatesClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineTemplatesClientBeginDeleteOptions contains the optional parameters for the VirtualMachineTemplatesClient.BeginDelete
// method.
type VirtualMachineTemplatesClientBeginDeleteOptions struct {
	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineTemplatesClientBeginUpdateOptions contains the optional parameters for the VirtualMachineTemplatesClient.BeginUpdate
// method.
type VirtualMachineTemplatesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualMachineTemplatesClientGetOptions contains the optional parameters for the VirtualMachineTemplatesClient.Get method.
type VirtualMachineTemplatesClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientListByResourceGroupOptions contains the optional parameters for the VirtualMachineTemplatesClient.NewListByResourceGroupPager
// method.
type VirtualMachineTemplatesClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VirtualMachineTemplatesClientListBySubscriptionOptions contains the optional parameters for the VirtualMachineTemplatesClient.NewListBySubscriptionPager
// method.
type VirtualMachineTemplatesClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientBeginCreateOrUpdateOptions contains the optional parameters for the VirtualNetworksClient.BeginCreateOrUpdate
// method.
type VirtualNetworksClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualNetworksClientBeginDeleteOptions contains the optional parameters for the VirtualNetworksClient.BeginDelete method.
type VirtualNetworksClientBeginDeleteOptions struct {
	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualNetworksClientBeginUpdateOptions contains the optional parameters for the VirtualNetworksClient.BeginUpdate method.
type VirtualNetworksClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VirtualNetworksClientGetOptions contains the optional parameters for the VirtualNetworksClient.Get method.
type VirtualNetworksClientGetOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientListByResourceGroupOptions contains the optional parameters for the VirtualNetworksClient.NewListByResourceGroupPager
// method.
type VirtualNetworksClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VirtualNetworksClientListBySubscriptionOptions contains the optional parameters for the VirtualNetworksClient.NewListBySubscriptionPager
// method.
type VirtualNetworksClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// VmmServersClientBeginCreateOrUpdateOptions contains the optional parameters for the VmmServersClient.BeginCreateOrUpdate
// method.
type VmmServersClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VmmServersClientBeginDeleteOptions contains the optional parameters for the VmmServersClient.BeginDelete method.
type VmmServersClientBeginDeleteOptions struct {
	// Forces the resource to be deleted.
	Force *ForceDelete

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VmmServersClientBeginUpdateOptions contains the optional parameters for the VmmServersClient.BeginUpdate method.
type VmmServersClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VmmServersClientGetOptions contains the optional parameters for the VmmServersClient.Get method.
type VmmServersClientGetOptions struct {
	// placeholder for future optional parameters
}

// VmmServersClientListByResourceGroupOptions contains the optional parameters for the VmmServersClient.NewListByResourceGroupPager
// method.
type VmmServersClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// VmmServersClientListBySubscriptionOptions contains the optional parameters for the VmmServersClient.NewListBySubscriptionPager
// method.
type VmmServersClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}
