//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armscvmm

// AvailabilitySetsClientCreateOrUpdateResponse contains the response from method AvailabilitySetsClient.BeginCreateOrUpdate.
type AvailabilitySetsClientCreateOrUpdateResponse struct {
	// The AvailabilitySets resource definition.
	AvailabilitySet
}

// AvailabilitySetsClientDeleteResponse contains the response from method AvailabilitySetsClient.BeginDelete.
type AvailabilitySetsClientDeleteResponse struct {
	// placeholder for future response values
}

// AvailabilitySetsClientGetResponse contains the response from method AvailabilitySetsClient.Get.
type AvailabilitySetsClientGetResponse struct {
	// The AvailabilitySets resource definition.
	AvailabilitySet
}

// AvailabilitySetsClientListByResourceGroupResponse contains the response from method AvailabilitySetsClient.NewListByResourceGroupPager.
type AvailabilitySetsClientListByResourceGroupResponse struct {
	// The response of a AvailabilitySet list operation.
	AvailabilitySetListResult
}

// AvailabilitySetsClientListBySubscriptionResponse contains the response from method AvailabilitySetsClient.NewListBySubscriptionPager.
type AvailabilitySetsClientListBySubscriptionResponse struct {
	// The response of a AvailabilitySet list operation.
	AvailabilitySetListResult
}

// AvailabilitySetsClientUpdateResponse contains the response from method AvailabilitySetsClient.BeginUpdate.
type AvailabilitySetsClientUpdateResponse struct {
	// The AvailabilitySets resource definition.
	AvailabilitySet
}

// CloudsClientCreateOrUpdateResponse contains the response from method CloudsClient.BeginCreateOrUpdate.
type CloudsClientCreateOrUpdateResponse struct {
	// The Clouds resource definition.
	Cloud
}

// CloudsClientDeleteResponse contains the response from method CloudsClient.BeginDelete.
type CloudsClientDeleteResponse struct {
	// placeholder for future response values
}

// CloudsClientGetResponse contains the response from method CloudsClient.Get.
type CloudsClientGetResponse struct {
	// The Clouds resource definition.
	Cloud
}

// CloudsClientListByResourceGroupResponse contains the response from method CloudsClient.NewListByResourceGroupPager.
type CloudsClientListByResourceGroupResponse struct {
	// The response of a Cloud list operation.
	CloudListResult
}

// CloudsClientListBySubscriptionResponse contains the response from method CloudsClient.NewListBySubscriptionPager.
type CloudsClientListBySubscriptionResponse struct {
	// The response of a Cloud list operation.
	CloudListResult
}

// CloudsClientUpdateResponse contains the response from method CloudsClient.BeginUpdate.
type CloudsClientUpdateResponse struct {
	// The Clouds resource definition.
	Cloud
}

// GuestAgentsClientCreateResponse contains the response from method GuestAgentsClient.BeginCreate.
type GuestAgentsClientCreateResponse struct {
	// Defines the GuestAgent.
	GuestAgent
}

// GuestAgentsClientDeleteResponse contains the response from method GuestAgentsClient.Delete.
type GuestAgentsClientDeleteResponse struct {
	// placeholder for future response values
}

// GuestAgentsClientGetResponse contains the response from method GuestAgentsClient.Get.
type GuestAgentsClientGetResponse struct {
	// Defines the GuestAgent.
	GuestAgent
}

// GuestAgentsClientListByVirtualMachineInstanceResponse contains the response from method GuestAgentsClient.NewListByVirtualMachineInstancePager.
type GuestAgentsClientListByVirtualMachineInstanceResponse struct {
	// The response of a GuestAgent list operation.
	GuestAgentListResult
}

// InventoryItemsClientCreateResponse contains the response from method InventoryItemsClient.Create.
type InventoryItemsClientCreateResponse struct {
	// Defines the inventory item.
	InventoryItem
}

// InventoryItemsClientDeleteResponse contains the response from method InventoryItemsClient.Delete.
type InventoryItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// InventoryItemsClientGetResponse contains the response from method InventoryItemsClient.Get.
type InventoryItemsClientGetResponse struct {
	// Defines the inventory item.
	InventoryItem
}

// InventoryItemsClientListByVmmServerResponse contains the response from method InventoryItemsClient.NewListByVmmServerPager.
type InventoryItemsClientListByVmmServerResponse struct {
	// The response of a InventoryItem list operation.
	InventoryItemListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// VMInstanceHybridIdentityMetadatasClientGetResponse contains the response from method VMInstanceHybridIdentityMetadatasClient.Get.
type VMInstanceHybridIdentityMetadatasClientGetResponse struct {
	// Defines the HybridIdentityMetadata.
	VMInstanceHybridIdentityMetadata
}

// VMInstanceHybridIdentityMetadatasClientListByVirtualMachineInstanceResponse contains the response from method VMInstanceHybridIdentityMetadatasClient.NewListByVirtualMachineInstancePager.
type VMInstanceHybridIdentityMetadatasClientListByVirtualMachineInstanceResponse struct {
	// The response of a VmInstanceHybridIdentityMetadata list operation.
	VMInstanceHybridIdentityMetadataListResult
}

// VirtualMachineInstancesClientCreateCheckpointResponse contains the response from method VirtualMachineInstancesClient.BeginCreateCheckpoint.
type VirtualMachineInstancesClientCreateCheckpointResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientCreateOrUpdateResponse contains the response from method VirtualMachineInstancesClient.BeginCreateOrUpdate.
type VirtualMachineInstancesClientCreateOrUpdateResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineInstancesClientDeleteCheckpointResponse contains the response from method VirtualMachineInstancesClient.BeginDeleteCheckpoint.
type VirtualMachineInstancesClientDeleteCheckpointResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientDeleteResponse contains the response from method VirtualMachineInstancesClient.BeginDelete.
type VirtualMachineInstancesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientGetResponse contains the response from method VirtualMachineInstancesClient.Get.
type VirtualMachineInstancesClientGetResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineInstancesClientListResponse contains the response from method VirtualMachineInstancesClient.NewListPager.
type VirtualMachineInstancesClientListResponse struct {
	// The response of a VirtualMachineInstance list operation.
	VirtualMachineInstanceListResult
}

// VirtualMachineInstancesClientRestartResponse contains the response from method VirtualMachineInstancesClient.BeginRestart.
type VirtualMachineInstancesClientRestartResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientRestoreCheckpointResponse contains the response from method VirtualMachineInstancesClient.BeginRestoreCheckpoint.
type VirtualMachineInstancesClientRestoreCheckpointResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientStartResponse contains the response from method VirtualMachineInstancesClient.BeginStart.
type VirtualMachineInstancesClientStartResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientStopResponse contains the response from method VirtualMachineInstancesClient.BeginStop.
type VirtualMachineInstancesClientStopResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientUpdateResponse contains the response from method VirtualMachineInstancesClient.BeginUpdate.
type VirtualMachineInstancesClientUpdateResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineTemplatesClientCreateOrUpdateResponse contains the response from method VirtualMachineTemplatesClient.BeginCreateOrUpdate.
type VirtualMachineTemplatesClientCreateOrUpdateResponse struct {
	// The VirtualMachineTemplates resource definition.
	VirtualMachineTemplate
}

// VirtualMachineTemplatesClientDeleteResponse contains the response from method VirtualMachineTemplatesClient.BeginDelete.
type VirtualMachineTemplatesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachineTemplatesClientGetResponse contains the response from method VirtualMachineTemplatesClient.Get.
type VirtualMachineTemplatesClientGetResponse struct {
	// The VirtualMachineTemplates resource definition.
	VirtualMachineTemplate
}

// VirtualMachineTemplatesClientListByResourceGroupResponse contains the response from method VirtualMachineTemplatesClient.NewListByResourceGroupPager.
type VirtualMachineTemplatesClientListByResourceGroupResponse struct {
	// The response of a VirtualMachineTemplate list operation.
	VirtualMachineTemplateListResult
}

// VirtualMachineTemplatesClientListBySubscriptionResponse contains the response from method VirtualMachineTemplatesClient.NewListBySubscriptionPager.
type VirtualMachineTemplatesClientListBySubscriptionResponse struct {
	// The response of a VirtualMachineTemplate list operation.
	VirtualMachineTemplateListResult
}

// VirtualMachineTemplatesClientUpdateResponse contains the response from method VirtualMachineTemplatesClient.BeginUpdate.
type VirtualMachineTemplatesClientUpdateResponse struct {
	// The VirtualMachineTemplates resource definition.
	VirtualMachineTemplate
}

// VirtualNetworksClientCreateOrUpdateResponse contains the response from method VirtualNetworksClient.BeginCreateOrUpdate.
type VirtualNetworksClientCreateOrUpdateResponse struct {
	// The VirtualNetworks resource definition.
	VirtualNetwork
}

// VirtualNetworksClientDeleteResponse contains the response from method VirtualNetworksClient.BeginDelete.
type VirtualNetworksClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualNetworksClientGetResponse contains the response from method VirtualNetworksClient.Get.
type VirtualNetworksClientGetResponse struct {
	// The VirtualNetworks resource definition.
	VirtualNetwork
}

// VirtualNetworksClientListByResourceGroupResponse contains the response from method VirtualNetworksClient.NewListByResourceGroupPager.
type VirtualNetworksClientListByResourceGroupResponse struct {
	// The response of a VirtualNetwork list operation.
	VirtualNetworkListResult
}

// VirtualNetworksClientListBySubscriptionResponse contains the response from method VirtualNetworksClient.NewListBySubscriptionPager.
type VirtualNetworksClientListBySubscriptionResponse struct {
	// The response of a VirtualNetwork list operation.
	VirtualNetworkListResult
}

// VirtualNetworksClientUpdateResponse contains the response from method VirtualNetworksClient.BeginUpdate.
type VirtualNetworksClientUpdateResponse struct {
	// The VirtualNetworks resource definition.
	VirtualNetwork
}

// VmmServersClientCreateOrUpdateResponse contains the response from method VmmServersClient.BeginCreateOrUpdate.
type VmmServersClientCreateOrUpdateResponse struct {
	// The VmmServers resource definition.
	VmmServer
}

// VmmServersClientDeleteResponse contains the response from method VmmServersClient.BeginDelete.
type VmmServersClientDeleteResponse struct {
	// placeholder for future response values
}

// VmmServersClientGetResponse contains the response from method VmmServersClient.Get.
type VmmServersClientGetResponse struct {
	// The VmmServers resource definition.
	VmmServer
}

// VmmServersClientListByResourceGroupResponse contains the response from method VmmServersClient.NewListByResourceGroupPager.
type VmmServersClientListByResourceGroupResponse struct {
	// The response of a VmmServer list operation.
	VmmServerListResult
}

// VmmServersClientListBySubscriptionResponse contains the response from method VmmServersClient.NewListBySubscriptionPager.
type VmmServersClientListBySubscriptionResponse struct {
	// The response of a VmmServer list operation.
	VmmServerListResult
}

// VmmServersClientUpdateResponse contains the response from method VmmServersClient.BeginUpdate.
type VmmServersClientUpdateResponse struct {
	// The VmmServers resource definition.
	VmmServer
}
