//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsecurityinsights

// ActionsClientCreateOrUpdateResponse contains the response from method ActionsClient.CreateOrUpdate.
type ActionsClientCreateOrUpdateResponse struct {
	// Action for alert rule.
	ActionResponse
}

// ActionsClientDeleteResponse contains the response from method ActionsClient.Delete.
type ActionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ActionsClientGetResponse contains the response from method ActionsClient.Get.
type ActionsClientGetResponse struct {
	// Action for alert rule.
	ActionResponse
}

// ActionsClientListByAlertRuleResponse contains the response from method ActionsClient.NewListByAlertRulePager.
type ActionsClientListByAlertRuleResponse struct {
	// List all the actions.
	ActionsList
}

// AlertRuleTemplatesClientGetResponse contains the response from method AlertRuleTemplatesClient.Get.
type AlertRuleTemplatesClientGetResponse struct {
	// Alert rule template.
	AlertRuleTemplateClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type AlertRuleTemplatesClientGetResponse.
func (a *AlertRuleTemplatesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalAlertRuleTemplateClassification(data)
	if err != nil {
		return err
	}
	a.AlertRuleTemplateClassification = res
	return nil
}

// AlertRuleTemplatesClientListResponse contains the response from method AlertRuleTemplatesClient.NewListPager.
type AlertRuleTemplatesClientListResponse struct {
	// List all the alert rule templates.
	AlertRuleTemplatesList
}

// AlertRulesClientCreateOrUpdateResponse contains the response from method AlertRulesClient.CreateOrUpdate.
type AlertRulesClientCreateOrUpdateResponse struct {
	// Alert rule.
	AlertRuleClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type AlertRulesClientCreateOrUpdateResponse.
func (a *AlertRulesClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalAlertRuleClassification(data)
	if err != nil {
		return err
	}
	a.AlertRuleClassification = res
	return nil
}

// AlertRulesClientDeleteResponse contains the response from method AlertRulesClient.Delete.
type AlertRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// AlertRulesClientGetResponse contains the response from method AlertRulesClient.Get.
type AlertRulesClientGetResponse struct {
	// Alert rule.
	AlertRuleClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type AlertRulesClientGetResponse.
func (a *AlertRulesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalAlertRuleClassification(data)
	if err != nil {
		return err
	}
	a.AlertRuleClassification = res
	return nil
}

// AlertRulesClientListResponse contains the response from method AlertRulesClient.NewListPager.
type AlertRulesClientListResponse struct {
	// List all the alert rules.
	AlertRulesList
}

// AutomationRulesClientCreateOrUpdateResponse contains the response from method AutomationRulesClient.CreateOrUpdate.
type AutomationRulesClientCreateOrUpdateResponse struct {
	AutomationRule
}

// AutomationRulesClientDeleteResponse contains the response from method AutomationRulesClient.Delete.
type AutomationRulesClientDeleteResponse struct {
	// Anything
	Interface any
}

// AutomationRulesClientGetResponse contains the response from method AutomationRulesClient.Get.
type AutomationRulesClientGetResponse struct {
	AutomationRule
}

// AutomationRulesClientListResponse contains the response from method AutomationRulesClient.NewListPager.
type AutomationRulesClientListResponse struct {
	AutomationRulesList
}

// BookmarkClientExpandResponse contains the response from method BookmarkClient.Expand.
type BookmarkClientExpandResponse struct {
	// The entity expansion result operation response.
	BookmarkExpandResponse
}

// BookmarkRelationsClientCreateOrUpdateResponse contains the response from method BookmarkRelationsClient.CreateOrUpdate.
type BookmarkRelationsClientCreateOrUpdateResponse struct {
	// Represents a relation between two resources
	Relation
}

// BookmarkRelationsClientDeleteResponse contains the response from method BookmarkRelationsClient.Delete.
type BookmarkRelationsClientDeleteResponse struct {
	// placeholder for future response values
}

// BookmarkRelationsClientGetResponse contains the response from method BookmarkRelationsClient.Get.
type BookmarkRelationsClientGetResponse struct {
	// Represents a relation between two resources
	Relation
}

// BookmarkRelationsClientListResponse contains the response from method BookmarkRelationsClient.NewListPager.
type BookmarkRelationsClientListResponse struct {
	// List of relations.
	RelationList
}

// BookmarksClientCreateOrUpdateResponse contains the response from method BookmarksClient.CreateOrUpdate.
type BookmarksClientCreateOrUpdateResponse struct {
	// Represents a bookmark in Azure Security Insights.
	Bookmark
}

// BookmarksClientDeleteResponse contains the response from method BookmarksClient.Delete.
type BookmarksClientDeleteResponse struct {
	// placeholder for future response values
}

// BookmarksClientGetResponse contains the response from method BookmarksClient.Get.
type BookmarksClientGetResponse struct {
	// Represents a bookmark in Azure Security Insights.
	Bookmark
}

// BookmarksClientListResponse contains the response from method BookmarksClient.NewListPager.
type BookmarksClientListResponse struct {
	// List all the bookmarks.
	BookmarkList
}

// DataConnectorsCheckRequirementsClientPostResponse contains the response from method DataConnectorsCheckRequirementsClient.Post.
type DataConnectorsCheckRequirementsClientPostResponse struct {
	// Data connector requirements status.
	DataConnectorRequirementsState
}

// DataConnectorsClientConnectResponse contains the response from method DataConnectorsClient.Connect.
type DataConnectorsClientConnectResponse struct {
	// placeholder for future response values
}

// DataConnectorsClientCreateOrUpdateResponse contains the response from method DataConnectorsClient.CreateOrUpdate.
type DataConnectorsClientCreateOrUpdateResponse struct {
	// Data connector
	DataConnectorClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type DataConnectorsClientCreateOrUpdateResponse.
func (d *DataConnectorsClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDataConnectorClassification(data)
	if err != nil {
		return err
	}
	d.DataConnectorClassification = res
	return nil
}

// DataConnectorsClientDeleteResponse contains the response from method DataConnectorsClient.Delete.
type DataConnectorsClientDeleteResponse struct {
	// placeholder for future response values
}

// DataConnectorsClientDisconnectResponse contains the response from method DataConnectorsClient.Disconnect.
type DataConnectorsClientDisconnectResponse struct {
	// placeholder for future response values
}

// DataConnectorsClientGetResponse contains the response from method DataConnectorsClient.Get.
type DataConnectorsClientGetResponse struct {
	// Data connector
	DataConnectorClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type DataConnectorsClientGetResponse.
func (d *DataConnectorsClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDataConnectorClassification(data)
	if err != nil {
		return err
	}
	d.DataConnectorClassification = res
	return nil
}

// DataConnectorsClientListResponse contains the response from method DataConnectorsClient.NewListPager.
type DataConnectorsClientListResponse struct {
	// List all the data connectors.
	DataConnectorList
}

// DomainWhoisClientGetResponse contains the response from method DomainWhoisClient.Get.
type DomainWhoisClientGetResponse struct {
	// Whois information for a given domain and associated metadata
	EnrichmentDomainWhois
}

// EntitiesClientExpandResponse contains the response from method EntitiesClient.Expand.
type EntitiesClientExpandResponse struct {
	// The entity expansion result operation response.
	EntityExpandResponse
}

// EntitiesClientGetInsightsResponse contains the response from method EntitiesClient.GetInsights.
type EntitiesClientGetInsightsResponse struct {
	// The Get Insights result operation response.
	EntityGetInsightsResponse
}

// EntitiesClientGetResponse contains the response from method EntitiesClient.Get.
type EntitiesClientGetResponse struct {
	// Specific entity.
	EntityClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type EntitiesClientGetResponse.
func (e *EntitiesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalEntityClassification(data)
	if err != nil {
		return err
	}
	e.EntityClassification = res
	return nil
}

// EntitiesClientListResponse contains the response from method EntitiesClient.NewListPager.
type EntitiesClientListResponse struct {
	// List of all the entities.
	EntityList
}

// EntitiesClientQueriesResponse contains the response from method EntitiesClient.Queries.
type EntitiesClientQueriesResponse struct {
	// Retrieve queries for entity result operation response.
	GetQueriesResponse
}

// EntitiesGetTimelineClientListResponse contains the response from method EntitiesGetTimelineClient.List.
type EntitiesGetTimelineClientListResponse struct {
	// The entity timeline result operation response.
	EntityTimelineResponse
}

// EntitiesRelationsClientListResponse contains the response from method EntitiesRelationsClient.NewListPager.
type EntitiesRelationsClientListResponse struct {
	// List of relations.
	RelationList
}

// EntityQueriesClientCreateOrUpdateResponse contains the response from method EntityQueriesClient.CreateOrUpdate.
type EntityQueriesClientCreateOrUpdateResponse struct {
	// Specific entity query.
	EntityQueryClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type EntityQueriesClientCreateOrUpdateResponse.
func (e *EntityQueriesClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalEntityQueryClassification(data)
	if err != nil {
		return err
	}
	e.EntityQueryClassification = res
	return nil
}

// EntityQueriesClientDeleteResponse contains the response from method EntityQueriesClient.Delete.
type EntityQueriesClientDeleteResponse struct {
	// placeholder for future response values
}

// EntityQueriesClientGetResponse contains the response from method EntityQueriesClient.Get.
type EntityQueriesClientGetResponse struct {
	// Specific entity query.
	EntityQueryClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type EntityQueriesClientGetResponse.
func (e *EntityQueriesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalEntityQueryClassification(data)
	if err != nil {
		return err
	}
	e.EntityQueryClassification = res
	return nil
}

// EntityQueriesClientListResponse contains the response from method EntityQueriesClient.NewListPager.
type EntityQueriesClientListResponse struct {
	// List of all the entity queries.
	EntityQueryList
}

// EntityQueryTemplatesClientGetResponse contains the response from method EntityQueryTemplatesClient.Get.
type EntityQueryTemplatesClientGetResponse struct {
	// Specific entity query template.
	EntityQueryTemplateClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type EntityQueryTemplatesClientGetResponse.
func (e *EntityQueryTemplatesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalEntityQueryTemplateClassification(data)
	if err != nil {
		return err
	}
	e.EntityQueryTemplateClassification = res
	return nil
}

// EntityQueryTemplatesClientListResponse contains the response from method EntityQueryTemplatesClient.NewListPager.
type EntityQueryTemplatesClientListResponse struct {
	// List of all the entity query templates.
	EntityQueryTemplateList
}

// EntityRelationsClientGetRelationResponse contains the response from method EntityRelationsClient.GetRelation.
type EntityRelationsClientGetRelationResponse struct {
	// Represents a relation between two resources
	Relation
}

// FileImportsClientCreateResponse contains the response from method FileImportsClient.Create.
type FileImportsClientCreateResponse struct {
	// Represents a file import in Azure Security Insights.
	FileImport
}

// FileImportsClientDeleteResponse contains the response from method FileImportsClient.BeginDelete.
type FileImportsClientDeleteResponse struct {
	// Represents a file import in Azure Security Insights.
	FileImport
}

// FileImportsClientGetResponse contains the response from method FileImportsClient.Get.
type FileImportsClientGetResponse struct {
	// Represents a file import in Azure Security Insights.
	FileImport
}

// FileImportsClientListResponse contains the response from method FileImportsClient.NewListPager.
type FileImportsClientListResponse struct {
	// List all the file imports.
	FileImportList
}

// IPGeodataClientGetResponse contains the response from method IPGeodataClient.Get.
type IPGeodataClientGetResponse struct {
	// Geodata information for a given IP address
	EnrichmentIPGeodata
}

// IncidentCommentsClientCreateOrUpdateResponse contains the response from method IncidentCommentsClient.CreateOrUpdate.
type IncidentCommentsClientCreateOrUpdateResponse struct {
	// Represents an incident comment
	IncidentComment
}

// IncidentCommentsClientDeleteResponse contains the response from method IncidentCommentsClient.Delete.
type IncidentCommentsClientDeleteResponse struct {
	// placeholder for future response values
}

// IncidentCommentsClientGetResponse contains the response from method IncidentCommentsClient.Get.
type IncidentCommentsClientGetResponse struct {
	// Represents an incident comment
	IncidentComment
}

// IncidentCommentsClientListResponse contains the response from method IncidentCommentsClient.NewListPager.
type IncidentCommentsClientListResponse struct {
	// List of incident comments.
	IncidentCommentList
}

// IncidentRelationsClientCreateOrUpdateResponse contains the response from method IncidentRelationsClient.CreateOrUpdate.
type IncidentRelationsClientCreateOrUpdateResponse struct {
	// Represents a relation between two resources
	Relation
}

// IncidentRelationsClientDeleteResponse contains the response from method IncidentRelationsClient.Delete.
type IncidentRelationsClientDeleteResponse struct {
	// placeholder for future response values
}

// IncidentRelationsClientGetResponse contains the response from method IncidentRelationsClient.Get.
type IncidentRelationsClientGetResponse struct {
	// Represents a relation between two resources
	Relation
}

// IncidentRelationsClientListResponse contains the response from method IncidentRelationsClient.NewListPager.
type IncidentRelationsClientListResponse struct {
	// List of relations.
	RelationList
}

// IncidentsClientCreateOrUpdateResponse contains the response from method IncidentsClient.CreateOrUpdate.
type IncidentsClientCreateOrUpdateResponse struct {
	// Represents an incident in Azure Security Insights.
	Incident
}

// IncidentsClientCreateTeamResponse contains the response from method IncidentsClient.CreateTeam.
type IncidentsClientCreateTeamResponse struct {
	// Describes team information
	TeamInformation
}

// IncidentsClientDeleteResponse contains the response from method IncidentsClient.Delete.
type IncidentsClientDeleteResponse struct {
	// placeholder for future response values
}

// IncidentsClientGetResponse contains the response from method IncidentsClient.Get.
type IncidentsClientGetResponse struct {
	// Represents an incident in Azure Security Insights.
	Incident
}

// IncidentsClientListAlertsResponse contains the response from method IncidentsClient.ListAlerts.
type IncidentsClientListAlertsResponse struct {
	// List of incident alerts.
	IncidentAlertList
}

// IncidentsClientListBookmarksResponse contains the response from method IncidentsClient.ListBookmarks.
type IncidentsClientListBookmarksResponse struct {
	// List of incident bookmarks.
	IncidentBookmarkList
}

// IncidentsClientListEntitiesResponse contains the response from method IncidentsClient.ListEntities.
type IncidentsClientListEntitiesResponse struct {
	// The incident related entities response.
	IncidentEntitiesResponse
}

// IncidentsClientListResponse contains the response from method IncidentsClient.NewListPager.
type IncidentsClientListResponse struct {
	// List all the incidents.
	IncidentList
}

// IncidentsClientRunPlaybookResponse contains the response from method IncidentsClient.RunPlaybook.
type IncidentsClientRunPlaybookResponse struct {
	// Anything
	Interface any
}

// MetadataClientCreateResponse contains the response from method MetadataClient.Create.
type MetadataClientCreateResponse struct {
	// Metadata resource definition.
	MetadataModel
}

// MetadataClientDeleteResponse contains the response from method MetadataClient.Delete.
type MetadataClientDeleteResponse struct {
	// placeholder for future response values
}

// MetadataClientGetResponse contains the response from method MetadataClient.Get.
type MetadataClientGetResponse struct {
	// Metadata resource definition.
	MetadataModel
}

// MetadataClientListResponse contains the response from method MetadataClient.NewListPager.
type MetadataClientListResponse struct {
	// List of all the metadata.
	MetadataList
}

// MetadataClientUpdateResponse contains the response from method MetadataClient.Update.
type MetadataClientUpdateResponse struct {
	// Metadata resource definition.
	MetadataModel
}

// OfficeConsentsClientDeleteResponse contains the response from method OfficeConsentsClient.Delete.
type OfficeConsentsClientDeleteResponse struct {
	// placeholder for future response values
}

// OfficeConsentsClientGetResponse contains the response from method OfficeConsentsClient.Get.
type OfficeConsentsClientGetResponse struct {
	// Consent for Office365 tenant that already made.
	OfficeConsent
}

// OfficeConsentsClientListResponse contains the response from method OfficeConsentsClient.NewListPager.
type OfficeConsentsClientListResponse struct {
	// List of all the office365 consents.
	OfficeConsentList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Lists the operations available in the SecurityInsights RP.
	OperationsList
}

// ProductSettingsClientDeleteResponse contains the response from method ProductSettingsClient.Delete.
type ProductSettingsClientDeleteResponse struct {
	// placeholder for future response values
}

// ProductSettingsClientGetResponse contains the response from method ProductSettingsClient.Get.
type ProductSettingsClientGetResponse struct {
	// The Setting.
	SettingsClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ProductSettingsClientGetResponse.
func (p *ProductSettingsClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalSettingsClassification(data)
	if err != nil {
		return err
	}
	p.SettingsClassification = res
	return nil
}

// ProductSettingsClientListResponse contains the response from method ProductSettingsClient.List.
type ProductSettingsClientListResponse struct {
	// List of all the settings.
	SettingList
}

// ProductSettingsClientUpdateResponse contains the response from method ProductSettingsClient.Update.
type ProductSettingsClientUpdateResponse struct {
	// The Setting.
	SettingsClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ProductSettingsClientUpdateResponse.
func (p *ProductSettingsClientUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalSettingsClassification(data)
	if err != nil {
		return err
	}
	p.SettingsClassification = res
	return nil
}

// SecurityMLAnalyticsSettingsClientCreateOrUpdateResponse contains the response from method SecurityMLAnalyticsSettingsClient.CreateOrUpdate.
type SecurityMLAnalyticsSettingsClientCreateOrUpdateResponse struct {
	// Security ML Analytics Setting
	SecurityMLAnalyticsSettingClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SecurityMLAnalyticsSettingsClientCreateOrUpdateResponse.
func (s *SecurityMLAnalyticsSettingsClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalSecurityMLAnalyticsSettingClassification(data)
	if err != nil {
		return err
	}
	s.SecurityMLAnalyticsSettingClassification = res
	return nil
}

// SecurityMLAnalyticsSettingsClientDeleteResponse contains the response from method SecurityMLAnalyticsSettingsClient.Delete.
type SecurityMLAnalyticsSettingsClientDeleteResponse struct {
	// placeholder for future response values
}

// SecurityMLAnalyticsSettingsClientGetResponse contains the response from method SecurityMLAnalyticsSettingsClient.Get.
type SecurityMLAnalyticsSettingsClientGetResponse struct {
	// Security ML Analytics Setting
	SecurityMLAnalyticsSettingClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SecurityMLAnalyticsSettingsClientGetResponse.
func (s *SecurityMLAnalyticsSettingsClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalSecurityMLAnalyticsSettingClassification(data)
	if err != nil {
		return err
	}
	s.SecurityMLAnalyticsSettingClassification = res
	return nil
}

// SecurityMLAnalyticsSettingsClientListResponse contains the response from method SecurityMLAnalyticsSettingsClient.NewListPager.
type SecurityMLAnalyticsSettingsClientListResponse struct {
	// List all the SecurityMLAnalyticsSettings
	SecurityMLAnalyticsSettingsList
}

// SentinelOnboardingStatesClientCreateResponse contains the response from method SentinelOnboardingStatesClient.Create.
type SentinelOnboardingStatesClientCreateResponse struct {
	// Sentinel onboarding state
	SentinelOnboardingState
}

// SentinelOnboardingStatesClientDeleteResponse contains the response from method SentinelOnboardingStatesClient.Delete.
type SentinelOnboardingStatesClientDeleteResponse struct {
	// placeholder for future response values
}

// SentinelOnboardingStatesClientGetResponse contains the response from method SentinelOnboardingStatesClient.Get.
type SentinelOnboardingStatesClientGetResponse struct {
	// Sentinel onboarding state
	SentinelOnboardingState
}

// SentinelOnboardingStatesClientListResponse contains the response from method SentinelOnboardingStatesClient.List.
type SentinelOnboardingStatesClientListResponse struct {
	// List of the Sentinel onboarding states
	SentinelOnboardingStatesList
}

// SourceControlClientListRepositoriesResponse contains the response from method SourceControlClient.NewListRepositoriesPager.
type SourceControlClientListRepositoriesResponse struct {
	// List all the source controls.
	RepoList
}

// SourceControlsClientCreateResponse contains the response from method SourceControlsClient.Create.
type SourceControlsClientCreateResponse struct {
	// Represents a SourceControl in Azure Security Insights.
	SourceControl
}

// SourceControlsClientDeleteResponse contains the response from method SourceControlsClient.Delete.
type SourceControlsClientDeleteResponse struct {
	// placeholder for future response values
}

// SourceControlsClientGetResponse contains the response from method SourceControlsClient.Get.
type SourceControlsClientGetResponse struct {
	// Represents a SourceControl in Azure Security Insights.
	SourceControl
}

// SourceControlsClientListResponse contains the response from method SourceControlsClient.NewListPager.
type SourceControlsClientListResponse struct {
	// List all the source controls.
	SourceControlList
}

// ThreatIntelligenceIndicatorClientAppendTagsResponse contains the response from method ThreatIntelligenceIndicatorClient.AppendTags.
type ThreatIntelligenceIndicatorClientAppendTagsResponse struct {
	// placeholder for future response values
}

// ThreatIntelligenceIndicatorClientCreateIndicatorResponse contains the response from method ThreatIntelligenceIndicatorClient.CreateIndicator.
type ThreatIntelligenceIndicatorClientCreateIndicatorResponse struct {
	// Threat intelligence information object.
	ThreatIntelligenceInformationClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ThreatIntelligenceIndicatorClientCreateIndicatorResponse.
func (t *ThreatIntelligenceIndicatorClientCreateIndicatorResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalThreatIntelligenceInformationClassification(data)
	if err != nil {
		return err
	}
	t.ThreatIntelligenceInformationClassification = res
	return nil
}

// ThreatIntelligenceIndicatorClientCreateResponse contains the response from method ThreatIntelligenceIndicatorClient.Create.
type ThreatIntelligenceIndicatorClientCreateResponse struct {
	// Threat intelligence information object.
	ThreatIntelligenceInformationClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ThreatIntelligenceIndicatorClientCreateResponse.
func (t *ThreatIntelligenceIndicatorClientCreateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalThreatIntelligenceInformationClassification(data)
	if err != nil {
		return err
	}
	t.ThreatIntelligenceInformationClassification = res
	return nil
}

// ThreatIntelligenceIndicatorClientDeleteResponse contains the response from method ThreatIntelligenceIndicatorClient.Delete.
type ThreatIntelligenceIndicatorClientDeleteResponse struct {
	// placeholder for future response values
}

// ThreatIntelligenceIndicatorClientGetResponse contains the response from method ThreatIntelligenceIndicatorClient.Get.
type ThreatIntelligenceIndicatorClientGetResponse struct {
	// Threat intelligence information object.
	ThreatIntelligenceInformationClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ThreatIntelligenceIndicatorClientGetResponse.
func (t *ThreatIntelligenceIndicatorClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalThreatIntelligenceInformationClassification(data)
	if err != nil {
		return err
	}
	t.ThreatIntelligenceInformationClassification = res
	return nil
}

// ThreatIntelligenceIndicatorClientQueryIndicatorsResponse contains the response from method ThreatIntelligenceIndicatorClient.NewQueryIndicatorsPager.
type ThreatIntelligenceIndicatorClientQueryIndicatorsResponse struct {
	// List of all the threat intelligence information objects.
	ThreatIntelligenceInformationList
}

// ThreatIntelligenceIndicatorClientReplaceTagsResponse contains the response from method ThreatIntelligenceIndicatorClient.ReplaceTags.
type ThreatIntelligenceIndicatorClientReplaceTagsResponse struct {
	// Threat intelligence information object.
	ThreatIntelligenceInformationClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ThreatIntelligenceIndicatorClientReplaceTagsResponse.
func (t *ThreatIntelligenceIndicatorClientReplaceTagsResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalThreatIntelligenceInformationClassification(data)
	if err != nil {
		return err
	}
	t.ThreatIntelligenceInformationClassification = res
	return nil
}

// ThreatIntelligenceIndicatorMetricsClientListResponse contains the response from method ThreatIntelligenceIndicatorMetricsClient.List.
type ThreatIntelligenceIndicatorMetricsClientListResponse struct {
	// List of all the threat intelligence metric fields (type/threat type/source).
	ThreatIntelligenceMetricsList
}

// ThreatIntelligenceIndicatorsClientListResponse contains the response from method ThreatIntelligenceIndicatorsClient.NewListPager.
type ThreatIntelligenceIndicatorsClientListResponse struct {
	// List of all the threat intelligence information objects.
	ThreatIntelligenceInformationList
}

// WatchlistItemsClientCreateOrUpdateResponse contains the response from method WatchlistItemsClient.CreateOrUpdate.
type WatchlistItemsClientCreateOrUpdateResponse struct {
	// Represents a Watchlist item in Azure Security Insights.
	WatchlistItem
}

// WatchlistItemsClientDeleteResponse contains the response from method WatchlistItemsClient.Delete.
type WatchlistItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// WatchlistItemsClientGetResponse contains the response from method WatchlistItemsClient.Get.
type WatchlistItemsClientGetResponse struct {
	// Represents a Watchlist item in Azure Security Insights.
	WatchlistItem
}

// WatchlistItemsClientListResponse contains the response from method WatchlistItemsClient.NewListPager.
type WatchlistItemsClientListResponse struct {
	// List all the watchlist items.
	WatchlistItemList
}

// WatchlistsClientCreateOrUpdateResponse contains the response from method WatchlistsClient.CreateOrUpdate.
type WatchlistsClientCreateOrUpdateResponse struct {
	// Represents a Watchlist in Azure Security Insights.
	Watchlist

	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string
}

// WatchlistsClientDeleteResponse contains the response from method WatchlistsClient.Delete.
type WatchlistsClientDeleteResponse struct {
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string
}

// WatchlistsClientGetResponse contains the response from method WatchlistsClient.Get.
type WatchlistsClientGetResponse struct {
	// Represents a Watchlist in Azure Security Insights.
	Watchlist
}

// WatchlistsClientListResponse contains the response from method WatchlistsClient.NewListPager.
type WatchlistsClientListResponse struct {
	// List all the watchlists.
	WatchlistList
}
