//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armservicefabricmanagedclusters

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The customer subscription identifier.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewApplicationTypeVersionsClient creates a new instance of ApplicationTypeVersionsClient.
func (c *ClientFactory) NewApplicationTypeVersionsClient() *ApplicationTypeVersionsClient {
	return &ApplicationTypeVersionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewApplicationTypesClient creates a new instance of ApplicationTypesClient.
func (c *ClientFactory) NewApplicationTypesClient() *ApplicationTypesClient {
	return &ApplicationTypesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewApplicationsClient creates a new instance of ApplicationsClient.
func (c *ClientFactory) NewApplicationsClient() *ApplicationsClient {
	return &ApplicationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedApplyMaintenanceWindowClient creates a new instance of ManagedApplyMaintenanceWindowClient.
func (c *ClientFactory) NewManagedApplyMaintenanceWindowClient() *ManagedApplyMaintenanceWindowClient {
	return &ManagedApplyMaintenanceWindowClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedAzResiliencyStatusClient creates a new instance of ManagedAzResiliencyStatusClient.
func (c *ClientFactory) NewManagedAzResiliencyStatusClient() *ManagedAzResiliencyStatusClient {
	return &ManagedAzResiliencyStatusClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedClusterVersionClient creates a new instance of ManagedClusterVersionClient.
func (c *ClientFactory) NewManagedClusterVersionClient() *ManagedClusterVersionClient {
	return &ManagedClusterVersionClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedClustersClient creates a new instance of ManagedClustersClient.
func (c *ClientFactory) NewManagedClustersClient() *ManagedClustersClient {
	return &ManagedClustersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedMaintenanceWindowStatusClient creates a new instance of ManagedMaintenanceWindowStatusClient.
func (c *ClientFactory) NewManagedMaintenanceWindowStatusClient() *ManagedMaintenanceWindowStatusClient {
	return &ManagedMaintenanceWindowStatusClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedUnsupportedVMSizesClient creates a new instance of ManagedUnsupportedVMSizesClient.
func (c *ClientFactory) NewManagedUnsupportedVMSizesClient() *ManagedUnsupportedVMSizesClient {
	return &ManagedUnsupportedVMSizesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewNodeTypeSKUsClient creates a new instance of NodeTypeSKUsClient.
func (c *ClientFactory) NewNodeTypeSKUsClient() *NodeTypeSKUsClient {
	return &NodeTypeSKUsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewNodeTypesClient creates a new instance of NodeTypesClient.
func (c *ClientFactory) NewNodeTypesClient() *NodeTypesClient {
	return &NodeTypesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationResultsClient creates a new instance of OperationResultsClient.
func (c *ClientFactory) NewOperationResultsClient() *OperationResultsClient {
	return &OperationResultsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationStatusClient creates a new instance of OperationStatusClient.
func (c *ClientFactory) NewOperationStatusClient() *OperationStatusClient {
	return &OperationStatusClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewServicesClient creates a new instance of ServicesClient.
func (c *ClientFactory) NewServicesClient() *ServicesClient {
	return &ServicesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
