//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armservicefabricmanagedclusters_test

import (
	"context"
	"log"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/servicefabricmanagedclusters/armservicefabricmanagedclusters"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypeListOperation_example.json
func ExampleNodeTypesClient_NewListByManagedClustersPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewNodeTypesClient().NewListByManagedClustersPager("resRg", "myCluster", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.NodeTypeListResult = armservicefabricmanagedclusters.NodeTypeListResult{
		// 	Value: []*armservicefabricmanagedclusters.NodeType{
		// 		{
		// 			Name: to.Ptr("FE"),
		// 			Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
		// 			ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/FE"),
		// 			Tags: map[string]*string{
		// 			},
		// 			Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
		// 				Capacities: map[string]*string{
		// 				},
		// 				DataDiskSizeGB: to.Ptr[int32](100),
		// 				DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
		// 				IsPrimary: to.Ptr(true),
		// 				IsStateless: to.Ptr(false),
		// 				PlacementProperties: map[string]*string{
		// 				},
		// 				VMImageOffer: to.Ptr("WindowsServer"),
		// 				VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
		// 				VMImageSKU: to.Ptr("2016-Datacenter"),
		// 				VMImageVersion: to.Ptr("latest"),
		// 				VMInstanceCount: to.Ptr[int32](5),
		// 				VMSize: to.Ptr("Standard_D2"),
		// 			},
		// 			SKU: &armservicefabricmanagedclusters.NodeTypeSKU{
		// 				Name: to.Ptr("Standard_P0"),
		// 				Capacity: to.Ptr[int32](5),
		// 				Tier: to.Ptr("Standard"),
		// 			},
		// 		},
		// 		{
		// 			Name: to.Ptr("BE"),
		// 			Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
		// 			ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
		// 			Tags: map[string]*string{
		// 			},
		// 			Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
		// 				Capacities: map[string]*string{
		// 				},
		// 				DataDiskSizeGB: to.Ptr[int32](200),
		// 				DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
		// 				IsPrimary: to.Ptr(false),
		// 				IsStateless: to.Ptr(false),
		// 				PlacementProperties: map[string]*string{
		// 				},
		// 				VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
		// 					{
		// 						Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
		// 						Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
		// 							Type: to.Ptr("GenevaMonitoring"),
		// 							AutoUpgradeMinorVersion: to.Ptr(true),
		// 							Publisher: to.Ptr("Microsoft.Azure.Geneva"),
		// 							Settings: map[string]any{
		// 							},
		// 							TypeHandlerVersion: to.Ptr("2.0"),
		// 						},
		// 				}},
		// 				VMImageOffer: to.Ptr("WindowsServer"),
		// 				VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
		// 				VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
		// 				VMImageVersion: to.Ptr("latest"),
		// 				VMInstanceCount: to.Ptr[int32](10),
		// 				VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
		// 					{
		// 						SourceVault: &armservicefabricmanagedclusters.SubResource{
		// 							ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
		// 						},
		// 						VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
		// 							{
		// 								CertificateStore: to.Ptr("My"),
		// 								CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
		// 						}},
		// 				}},
		// 				VMSize: to.Ptr("Standard_DS3"),
		// 			},
		// 			SKU: &armservicefabricmanagedclusters.NodeTypeSKU{
		// 				Name: to.Ptr("Standard_S0"),
		// 				Capacity: to.Ptr[int32](10),
		// 				Tier: to.Ptr("Standard"),
		// 			},
		// 	}},
		// }
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/RestartNodes_example.json
func ExampleNodeTypesClient_BeginRestart() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginRestart(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeActionParameters{
		Nodes: []*string{
			to.Ptr("BE_0"),
			to.Ptr("BE_3")},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/ReimageNodes_UD_example.json
func ExampleNodeTypesClient_BeginReimage_reimageAllNodesByUpgradeDomain() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginReimage(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeActionParameters{
		UpdateType: to.Ptr(armservicefabricmanagedclusters.UpdateTypeByUpgradeDomain),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/ReimageNodes_example.json
func ExampleNodeTypesClient_BeginReimage_reimageNodes() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginReimage(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeActionParameters{
		Nodes: []*string{
			to.Ptr("BE_0"),
			to.Ptr("BE_3")},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/DeleteNodes_example.json
func ExampleNodeTypesClient_BeginDeleteNode() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginDeleteNode(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeActionParameters{
		Nodes: []*string{
			to.Ptr("BE_0"),
			to.Ptr("BE_3")},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypeGetOperation_example.json
func ExampleNodeTypesClient_Get() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewNodeTypesClient().Get(ctx, "resRg", "myCluster", "FE", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("FE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/FE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](100),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(true),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](5),
	// 		VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
	// 			{
	// 				SourceVault: &armservicefabricmanagedclusters.SubResource{
	// 					ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
	// 				},
	// 				VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
	// 					{
	// 						CertificateStore: to.Ptr("My"),
	// 						CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
	// 				}},
	// 		}},
	// 		VMSize: to.Ptr("Standard_D2"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationAutoScale_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putANodeTypeWithAutoScaleParameters() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			Capacities: map[string]*string{
				"ClientConnections": to.Ptr("65536"),
			},
			DataDiskSizeGB:          to.Ptr[int32](200),
			DataDiskType:            to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
			IsPrimary:               to.Ptr(false),
			IsStateless:             to.Ptr(true),
			MultiplePlacementGroups: to.Ptr(true),
			PlacementProperties: map[string]*string{
				"HasSSD":       to.Ptr("true"),
				"NodeColor":    to.Ptr("green"),
				"SomeProperty": to.Ptr("5"),
			},
			VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
				{
					Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
					Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
						Type:                    to.Ptr("GenevaMonitoring"),
						AutoUpgradeMinorVersion: to.Ptr(true),
						Publisher:               to.Ptr("Microsoft.Azure.Geneva"),
						Settings:                map[string]any{},
						TypeHandlerVersion:      to.Ptr("2.0"),
					},
				}},
			VMImageOffer:     to.Ptr("WindowsServer"),
			VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
			VMImageSKU:       to.Ptr("2016-Datacenter-Server-Core"),
			VMImageVersion:   to.Ptr("latest"),
			VMInstanceCount:  to.Ptr[int32](-1),
			VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
				UserAssignedIdentities: []*string{
					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity"),
					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity2")},
			},
			VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
				{
					SourceVault: &armservicefabricmanagedclusters.SubResource{
						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
					},
					VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
						{
							CertificateStore: to.Ptr("My"),
							CertificateURL:   to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
						}},
				}},
			VMSize: to.Ptr("Standard_DS3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 			"ClientConnections": to.Ptr("65536"),
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(true),
	// 		MultiplePlacementGroups: to.Ptr(true),
	// 		PlacementProperties: map[string]*string{
	// 			"HasSSD": to.Ptr("true"),
	// 			"NodeColor": to.Ptr("green"),
	// 			"SomeProperty": to.Ptr("5"),
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
	// 			{
	// 				Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
	// 				Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
	// 					Type: to.Ptr("GenevaMonitoring"),
	// 					AutoUpgradeMinorVersion: to.Ptr(true),
	// 					ForceUpdateTag: to.Ptr("v.1.0"),
	// 					Publisher: to.Ptr("Microsoft.Azure.Geneva"),
	// 					Settings: map[string]any{
	// 					},
	// 					TypeHandlerVersion: to.Ptr("2.0"),
	// 				},
	// 		}},
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
	// 			UserAssignedIdentities: []*string{
	// 				to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity"),
	// 				to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity2")},
	// 			},
	// 			VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
	// 				{
	// 					SourceVault: &armservicefabricmanagedclusters.SubResource{
	// 						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
	// 					},
	// 					VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
	// 						{
	// 							CertificateStore: to.Ptr("My"),
	// 							CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
	// 					}},
	// 			}},
	// 			VMSize: to.Ptr("Standard_DS3"),
	// 		},
	// 		SKU: &armservicefabricmanagedclusters.NodeTypeSKU{
	// 			Name: to.Ptr("Standard_S2"),
	// 			Capacity: to.Ptr[int32](10),
	// 			Tier: to.Ptr("Standard"),
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperation_example_max.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putANodeTypeWithMaximumParameters() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE-testResourceGroup-testRegion-test", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			AdditionalDataDisks: []*armservicefabricmanagedclusters.VmssDataDisk{
				{
					DiskLetter: to.Ptr("F"),
					DiskSizeGB: to.Ptr[int32](256),
					DiskType:   to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
					Lun:        to.Ptr[int32](1),
				},
				{
					DiskLetter: to.Ptr("G"),
					DiskSizeGB: to.Ptr[int32](150),
					DiskType:   to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
					Lun:        to.Ptr[int32](2),
				}},
			AdditionalNetworkInterfaceConfigurations: []*armservicefabricmanagedclusters.AdditionalNetworkInterfaceConfiguration{
				{
					Name: to.Ptr("nic-1"),
					DscpConfiguration: &armservicefabricmanagedclusters.SubResource{
						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/dscpConfigurations/myDscpConfig"),
					},
					EnableAcceleratedNetworking: to.Ptr(true),
					IPConfigurations: []*armservicefabricmanagedclusters.IPConfiguration{
						{
							Name: to.Ptr("ipconfig-1"),
							ApplicationGatewayBackendAddressPools: []*armservicefabricmanagedclusters.SubResource{
								{
									ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/applicationGateways/appgw-test/backendAddressPools/appgwBepoolTest"),
								}},
							LoadBalancerBackendAddressPools: []*armservicefabricmanagedclusters.SubResource{
								{
									ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/backendAddressPools/LoadBalancerBEAddressPool"),
								}},
							LoadBalancerInboundNatPools: []*armservicefabricmanagedclusters.SubResource{
								{
									ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/inboundNatPools/LoadBalancerNATPool"),
								}},
							PrivateIPAddressVersion: to.Ptr(armservicefabricmanagedclusters.PrivateIPAddressVersionIPv4),
							PublicIPAddressConfiguration: &armservicefabricmanagedclusters.IPConfigurationPublicIPAddressConfiguration{
								Name: to.Ptr("publicip-1"),
								IPTags: []*armservicefabricmanagedclusters.IPTag{
									{
										IPTagType: to.Ptr("RoutingPreference"),
										Tag:       to.Ptr("Internet"),
									}},
								PublicIPAddressVersion: to.Ptr(armservicefabricmanagedclusters.PublicIPAddressVersionIPv4),
							},
							Subnet: &armservicefabricmanagedclusters.SubResource{
								ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
							},
						}},
				}},
			Capacities: map[string]*string{
				"ClientConnections": to.Ptr("65536"),
			},
			ComputerNamePrefix:          to.Ptr("BE"),
			DataDiskLetter:              to.Ptr("S"),
			DataDiskSizeGB:              to.Ptr[int32](200),
			DataDiskType:                to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
			DscpConfigurationID:         to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/dscpConfigurations/myDscpConfig"),
			EnableAcceleratedNetworking: to.Ptr(true),
			EnableEncryptionAtHost:      to.Ptr(true),
			EnableNodePublicIP:          to.Ptr(true),
			EnableNodePublicIPv6:        to.Ptr(true),
			EnableOverProvisioning:      to.Ptr(false),
			EvictionPolicy:              to.Ptr(armservicefabricmanagedclusters.EvictionPolicyTypeDeallocate),
			FrontendConfigurations: []*armservicefabricmanagedclusters.FrontendConfiguration{
				{
					ApplicationGatewayBackendAddressPoolID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/applicationGateways/appgw-test/backendAddressPools/appgwBepoolTest"),
					LoadBalancerBackendAddressPoolID:       to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/backendAddressPools/LoadBalancerBEAddressPool"),
					LoadBalancerInboundNatPoolID:           to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/inboundNatPools/LoadBalancerNATPool"),
				}},
			IsPrimary:               to.Ptr(false),
			IsSpotVM:                to.Ptr(true),
			IsStateless:             to.Ptr(true),
			MultiplePlacementGroups: to.Ptr(true),
			NatGatewayID:            to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/natGateways/myNatGateway"),
			PlacementProperties: map[string]*string{
				"HasSSD":       to.Ptr("true"),
				"NodeColor":    to.Ptr("green"),
				"SomeProperty": to.Ptr("5"),
			},
			SecureBootEnabled:            to.Ptr(true),
			SecurityType:                 to.Ptr(armservicefabricmanagedclusters.SecurityTypeTrustedLaunch),
			ServiceArtifactReferenceID:   to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Compute/galleries/myGallery/serviceArtifacts/myServiceArtifact/vmArtifactsProfiles/myVmArtifactProfile"),
			SpotRestoreTimeout:           to.Ptr("PT30M"),
			SubnetID:                     to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
			UseDefaultPublicLoadBalancer: to.Ptr(true),
			UseEphemeralOSDisk:           to.Ptr(true),
			VMApplications: []*armservicefabricmanagedclusters.VMApplication{
				{
					ConfigurationReference:          to.Ptr("https://mystorageaccount.blob.core.windows.net/containername/blobname"),
					EnableAutomaticUpgrade:          to.Ptr(true),
					Order:                           to.Ptr[int32](1),
					PackageReferenceID:              to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Compute/galleries/myGallery/applications/myApplication/versions/1.0.0"),
					TreatFailureAsDeploymentFailure: to.Ptr(false),
					VMGalleryTags:                   to.Ptr("{\"Tag1\":\"Value1\",\"Tag2\":\"Value2\"}"),
				}},
			VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
				{
					Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
					Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
						Type:                    to.Ptr("GenevaMonitoring"),
						AutoUpgradeMinorVersion: to.Ptr(true),
						EnableAutomaticUpgrade:  to.Ptr(true),
						ForceUpdateTag:          to.Ptr("v.1.0"),
						Publisher:               to.Ptr("Microsoft.Azure.Geneva"),
						Settings:                map[string]any{},
						SetupOrder: []*armservicefabricmanagedclusters.VmssExtensionSetupOrder{
							to.Ptr(armservicefabricmanagedclusters.VmssExtensionSetupOrderBeforeSFRuntime)},
						TypeHandlerVersion: to.Ptr("2.0"),
					},
				}},
			VMImageOffer:     to.Ptr("WindowsServer"),
			VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
			VMImageSKU:       to.Ptr("2016-Datacenter-Server-Core"),
			VMImageVersion:   to.Ptr("latest"),
			VMInstanceCount:  to.Ptr[int32](10),
			VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
				UserAssignedIdentities: []*string{
					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity"),
					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity2")},
			},
			VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
				{
					SourceVault: &armservicefabricmanagedclusters.SubResource{
						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
					},
					VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
						{
							CertificateStore: to.Ptr("My"),
							CertificateURL:   to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
						}},
				}},
			VMSetupActions: []*armservicefabricmanagedclusters.VMSetupAction{
				to.Ptr(armservicefabricmanagedclusters.VMSetupActionEnableContainers),
				to.Ptr(armservicefabricmanagedclusters.VMSetupActionEnableHyperV)},
			VMSize: to.Ptr("Standard_DS3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		AdditionalDataDisks: []*armservicefabricmanagedclusters.VmssDataDisk{
	// 			{
	// 				DiskLetter: to.Ptr("F"),
	// 				DiskSizeGB: to.Ptr[int32](256),
	// 				DiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 				Lun: to.Ptr[int32](1),
	// 			},
	// 			{
	// 				DiskLetter: to.Ptr("G"),
	// 				DiskSizeGB: to.Ptr[int32](150),
	// 				DiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
	// 				Lun: to.Ptr[int32](2),
	// 		}},
	// 		AdditionalNetworkInterfaceConfigurations: []*armservicefabricmanagedclusters.AdditionalNetworkInterfaceConfiguration{
	// 			{
	// 				Name: to.Ptr("nic-1"),
	// 				DscpConfiguration: &armservicefabricmanagedclusters.SubResource{
	// 					ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/dscpConfigurations/myDscpConfig"),
	// 				},
	// 				EnableAcceleratedNetworking: to.Ptr(true),
	// 				IPConfigurations: []*armservicefabricmanagedclusters.IPConfiguration{
	// 					{
	// 						Name: to.Ptr("ipconfig-1"),
	// 						ApplicationGatewayBackendAddressPools: []*armservicefabricmanagedclusters.SubResource{
	// 							{
	// 								ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/applicationGateways/appgw-test/backendAddressPools/appgwBepoolTest"),
	// 						}},
	// 						LoadBalancerBackendAddressPools: []*armservicefabricmanagedclusters.SubResource{
	// 							{
	// 								ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/backendAddressPools/LoadBalancerBEAddressPool"),
	// 						}},
	// 						LoadBalancerInboundNatPools: []*armservicefabricmanagedclusters.SubResource{
	// 							{
	// 								ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/inboundNatPools/LoadBalancerNATPool"),
	// 						}},
	// 						PrivateIPAddressVersion: to.Ptr(armservicefabricmanagedclusters.PrivateIPAddressVersionIPv4),
	// 						PublicIPAddressConfiguration: &armservicefabricmanagedclusters.IPConfigurationPublicIPAddressConfiguration{
	// 							Name: to.Ptr("publicip-1"),
	// 							IPTags: []*armservicefabricmanagedclusters.IPTag{
	// 								{
	// 									IPTagType: to.Ptr("RoutingPreference"),
	// 									Tag: to.Ptr("Internet"),
	// 							}},
	// 							PublicIPAddressVersion: to.Ptr(armservicefabricmanagedclusters.PublicIPAddressVersionIPv4),
	// 						},
	// 						Subnet: &armservicefabricmanagedclusters.SubResource{
	// 							ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 						},
	// 				}},
	// 		}},
	// 		Capacities: map[string]*string{
	// 			"ClientConnections": to.Ptr("65536"),
	// 		},
	// 		DataDiskLetter: to.Ptr("S"),
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypePremiumLRS),
	// 		DscpConfigurationID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/dscpConfigurations/myDscpConfig"),
	// 		EnableAcceleratedNetworking: to.Ptr(true),
	// 		EnableEncryptionAtHost: to.Ptr(true),
	// 		EnableNodePublicIP: to.Ptr(true),
	// 		EnableNodePublicIPv6: to.Ptr(true),
	// 		EnableOverProvisioning: to.Ptr(false),
	// 		EvictionPolicy: to.Ptr(armservicefabricmanagedclusters.EvictionPolicyTypeDeallocate),
	// 		FrontendConfigurations: []*armservicefabricmanagedclusters.FrontendConfiguration{
	// 			{
	// 				ApplicationGatewayBackendAddressPoolID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/applicationGateways/appgw-test/backendAddressPools/appgwBepoolTest"),
	// 				LoadBalancerBackendAddressPoolID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/backendAddressPools/LoadBalancerBEAddressPool"),
	// 				LoadBalancerInboundNatPoolID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/loadBalancers/test-LB/inboundNatPools/LoadBalancerNATPool"),
	// 		}},
	// 		IsPrimary: to.Ptr(false),
	// 		IsSpotVM: to.Ptr(true),
	// 		IsStateless: to.Ptr(true),
	// 		MultiplePlacementGroups: to.Ptr(true),
	// 		NatGatewayID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/natGateways/myNatGateway"),
	// 		PlacementProperties: map[string]*string{
	// 			"HasSSD": to.Ptr("true"),
	// 			"NodeColor": to.Ptr("green"),
	// 			"SomeProperty": to.Ptr("5"),
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		SecureBootEnabled: to.Ptr(true),
	// 		SecurityType: to.Ptr(armservicefabricmanagedclusters.SecurityTypeTrustedLaunch),
	// 		ServiceArtifactReferenceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Compute/galleries/myGallery/serviceArtifacts/myServiceArtifact/vmArtifactsProfiles/myVmArtifactProfile"),
	// 		SpotRestoreTimeout: to.Ptr("PT30M"),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		UseDefaultPublicLoadBalancer: to.Ptr(true),
	// 		UseEphemeralOSDisk: to.Ptr(true),
	// 		VMApplications: []*armservicefabricmanagedclusters.VMApplication{
	// 			{
	// 				ConfigurationReference: to.Ptr("https://mystorageaccount.blob.core.windows.net/containername/blobname"),
	// 				EnableAutomaticUpgrade: to.Ptr(true),
	// 				Order: to.Ptr[int32](1),
	// 				PackageReferenceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.Compute/galleries/myGallery/applications/myApplication/versions/1.0.0"),
	// 				TreatFailureAsDeploymentFailure: to.Ptr(false),
	// 				VMGalleryTags: to.Ptr("{\"Tag1\":\"Value1\",\"Tag2\":\"Value2\"}"),
	// 		}},
	// 		VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
	// 			{
	// 				Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
	// 				Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
	// 					Type: to.Ptr("GenevaMonitoring"),
	// 					AutoUpgradeMinorVersion: to.Ptr(true),
	// 					EnableAutomaticUpgrade: to.Ptr(true),
	// 					ForceUpdateTag: to.Ptr("v.1.0"),
	// 					Publisher: to.Ptr("Microsoft.Azure.Geneva"),
	// 					Settings: map[string]any{
	// 					},
	// 					SetupOrder: []*armservicefabricmanagedclusters.VmssExtensionSetupOrder{
	// 						to.Ptr(armservicefabricmanagedclusters.VmssExtensionSetupOrderBeforeSFRuntime)},
	// 						TypeHandlerVersion: to.Ptr("2.0"),
	// 					},
	// 			}},
	// 			VMImageOffer: to.Ptr("WindowsServer"),
	// 			VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 			VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 			VMImageVersion: to.Ptr("latest"),
	// 			VMInstanceCount: to.Ptr[int32](10),
	// 			VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
	// 				UserAssignedIdentities: []*string{
	// 					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity"),
	// 					to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity2")},
	// 				},
	// 				VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
	// 					{
	// 						SourceVault: &armservicefabricmanagedclusters.SubResource{
	// 							ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
	// 						},
	// 						VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
	// 							{
	// 								CertificateStore: to.Ptr("My"),
	// 								CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
	// 						}},
	// 				}},
	// 				VMSetupActions: []*armservicefabricmanagedclusters.VMSetupAction{
	// 					to.Ptr(armservicefabricmanagedclusters.VMSetupActionEnableContainers),
	// 					to.Ptr(armservicefabricmanagedclusters.VMSetupActionEnableHyperV)},
	// 					VMSize: to.Ptr("Standard_DS3"),
	// 					Zones: []*string{
	// 						to.Ptr("1"),
	// 						to.Ptr("2"),
	// 						to.Ptr("3")},
	// 					},
	// 				}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperation_example_min.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putANodeTypeWithMinimumParameters() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			DataDiskSizeGB:   to.Ptr[int32](200),
			IsPrimary:        to.Ptr(false),
			VMImageOffer:     to.Ptr("WindowsServer"),
			VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
			VMImageSKU:       to.Ptr("2016-Datacenter-Server-Core"),
			VMImageVersion:   to.Ptr("latest"),
			VMInstanceCount:  to.Ptr[int32](10),
			VMSize:           to.Ptr("Standard_D3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSize: to.Ptr("Standard_D3"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationStateless_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putAnStatelessNodeTypeWithTemporaryDiskForServiceFabric() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			EnableEncryptionAtHost:  to.Ptr(true),
			IsPrimary:               to.Ptr(false),
			IsStateless:             to.Ptr(true),
			MultiplePlacementGroups: to.Ptr(true),
			UseTempDataDisk:         to.Ptr(true),
			VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
				{
					Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
					Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
						Type:                    to.Ptr("GenevaMonitoring"),
						AutoUpgradeMinorVersion: to.Ptr(true),
						Publisher:               to.Ptr("Microsoft.Azure.Geneva"),
						Settings:                map[string]any{},
						TypeHandlerVersion:      to.Ptr("2.0"),
					},
				}},
			VMImageOffer:     to.Ptr("WindowsServer"),
			VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
			VMImageSKU:       to.Ptr("2016-Datacenter-Server-Core"),
			VMImageVersion:   to.Ptr("latest"),
			VMInstanceCount:  to.Ptr[int32](10),
			VMSize:           to.Ptr("Standard_DS3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		EnableEncryptionAtHost: to.Ptr(true),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(true),
	// 		MultiplePlacementGroups: to.Ptr(true),
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		UseTempDataDisk: to.Ptr(true),
	// 		VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
	// 			{
	// 				Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
	// 				Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
	// 					Type: to.Ptr("GenevaMonitoring"),
	// 					AutoUpgradeMinorVersion: to.Ptr(true),
	// 					Publisher: to.Ptr("Microsoft.Azure.Geneva"),
	// 					Settings: map[string]any{
	// 					},
	// 					TypeHandlerVersion: to.Ptr("2.0"),
	// 				},
	// 		}},
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSize: to.Ptr("Standard_DS3"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationCustomImage_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putNodeTypeWithCustomVmImage() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			DataDiskSizeGB:    to.Ptr[int32](200),
			IsPrimary:         to.Ptr(false),
			VMImageResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/test-custom-image/providers/Microsoft.Compute/galleries/myCustomImages/images/Win2019DC"),
			VMInstanceCount:   to.Ptr[int32](10),
			VMSize:            to.Ptr("Standard_D3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMImageResourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/test-custom-image/providers/Microsoft.Compute/galleries/myCustomImages/images/Win2019DC"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSize: to.Ptr("Standard_D3"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationDedicatedHost_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putNodeTypeWithDedicatedHosts() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			Capacities:          map[string]*string{},
			DataDiskSizeGB:      to.Ptr[int32](200),
			DataDiskType:        to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
			HostGroupID:         to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/testhostgroupRG/providers/Microsoft.Compute/hostGroups/testHostGroup"),
			IsPrimary:           to.Ptr(false),
			PlacementProperties: map[string]*string{},
			VMImageOffer:        to.Ptr("WindowsServer"),
			VMImagePublisher:    to.Ptr("MicrosoftWindowsServer"),
			VMImageSKU:          to.Ptr("2019-Datacenter"),
			VMImageVersion:      to.Ptr("latest"),
			VMInstanceCount:     to.Ptr[int32](10),
			VMSize:              to.Ptr("Standard_D8s_v3"),
			Zones: []*string{
				to.Ptr("1")},
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		HostGroupID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/testhostgroupRG/providers/Microsoft.Compute/hostGroups/testHostGroup"),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2019-Datacenter"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSize: to.Ptr("Standard_D8s_v3"),
	// 		Zones: []*string{
	// 			to.Ptr("1")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationCustomSharedGalleriesImage_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putNodeTypeWithSharedGalleriesCustomVmImage() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			DataDiskSizeGB:         to.Ptr[int32](200),
			IsPrimary:              to.Ptr(false),
			VMInstanceCount:        to.Ptr[int32](10),
			VMSharedGalleryImageID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/test-custom-image/providers/Microsoft.Compute/sharedGalleries/35349201-a0b3-405e-8a23-9f1450984307-SFSHAREDGALLERY/images/TestNoProdContainerDImage/versions/latest"),
			VMSize:                 to.Ptr("Standard_D3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSharedGalleryImageID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/test-custom-image/providers/Microsoft.Compute/sharedGalleries/35349201-a0b3-405e-8a23-9f1450984307-SFSHAREDGALLERY/images/TestNoProdContainerDImage/versions/latest"),
	// 		VMSize: to.Ptr("Standard_D3"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePutOperationVmImagePlan_example.json
func ExampleNodeTypesClient_BeginCreateOrUpdate_putNodeTypeWithVmImagePlan() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginCreateOrUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeType{
		Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
			DataDiskSizeGB: to.Ptr[int32](200),
			IsPrimary:      to.Ptr(false),
			VMImageOffer:   to.Ptr("windows_2022_test"),
			VMImagePlan: &armservicefabricmanagedclusters.VMImagePlan{
				Name:      to.Ptr("win_2022_test_20_10_gen2"),
				Product:   to.Ptr("windows_2022_test"),
				Publisher: to.Ptr("testpublisher"),
			},
			VMImagePublisher: to.Ptr("testpublisher"),
			VMImageSKU:       to.Ptr("win_2022_test_20_10_gen2"),
			VMImageVersion:   to.Ptr("latest"),
			VMInstanceCount:  to.Ptr[int32](10),
			VMSize:           to.Ptr("Standard_D3"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMImageOffer: to.Ptr("windows_2022_test"),
	// 		VMImagePlan: &armservicefabricmanagedclusters.VMImagePlan{
	// 			Name: to.Ptr("win_2022_test_20_10_gen2"),
	// 			Product: to.Ptr("windows_2022_test"),
	// 			Publisher: to.Ptr("testpublisher"),
	// 		},
	// 		VMImagePublisher: to.Ptr("testpublisher"),
	// 		VMImageSKU: to.Ptr("win_2022_test_20_10_gen2"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMSize: to.Ptr("Standard_D3"),
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePatchOperation_example.json
func ExampleNodeTypesClient_BeginUpdate_patchANodeType() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeUpdateParameters{
		Tags: map[string]*string{
			"a": to.Ptr("b"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 		"a": to.Ptr("b"),
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 			"ClientConnections": to.Ptr("65536"),
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 			"HasSSD": to.Ptr("true"),
	// 			"NodeColor": to.Ptr("green"),
	// 			"SomeProperty": to.Ptr("5"),
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
	// 			{
	// 				Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
	// 				Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
	// 					Type: to.Ptr("GenevaMonitoring"),
	// 					AutoUpgradeMinorVersion: to.Ptr(true),
	// 					Publisher: to.Ptr("Microsoft.Azure.Geneva"),
	// 					Settings: map[string]any{
	// 					},
	// 					TypeHandlerVersion: to.Ptr("2.0"),
	// 				},
	// 		}},
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
	// 			UserAssignedIdentities: []*string{
	// 				to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity")},
	// 			},
	// 			VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
	// 				{
	// 					SourceVault: &armservicefabricmanagedclusters.SubResource{
	// 						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
	// 					},
	// 					VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
	// 						{
	// 							CertificateStore: to.Ptr("My"),
	// 							CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
	// 					}},
	// 			}},
	// 			VMSize: to.Ptr("Standard_D3"),
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypePatchOperationAutoScale_example.json
func ExampleNodeTypesClient_BeginUpdate_patchANodeTypeWhileAutoScaling() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginUpdate(ctx, "resRg", "myCluster", "BE", armservicefabricmanagedclusters.NodeTypeUpdateParameters{
		SKU: &armservicefabricmanagedclusters.NodeTypeSKU{
			Name:     to.Ptr("Standard_S0"),
			Capacity: to.Ptr[int32](10),
			Tier:     to.Ptr("Standard"),
		},
		Tags: map[string]*string{
			"a": to.Ptr("b"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.NodeType = armservicefabricmanagedclusters.NodeType{
	// 	Name: to.Ptr("BE"),
	// 	Type: to.Ptr("Microsoft.ServiceFabric/managedClusters/nodeTypes"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourcegroups/resRg/providers/Microsoft.ServiceFabric/managedClusters/myCluster/nodeTypes/BE"),
	// 	Tags: map[string]*string{
	// 		"a": to.Ptr("b"),
	// 	},
	// 	Properties: &armservicefabricmanagedclusters.NodeTypeProperties{
	// 		Capacities: map[string]*string{
	// 			"ClientConnections": to.Ptr("65536"),
	// 		},
	// 		DataDiskSizeGB: to.Ptr[int32](200),
	// 		DataDiskType: to.Ptr(armservicefabricmanagedclusters.DiskTypeStandardSSDLRS),
	// 		IsPrimary: to.Ptr(false),
	// 		IsStateless: to.Ptr(false),
	// 		PlacementProperties: map[string]*string{
	// 			"HasSSD": to.Ptr("true"),
	// 			"NodeColor": to.Ptr("green"),
	// 			"SomeProperty": to.Ptr("5"),
	// 		},
	// 		ProvisioningState: to.Ptr(armservicefabricmanagedclusters.ManagedResourceProvisioningStateSucceeded),
	// 		VMExtensions: []*armservicefabricmanagedclusters.VMSSExtension{
	// 			{
	// 				Name: to.Ptr("Microsoft.Azure.Geneva.GenevaMonitoring"),
	// 				Properties: &armservicefabricmanagedclusters.VMSSExtensionProperties{
	// 					Type: to.Ptr("GenevaMonitoring"),
	// 					AutoUpgradeMinorVersion: to.Ptr(true),
	// 					Publisher: to.Ptr("Microsoft.Azure.Geneva"),
	// 					Settings: map[string]any{
	// 					},
	// 					TypeHandlerVersion: to.Ptr("2.0"),
	// 				},
	// 		}},
	// 		VMImageOffer: to.Ptr("WindowsServer"),
	// 		VMImagePublisher: to.Ptr("MicrosoftWindowsServer"),
	// 		VMImageSKU: to.Ptr("2016-Datacenter-Server-Core"),
	// 		VMImageVersion: to.Ptr("latest"),
	// 		VMInstanceCount: to.Ptr[int32](10),
	// 		VMManagedIdentity: &armservicefabricmanagedclusters.VMManagedIdentity{
	// 			UserAssignedIdentities: []*string{
	// 				to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myIdentity")},
	// 			},
	// 			VMSecrets: []*armservicefabricmanagedclusters.VaultSecretGroup{
	// 				{
	// 					SourceVault: &armservicefabricmanagedclusters.SubResource{
	// 						ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resRg/providers/Microsoft.KeyVault/vaults/myVault"),
	// 					},
	// 					VaultCertificates: []*armservicefabricmanagedclusters.VaultCertificate{
	// 						{
	// 							CertificateStore: to.Ptr("My"),
	// 							CertificateURL: to.Ptr("https://myVault.vault.azure.net:443/secrets/myCert/ef1a31d39e1f46bca33def54b6cda54c"),
	// 					}},
	// 			}},
	// 			VMSize: to.Ptr("Standard_D3"),
	// 		},
	// 		SKU: &armservicefabricmanagedclusters.NodeTypeSKU{
	// 			Name: to.Ptr("Standard_S0"),
	// 			Capacity: to.Ptr[int32](10),
	// 			Tier: to.Ptr("Standard"),
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/069a65e8a6d1a6c0c58d9a9d97610b7103b6e8a5/specification/servicefabricmanagedclusters/resource-manager/Microsoft.ServiceFabric/preview/2024-09-01-preview/examples/NodeTypeDeleteOperation_example.json
func ExampleNodeTypesClient_BeginDelete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armservicefabricmanagedclusters.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewNodeTypesClient().BeginDelete(ctx, "resRg", "myCluster", "BE", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}
