//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsignalr

// ClientCheckNameAvailabilityResponse contains the response from method Client.CheckNameAvailability.
type ClientCheckNameAvailabilityResponse struct {
	// Result of the request to check name availability. It contains a flag and possible reason of failure.
	NameAvailability
}

// ClientCreateOrUpdateResponse contains the response from method Client.BeginCreateOrUpdate.
type ClientCreateOrUpdateResponse struct {
	// A class represent a resource.
	ResourceInfo
}

// ClientDeleteResponse contains the response from method Client.BeginDelete.
type ClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	// A class represent a resource.
	ResourceInfo
}

// ClientListByResourceGroupResponse contains the response from method Client.NewListByResourceGroupPager.
type ClientListByResourceGroupResponse struct {
	// Object that includes an array of resources and a possible link for next set.
	ResourceInfoList
}

// ClientListBySubscriptionResponse contains the response from method Client.NewListBySubscriptionPager.
type ClientListBySubscriptionResponse struct {
	// Object that includes an array of resources and a possible link for next set.
	ResourceInfoList
}

// ClientListKeysResponse contains the response from method Client.ListKeys.
type ClientListKeysResponse struct {
	// A class represents the access keys of the resource.
	Keys
}

// ClientListReplicaSKUsResponse contains the response from method Client.ListReplicaSKUs.
type ClientListReplicaSKUsResponse struct {
	// The list skus operation response
	SKUList
}

// ClientListSKUsResponse contains the response from method Client.ListSKUs.
type ClientListSKUsResponse struct {
	// The list skus operation response
	SKUList
}

// ClientRegenerateKeyResponse contains the response from method Client.BeginRegenerateKey.
type ClientRegenerateKeyResponse struct {
	// A class represents the access keys of the resource.
	Keys
}

// ClientRestartResponse contains the response from method Client.BeginRestart.
type ClientRestartResponse struct {
	// placeholder for future response values
}

// ClientUpdateResponse contains the response from method Client.BeginUpdate.
type ClientUpdateResponse struct {
	// A class represent a resource.
	ResourceInfo
}

// CustomCertificatesClientCreateOrUpdateResponse contains the response from method CustomCertificatesClient.BeginCreateOrUpdate.
type CustomCertificatesClientCreateOrUpdateResponse struct {
	// A custom certificate.
	CustomCertificate
}

// CustomCertificatesClientDeleteResponse contains the response from method CustomCertificatesClient.Delete.
type CustomCertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomCertificatesClientGetResponse contains the response from method CustomCertificatesClient.Get.
type CustomCertificatesClientGetResponse struct {
	// A custom certificate.
	CustomCertificate
}

// CustomCertificatesClientListResponse contains the response from method CustomCertificatesClient.NewListPager.
type CustomCertificatesClientListResponse struct {
	// Custom certificates list.
	CustomCertificateList
}

// CustomDomainsClientCreateOrUpdateResponse contains the response from method CustomDomainsClient.BeginCreateOrUpdate.
type CustomDomainsClientCreateOrUpdateResponse struct {
	// A custom domain
	CustomDomain
}

// CustomDomainsClientDeleteResponse contains the response from method CustomDomainsClient.BeginDelete.
type CustomDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomDomainsClientGetResponse contains the response from method CustomDomainsClient.Get.
type CustomDomainsClientGetResponse struct {
	// A custom domain
	CustomDomain
}

// CustomDomainsClientListResponse contains the response from method CustomDomainsClient.NewListPager.
type CustomDomainsClientListResponse struct {
	// Custom domains list
	CustomDomainList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list REST API operations. It contains a list of operations.
	OperationList
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// A private endpoint connection to an azure resource
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// A list of private endpoint connections
	PrivateEndpointConnectionList
}

// PrivateEndpointConnectionsClientUpdateResponse contains the response from method PrivateEndpointConnectionsClient.Update.
type PrivateEndpointConnectionsClientUpdateResponse struct {
	// A private endpoint connection to an azure resource
	PrivateEndpointConnection
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.NewListPager.
type PrivateLinkResourcesClientListResponse struct {
	// Contains a list of PrivateLinkResource and a possible link to query more results
	PrivateLinkResourceList
}

// ReplicasClientCreateOrUpdateResponse contains the response from method ReplicasClient.BeginCreateOrUpdate.
type ReplicasClientCreateOrUpdateResponse struct {
	// A class represent a replica resource.
	Replica
}

// ReplicasClientDeleteResponse contains the response from method ReplicasClient.Delete.
type ReplicasClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicasClientGetResponse contains the response from method ReplicasClient.Get.
type ReplicasClientGetResponse struct {
	// A class represent a replica resource.
	Replica
}

// ReplicasClientListResponse contains the response from method ReplicasClient.NewListPager.
type ReplicasClientListResponse struct {
	ReplicaList
}

// ReplicasClientRestartResponse contains the response from method ReplicasClient.BeginRestart.
type ReplicasClientRestartResponse struct {
	// placeholder for future response values
}

// ReplicasClientUpdateResponse contains the response from method ReplicasClient.BeginUpdate.
type ReplicasClientUpdateResponse struct {
	// A class represent a replica resource.
	Replica
}

// SharedPrivateLinkResourcesClientCreateOrUpdateResponse contains the response from method SharedPrivateLinkResourcesClient.BeginCreateOrUpdate.
type SharedPrivateLinkResourcesClientCreateOrUpdateResponse struct {
	// Describes a Shared Private Link Resource
	SharedPrivateLinkResource
}

// SharedPrivateLinkResourcesClientDeleteResponse contains the response from method SharedPrivateLinkResourcesClient.BeginDelete.
type SharedPrivateLinkResourcesClientDeleteResponse struct {
	// placeholder for future response values
}

// SharedPrivateLinkResourcesClientGetResponse contains the response from method SharedPrivateLinkResourcesClient.Get.
type SharedPrivateLinkResourcesClientGetResponse struct {
	// Describes a Shared Private Link Resource
	SharedPrivateLinkResource
}

// SharedPrivateLinkResourcesClientListResponse contains the response from method SharedPrivateLinkResourcesClient.NewListPager.
type SharedPrivateLinkResourcesClientListResponse struct {
	// A list of shared private link resources
	SharedPrivateLinkResourceList
}

// UsagesClientListResponse contains the response from method UsagesClient.NewListPager.
type UsagesClientListResponse struct {
	// Object that includes an array of the resource usages and a possible link for next set.
	UsageList
}
