//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsql

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The subscription ID that identifies an Azure subscription.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewAgentClient creates a new instance of AgentClient.
func (c *ClientFactory) NewAgentClient() *AgentClient {
	return &AgentClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewBackupShortTermRetentionPoliciesClient creates a new instance of BackupShortTermRetentionPoliciesClient.
func (c *ClientFactory) NewBackupShortTermRetentionPoliciesClient() *BackupShortTermRetentionPoliciesClient {
	return &BackupShortTermRetentionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCapabilitiesClient creates a new instance of CapabilitiesClient.
func (c *ClientFactory) NewCapabilitiesClient() *CapabilitiesClient {
	return &CapabilitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDataMaskingPoliciesClient creates a new instance of DataMaskingPoliciesClient.
func (c *ClientFactory) NewDataMaskingPoliciesClient() *DataMaskingPoliciesClient {
	return &DataMaskingPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDataMaskingRulesClient creates a new instance of DataMaskingRulesClient.
func (c *ClientFactory) NewDataMaskingRulesClient() *DataMaskingRulesClient {
	return &DataMaskingRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDataWarehouseUserActivitiesClient creates a new instance of DataWarehouseUserActivitiesClient.
func (c *ClientFactory) NewDataWarehouseUserActivitiesClient() *DataWarehouseUserActivitiesClient {
	return &DataWarehouseUserActivitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseAdvancedThreatProtectionSettingsClient creates a new instance of DatabaseAdvancedThreatProtectionSettingsClient.
func (c *ClientFactory) NewDatabaseAdvancedThreatProtectionSettingsClient() *DatabaseAdvancedThreatProtectionSettingsClient {
	return &DatabaseAdvancedThreatProtectionSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseAdvisorsClient creates a new instance of DatabaseAdvisorsClient.
func (c *ClientFactory) NewDatabaseAdvisorsClient() *DatabaseAdvisorsClient {
	return &DatabaseAdvisorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseAutomaticTuningClient creates a new instance of DatabaseAutomaticTuningClient.
func (c *ClientFactory) NewDatabaseAutomaticTuningClient() *DatabaseAutomaticTuningClient {
	return &DatabaseAutomaticTuningClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseBlobAuditingPoliciesClient creates a new instance of DatabaseBlobAuditingPoliciesClient.
func (c *ClientFactory) NewDatabaseBlobAuditingPoliciesClient() *DatabaseBlobAuditingPoliciesClient {
	return &DatabaseBlobAuditingPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseColumnsClient creates a new instance of DatabaseColumnsClient.
func (c *ClientFactory) NewDatabaseColumnsClient() *DatabaseColumnsClient {
	return &DatabaseColumnsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseEncryptionProtectorsClient creates a new instance of DatabaseEncryptionProtectorsClient.
func (c *ClientFactory) NewDatabaseEncryptionProtectorsClient() *DatabaseEncryptionProtectorsClient {
	return &DatabaseEncryptionProtectorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseExtensionsClient creates a new instance of DatabaseExtensionsClient.
func (c *ClientFactory) NewDatabaseExtensionsClient() *DatabaseExtensionsClient {
	return &DatabaseExtensionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseOperationsClient creates a new instance of DatabaseOperationsClient.
func (c *ClientFactory) NewDatabaseOperationsClient() *DatabaseOperationsClient {
	return &DatabaseOperationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseRecommendedActionsClient creates a new instance of DatabaseRecommendedActionsClient.
func (c *ClientFactory) NewDatabaseRecommendedActionsClient() *DatabaseRecommendedActionsClient {
	return &DatabaseRecommendedActionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentBaselinesClient creates a new instance of DatabaseSQLVulnerabilityAssessmentBaselinesClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentBaselinesClient() *DatabaseSQLVulnerabilityAssessmentBaselinesClient {
	return &DatabaseSQLVulnerabilityAssessmentBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentExecuteScanClient creates a new instance of DatabaseSQLVulnerabilityAssessmentExecuteScanClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentExecuteScanClient() *DatabaseSQLVulnerabilityAssessmentExecuteScanClient {
	return &DatabaseSQLVulnerabilityAssessmentExecuteScanClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentRuleBaselinesClient creates a new instance of DatabaseSQLVulnerabilityAssessmentRuleBaselinesClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentRuleBaselinesClient() *DatabaseSQLVulnerabilityAssessmentRuleBaselinesClient {
	return &DatabaseSQLVulnerabilityAssessmentRuleBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentScanResultClient creates a new instance of DatabaseSQLVulnerabilityAssessmentScanResultClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentScanResultClient() *DatabaseSQLVulnerabilityAssessmentScanResultClient {
	return &DatabaseSQLVulnerabilityAssessmentScanResultClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentScansClient creates a new instance of DatabaseSQLVulnerabilityAssessmentScansClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentScansClient() *DatabaseSQLVulnerabilityAssessmentScansClient {
	return &DatabaseSQLVulnerabilityAssessmentScansClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSQLVulnerabilityAssessmentsSettingsClient creates a new instance of DatabaseSQLVulnerabilityAssessmentsSettingsClient.
func (c *ClientFactory) NewDatabaseSQLVulnerabilityAssessmentsSettingsClient() *DatabaseSQLVulnerabilityAssessmentsSettingsClient {
	return &DatabaseSQLVulnerabilityAssessmentsSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSchemasClient creates a new instance of DatabaseSchemasClient.
func (c *ClientFactory) NewDatabaseSchemasClient() *DatabaseSchemasClient {
	return &DatabaseSchemasClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseSecurityAlertPoliciesClient creates a new instance of DatabaseSecurityAlertPoliciesClient.
func (c *ClientFactory) NewDatabaseSecurityAlertPoliciesClient() *DatabaseSecurityAlertPoliciesClient {
	return &DatabaseSecurityAlertPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseTablesClient creates a new instance of DatabaseTablesClient.
func (c *ClientFactory) NewDatabaseTablesClient() *DatabaseTablesClient {
	return &DatabaseTablesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseUsagesClient creates a new instance of DatabaseUsagesClient.
func (c *ClientFactory) NewDatabaseUsagesClient() *DatabaseUsagesClient {
	return &DatabaseUsagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseVulnerabilityAssessmentRuleBaselinesClient creates a new instance of DatabaseVulnerabilityAssessmentRuleBaselinesClient.
func (c *ClientFactory) NewDatabaseVulnerabilityAssessmentRuleBaselinesClient() *DatabaseVulnerabilityAssessmentRuleBaselinesClient {
	return &DatabaseVulnerabilityAssessmentRuleBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseVulnerabilityAssessmentScansClient creates a new instance of DatabaseVulnerabilityAssessmentScansClient.
func (c *ClientFactory) NewDatabaseVulnerabilityAssessmentScansClient() *DatabaseVulnerabilityAssessmentScansClient {
	return &DatabaseVulnerabilityAssessmentScansClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabaseVulnerabilityAssessmentsClient creates a new instance of DatabaseVulnerabilityAssessmentsClient.
func (c *ClientFactory) NewDatabaseVulnerabilityAssessmentsClient() *DatabaseVulnerabilityAssessmentsClient {
	return &DatabaseVulnerabilityAssessmentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatabasesClient creates a new instance of DatabasesClient.
func (c *ClientFactory) NewDatabasesClient() *DatabasesClient {
	return &DatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDeletedServersClient creates a new instance of DeletedServersClient.
func (c *ClientFactory) NewDeletedServersClient() *DeletedServersClient {
	return &DeletedServersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDistributedAvailabilityGroupsClient creates a new instance of DistributedAvailabilityGroupsClient.
func (c *ClientFactory) NewDistributedAvailabilityGroupsClient() *DistributedAvailabilityGroupsClient {
	return &DistributedAvailabilityGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewElasticPoolActivitiesClient creates a new instance of ElasticPoolActivitiesClient.
func (c *ClientFactory) NewElasticPoolActivitiesClient() *ElasticPoolActivitiesClient {
	return &ElasticPoolActivitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewElasticPoolDatabaseActivitiesClient creates a new instance of ElasticPoolDatabaseActivitiesClient.
func (c *ClientFactory) NewElasticPoolDatabaseActivitiesClient() *ElasticPoolDatabaseActivitiesClient {
	return &ElasticPoolDatabaseActivitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewElasticPoolOperationsClient creates a new instance of ElasticPoolOperationsClient.
func (c *ClientFactory) NewElasticPoolOperationsClient() *ElasticPoolOperationsClient {
	return &ElasticPoolOperationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewElasticPoolsClient creates a new instance of ElasticPoolsClient.
func (c *ClientFactory) NewElasticPoolsClient() *ElasticPoolsClient {
	return &ElasticPoolsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewEncryptionProtectorsClient creates a new instance of EncryptionProtectorsClient.
func (c *ClientFactory) NewEncryptionProtectorsClient() *EncryptionProtectorsClient {
	return &EncryptionProtectorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewEndpointCertificatesClient creates a new instance of EndpointCertificatesClient.
func (c *ClientFactory) NewEndpointCertificatesClient() *EndpointCertificatesClient {
	return &EndpointCertificatesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewExtendedDatabaseBlobAuditingPoliciesClient creates a new instance of ExtendedDatabaseBlobAuditingPoliciesClient.
func (c *ClientFactory) NewExtendedDatabaseBlobAuditingPoliciesClient() *ExtendedDatabaseBlobAuditingPoliciesClient {
	return &ExtendedDatabaseBlobAuditingPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewExtendedServerBlobAuditingPoliciesClient creates a new instance of ExtendedServerBlobAuditingPoliciesClient.
func (c *ClientFactory) NewExtendedServerBlobAuditingPoliciesClient() *ExtendedServerBlobAuditingPoliciesClient {
	return &ExtendedServerBlobAuditingPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewFailoverGroupsClient creates a new instance of FailoverGroupsClient.
func (c *ClientFactory) NewFailoverGroupsClient() *FailoverGroupsClient {
	return &FailoverGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewFirewallRulesClient creates a new instance of FirewallRulesClient.
func (c *ClientFactory) NewFirewallRulesClient() *FirewallRulesClient {
	return &FirewallRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewGeoBackupPoliciesClient creates a new instance of GeoBackupPoliciesClient.
func (c *ClientFactory) NewGeoBackupPoliciesClient() *GeoBackupPoliciesClient {
	return &GeoBackupPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewIPv6FirewallRulesClient creates a new instance of IPv6FirewallRulesClient.
func (c *ClientFactory) NewIPv6FirewallRulesClient() *IPv6FirewallRulesClient {
	return &IPv6FirewallRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewInstanceFailoverGroupsClient creates a new instance of InstanceFailoverGroupsClient.
func (c *ClientFactory) NewInstanceFailoverGroupsClient() *InstanceFailoverGroupsClient {
	return &InstanceFailoverGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewInstancePoolsClient creates a new instance of InstancePoolsClient.
func (c *ClientFactory) NewInstancePoolsClient() *InstancePoolsClient {
	return &InstancePoolsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobAgentsClient creates a new instance of JobAgentsClient.
func (c *ClientFactory) NewJobAgentsClient() *JobAgentsClient {
	return &JobAgentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobCredentialsClient creates a new instance of JobCredentialsClient.
func (c *ClientFactory) NewJobCredentialsClient() *JobCredentialsClient {
	return &JobCredentialsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobExecutionsClient creates a new instance of JobExecutionsClient.
func (c *ClientFactory) NewJobExecutionsClient() *JobExecutionsClient {
	return &JobExecutionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobPrivateEndpointsClient creates a new instance of JobPrivateEndpointsClient.
func (c *ClientFactory) NewJobPrivateEndpointsClient() *JobPrivateEndpointsClient {
	return &JobPrivateEndpointsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobStepExecutionsClient creates a new instance of JobStepExecutionsClient.
func (c *ClientFactory) NewJobStepExecutionsClient() *JobStepExecutionsClient {
	return &JobStepExecutionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobStepsClient creates a new instance of JobStepsClient.
func (c *ClientFactory) NewJobStepsClient() *JobStepsClient {
	return &JobStepsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobTargetExecutionsClient creates a new instance of JobTargetExecutionsClient.
func (c *ClientFactory) NewJobTargetExecutionsClient() *JobTargetExecutionsClient {
	return &JobTargetExecutionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobTargetGroupsClient creates a new instance of JobTargetGroupsClient.
func (c *ClientFactory) NewJobTargetGroupsClient() *JobTargetGroupsClient {
	return &JobTargetGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobVersionsClient creates a new instance of JobVersionsClient.
func (c *ClientFactory) NewJobVersionsClient() *JobVersionsClient {
	return &JobVersionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewJobsClient creates a new instance of JobsClient.
func (c *ClientFactory) NewJobsClient() *JobsClient {
	return &JobsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLedgerDigestUploadsClient creates a new instance of LedgerDigestUploadsClient.
func (c *ClientFactory) NewLedgerDigestUploadsClient() *LedgerDigestUploadsClient {
	return &LedgerDigestUploadsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLongTermRetentionBackupsClient creates a new instance of LongTermRetentionBackupsClient.
func (c *ClientFactory) NewLongTermRetentionBackupsClient() *LongTermRetentionBackupsClient {
	return &LongTermRetentionBackupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLongTermRetentionManagedInstanceBackupsClient creates a new instance of LongTermRetentionManagedInstanceBackupsClient.
func (c *ClientFactory) NewLongTermRetentionManagedInstanceBackupsClient() *LongTermRetentionManagedInstanceBackupsClient {
	return &LongTermRetentionManagedInstanceBackupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLongTermRetentionPoliciesClient creates a new instance of LongTermRetentionPoliciesClient.
func (c *ClientFactory) NewLongTermRetentionPoliciesClient() *LongTermRetentionPoliciesClient {
	return &LongTermRetentionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewMaintenanceWindowOptionsClient creates a new instance of MaintenanceWindowOptionsClient.
func (c *ClientFactory) NewMaintenanceWindowOptionsClient() *MaintenanceWindowOptionsClient {
	return &MaintenanceWindowOptionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewMaintenanceWindowsClient creates a new instance of MaintenanceWindowsClient.
func (c *ClientFactory) NewMaintenanceWindowsClient() *MaintenanceWindowsClient {
	return &MaintenanceWindowsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedBackupShortTermRetentionPoliciesClient creates a new instance of ManagedBackupShortTermRetentionPoliciesClient.
func (c *ClientFactory) NewManagedBackupShortTermRetentionPoliciesClient() *ManagedBackupShortTermRetentionPoliciesClient {
	return &ManagedBackupShortTermRetentionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseAdvancedThreatProtectionSettingsClient creates a new instance of ManagedDatabaseAdvancedThreatProtectionSettingsClient.
func (c *ClientFactory) NewManagedDatabaseAdvancedThreatProtectionSettingsClient() *ManagedDatabaseAdvancedThreatProtectionSettingsClient {
	return &ManagedDatabaseAdvancedThreatProtectionSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseColumnsClient creates a new instance of ManagedDatabaseColumnsClient.
func (c *ClientFactory) NewManagedDatabaseColumnsClient() *ManagedDatabaseColumnsClient {
	return &ManagedDatabaseColumnsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseMoveOperationsClient creates a new instance of ManagedDatabaseMoveOperationsClient.
func (c *ClientFactory) NewManagedDatabaseMoveOperationsClient() *ManagedDatabaseMoveOperationsClient {
	return &ManagedDatabaseMoveOperationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseQueriesClient creates a new instance of ManagedDatabaseQueriesClient.
func (c *ClientFactory) NewManagedDatabaseQueriesClient() *ManagedDatabaseQueriesClient {
	return &ManagedDatabaseQueriesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseRecommendedSensitivityLabelsClient creates a new instance of ManagedDatabaseRecommendedSensitivityLabelsClient.
func (c *ClientFactory) NewManagedDatabaseRecommendedSensitivityLabelsClient() *ManagedDatabaseRecommendedSensitivityLabelsClient {
	return &ManagedDatabaseRecommendedSensitivityLabelsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseRestoreDetailsClient creates a new instance of ManagedDatabaseRestoreDetailsClient.
func (c *ClientFactory) NewManagedDatabaseRestoreDetailsClient() *ManagedDatabaseRestoreDetailsClient {
	return &ManagedDatabaseRestoreDetailsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseSchemasClient creates a new instance of ManagedDatabaseSchemasClient.
func (c *ClientFactory) NewManagedDatabaseSchemasClient() *ManagedDatabaseSchemasClient {
	return &ManagedDatabaseSchemasClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseSecurityAlertPoliciesClient creates a new instance of ManagedDatabaseSecurityAlertPoliciesClient.
func (c *ClientFactory) NewManagedDatabaseSecurityAlertPoliciesClient() *ManagedDatabaseSecurityAlertPoliciesClient {
	return &ManagedDatabaseSecurityAlertPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseSecurityEventsClient creates a new instance of ManagedDatabaseSecurityEventsClient.
func (c *ClientFactory) NewManagedDatabaseSecurityEventsClient() *ManagedDatabaseSecurityEventsClient {
	return &ManagedDatabaseSecurityEventsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseSensitivityLabelsClient creates a new instance of ManagedDatabaseSensitivityLabelsClient.
func (c *ClientFactory) NewManagedDatabaseSensitivityLabelsClient() *ManagedDatabaseSensitivityLabelsClient {
	return &ManagedDatabaseSensitivityLabelsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseTablesClient creates a new instance of ManagedDatabaseTablesClient.
func (c *ClientFactory) NewManagedDatabaseTablesClient() *ManagedDatabaseTablesClient {
	return &ManagedDatabaseTablesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseTransparentDataEncryptionClient creates a new instance of ManagedDatabaseTransparentDataEncryptionClient.
func (c *ClientFactory) NewManagedDatabaseTransparentDataEncryptionClient() *ManagedDatabaseTransparentDataEncryptionClient {
	return &ManagedDatabaseTransparentDataEncryptionClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseVulnerabilityAssessmentRuleBaselinesClient creates a new instance of ManagedDatabaseVulnerabilityAssessmentRuleBaselinesClient.
func (c *ClientFactory) NewManagedDatabaseVulnerabilityAssessmentRuleBaselinesClient() *ManagedDatabaseVulnerabilityAssessmentRuleBaselinesClient {
	return &ManagedDatabaseVulnerabilityAssessmentRuleBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseVulnerabilityAssessmentScansClient creates a new instance of ManagedDatabaseVulnerabilityAssessmentScansClient.
func (c *ClientFactory) NewManagedDatabaseVulnerabilityAssessmentScansClient() *ManagedDatabaseVulnerabilityAssessmentScansClient {
	return &ManagedDatabaseVulnerabilityAssessmentScansClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabaseVulnerabilityAssessmentsClient creates a new instance of ManagedDatabaseVulnerabilityAssessmentsClient.
func (c *ClientFactory) NewManagedDatabaseVulnerabilityAssessmentsClient() *ManagedDatabaseVulnerabilityAssessmentsClient {
	return &ManagedDatabaseVulnerabilityAssessmentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedDatabasesClient creates a new instance of ManagedDatabasesClient.
func (c *ClientFactory) NewManagedDatabasesClient() *ManagedDatabasesClient {
	return &ManagedDatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceAdministratorsClient creates a new instance of ManagedInstanceAdministratorsClient.
func (c *ClientFactory) NewManagedInstanceAdministratorsClient() *ManagedInstanceAdministratorsClient {
	return &ManagedInstanceAdministratorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceAdvancedThreatProtectionSettingsClient creates a new instance of ManagedInstanceAdvancedThreatProtectionSettingsClient.
func (c *ClientFactory) NewManagedInstanceAdvancedThreatProtectionSettingsClient() *ManagedInstanceAdvancedThreatProtectionSettingsClient {
	return &ManagedInstanceAdvancedThreatProtectionSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceAzureADOnlyAuthenticationsClient creates a new instance of ManagedInstanceAzureADOnlyAuthenticationsClient.
func (c *ClientFactory) NewManagedInstanceAzureADOnlyAuthenticationsClient() *ManagedInstanceAzureADOnlyAuthenticationsClient {
	return &ManagedInstanceAzureADOnlyAuthenticationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceDtcsClient creates a new instance of ManagedInstanceDtcsClient.
func (c *ClientFactory) NewManagedInstanceDtcsClient() *ManagedInstanceDtcsClient {
	return &ManagedInstanceDtcsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceEncryptionProtectorsClient creates a new instance of ManagedInstanceEncryptionProtectorsClient.
func (c *ClientFactory) NewManagedInstanceEncryptionProtectorsClient() *ManagedInstanceEncryptionProtectorsClient {
	return &ManagedInstanceEncryptionProtectorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceKeysClient creates a new instance of ManagedInstanceKeysClient.
func (c *ClientFactory) NewManagedInstanceKeysClient() *ManagedInstanceKeysClient {
	return &ManagedInstanceKeysClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceLongTermRetentionPoliciesClient creates a new instance of ManagedInstanceLongTermRetentionPoliciesClient.
func (c *ClientFactory) NewManagedInstanceLongTermRetentionPoliciesClient() *ManagedInstanceLongTermRetentionPoliciesClient {
	return &ManagedInstanceLongTermRetentionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceOperationsClient creates a new instance of ManagedInstanceOperationsClient.
func (c *ClientFactory) NewManagedInstanceOperationsClient() *ManagedInstanceOperationsClient {
	return &ManagedInstanceOperationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstancePrivateEndpointConnectionsClient creates a new instance of ManagedInstancePrivateEndpointConnectionsClient.
func (c *ClientFactory) NewManagedInstancePrivateEndpointConnectionsClient() *ManagedInstancePrivateEndpointConnectionsClient {
	return &ManagedInstancePrivateEndpointConnectionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstancePrivateLinkResourcesClient creates a new instance of ManagedInstancePrivateLinkResourcesClient.
func (c *ClientFactory) NewManagedInstancePrivateLinkResourcesClient() *ManagedInstancePrivateLinkResourcesClient {
	return &ManagedInstancePrivateLinkResourcesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceTdeCertificatesClient creates a new instance of ManagedInstanceTdeCertificatesClient.
func (c *ClientFactory) NewManagedInstanceTdeCertificatesClient() *ManagedInstanceTdeCertificatesClient {
	return &ManagedInstanceTdeCertificatesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstanceVulnerabilityAssessmentsClient creates a new instance of ManagedInstanceVulnerabilityAssessmentsClient.
func (c *ClientFactory) NewManagedInstanceVulnerabilityAssessmentsClient() *ManagedInstanceVulnerabilityAssessmentsClient {
	return &ManagedInstanceVulnerabilityAssessmentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedInstancesClient creates a new instance of ManagedInstancesClient.
func (c *ClientFactory) NewManagedInstancesClient() *ManagedInstancesClient {
	return &ManagedInstancesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedLedgerDigestUploadsClient creates a new instance of ManagedLedgerDigestUploadsClient.
func (c *ClientFactory) NewManagedLedgerDigestUploadsClient() *ManagedLedgerDigestUploadsClient {
	return &ManagedLedgerDigestUploadsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedRestorableDroppedDatabaseBackupShortTermRetentionPoliciesClient creates a new instance of ManagedRestorableDroppedDatabaseBackupShortTermRetentionPoliciesClient.
func (c *ClientFactory) NewManagedRestorableDroppedDatabaseBackupShortTermRetentionPoliciesClient() *ManagedRestorableDroppedDatabaseBackupShortTermRetentionPoliciesClient {
	return &ManagedRestorableDroppedDatabaseBackupShortTermRetentionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedServerDNSAliasesClient creates a new instance of ManagedServerDNSAliasesClient.
func (c *ClientFactory) NewManagedServerDNSAliasesClient() *ManagedServerDNSAliasesClient {
	return &ManagedServerDNSAliasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagedServerSecurityAlertPoliciesClient creates a new instance of ManagedServerSecurityAlertPoliciesClient.
func (c *ClientFactory) NewManagedServerSecurityAlertPoliciesClient() *ManagedServerSecurityAlertPoliciesClient {
	return &ManagedServerSecurityAlertPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewOutboundFirewallRulesClient creates a new instance of OutboundFirewallRulesClient.
func (c *ClientFactory) NewOutboundFirewallRulesClient() *OutboundFirewallRulesClient {
	return &OutboundFirewallRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewPrivateEndpointConnectionsClient creates a new instance of PrivateEndpointConnectionsClient.
func (c *ClientFactory) NewPrivateEndpointConnectionsClient() *PrivateEndpointConnectionsClient {
	return &PrivateEndpointConnectionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewPrivateLinkResourcesClient creates a new instance of PrivateLinkResourcesClient.
func (c *ClientFactory) NewPrivateLinkResourcesClient() *PrivateLinkResourcesClient {
	return &PrivateLinkResourcesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRecommendedSensitivityLabelsClient creates a new instance of RecommendedSensitivityLabelsClient.
func (c *ClientFactory) NewRecommendedSensitivityLabelsClient() *RecommendedSensitivityLabelsClient {
	return &RecommendedSensitivityLabelsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRecoverableDatabasesClient creates a new instance of RecoverableDatabasesClient.
func (c *ClientFactory) NewRecoverableDatabasesClient() *RecoverableDatabasesClient {
	return &RecoverableDatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRecoverableManagedDatabasesClient creates a new instance of RecoverableManagedDatabasesClient.
func (c *ClientFactory) NewRecoverableManagedDatabasesClient() *RecoverableManagedDatabasesClient {
	return &RecoverableManagedDatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewReplicationLinksClient creates a new instance of ReplicationLinksClient.
func (c *ClientFactory) NewReplicationLinksClient() *ReplicationLinksClient {
	return &ReplicationLinksClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRestorableDroppedDatabasesClient creates a new instance of RestorableDroppedDatabasesClient.
func (c *ClientFactory) NewRestorableDroppedDatabasesClient() *RestorableDroppedDatabasesClient {
	return &RestorableDroppedDatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRestorableDroppedManagedDatabasesClient creates a new instance of RestorableDroppedManagedDatabasesClient.
func (c *ClientFactory) NewRestorableDroppedManagedDatabasesClient() *RestorableDroppedManagedDatabasesClient {
	return &RestorableDroppedManagedDatabasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRestorePointsClient creates a new instance of RestorePointsClient.
func (c *ClientFactory) NewRestorePointsClient() *RestorePointsClient {
	return &RestorePointsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSensitivityLabelsClient creates a new instance of SensitivityLabelsClient.
func (c *ClientFactory) NewSensitivityLabelsClient() *SensitivityLabelsClient {
	return &SensitivityLabelsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerAdvancedThreatProtectionSettingsClient creates a new instance of ServerAdvancedThreatProtectionSettingsClient.
func (c *ClientFactory) NewServerAdvancedThreatProtectionSettingsClient() *ServerAdvancedThreatProtectionSettingsClient {
	return &ServerAdvancedThreatProtectionSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerAdvisorsClient creates a new instance of ServerAdvisorsClient.
func (c *ClientFactory) NewServerAdvisorsClient() *ServerAdvisorsClient {
	return &ServerAdvisorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerAutomaticTuningClient creates a new instance of ServerAutomaticTuningClient.
func (c *ClientFactory) NewServerAutomaticTuningClient() *ServerAutomaticTuningClient {
	return &ServerAutomaticTuningClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerAzureADAdministratorsClient creates a new instance of ServerAzureADAdministratorsClient.
func (c *ClientFactory) NewServerAzureADAdministratorsClient() *ServerAzureADAdministratorsClient {
	return &ServerAzureADAdministratorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerAzureADOnlyAuthenticationsClient creates a new instance of ServerAzureADOnlyAuthenticationsClient.
func (c *ClientFactory) NewServerAzureADOnlyAuthenticationsClient() *ServerAzureADOnlyAuthenticationsClient {
	return &ServerAzureADOnlyAuthenticationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerBlobAuditingPoliciesClient creates a new instance of ServerBlobAuditingPoliciesClient.
func (c *ClientFactory) NewServerBlobAuditingPoliciesClient() *ServerBlobAuditingPoliciesClient {
	return &ServerBlobAuditingPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerCommunicationLinksClient creates a new instance of ServerCommunicationLinksClient.
func (c *ClientFactory) NewServerCommunicationLinksClient() *ServerCommunicationLinksClient {
	return &ServerCommunicationLinksClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerConfigurationOptionsClient creates a new instance of ServerConfigurationOptionsClient.
func (c *ClientFactory) NewServerConfigurationOptionsClient() *ServerConfigurationOptionsClient {
	return &ServerConfigurationOptionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerConnectionPoliciesClient creates a new instance of ServerConnectionPoliciesClient.
func (c *ClientFactory) NewServerConnectionPoliciesClient() *ServerConnectionPoliciesClient {
	return &ServerConnectionPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerDNSAliasesClient creates a new instance of ServerDNSAliasesClient.
func (c *ClientFactory) NewServerDNSAliasesClient() *ServerDNSAliasesClient {
	return &ServerDNSAliasesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerDevOpsAuditSettingsClient creates a new instance of ServerDevOpsAuditSettingsClient.
func (c *ClientFactory) NewServerDevOpsAuditSettingsClient() *ServerDevOpsAuditSettingsClient {
	return &ServerDevOpsAuditSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerKeysClient creates a new instance of ServerKeysClient.
func (c *ClientFactory) NewServerKeysClient() *ServerKeysClient {
	return &ServerKeysClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerOperationsClient creates a new instance of ServerOperationsClient.
func (c *ClientFactory) NewServerOperationsClient() *ServerOperationsClient {
	return &ServerOperationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerSecurityAlertPoliciesClient creates a new instance of ServerSecurityAlertPoliciesClient.
func (c *ClientFactory) NewServerSecurityAlertPoliciesClient() *ServerSecurityAlertPoliciesClient {
	return &ServerSecurityAlertPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerTrustCertificatesClient creates a new instance of ServerTrustCertificatesClient.
func (c *ClientFactory) NewServerTrustCertificatesClient() *ServerTrustCertificatesClient {
	return &ServerTrustCertificatesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerTrustGroupsClient creates a new instance of ServerTrustGroupsClient.
func (c *ClientFactory) NewServerTrustGroupsClient() *ServerTrustGroupsClient {
	return &ServerTrustGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerUsagesClient creates a new instance of ServerUsagesClient.
func (c *ClientFactory) NewServerUsagesClient() *ServerUsagesClient {
	return &ServerUsagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServerVulnerabilityAssessmentsClient creates a new instance of ServerVulnerabilityAssessmentsClient.
func (c *ClientFactory) NewServerVulnerabilityAssessmentsClient() *ServerVulnerabilityAssessmentsClient {
	return &ServerVulnerabilityAssessmentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServersClient creates a new instance of ServersClient.
func (c *ClientFactory) NewServersClient() *ServersClient {
	return &ServersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewServiceObjectivesClient creates a new instance of ServiceObjectivesClient.
func (c *ClientFactory) NewServiceObjectivesClient() *ServiceObjectivesClient {
	return &ServiceObjectivesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewStartStopManagedInstanceSchedulesClient creates a new instance of StartStopManagedInstanceSchedulesClient.
func (c *ClientFactory) NewStartStopManagedInstanceSchedulesClient() *StartStopManagedInstanceSchedulesClient {
	return &StartStopManagedInstanceSchedulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSubscriptionUsagesClient creates a new instance of SubscriptionUsagesClient.
func (c *ClientFactory) NewSubscriptionUsagesClient() *SubscriptionUsagesClient {
	return &SubscriptionUsagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSynapseLinkWorkspacesClient creates a new instance of SynapseLinkWorkspacesClient.
func (c *ClientFactory) NewSynapseLinkWorkspacesClient() *SynapseLinkWorkspacesClient {
	return &SynapseLinkWorkspacesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSyncAgentsClient creates a new instance of SyncAgentsClient.
func (c *ClientFactory) NewSyncAgentsClient() *SyncAgentsClient {
	return &SyncAgentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSyncGroupsClient creates a new instance of SyncGroupsClient.
func (c *ClientFactory) NewSyncGroupsClient() *SyncGroupsClient {
	return &SyncGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSyncMembersClient creates a new instance of SyncMembersClient.
func (c *ClientFactory) NewSyncMembersClient() *SyncMembersClient {
	return &SyncMembersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewTdeCertificatesClient creates a new instance of TdeCertificatesClient.
func (c *ClientFactory) NewTdeCertificatesClient() *TdeCertificatesClient {
	return &TdeCertificatesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewTimeZonesClient creates a new instance of TimeZonesClient.
func (c *ClientFactory) NewTimeZonesClient() *TimeZonesClient {
	return &TimeZonesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewTransparentDataEncryptionsClient creates a new instance of TransparentDataEncryptionsClient.
func (c *ClientFactory) NewTransparentDataEncryptionsClient() *TransparentDataEncryptionsClient {
	return &TransparentDataEncryptionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUsagesClient creates a new instance of UsagesClient.
func (c *ClientFactory) NewUsagesClient() *UsagesClient {
	return &UsagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVirtualClustersClient creates a new instance of VirtualClustersClient.
func (c *ClientFactory) NewVirtualClustersClient() *VirtualClustersClient {
	return &VirtualClustersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVirtualNetworkRulesClient creates a new instance of VirtualNetworkRulesClient.
func (c *ClientFactory) NewVirtualNetworkRulesClient() *VirtualNetworkRulesClient {
	return &VirtualNetworkRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentBaselineClient creates a new instance of VulnerabilityAssessmentBaselineClient.
func (c *ClientFactory) NewVulnerabilityAssessmentBaselineClient() *VulnerabilityAssessmentBaselineClient {
	return &VulnerabilityAssessmentBaselineClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentBaselinesClient creates a new instance of VulnerabilityAssessmentBaselinesClient.
func (c *ClientFactory) NewVulnerabilityAssessmentBaselinesClient() *VulnerabilityAssessmentBaselinesClient {
	return &VulnerabilityAssessmentBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentExecuteScanClient creates a new instance of VulnerabilityAssessmentExecuteScanClient.
func (c *ClientFactory) NewVulnerabilityAssessmentExecuteScanClient() *VulnerabilityAssessmentExecuteScanClient {
	return &VulnerabilityAssessmentExecuteScanClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentRuleBaselineClient creates a new instance of VulnerabilityAssessmentRuleBaselineClient.
func (c *ClientFactory) NewVulnerabilityAssessmentRuleBaselineClient() *VulnerabilityAssessmentRuleBaselineClient {
	return &VulnerabilityAssessmentRuleBaselineClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentRuleBaselinesClient creates a new instance of VulnerabilityAssessmentRuleBaselinesClient.
func (c *ClientFactory) NewVulnerabilityAssessmentRuleBaselinesClient() *VulnerabilityAssessmentRuleBaselinesClient {
	return &VulnerabilityAssessmentRuleBaselinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentScanResultClient creates a new instance of VulnerabilityAssessmentScanResultClient.
func (c *ClientFactory) NewVulnerabilityAssessmentScanResultClient() *VulnerabilityAssessmentScanResultClient {
	return &VulnerabilityAssessmentScanResultClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentScansClient creates a new instance of VulnerabilityAssessmentScansClient.
func (c *ClientFactory) NewVulnerabilityAssessmentScansClient() *VulnerabilityAssessmentScansClient {
	return &VulnerabilityAssessmentScansClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentsClient creates a new instance of VulnerabilityAssessmentsClient.
func (c *ClientFactory) NewVulnerabilityAssessmentsClient() *VulnerabilityAssessmentsClient {
	return &VulnerabilityAssessmentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVulnerabilityAssessmentsSettingsClient creates a new instance of VulnerabilityAssessmentsSettingsClient.
func (c *ClientFactory) NewVulnerabilityAssessmentsSettingsClient() *VulnerabilityAssessmentsSettingsClient {
	return &VulnerabilityAssessmentsSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewWorkloadClassifiersClient creates a new instance of WorkloadClassifiersClient.
func (c *ClientFactory) NewWorkloadClassifiersClient() *WorkloadClassifiersClient {
	return &WorkloadClassifiersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewWorkloadGroupsClient creates a new instance of WorkloadGroupsClient.
func (c *ClientFactory) NewWorkloadGroupsClient() *WorkloadGroupsClient {
	return &WorkloadGroupsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
