//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armstoragemover

// AgentsClientCreateOrUpdateResponse contains the response from method AgentsClient.CreateOrUpdate.
type AgentsClientCreateOrUpdateResponse struct {
	// The Agent resource.
	Agent
}

// AgentsClientDeleteResponse contains the response from method AgentsClient.BeginDelete.
type AgentsClientDeleteResponse struct {
	// placeholder for future response values
}

// AgentsClientGetResponse contains the response from method AgentsClient.Get.
type AgentsClientGetResponse struct {
	// The Agent resource.
	Agent
}

// AgentsClientListResponse contains the response from method AgentsClient.NewListPager.
type AgentsClientListResponse struct {
	// List of Agents.
	AgentList
}

// AgentsClientUpdateResponse contains the response from method AgentsClient.Update.
type AgentsClientUpdateResponse struct {
	// The Agent resource.
	Agent
}

// EndpointsClientCreateOrUpdateResponse contains the response from method EndpointsClient.CreateOrUpdate.
type EndpointsClientCreateOrUpdateResponse struct {
	// The Endpoint resource, which contains information about file sources and targets.
	Endpoint
}

// EndpointsClientDeleteResponse contains the response from method EndpointsClient.BeginDelete.
type EndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// EndpointsClientGetResponse contains the response from method EndpointsClient.Get.
type EndpointsClientGetResponse struct {
	// The Endpoint resource, which contains information about file sources and targets.
	Endpoint
}

// EndpointsClientListResponse contains the response from method EndpointsClient.NewListPager.
type EndpointsClientListResponse struct {
	// List of Endpoints.
	EndpointList
}

// EndpointsClientUpdateResponse contains the response from method EndpointsClient.Update.
type EndpointsClientUpdateResponse struct {
	// The Endpoint resource, which contains information about file sources and targets.
	Endpoint
}

// JobDefinitionsClientCreateOrUpdateResponse contains the response from method JobDefinitionsClient.CreateOrUpdate.
type JobDefinitionsClientCreateOrUpdateResponse struct {
	// The Job Definition resource.
	JobDefinition
}

// JobDefinitionsClientDeleteResponse contains the response from method JobDefinitionsClient.BeginDelete.
type JobDefinitionsClientDeleteResponse struct {
	// placeholder for future response values
}

// JobDefinitionsClientGetResponse contains the response from method JobDefinitionsClient.Get.
type JobDefinitionsClientGetResponse struct {
	// The Job Definition resource.
	JobDefinition
}

// JobDefinitionsClientListResponse contains the response from method JobDefinitionsClient.NewListPager.
type JobDefinitionsClientListResponse struct {
	// List of Job Definitions.
	JobDefinitionList
}

// JobDefinitionsClientStartJobResponse contains the response from method JobDefinitionsClient.StartJob.
type JobDefinitionsClientStartJobResponse struct {
	// Response that identifies a Job Run.
	JobRunResourceID
}

// JobDefinitionsClientStopJobResponse contains the response from method JobDefinitionsClient.StopJob.
type JobDefinitionsClientStopJobResponse struct {
	// Response that identifies a Job Run.
	JobRunResourceID
}

// JobDefinitionsClientUpdateResponse contains the response from method JobDefinitionsClient.Update.
type JobDefinitionsClientUpdateResponse struct {
	// The Job Definition resource.
	JobDefinition
}

// JobRunsClientGetResponse contains the response from method JobRunsClient.Get.
type JobRunsClientGetResponse struct {
	// The Job Run resource.
	JobRun
}

// JobRunsClientListResponse contains the response from method JobRunsClient.NewListPager.
type JobRunsClientListResponse struct {
	// List of Job Runs.
	JobRunList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// ProjectsClientCreateOrUpdateResponse contains the response from method ProjectsClient.CreateOrUpdate.
type ProjectsClientCreateOrUpdateResponse struct {
	// The Project resource.
	Project
}

// ProjectsClientDeleteResponse contains the response from method ProjectsClient.BeginDelete.
type ProjectsClientDeleteResponse struct {
	// placeholder for future response values
}

// ProjectsClientGetResponse contains the response from method ProjectsClient.Get.
type ProjectsClientGetResponse struct {
	// The Project resource.
	Project
}

// ProjectsClientListResponse contains the response from method ProjectsClient.NewListPager.
type ProjectsClientListResponse struct {
	// List of Project resources.
	ProjectList
}

// ProjectsClientUpdateResponse contains the response from method ProjectsClient.Update.
type ProjectsClientUpdateResponse struct {
	// The Project resource.
	Project
}

// StorageMoversClientCreateOrUpdateResponse contains the response from method StorageMoversClient.CreateOrUpdate.
type StorageMoversClientCreateOrUpdateResponse struct {
	// The Storage Mover resource, which is a container for a group of Agents, Projects, and Endpoints.
	StorageMover
}

// StorageMoversClientDeleteResponse contains the response from method StorageMoversClient.BeginDelete.
type StorageMoversClientDeleteResponse struct {
	// placeholder for future response values
}

// StorageMoversClientGetResponse contains the response from method StorageMoversClient.Get.
type StorageMoversClientGetResponse struct {
	// The Storage Mover resource, which is a container for a group of Agents, Projects, and Endpoints.
	StorageMover
}

// StorageMoversClientListBySubscriptionResponse contains the response from method StorageMoversClient.NewListBySubscriptionPager.
type StorageMoversClientListBySubscriptionResponse struct {
	// List of Storage Movers.
	List
}

// StorageMoversClientListResponse contains the response from method StorageMoversClient.NewListPager.
type StorageMoversClientListResponse struct {
	// List of Storage Movers.
	List
}

// StorageMoversClientUpdateResponse contains the response from method StorageMoversClient.Update.
type StorageMoversClientUpdateResponse struct {
	// The Storage Mover resource, which is a container for a group of Agents, Projects, and Endpoints.
	StorageMover
}
