//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsupport

// ChatTranscriptsClientGetResponse contains the response from method ChatTranscriptsClient.Get.
type ChatTranscriptsClientGetResponse struct {
	// Object that represents a Chat Transcript resource.
	ChatTranscriptDetails
}

// ChatTranscriptsClientListResponse contains the response from method ChatTranscriptsClient.NewListPager.
type ChatTranscriptsClientListResponse struct {
	// Collection of Chat Transcripts resources.
	ChatTranscriptsListResult
}

// ChatTranscriptsNoSubscriptionClientGetResponse contains the response from method ChatTranscriptsNoSubscriptionClient.Get.
type ChatTranscriptsNoSubscriptionClientGetResponse struct {
	// Object that represents a Chat Transcript resource.
	ChatTranscriptDetails
}

// ChatTranscriptsNoSubscriptionClientListResponse contains the response from method ChatTranscriptsNoSubscriptionClient.NewListPager.
type ChatTranscriptsNoSubscriptionClientListResponse struct {
	// Collection of Chat Transcripts resources.
	ChatTranscriptsListResult
}

// CommunicationsClientCheckNameAvailabilityResponse contains the response from method CommunicationsClient.CheckNameAvailability.
type CommunicationsClientCheckNameAvailabilityResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// CommunicationsClientCreateResponse contains the response from method CommunicationsClient.BeginCreate.
type CommunicationsClientCreateResponse struct {
	// Object that represents a Communication resource.
	CommunicationDetails
}

// CommunicationsClientGetResponse contains the response from method CommunicationsClient.Get.
type CommunicationsClientGetResponse struct {
	// Object that represents a Communication resource.
	CommunicationDetails
}

// CommunicationsClientListResponse contains the response from method CommunicationsClient.NewListPager.
type CommunicationsClientListResponse struct {
	// Collection of Communication resources.
	CommunicationsListResult
}

// CommunicationsNoSubscriptionClientCheckNameAvailabilityResponse contains the response from method CommunicationsNoSubscriptionClient.CheckNameAvailability.
type CommunicationsNoSubscriptionClientCheckNameAvailabilityResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// CommunicationsNoSubscriptionClientCreateResponse contains the response from method CommunicationsNoSubscriptionClient.BeginCreate.
type CommunicationsNoSubscriptionClientCreateResponse struct {
	// Object that represents a Communication resource.
	CommunicationDetails
}

// CommunicationsNoSubscriptionClientGetResponse contains the response from method CommunicationsNoSubscriptionClient.Get.
type CommunicationsNoSubscriptionClientGetResponse struct {
	// Object that represents a Communication resource.
	CommunicationDetails
}

// CommunicationsNoSubscriptionClientListResponse contains the response from method CommunicationsNoSubscriptionClient.NewListPager.
type CommunicationsNoSubscriptionClientListResponse struct {
	// Collection of Communication resources.
	CommunicationsListResult
}

// FileWorkspacesClientCreateResponse contains the response from method FileWorkspacesClient.Create.
type FileWorkspacesClientCreateResponse struct {
	// Object that represents FileWorkspaceDetails resource
	FileWorkspaceDetails
}

// FileWorkspacesClientGetResponse contains the response from method FileWorkspacesClient.Get.
type FileWorkspacesClientGetResponse struct {
	// Object that represents FileWorkspaceDetails resource
	FileWorkspaceDetails
}

// FileWorkspacesNoSubscriptionClientCreateResponse contains the response from method FileWorkspacesNoSubscriptionClient.Create.
type FileWorkspacesNoSubscriptionClientCreateResponse struct {
	// Object that represents FileWorkspaceDetails resource
	FileWorkspaceDetails
}

// FileWorkspacesNoSubscriptionClientGetResponse contains the response from method FileWorkspacesNoSubscriptionClient.Get.
type FileWorkspacesNoSubscriptionClientGetResponse struct {
	// Object that represents FileWorkspaceDetails resource
	FileWorkspaceDetails
}

// FilesClientCreateResponse contains the response from method FilesClient.Create.
type FilesClientCreateResponse struct {
	// Object that represents File Details resource
	FileDetails
}

// FilesClientGetResponse contains the response from method FilesClient.Get.
type FilesClientGetResponse struct {
	// Object that represents File Details resource
	FileDetails
}

// FilesClientListResponse contains the response from method FilesClient.NewListPager.
type FilesClientListResponse struct {
	// Object that represents a collection of File resources.
	FilesListResult
}

// FilesClientUploadResponse contains the response from method FilesClient.Upload.
type FilesClientUploadResponse struct {
	// placeholder for future response values
}

// FilesNoSubscriptionClientCreateResponse contains the response from method FilesNoSubscriptionClient.Create.
type FilesNoSubscriptionClientCreateResponse struct {
	// Object that represents File Details resource
	FileDetails
}

// FilesNoSubscriptionClientGetResponse contains the response from method FilesNoSubscriptionClient.Get.
type FilesNoSubscriptionClientGetResponse struct {
	// Object that represents File Details resource
	FileDetails
}

// FilesNoSubscriptionClientListResponse contains the response from method FilesNoSubscriptionClient.NewListPager.
type FilesNoSubscriptionClientListResponse struct {
	// Object that represents a collection of File resources.
	FilesListResult
}

// FilesNoSubscriptionClientUploadResponse contains the response from method FilesNoSubscriptionClient.Upload.
type FilesNoSubscriptionClientUploadResponse struct {
	// placeholder for future response values
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// The list of operations supported by Microsoft Support resource provider.
	OperationsListResult
}

// ProblemClassificationsClientGetResponse contains the response from method ProblemClassificationsClient.Get.
type ProblemClassificationsClientGetResponse struct {
	// ProblemClassification resource object.
	ProblemClassification
}

// ProblemClassificationsClientListResponse contains the response from method ProblemClassificationsClient.NewListPager.
type ProblemClassificationsClientListResponse struct {
	// Collection of ProblemClassification resources.
	ProblemClassificationsListResult
}

// ServicesClientGetResponse contains the response from method ServicesClient.Get.
type ServicesClientGetResponse struct {
	// Object that represents a Service resource.
	Service
}

// ServicesClientListResponse contains the response from method ServicesClient.NewListPager.
type ServicesClientListResponse struct {
	// Collection of Service resources.
	ServicesListResult
}

// TicketsClientCheckNameAvailabilityResponse contains the response from method TicketsClient.CheckNameAvailability.
type TicketsClientCheckNameAvailabilityResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// TicketsClientCreateResponse contains the response from method TicketsClient.BeginCreate.
type TicketsClientCreateResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}

// TicketsClientGetResponse contains the response from method TicketsClient.Get.
type TicketsClientGetResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}

// TicketsClientListResponse contains the response from method TicketsClient.NewListPager.
type TicketsClientListResponse struct {
	// Object that represents a collection of SupportTicket resources.
	TicketsListResult
}

// TicketsClientUpdateResponse contains the response from method TicketsClient.Update.
type TicketsClientUpdateResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}

// TicketsNoSubscriptionClientCheckNameAvailabilityResponse contains the response from method TicketsNoSubscriptionClient.CheckNameAvailability.
type TicketsNoSubscriptionClientCheckNameAvailabilityResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// TicketsNoSubscriptionClientCreateResponse contains the response from method TicketsNoSubscriptionClient.BeginCreate.
type TicketsNoSubscriptionClientCreateResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}

// TicketsNoSubscriptionClientGetResponse contains the response from method TicketsNoSubscriptionClient.Get.
type TicketsNoSubscriptionClientGetResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}

// TicketsNoSubscriptionClientListResponse contains the response from method TicketsNoSubscriptionClient.NewListPager.
type TicketsNoSubscriptionClientListResponse struct {
	// Object that represents a collection of SupportTicket resources.
	TicketsListResult
}

// TicketsNoSubscriptionClientUpdateResponse contains the response from method TicketsNoSubscriptionClient.Update.
type TicketsNoSubscriptionClientUpdateResponse struct {
	// Object that represents SupportTicketDetails resource.
	TicketDetails
}
