//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armtestbase

// AccountsClientCheckPackageNameAvailabilityResponse contains the response from method AccountsClient.CheckPackageNameAvailability.
type AccountsClientCheckPackageNameAvailabilityResponse struct {
	// Description of a Check Name availability response properties.
	CheckNameAvailabilityResult
}

// AccountsClientCreateResponse contains the response from method AccountsClient.BeginCreate.
type AccountsClientCreateResponse struct {
	// The Test Base Account resource.
	AccountResource
}

// AccountsClientDeleteResponse contains the response from method AccountsClient.BeginDelete.
type AccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountsClientGetFileUploadURLResponse contains the response from method AccountsClient.GetFileUploadURL.
type AccountsClientGetFileUploadURLResponse struct {
	// The URL response
	FileUploadURLResponse
}

// AccountsClientGetResponse contains the response from method AccountsClient.Get.
type AccountsClientGetResponse struct {
	// The Test Base Account resource.
	AccountResource
}

// AccountsClientListByResourceGroupResponse contains the response from method AccountsClient.NewListByResourceGroupPager.
type AccountsClientListByResourceGroupResponse struct {
	// A list of Test Base Accounts.
	AccountListResult
}

// AccountsClientListBySubscriptionResponse contains the response from method AccountsClient.NewListBySubscriptionPager.
type AccountsClientListBySubscriptionResponse struct {
	// A list of Test Base Accounts.
	AccountListResult
}

// AccountsClientOffboardResponse contains the response from method AccountsClient.BeginOffboard.
type AccountsClientOffboardResponse struct {
	// placeholder for future response values
}

// AccountsClientUpdateResponse contains the response from method AccountsClient.BeginUpdate.
type AccountsClientUpdateResponse struct {
	// The Test Base Account resource.
	AccountResource
}

// AnalysisResultsClientGetResponse contains the response from method AnalysisResultsClient.Get.
type AnalysisResultsClientGetResponse struct {
	// The Analysis Result Singleton Resource.
	AnalysisResultSingletonResource
}

// AnalysisResultsClientListResponse contains the response from method AnalysisResultsClient.NewListPager.
type AnalysisResultsClientListResponse struct {
	// A list of Analysis Results. It will only contain one element as all the data will be nested in a singleton object.
	AnalysisResultListResult
}

// AvailableOSClientGetResponse contains the response from method AvailableOSClient.Get.
type AvailableOSClientGetResponse struct {
	// The Available OS resource.
	AvailableOSResource
}

// AvailableOSClientListResponse contains the response from method AvailableOSClient.NewListPager.
type AvailableOSClientListResponse struct {
	// A list of available OSs.
	AvailableOSListResult
}

// CustomerEventsClientCreateResponse contains the response from method CustomerEventsClient.BeginCreate.
type CustomerEventsClientCreateResponse struct {
	// The Customer Notification Event resource.
	CustomerEventResource
}

// CustomerEventsClientDeleteResponse contains the response from method CustomerEventsClient.BeginDelete.
type CustomerEventsClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomerEventsClientGetResponse contains the response from method CustomerEventsClient.Get.
type CustomerEventsClientGetResponse struct {
	// The Customer Notification Event resource.
	CustomerEventResource
}

// CustomerEventsClientListByTestBaseAccountResponse contains the response from method CustomerEventsClient.NewListByTestBaseAccountPager.
type CustomerEventsClientListByTestBaseAccountResponse struct {
	// A list of Test Base Customer Events.
	CustomerEventListResult
}

// EmailEventsClientGetResponse contains the response from method EmailEventsClient.Get.
type EmailEventsClientGetResponse struct {
	// The email event resource.
	EmailEventResource
}

// EmailEventsClientListResponse contains the response from method EmailEventsClient.NewListPager.
type EmailEventsClientListResponse struct {
	// A list of email events.
	EmailEventListResult
}

// FavoriteProcessesClientCreateResponse contains the response from method FavoriteProcessesClient.Create.
type FavoriteProcessesClientCreateResponse struct {
	// A favorite process identifier.
	FavoriteProcessResource
}

// FavoriteProcessesClientDeleteResponse contains the response from method FavoriteProcessesClient.Delete.
type FavoriteProcessesClientDeleteResponse struct {
	// placeholder for future response values
}

// FavoriteProcessesClientGetResponse contains the response from method FavoriteProcessesClient.Get.
type FavoriteProcessesClientGetResponse struct {
	// A favorite process identifier.
	FavoriteProcessResource
}

// FavoriteProcessesClientListResponse contains the response from method FavoriteProcessesClient.NewListPager.
type FavoriteProcessesClientListResponse struct {
	// A list of favorite processes for a package.
	FavoriteProcessListResult
}

// FlightingRingsClientGetResponse contains the response from method FlightingRingsClient.Get.
type FlightingRingsClientGetResponse struct {
	// The flighting ring resource.
	FlightingRingResource
}

// FlightingRingsClientListResponse contains the response from method FlightingRingsClient.NewListPager.
type FlightingRingsClientListResponse struct {
	// A list of flighting rings.
	FlightingRingListResult
}

// OSUpdatesClientGetResponse contains the response from method OSUpdatesClient.Get.
type OSUpdatesClientGetResponse struct {
	// An OS Update.
	OSUpdateResource
}

// OSUpdatesClientListResponse contains the response from method OSUpdatesClient.NewListPager.
type OSUpdatesClientListResponse struct {
	// A list of OS Updates.
	OSUpdateListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of operations supported by the resource provider.
	OperationListResult
}

// PackagesClientCreateResponse contains the response from method PackagesClient.BeginCreate.
type PackagesClientCreateResponse struct {
	// The Test Base Package resource.
	PackageResource
}

// PackagesClientDeleteResponse contains the response from method PackagesClient.BeginDelete.
type PackagesClientDeleteResponse struct {
	// placeholder for future response values
}

// PackagesClientGetDownloadURLResponse contains the response from method PackagesClient.GetDownloadURL.
type PackagesClientGetDownloadURLResponse struct {
	// The response of getting a download URL.
	DownloadURLResponse
}

// PackagesClientGetResponse contains the response from method PackagesClient.Get.
type PackagesClientGetResponse struct {
	// The Test Base Package resource.
	PackageResource
}

// PackagesClientHardDeleteResponse contains the response from method PackagesClient.BeginHardDelete.
type PackagesClientHardDeleteResponse struct {
	// placeholder for future response values
}

// PackagesClientListByTestBaseAccountResponse contains the response from method PackagesClient.NewListByTestBaseAccountPager.
type PackagesClientListByTestBaseAccountResponse struct {
	// A list of Test Base Packages.
	PackageListResult
}

// PackagesClientUpdateResponse contains the response from method PackagesClient.BeginUpdate.
type PackagesClientUpdateResponse struct {
	// The Test Base Package resource.
	PackageResource
}

// SKUsClientListResponse contains the response from method SKUsClient.NewListPager.
type SKUsClientListResponse struct {
	// A list of Test Base Account SKUs.
	AccountSKUListResult
}

// TestResultsClientGetDownloadURLResponse contains the response from method TestResultsClient.GetDownloadURL.
type TestResultsClientGetDownloadURLResponse struct {
	// The response of getting a download URL.
	DownloadURLResponse
}

// TestResultsClientGetResponse contains the response from method TestResultsClient.Get.
type TestResultsClientGetResponse struct {
	// The Test Result Resource.
	TestResultResource
}

// TestResultsClientGetVideoDownloadURLResponse contains the response from method TestResultsClient.GetVideoDownloadURL.
type TestResultsClientGetVideoDownloadURLResponse struct {
	// The response of getting a download URL.
	DownloadURLResponse
}

// TestResultsClientListResponse contains the response from method TestResultsClient.NewListPager.
type TestResultsClientListResponse struct {
	// A list of Test Results.
	TestResultListResult
}

// TestSummariesClientGetResponse contains the response from method TestSummariesClient.Get.
type TestSummariesClientGetResponse struct {
	// Summary of a Test.
	TestSummaryResource
}

// TestSummariesClientListResponse contains the response from method TestSummariesClient.NewListPager.
type TestSummariesClientListResponse struct {
	// A list of Test Summaries.
	TestSummaryListResult
}

// TestTypesClientGetResponse contains the response from method TestTypesClient.Get.
type TestTypesClientGetResponse struct {
	// The test type resource.
	TestTypeResource
}

// TestTypesClientListResponse contains the response from method TestTypesClient.NewListPager.
type TestTypesClientListResponse struct {
	// A list of test types.
	TestTypeListResult
}

// UsageClientListResponse contains the response from method UsageClient.NewListPager.
type UsageClientListResponse struct {
	// A list of Test Base Account usage data.
	AccountUsageDataList
}
