//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armtrafficmanager

// EndpointsClientCreateOrUpdateResponse contains the response from method EndpointsClient.CreateOrUpdate.
type EndpointsClientCreateOrUpdateResponse struct {
	// Class representing a Traffic Manager endpoint.
	Endpoint
}

// EndpointsClientDeleteResponse contains the response from method EndpointsClient.Delete.
type EndpointsClientDeleteResponse struct {
	// The result of the request or operation.
	DeleteOperationResult
}

// EndpointsClientGetResponse contains the response from method EndpointsClient.Get.
type EndpointsClientGetResponse struct {
	// Class representing a Traffic Manager endpoint.
	Endpoint
}

// EndpointsClientUpdateResponse contains the response from method EndpointsClient.Update.
type EndpointsClientUpdateResponse struct {
	// Class representing a Traffic Manager endpoint.
	Endpoint
}

// GeographicHierarchiesClientGetDefaultResponse contains the response from method GeographicHierarchiesClient.GetDefault.
type GeographicHierarchiesClientGetDefaultResponse struct {
	// Class representing the Geographic hierarchy used with the Geographic traffic routing method.
	GeographicHierarchy
}

// HeatMapClientGetResponse contains the response from method HeatMapClient.Get.
type HeatMapClientGetResponse struct {
	// Class representing a Traffic Manager HeatMap.
	HeatMapModel
}

// ProfilesClientCheckTrafficManagerNameAvailabilityV2Response contains the response from method ProfilesClient.CheckTrafficManagerNameAvailabilityV2.
type ProfilesClientCheckTrafficManagerNameAvailabilityV2Response struct {
	// Class representing a Traffic Manager Name Availability response.
	NameAvailability
}

// ProfilesClientCheckTrafficManagerRelativeDNSNameAvailabilityResponse contains the response from method ProfilesClient.CheckTrafficManagerRelativeDNSNameAvailability.
type ProfilesClientCheckTrafficManagerRelativeDNSNameAvailabilityResponse struct {
	// Class representing a Traffic Manager Name Availability response.
	NameAvailability
}

// ProfilesClientCreateOrUpdateResponse contains the response from method ProfilesClient.CreateOrUpdate.
type ProfilesClientCreateOrUpdateResponse struct {
	// Class representing a Traffic Manager profile.
	Profile
}

// ProfilesClientDeleteResponse contains the response from method ProfilesClient.Delete.
type ProfilesClientDeleteResponse struct {
	// The result of the request or operation.
	DeleteOperationResult
}

// ProfilesClientGetResponse contains the response from method ProfilesClient.Get.
type ProfilesClientGetResponse struct {
	// Class representing a Traffic Manager profile.
	Profile
}

// ProfilesClientListByResourceGroupResponse contains the response from method ProfilesClient.NewListByResourceGroupPager.
type ProfilesClientListByResourceGroupResponse struct {
	// The list Traffic Manager profiles operation response.
	ProfileListResult
}

// ProfilesClientListBySubscriptionResponse contains the response from method ProfilesClient.NewListBySubscriptionPager.
type ProfilesClientListBySubscriptionResponse struct {
	// The list Traffic Manager profiles operation response.
	ProfileListResult
}

// ProfilesClientUpdateResponse contains the response from method ProfilesClient.Update.
type ProfilesClientUpdateResponse struct {
	// Class representing a Traffic Manager profile.
	Profile
}

// UserMetricsKeysClientCreateOrUpdateResponse contains the response from method UserMetricsKeysClient.CreateOrUpdate.
type UserMetricsKeysClientCreateOrUpdateResponse struct {
	// Class representing Traffic Manager User Metrics.
	UserMetricsModel
}

// UserMetricsKeysClientDeleteResponse contains the response from method UserMetricsKeysClient.Delete.
type UserMetricsKeysClientDeleteResponse struct {
	// The result of the request or operation.
	DeleteOperationResult
}

// UserMetricsKeysClientGetResponse contains the response from method UserMetricsKeysClient.Get.
type UserMetricsKeysClientGetResponse struct {
	// Class representing Traffic Manager User Metrics.
	UserMetricsModel
}
