//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armvmwarecloudsimple

// CustomizationPoliciesClientGetResponse contains the response from method CustomizationPoliciesClient.Get.
type CustomizationPoliciesClientGetResponse struct {
	// The virtual machine customization policy
	CustomizationPolicy
}

// CustomizationPoliciesClientListResponse contains the response from method CustomizationPoliciesClient.NewListPager.
type CustomizationPoliciesClientListResponse struct {
	// List of customization polices response model
	CustomizationPoliciesListResponse
}

// DedicatedCloudNodesClientCreateOrUpdateResponse contains the response from method DedicatedCloudNodesClient.BeginCreateOrUpdate.
type DedicatedCloudNodesClientCreateOrUpdateResponse struct {
	// Dedicated cloud node model
	DedicatedCloudNode
}

// DedicatedCloudNodesClientDeleteResponse contains the response from method DedicatedCloudNodesClient.Delete.
type DedicatedCloudNodesClientDeleteResponse struct {
	// placeholder for future response values
}

// DedicatedCloudNodesClientGetResponse contains the response from method DedicatedCloudNodesClient.Get.
type DedicatedCloudNodesClientGetResponse struct {
	// Dedicated cloud node model
	DedicatedCloudNode
}

// DedicatedCloudNodesClientListByResourceGroupResponse contains the response from method DedicatedCloudNodesClient.NewListByResourceGroupPager.
type DedicatedCloudNodesClientListByResourceGroupResponse struct {
	// List of dedicated nodes response model
	DedicatedCloudNodeListResponse
}

// DedicatedCloudNodesClientListBySubscriptionResponse contains the response from method DedicatedCloudNodesClient.NewListBySubscriptionPager.
type DedicatedCloudNodesClientListBySubscriptionResponse struct {
	// List of dedicated nodes response model
	DedicatedCloudNodeListResponse
}

// DedicatedCloudNodesClientUpdateResponse contains the response from method DedicatedCloudNodesClient.Update.
type DedicatedCloudNodesClientUpdateResponse struct {
	// Dedicated cloud node model
	DedicatedCloudNode
}

// DedicatedCloudServicesClientCreateOrUpdateResponse contains the response from method DedicatedCloudServicesClient.CreateOrUpdate.
type DedicatedCloudServicesClientCreateOrUpdateResponse struct {
	// Dedicated cloud service model
	DedicatedCloudService
}

// DedicatedCloudServicesClientDeleteResponse contains the response from method DedicatedCloudServicesClient.BeginDelete.
type DedicatedCloudServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// DedicatedCloudServicesClientGetResponse contains the response from method DedicatedCloudServicesClient.Get.
type DedicatedCloudServicesClientGetResponse struct {
	// Dedicated cloud service model
	DedicatedCloudService
}

// DedicatedCloudServicesClientListByResourceGroupResponse contains the response from method DedicatedCloudServicesClient.NewListByResourceGroupPager.
type DedicatedCloudServicesClientListByResourceGroupResponse struct {
	// List of dedicated cloud services
	DedicatedCloudServiceListResponse
}

// DedicatedCloudServicesClientListBySubscriptionResponse contains the response from method DedicatedCloudServicesClient.NewListBySubscriptionPager.
type DedicatedCloudServicesClientListBySubscriptionResponse struct {
	// List of dedicated cloud services
	DedicatedCloudServiceListResponse
}

// DedicatedCloudServicesClientUpdateResponse contains the response from method DedicatedCloudServicesClient.Update.
type DedicatedCloudServicesClientUpdateResponse struct {
	// Dedicated cloud service model
	DedicatedCloudService
}

// OperationsClientGetResponse contains the response from method OperationsClient.Get.
type OperationsClientGetResponse struct {
	// Operation status response
	OperationResource

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// List of available operations
	AvailableOperationsListResponse
}

// PrivateCloudsClientGetResponse contains the response from method PrivateCloudsClient.Get.
type PrivateCloudsClientGetResponse struct {
	// Private cloud model
	PrivateCloud
}

// PrivateCloudsClientListResponse contains the response from method PrivateCloudsClient.NewListPager.
type PrivateCloudsClientListResponse struct {
	// List of private clouds
	PrivateCloudList
}

// ResourcePoolsClientGetResponse contains the response from method ResourcePoolsClient.Get.
type ResourcePoolsClientGetResponse struct {
	// Resource pool model
	ResourcePool
}

// ResourcePoolsClientListResponse contains the response from method ResourcePoolsClient.NewListPager.
type ResourcePoolsClientListResponse struct {
	// List of resource pools response model
	ResourcePoolsListResponse
}

// SKUsAvailabilityClientListResponse contains the response from method SKUsAvailabilityClient.NewListPager.
type SKUsAvailabilityClientListResponse struct {
	// List of SKU availabilities
	SKUAvailabilityListResponse
}

// UsagesClientListResponse contains the response from method UsagesClient.NewListPager.
type UsagesClientListResponse struct {
	// List of usages
	UsageListResponse
}

// VirtualMachineTemplatesClientGetResponse contains the response from method VirtualMachineTemplatesClient.Get.
type VirtualMachineTemplatesClientGetResponse struct {
	// Virtual machine template model
	VirtualMachineTemplate
}

// VirtualMachineTemplatesClientListResponse contains the response from method VirtualMachineTemplatesClient.NewListPager.
type VirtualMachineTemplatesClientListResponse struct {
	// List of virtual machine templates
	VirtualMachineTemplateListResponse
}

// VirtualMachinesClientCreateOrUpdateResponse contains the response from method VirtualMachinesClient.BeginCreateOrUpdate.
type VirtualMachinesClientCreateOrUpdateResponse struct {
	// Virtual machine model
	VirtualMachine
}

// VirtualMachinesClientDeleteResponse contains the response from method VirtualMachinesClient.BeginDelete.
type VirtualMachinesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientGetResponse contains the response from method VirtualMachinesClient.Get.
type VirtualMachinesClientGetResponse struct {
	// Virtual machine model
	VirtualMachine
}

// VirtualMachinesClientListByResourceGroupResponse contains the response from method VirtualMachinesClient.NewListByResourceGroupPager.
type VirtualMachinesClientListByResourceGroupResponse struct {
	// List of virtual machines
	VirtualMachineListResponse
}

// VirtualMachinesClientListBySubscriptionResponse contains the response from method VirtualMachinesClient.NewListBySubscriptionPager.
type VirtualMachinesClientListBySubscriptionResponse struct {
	// List of virtual machines
	VirtualMachineListResponse
}

// VirtualMachinesClientStartResponse contains the response from method VirtualMachinesClient.BeginStart.
type VirtualMachinesClientStartResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientStopResponse contains the response from method VirtualMachinesClient.BeginStop.
type VirtualMachinesClientStopResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientUpdateResponse contains the response from method VirtualMachinesClient.BeginUpdate.
type VirtualMachinesClientUpdateResponse struct {
	// Virtual machine model
	VirtualMachine
}

// VirtualNetworksClientGetResponse contains the response from method VirtualNetworksClient.Get.
type VirtualNetworksClientGetResponse struct {
	// Virtual network model
	VirtualNetwork
}

// VirtualNetworksClientListResponse contains the response from method VirtualNetworksClient.NewListPager.
type VirtualNetworksClientListResponse struct {
	// List of virtual networks
	VirtualNetworkListResponse
}
